/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/types","vs/base/common/arrays","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/node/pfs","vs/base/common/cancellation","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/strings","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/process","os","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/map","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","child_process","vs/platform/externalServices/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/codicons","vs/base/common/jsonFormatter","fs","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/hash","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/mime","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","string_decoder","util","minimist","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ne=function(Y){for(var e=[],D=0,n=Y.length;D<n;D++)e[D]=te[Y[D]];return e};define(te[99],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(n,L){if(!n)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=D}),define(te[48],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function D(A){return A?A.replace(/\$\((.*?)\)/g,(I,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=D;class n{constructor(I,b,E){this.id=I,this.definition=b,this.description=E,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function L(A,I){const b=["codicon","codicon-"+A];return I&&b.push("codicon-modifier-"+I),b}e.getClassNamesArray=L;var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function b(C){if(C instanceof n)return["codicon","codicon-"+C.id];const f=I.exec(C.id);if(!f)return b(n.error);let[,S,u]=f;const v=["codicon","codicon-"+S];return u&&v.push("codicon-modifier-"+u.substr(1)),v}A.asClassNameArray=b;function E(C){return b(C).join(" ")}A.asClassName=E;function P(C){return"."+b(C).join(".")}A.asCSSSelector=P})(T=e.CSSIcon||(e.CSSIcon={}))}),define(te[67],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function n(P){const C=[];for(let f in P)D.call(P,f)&&C.push(P[f]);return C}e.values=n;function L(P,C){for(let f in P)if(D.call(P,f)&&C({key:f,value:P[f]},function(){delete P[f]})===!1)return}e.forEach=L;function T(P,C){const f=Object.create(null);for(const S of P){const u=C(S);let v=f[u];v||(v=f[u]=[]),v.push(S)}return f}e.groupBy=T;function A(P){const C=Object.create(null);return P&&P.forEach((f,S)=>{C[S]=f}),C}e.fromMap=A;function I(P,C){const f=[],S=[];for(let u of P)C.has(u)||f.push(u);for(let u of C)P.has(u)||S.push(u);return{removed:f,added:S}}e.diffSets=I;function b(P,C){const f=[],S=[];for(let[u,v]of P)C.has(u)||f.push(v);for(let[u,v]of C)P.has(u)||S.push(v);return{removed:f,added:S}}e.diffMaps=b;class E{constructor(){this.map=new Map}add(C,f){let S=this.map.get(C);S||(S=new Set,this.map.set(C,S)),S.add(f)}delete(C,f){const S=this.map.get(C);!S||(S.delete(f),S.size===0&&this.map.delete(C))}forEach(C,f){const S=this.map.get(C);!S||S.forEach(f)}}e.SetMap=E}),define(te[54],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(A){return(I,b,E)=>{let P=null,C=null;if(typeof E.value=="function"?(P="value",C=E.value):typeof E.get=="function"&&(P="get",C=E.get),!C)throw new Error("not supported");E[P]=A(C,b)}}e.createDecorator=D;function n(A,I,b){let E=null,P=null;if(typeof b.value=="function"?(E="value",P=b.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(E="get",P=b.get),!P)throw new Error("not supported");const C=`$memoize$${I}`;b[E]=function(...f){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,f)}),this[C]}}e.memoize=n;function L(A,I,b){return D((E,P)=>{const C=`$debounce$${P}`,f=`$debounce$result$${P}`;return function(...S){this[f]||(this[f]=b?b():void 0),clearTimeout(this[C]),I&&(this[f]=I(this[f],...S),S=[this[f]]),this[C]=setTimeout(()=>{E.apply(this,S),this[f]=b?b():void 0},A)}})}e.debounce=L;function T(A,I,b){return D((E,P)=>{const C=`$throttle$timer$${P}`,f=`$throttle$result$${P}`,S=`$throttle$lastRun$${P}`,u=`$throttle$pending$${P}`;return function(...v){if(this[f]||(this[f]=b?b():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),I&&(this[f]=I(this[f],...v)),this[u])return;const d=this[S]+A;d<=Date.now()?(this[S]=Date.now(),E.apply(this,[this[f]]),this[f]=b?b():void 0):(this[u]=!0,this[C]=setTimeout(()=>{this[u]=!1,this[S]=Date.now(),E.apply(this,[this[f]]),this[f]=b?b():void 0},d-Date.now()))}})}e.throttle=T}),define(te[9],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(a=>{a(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=D,e.errorHandler=new D;function n(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=n;function L(l){b(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=L;function T(l){b(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=T;function A(l){if(l instanceof Error){let{name:i,message:a}=l;const r=l.stacktrace||l.stack;return{$isError:!0,name:i,message:a,stack:r}}return l}e.transformErrorForSerialization=A;const I="Canceled";function b(l){return l instanceof E?!0:l instanceof Error&&l.name===I&&l.message===I}e.isCancellationError=b;class E extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=E;function P(){const l=new Error(I);return l.name=l.message,l}e.canceled=P;function C(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=C;function f(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=f;function S(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function u(l){const i=new Error(`${l} has been disposed`);return i.name="DISPOSED",i}e.disposed=u;function v(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=v;class d extends Error{constructor(i){super("NotImplemented");i&&(this.message=i)}}e.NotImplementedError=d;class m extends Error{constructor(i){super("NotSupported");i&&(this.message=i)}}e.NotSupportedError=m;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function y(l){const i=l;return i instanceof Error&&Array.isArray(i.actions)}e.isErrorWithActions=y;function p(l,i=Object.create(null)){const a=new Error(l);return i.actions&&(a.actions=i.actions),a}e.createErrorWithActions=p}),define(te[16],ne([0,1,9]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(B,O=0){return B[B.length-(1+O)]}e.tail=n;function L(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=L;function T(B,O,N=(W,H)=>W===H){if(B===O)return!0;if(!B||!O||B.length!==O.length)return!1;for(let W=0,H=B.length;W<H;W++)if(!N(B[W],O[W]))return!1;return!0}e.equals=T;function A(B,O,N){let W=0,H=B.length-1;for(;W<=H;){const re=(W+H)/2|0,se=N(B[re],O);if(se<0)W=re+1;else if(se>0)H=re-1;else return re}return-(W+1)}e.binarySearch=A;function I(B,O){let N=0,W=B.length;if(W===0)return 0;for(;N<W;){const H=Math.floor((N+W)/2);O(B[H])?W=H:N=H+1}return N}e.findFirstInSorted=I;function b(B,O,N){if(B=B|0,B>=O.length)throw new TypeError("invalid index");let W=O[Math.floor(O.length*Math.random())],H=[],re=[],se=[];for(let ue of O){const de=N(ue,W);de<0?H.push(ue):de>0?re.push(ue):se.push(ue)}return B<H.length?b(B,H,N):B<H.length+se.length?se[0]:b(B-(H.length+se.length),re,N)}e.quickSelect=b;function E(B,O){const N=[];let W;for(const H of B.slice(0).sort(O))!W||O(W[0],H)!==0?(W=[H],N.push(W)):W.push(H);return N}e.groupBy=E;function P(B,O,N){const W=[];function H(ue,de,we){if(de===0&&we.length===0)return;const pe=W[W.length-1];pe&&pe.start+pe.deleteCount===ue?(pe.deleteCount+=de,pe.toInsert.push(...we)):W.push({start:ue,deleteCount:de,toInsert:we})}let re=0,se=0;for(;;){if(re===B.length){H(re,0,O.slice(se));break}if(se===O.length){H(re,B.length-re,[]);break}const ue=B[re],de=O[se],we=N(ue,de);we===0?(re+=1,se+=1):we<0?(H(re,1,[]),re+=1):we>0&&(H(re,0,[de]),se+=1)}return W}e.sortedDiff=P;function C(B,O,N){const W=P(B,O,N),H=[],re=[];for(const se of W)H.push(...B.slice(se.start,se.start+se.deleteCount)),re.push(...se.toInsert);return{removed:H,added:re}}e.delta=C;function f(B,O,N){if(N===0)return[];const W=B.slice(0,N).sort(O);return u(B,O,W,N,B.length),W}e.top=f;function S(B,O,N,W,H){return N===0?Promise.resolve([]):new Promise((re,se)=>{(async()=>{const ue=B.length,de=B.slice(0,N).sort(O);for(let we=N,pe=Math.min(N+W,ue);we<ue;we=pe,pe=Math.min(pe+W,ue)){if(we>N&&await new Promise(ge=>setTimeout(ge)),H&&H.isCancellationRequested)throw(0,D.canceled)();u(B,O,de,we,pe)}return de})().then(re,se)})}e.topAsync=S;function u(B,O,N,W,H){for(const re=N.length;W<H;W++){const se=B[W];if(O(se,N[re-1])<0){N.pop();const ue=I(N,de=>O(se,de)<0);N.splice(ue,0,se)}}}function v(B){return B.filter(O=>!!O)}e.coalesce=v;function d(B){let O=0;for(let N=0;N<B.length;N++)B[N]&&(B[O]=B[N],O+=1);B.length=O}e.coalesceInPlace=d;function m(B,O,N){B.splice(N,0,B.splice(O,1)[0])}e.move=m;function w(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=w;function y(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=y;function p(B,O=N=>N){const N=new Set;return B.filter(W=>{const H=O(W);return N.has(H)?!1:(N.add(H),!0)})}e.distinct=p;function l(B){const O=new Set;return N=>{const W=B(N);return O.has(W)?!1:(O.add(W),!0)}}e.uniqueFilter=l;function i(B,O){const N=a(B,O);if(N!==-1)return B[N]}e.findLast=i;function a(B,O){for(let N=B.length-1;N>=0;N--){const W=B[N];if(O(W))return N}return-1}e.lastIndex=a;function r(B,O){return B.length>0?B[0]:O}e.firstOrDefault=r;function t(B,O,N=(W,H)=>W===H){let W=0;for(let H=0,re=Math.min(B.length,O.length);H<re&&N(B[H],O[H]);H++)W++;return W}e.commonPrefixLength=t;function o(B){return[].concat(...B)}e.flatten=o;function s(B,O){let N=typeof O=="number"?B:0;typeof O=="number"?N=B:(N=0,O=B);const W=[];if(N<=O)for(let H=N;H<O;H++)W.push(H);else for(let H=N;H>O;H--)W.push(H);return W}e.range=s;function c(B,O,N){return B.reduce((W,H)=>(W[O(H)]=N?N(H):H,W),Object.create(null))}e.index=c;function h(B,O){return B.push(O),()=>g(B,O)}e.insert=h;function g(B,O){const N=B.indexOf(O);if(N>-1)return B.splice(N,1),O}e.remove=g;function R(B,O,N){const W=B.slice(0,O),H=B.slice(O);return W.concat(N,H)}e.arrayInsert=R;function _(B,O){let N;if(typeof O=="number"){let W=O;N=()=>{const H=Math.sin(W++)*179426549;return H-Math.floor(H)}}else N=Math.random;for(let W=B.length-1;W>0;W-=1){const H=Math.floor(N()*(W+1)),re=B[W];B[W]=B[H],B[H]=re}}e.shuffle=_;function U(B,O){const N=B.indexOf(O);N>-1&&(B.splice(N,1),B.unshift(O))}e.pushToStart=U;function F(B,O){const N=B.indexOf(O);N>-1&&(B.splice(N,1),B.push(O))}e.pushToEnd=F;function k(B,O){return Array.isArray(B)?B.map(O):O(B)}e.mapArrayOrNot=k;function M(B){return Array.isArray(B)?B:[B]}e.asArray=M;function $(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=$;function x(B,O){for(const N of B){const W=O(N);if(W!==void 0)return W}}e.mapFind=x;function z(B,O,N){const W=ee(B,O),H=B.length,re=N.length;B.length=H+re;for(let se=H-1;se>=W;se--)B[se+re]=B[se];for(let se=0;se<re;se++)B[se+W]=N[se]}e.insertInto=z;function G(B,O,N,W){const H=ee(B,O),re=B.splice(H,N);return z(B,H,W),re}e.splice=G;function ee(B,O){return O<0?Math.max(O+B.length,0):Math.min(O,B.length)}function q(B,O){return(N,W)=>O(B(N),B(W))}e.compareBy=q;const j=(B,O)=>B-O;e.numberComparator=j;function K(B,O){if(B.length===0)return;let N=B[0];for(let W=1;W<B.length;W++){const H=B[W];O(H,N)>0&&(N=H)}return N}e.findMaxBy=K;function V(B,O){if(B.length===0)return;let N=B[0];for(let W=1;W<B.length;W++){const H=B[W];O(H,N)>=0&&(N=H)}return N}e.findLastMaxBy=V;function Q(B,O){return K(B,(N,W)=>-O(N,W))}e.findMinBy=Q;class Z{constructor(O){this.items=O,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(O){let N=this.firstIdx;for(;N<this.items.length&&O(this.items[N]);)N++;const W=N===this.firstIdx?null:this.items.slice(this.firstIdx,N);return this.firstIdx=N,W}takeFromEndWhile(O){let N=this.lastIdx;for(;N>=0&&O(this.items[N]);)N--;const W=N===this.lastIdx?null:this.items.slice(N+1,this.lastIdx+1);return this.lastIdx=N,W}peek(){return this.items[this.firstIdx]}dequeue(){const O=this.items[this.firstIdx];return this.firstIdx++,O}takeCount(O){const N=this.items.slice(this.firstIdx,this.firstIdx+O);return this.firstIdx+=O,N}}e.ArrayQueue=Z}),define(te[68],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(n){const L=this;let T=!1,A;return function(){return T||(T=!0,A=n.apply(L,arguments)),A}}e.once=D}),define(te[55],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(n){function L(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}n.is=L;const T=Object.freeze([]);function A(){return T}n.empty=A;function*I(l){yield l}n.single=I;function b(l){return l||T}n.from=b;function E(l){return!l||l[Symbol.iterator]().next().done===!0}n.isEmpty=E;function P(l){return l[Symbol.iterator]().next().value}n.first=P;function C(l,i){for(const a of l)if(i(a))return!0;return!1}n.some=C;function f(l,i){for(const a of l)if(i(a))return a}n.find=f;function*S(l,i){for(const a of l)i(a)&&(yield a)}n.filter=S;function*u(l,i){let a=0;for(const r of l)yield i(r,a++)}n.map=u;function*v(...l){for(const i of l)for(const a of i)yield a}n.concat=v;function*d(l){for(const i of l)for(const a of i)yield a}n.concatNested=d;function m(l,i,a){let r=a;for(const t of l)r=i(r,t);return r}n.reduce=m;function*w(l,i,a=l.length){for(i<0&&(i+=l.length),a<0?a+=l.length:a>l.length&&(a=l.length);i<a;i++)yield l[i]}n.slice=w;function y(l,i=Number.POSITIVE_INFINITY){const a=[];if(i===0)return[a,l];const r=l[Symbol.iterator]();for(let t=0;t<i;t++){const o=r.next();if(o.done)return[a,n.empty()];a.push(o.value)}return[a,{[Symbol.iterator](){return r}}]}n.consume=y;function p(l,i,a=(r,t)=>r===t){const r=l[Symbol.iterator](),t=i[Symbol.iterator]();for(;;){const o=r.next(),s=t.next();if(o.done!==s.done)return!1;if(o.done)return!0;if(!a(o.value,s.value))return!1}}n.equals=p})(D=e.Iterable||(e.Iterable={}))}),define(te[35],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var n;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(i){i.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function A(i,a=!1){let r=0,t=i.length,o="",s=0,c=16,h=0;function g($){let x=0,z=0;for(;x<$;){const G=i.charCodeAt(r);if(G>=48&&G<=57)z=z*16+G-48;else if(G>=65&&G<=70)z=z*16+G-65+10;else if(G>=97&&G<=102)z=z*16+G-97+10;else break;r++,x++}return x<$&&(z=-1),z}function R($){r=$,o="",s=0,c=16,h=0}function _(){const $=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&E(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&E(i.charCodeAt(r)))for(r++;r<i.length&&E(i.charCodeAt(r));)r++;else return h=3,i.substring($,r);let x=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&E(i.charCodeAt(r))){for(r++;r<i.length&&E(i.charCodeAt(r));)r++;x=r}else h=3;return i.substring($,x)}function U(){let $="",x=r;for(;;){if(r>=t){$+=i.substring(x,r),h=2;break}const z=i.charCodeAt(r);if(z===34){$+=i.substring(x,r),r++;break}if(z===92){if($+=i.substring(x,r),r++,r>=t){h=2;break}switch(i.charCodeAt(r++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const ee=g(4);ee>=0?$+=String.fromCharCode(ee):h=4;break}default:h=5}x=r;continue}if(z>=0&&z<=31)if(b(z)){$+=i.substring(x,r),h=2;break}else h=6;r++}return $}function F(){if(o="",h=0,s=r,r>=t)return s=t,c=17;let $=i.charCodeAt(r);if(I($)){do r++,o+=String.fromCharCode($),$=i.charCodeAt(r);while(I($));return c=15}if(b($))return r++,o+=String.fromCharCode($),$===13&&i.charCodeAt(r)===10&&(r++,o+=`
`),c=14;switch($){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,o=U(),c=10;case 47:{const x=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<t&&!b(i.charCodeAt(r));)r++;return o=i.substring(x,r),c=12}if(i.charCodeAt(r+1)===42){r+=2;const z=t-1;let G=!1;for(;r<z;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,G=!0;break}r++}return G||(r++,h=1),o=i.substring(x,r),c=13}return o+=String.fromCharCode($),r++,c=16}case 45:if(o+=String.fromCharCode($),r++,r===t||!E(i.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),c=11;default:for(;r<t&&k($);)r++,$=i.charCodeAt(r);if(s!==r){switch(o=i.substring(s,r),o){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return o+=String.fromCharCode($),r++,c=16}}function k($){if(I($)||b($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let $;do $=F();while($>=12&&$<=15);return $}return{setPosition:R,getPosition:()=>r,scan:a?M:F,getToken:()=>c,getTokenValue:()=>o,getTokenOffset:()=>s,getTokenLength:()=>r-s,getTokenError:()=>h}}e.createScanner=A;function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function b(i){return i===10||i===13||i===8232||i===8233}function E(i){return i>=48&&i<=57}var P;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(P||(P={}));function C(i,a){const r=[],t=new Object;let o;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function h(g,R,_,U){s.value=g,s.offset=R,s.length=_,s.type=U,s.colonOffset=void 0,o=s}try{y(i,{onObjectBegin:(g,R)=>{if(a<=g)throw t;o=void 0,c=a>g,r.push("")},onObjectProperty:(g,R,_)=>{if(a<R||(h(g,R,_,"property"),r[r.length-1]=g,a<=R+_))throw t},onObjectEnd:(g,R)=>{if(a<=g)throw t;o=void 0,r.pop()},onArrayBegin:(g,R)=>{if(a<=g)throw t;o=void 0,r.push(0)},onArrayEnd:(g,R)=>{if(a<=g)throw t;o=void 0,r.pop()},onLiteralValue:(g,R,_)=>{if(a<R||(h(g,R,_,l(g)),a<=R+_))throw t},onSeparator:(g,R,_)=>{if(a<=R)throw t;if(g===":"&&o&&o.type==="property")o.colonOffset=R,c=!1,o=void 0;else if(g===","){const U=r[r.length-1];typeof U=="number"?r[r.length-1]=U+1:(c=!0,r[r.length-1]=""),o=void 0}}})}catch(g){if(g!==t)throw g}return{path:r,previousNode:o,isAtPropertyKey:c,matches:g=>{let R=0;for(let _=0;R<g.length&&_<r.length;_++)if(g[R]===r[_]||g[R]==="*")R++;else if(g[R]!=="**")return!1;return R===g.length}}}e.getLocation=C;function f(i,a=[],r=T.DEFAULT){let t=null,o=[];const s=[];function c(g){Array.isArray(o)?o.push(g):t!==null&&(o[t]=g)}return y(i,{onObjectBegin:()=>{const g={};c(g),s.push(o),o=g,t=null},onObjectProperty:g=>{t=g},onObjectEnd:()=>{o=s.pop()},onArrayBegin:()=>{const g=[];c(g),s.push(o),o=g,t=null},onArrayEnd:()=>{o=s.pop()},onLiteralValue:c,onError:(g,R,_)=>{a.push({error:g,offset:R,length:_})}},r),o[0]}e.parse=f;function S(i,a=[],r=T.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(g){t.type==="property"&&(t.length=g-t.offset,t=t.parent)}function s(g){return t.children.push(g),g}y(i,{onObjectBegin:g=>{t=s({type:"object",offset:g,length:-1,parent:t,children:[]})},onObjectProperty:(g,R,_)=>{t=s({type:"property",offset:R,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:g,offset:R,length:_,parent:t})},onObjectEnd:(g,R)=>{t.length=g+R-t.offset,t=t.parent,o(g+R)},onArrayBegin:(g,R)=>{t=s({type:"array",offset:g,length:-1,parent:t,children:[]})},onArrayEnd:(g,R)=>{t.length=g+R-t.offset,t=t.parent,o(g+R)},onLiteralValue:(g,R,_)=>{s({type:l(g),offset:R,length:_,parent:t,value:g}),o(R+_)},onSeparator:(g,R,_)=>{t.type==="property"&&(g===":"?t.colonOffset=R:g===","&&o(R))},onError:(g,R,_)=>{a.push({error:g,offset:R,length:_})}},r);const h=t.children[0];return h&&delete h.parent,h}e.parseTree=S;function u(i,a){if(!i)return;let r=i;for(let t of a)if(typeof t=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let o=!1;for(const s of r.children)if(Array.isArray(s.children)&&s.children[0].value===t){r=s.children[1],o=!0;break}if(!o)return}else{const o=t;if(r.type!=="array"||o<0||!Array.isArray(r.children)||o>=r.children.length)return;r=r.children[o]}return r}e.findNodeAtLocation=u;function v(i){if(!i.parent||!i.parent.children)return[];const a=v(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;a.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&a.push(r)}return a}e.getNodePath=v;function d(i){switch(i.type){case"array":return i.children.map(d);case"object":{const a=Object.create(null);for(let r of i.children){const t=r.children[1];t&&(a[r.children[0].value]=d(t))}return a}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=d;function m(i,a,r=!1){return a>=i.offset&&a<i.offset+i.length||r&&a===i.offset+i.length}e.contains=m;function w(i,a,r=!1){if(m(i,a,r)){const t=i.children;if(Array.isArray(t))for(let o=0;o<t.length&&t[o].offset<=a;o++){const s=w(t[o],a,r);if(s)return s}return i}}e.findNodeAtOffset=w;function y(i,a,r=T.DEFAULT){const t=A(i,!1);function o(Z){return Z?()=>Z(t.getTokenOffset(),t.getTokenLength()):()=>!0}function s(Z){return Z?B=>Z(B,t.getTokenOffset(),t.getTokenLength()):()=>!0}const c=o(a.onObjectBegin),h=s(a.onObjectProperty),g=o(a.onObjectEnd),R=o(a.onArrayBegin),_=o(a.onArrayEnd),U=s(a.onLiteralValue),F=s(a.onSeparator),k=o(a.onComment),M=s(a.onError),$=r&&r.disallowComments,x=r&&r.allowTrailingComma;function z(){for(;;){const Z=t.scan();switch(t.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:$||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(Z){case 12:case 13:$?G(10):k();break;case 16:G(1);break;case 15:case 14:break;default:return Z}}}function G(Z,B=[],O=[]){if(M(Z),B.length+O.length>0){let N=t.getToken();for(;N!==17;){if(B.indexOf(N)!==-1){z();break}else if(O.indexOf(N)!==-1)break;N=z()}}}function ee(Z){const B=t.getTokenValue();return Z?U(B):h(B),z(),!0}function q(){switch(t.getToken()){case 11:{let Z=0;try{Z=JSON.parse(t.getTokenValue()),typeof Z!="number"&&(G(2),Z=0)}catch{G(2)}U(Z);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return z(),!0}function j(){return t.getToken()!==10?(G(3,[],[2,5]),!1):(ee(!1),t.getToken()===6?(F(":"),z(),Q()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function K(){c(),z();let Z=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(Z||G(4,[],[]),F(","),z(),t.getToken()===2&&x)break}else Z&&G(6,[],[]);j()||G(4,[],[2,5]),Z=!0}return g(),t.getToken()!==2?G(7,[2],[]):z(),!0}function V(){R(),z();let Z=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(Z||G(4,[],[]),F(","),z(),t.getToken()===4&&x)break}else Z&&G(6,[],[]);Q()||G(4,[],[4,5]),Z=!0}return _(),t.getToken()!==4?G(8,[4],[]):z(),!0}function Q(){switch(t.getToken()){case 3:return V();case 1:return K();case 10:return ee(!0);default:return q()}}return z(),t.getToken()===17?r.allowEmptyContent?!0:(G(4,[],[]),!1):Q()?(t.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=y;function p(i,a){let r=A(i),t=[],o,s=0,c;do switch(c=r.getPosition(),o=r.scan(),o){case 12:case 13:case 17:s!==c&&t.push(i.substring(s,c)),a!==void 0&&t.push(r.getTokenValue().replace(/[^\r\n]/g,a)),s=r.getPosition();break}while(o!==17);return t.join("")}e.stripComments=p;function l(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(te[49],ne([0,1,35]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(E,P,C){let f,S,u,v,d;if(P){for(v=P.offset,d=v+P.length,u=v;u>0&&!b(E,u-1);)u--;let c=d;for(;c<E.length&&!b(E,c);)c++;S=E.substring(u,c),f=A(S,C)}else S=E,f=0,u=0,v=0,d=E.length;const m=I(C,E);let w=!1,y=0,p;C.insertSpaces?p=T(" ",C.tabSize||4):p="	";const l=(0,D.createScanner)(S,!1);let i=!1;function a(){return m+T(p,f+y)}function r(){let c=l.scan();for(w=!1;c===15||c===14;)w=w||c===14,c=l.scan();return i=c===16||l.getTokenError()!==0,c}const t=[];function o(c,h,g){!i&&h<d&&g>v&&E.substring(h,g)!==c&&t.push({offset:h,length:g-h,content:c})}let s=r();if(s!==17){const c=l.getTokenOffset()+u,h=T(p,f);o(h,u,c)}for(;s!==17;){let c=l.getTokenOffset()+l.getTokenLength()+u,h=r(),g="";for(;!w&&(h===12||h===13);){const _=l.getTokenOffset()+u;o(" ",c,_),c=l.getTokenOffset()+l.getTokenLength()+u,g=h===12?a():"",h=r()}if(h===2)s!==1&&(y--,g=a());else if(h===4)s!==3&&(y--,g=a());else{switch(s){case 3:case 1:y++,g=a();break;case 5:case 12:g=a();break;case 13:w?g=a():g=" ";break;case 6:g=" ";break;case 10:if(h===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?g=" ":h!==5&&h!==17&&(i=!0);break;case 16:i=!0;break}w&&(h===12||h===13)&&(g=a())}const R=l.getTokenOffset()+u;o(g,c,R),s=h}return t}e.format=n;function L(E,P){const C=JSON.stringify(E,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?C.replace(/\r\n|\r|\n/g,P.eol):C}e.toFormattedString=L;function T(E,P){let C="";for(let f=0;f<P;f++)C+=E;return C}function A(E,P){let C=0,f=0;const S=P.tabSize||4;for(;C<E.length;){const u=E.charAt(C);if(u===" ")f++;else if(u==="	")f+=S;else break;C++}return Math.floor(f/S)}function I(E,P){for(let C=0;C<P.length;C++){const f=P.charAt(C);if(f==="\r")return C+1<P.length&&P.charAt(C+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=I;function b(E,P){return`\r
`.indexOf(E.charAt(P))!==-1}e.isEOL=b}),define(te[69],ne([0,1,35,49]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(E,P,C){return T(E,P,void 0,C)}e.removeProperty=L;function T(E,P,C,f,S){const u=P.slice(),v=[],d=(0,D.parseTree)(E,v);let m,w;for(;u.length>0&&(w=u.pop(),m=(0,D.findNodeAtLocation)(d,u),m===void 0&&C!==void 0);)typeof w=="string"?C={[w]:C}:C=[C];if(m)if(m.type==="object"&&typeof w=="string"&&Array.isArray(m.children)){const y=(0,D.findNodeAtLocation)(m,[w]);if(y!==void 0)if(C===void 0){if(!y.parent)throw new Error("Malformed AST");const p=m.children.indexOf(y.parent);let l,i=y.parent.offset+y.parent.length;if(p>0){const a=m.children[p-1];l=a.offset+a.length}else l=m.offset+1,m.children.length>1&&(i=m.children[1].offset);return A(E,{offset:l,length:i-l,content:""},f)}else return A(E,{offset:y.offset,length:y.length,content:JSON.stringify(C)},f);else{if(C===void 0)return[];const p=`${JSON.stringify(w)}: ${JSON.stringify(C)}`,l=S?S(m.children.map(a=>a.children[0].value)):m.children.length;let i;if(l>0){const a=m.children[l-1];i={offset:a.offset+a.length,length:0,content:","+p}}else m.children.length===0?i={offset:m.offset+1,length:0,content:p}:i={offset:m.offset+1,length:0,content:p+","};return A(E,i,f)}}else if(m.type==="array"&&typeof w=="number"&&Array.isArray(m.children))if(C!==void 0){const y=`${JSON.stringify(C)}`;let p;if(m.children.length===0||w===0)p={offset:m.offset+1,length:0,content:m.children.length===0?y:y+","};else{const l=w===-1||w>m.children.length?m.children.length:w,i=m.children[l-1];p={offset:i.offset+i.length,length:0,content:","+y}}return A(E,p,f)}else{const y=w,p=m.children[y];let l;if(m.children.length===1)l={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===y){const i=m.children[y-1],a=i.offset+i.length,r=m.offset+m.length;l={offset:a,length:r-2-a,content:""}}else l={offset:p.offset,length:m.children[y+1].offset-p.offset,content:""};return A(E,l,f)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${m.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return A(E,{offset:d?d.offset:0,length:d?d.length:0,content:JSON.stringify(C)},f)}}e.setProperty=T;function A(E,P,C){let f=I(E,P),S=P.offset,u=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;S>0&&!(0,n.isEOL)(f,S-1);)S--;for(;u<f.length&&!(0,n.isEOL)(f,u);)u++}const v=(0,n.format)(f,{offset:S,length:u-S},C);for(let m=v.length-1;m>=0;m--){const w=v[m];f=I(f,w),S=Math.min(S,w.offset),u=Math.max(u,w.offset+w.length),u+=w.content.length-w.length}const d=E.length-(f.length-u)-S;return[{offset:S,length:d,content:f.substring(S,u)}]}e.withFormatting=A;function I(E,P){return E.substring(0,P.offset)+P.content+E.substring(P.offset+P.length)}e.applyEdit=I;function b(E,P){let C=P.slice(0).sort((S,u)=>{const v=S.offset-u.offset;return v===0?S.length-u.length:v}),f=E.length;for(let S=C.length-1;S>=0;S--){let u=C[S];if(u.offset+u.length<=f)E=I(E,u);else throw new Error("Overlapping edit");f=u.offset}return E}e.applyEdits=b}),define(te[100],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(L){this.executor=L,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(L){this._error=L}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(L){return new D(()=>L(this.getValue()))}}e.Lazy=D}),define(te[2],ne([0,1,68,55]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const L=!1;let T=null;function A(t){T=t}if(e.setDisposableTracker=A,L){const t="__is_disposable_tracked__";A(new class{trackDisposable(o){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[t]||console.log(s)},3e3)}setParent(o,s){if(o&&o!==w.None)try{o[t]=!0}catch{}}markAsDisposed(o){if(o&&o!==w.None)try{o[t]=!0}catch{}}markAsSingleton(o){}})}function I(t){return T?.trackDisposable(t),t}function b(t){T?.markAsDisposed(t)}function E(t,o){T?.setParent(t,o)}function P(t,o){if(!!T)for(const s of t)T.setParent(s,o)}function C(t){return T?.markAsSingleton(t),t}e.markAsSingleton=C;class f extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=f;function S(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=S;function u(t){if(n.Iterable.is(t)){let o=[];for(const s of t)if(s)try{s.dispose()}catch(c){o.push(c)}if(o.length===1)throw o[0];if(o.length>1)throw new f(o);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=u;function v(...t){const o=d(()=>u(t));return P(t,o),o}e.combinedDisposable=v;function d(t){const o=I({dispose:(0,D.once)(()=>{b(o),t()})});return o}e.toDisposable=d;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return E(o,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new m,I(this),E(this._store,this)}dispose(){b(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class y{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&E(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&E(o,null),o}}e.MutableDisposable=y;class p{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=p;class l{constructor(){this.references=new Map}acquire(o,...s){let c=this.references.get(o);c||(c={counter:0,object:this.createReferencedObject(o,...s)},this.references.set(o,c));const{object:h}=c,g=(0,D.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(o,c.object),this.references.delete(o))});return c.counter++,{object:h,dispose:g}}}e.ReferenceCollection=l;class i{constructor(o){this.referenceCollection=o}async acquire(o,...s){const c=this.referenceCollection.acquire(o,...s);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(h){throw c.dispose(),h}}}e.AsyncReferenceCollection=i;class a{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=a;function r(t){const o=new m;try{t(o)}finally{o.dispose()}}e.disposeOnReturn=r}),define(te[101],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(T){this.element=T,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class n{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let T=this._first;for(;T!==D.Undefined;){const A=T.next;T.prev=D.Undefined,T.next=D.Undefined,T=A}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,A){const I=new D(T);if(this._first===D.Undefined)this._first=I,this._last=I;else if(A){const E=this._last;this._last=I,I.prev=E,E.next=I}else{const E=this._first;this._first=I,I.next=E,E.prev=I}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(I))}}shift(){if(this._first!==D.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==D.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==D.Undefined&&T.next!==D.Undefined){const A=T.prev;A.next=T.next,T.next.prev=A}else T.prev===D.Undefined&&T.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):T.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):T.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==D.Undefined;)yield T.element,T=T.next}}e.LinkedList=n}),function(){function Y(L){const T=[];typeof L=="number"&&T.push("code/timeOrigin",L);function A(b){T.push(b,Date.now())}function I(){const b=[];for(let E=0;E<T.length;E+=2)b.push({name:T[E],startTime:T[E+1]});return b}return{mark:A,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(L+A.startTime)});return T}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function D(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=D(n))}(),define(te[4],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let n=!1,L=!1,T=!1,A=!1,I=!1,b=!1,E=!1,P=!1,C,f=D,S,u;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?v=e.globals.vscode.process:typeof process!="undefined"&&(v=process);const d=typeof v?.versions?.electron=="string",m=d&&v?.type==="renderer";if(e.isElectronSandboxed=m&&v?.sandboxed,typeof navigator=="object"&&!m)u=navigator.userAgent,n=u.indexOf("Windows")>=0,L=u.indexOf("Macintosh")>=0,P=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=u.indexOf("Linux")>=0,b=!0,C=navigator.language,f=C;else if(typeof v=="object"){n=v.platform==="win32",L=v.platform==="darwin",T=v.platform==="linux",A=T&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,E=d,C=D,f=D;const o=v.env.VSCODE_NLS_CONFIG;if(o)try{const s=JSON.parse(o),c=s.availableLanguages["*"];C=s.locale,f=c||D,S=s._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var w;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function y(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=y;let p=0;L?p=1:n?p=3:T&&(p=2),e.isWindows=n,e.isMacintosh=L,e.isLinux=T,e.isLinuxSnap=A,e.isNative=I,e.isElectron=E,e.isWeb=b,e.isIOS=P,e.platform=p,e.userAgent=u,e.language=f;var l;(function(o){function s(){return e.language}o.value=s;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=c;function h(){return e.language==="en"}o.isDefault=h})(l=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=S,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let h=0,g=o.length;h<g;h++){const R=o[h];if(R.id===c.data.vscodeScheduleAsyncWork){o.splice(h,1),R.callback();return}}});let s=0;return c=>{const h=++s;o.push({id:h,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:h},"*")}}return o=>setTimeout(o)})();var i;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||P?2:n?1:3;let a=!0,r=!1;function t(){if(!r){r=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,a=new Uint16Array(o.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=t,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(te[32],ne([0,1,4]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const L=D.globals.vscode.process;n={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(te[10],ne([0,1,32]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,L=97,T=90,A=122,I=46,b=47,E=92,P=58,C=63;class f extends Error{constructor(p,l,i){let a;typeof l=="string"&&l.indexOf("not ")===0?(a="must not be",l=l.replace(/^not /,"")):a="must be";const r=p.indexOf(".")!==-1?"property":"argument";let t=`The "${p}" ${r} ${a} of type ${l}`;t+=`. Received type ${typeof i}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function S(y,p){if(typeof y!="string")throw new f(p,"string",y)}function u(y){return y===b||y===E}function v(y){return y===b}function d(y){return y>=n&&y<=T||y>=L&&y<=A}function m(y,p,l,i){let a="",r=0,t=-1,o=0,s=0;for(let c=0;c<=y.length;++c){if(c<y.length)s=y.charCodeAt(c);else{if(i(s))break;s=b}if(i(s)){if(!(t===c-1||o===1))if(o===2){if(a.length<2||r!==2||a.charCodeAt(a.length-1)!==I||a.charCodeAt(a.length-2)!==I){if(a.length>2){const h=a.lastIndexOf(l);h===-1?(a="",r=0):(a=a.slice(0,h),r=a.length-1-a.lastIndexOf(l)),t=c,o=0;continue}else if(a.length!==0){a="",r=0,t=c,o=0;continue}}p&&(a+=a.length>0?`${l}..`:"..",r=2)}else a.length>0?a+=`${l}${y.slice(t+1,c)}`:a=y.slice(t+1,c),r=c-t-1;t=c,o=0}else s===I&&o!==-1?++o:o=-1}return a}function w(y,p){if(p===null||typeof p!="object")throw new f("pathObject","Object",p);const l=p.dir||p.root,i=p.base||`${p.name||""}${p.ext||""}`;return l?l===p.root?`${l}${i}`:`${l}${y}${i}`:i}e.win32={resolve(...y){let p="",l="",i=!1;for(let a=y.length-1;a>=-1;a--){let r;if(a>=0){if(r=y[a],S(r,"path"),r.length===0)continue}else p.length===0?r=D.cwd():(r=D.env[`=${p}`]||D.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==p.toLowerCase()&&r.charCodeAt(2)===E)&&(r=`${p}\\`));const t=r.length;let o=0,s="",c=!1;const h=r.charCodeAt(0);if(t===1)u(h)&&(o=1,c=!0);else if(u(h))if(c=!0,u(r.charCodeAt(1))){let g=2,R=g;for(;g<t&&!u(r.charCodeAt(g));)g++;if(g<t&&g!==R){const _=r.slice(R,g);for(R=g;g<t&&u(r.charCodeAt(g));)g++;if(g<t&&g!==R){for(R=g;g<t&&!u(r.charCodeAt(g));)g++;(g===t||g!==R)&&(s=`\\\\${_}\\${r.slice(R,g)}`,o=g)}}}else o=1;else d(h)&&r.charCodeAt(1)===P&&(s=r.slice(0,2),o=2,t>2&&u(r.charCodeAt(2))&&(c=!0,o=3));if(s.length>0)if(p.length>0){if(s.toLowerCase()!==p.toLowerCase())continue}else p=s;if(i){if(p.length>0)break}else if(l=`${r.slice(o)}\\${l}`,i=c,c&&p.length>0)break}return l=m(l,!i,"\\",u),i?`${p}\\${l}`:`${p}${l}`||"."},normalize(y){S(y,"path");const p=y.length;if(p===0)return".";let l=0,i,a=!1;const r=y.charCodeAt(0);if(p===1)return v(r)?"\\":y;if(u(r))if(a=!0,u(y.charCodeAt(1))){let o=2,s=o;for(;o<p&&!u(y.charCodeAt(o));)o++;if(o<p&&o!==s){const c=y.slice(s,o);for(s=o;o<p&&u(y.charCodeAt(o));)o++;if(o<p&&o!==s){for(s=o;o<p&&!u(y.charCodeAt(o));)o++;if(o===p)return`\\\\${c}\\${y.slice(s)}\\`;o!==s&&(i=`\\\\${c}\\${y.slice(s,o)}`,l=o)}}}else l=1;else d(r)&&y.charCodeAt(1)===P&&(i=y.slice(0,2),l=2,p>2&&u(y.charCodeAt(2))&&(a=!0,l=3));let t=l<p?m(y.slice(l),!a,"\\",u):"";return t.length===0&&!a&&(t="."),t.length>0&&u(y.charCodeAt(p-1))&&(t+="\\"),i===void 0?a?`\\${t}`:t:a?`${i}\\${t}`:`${i}${t}`},isAbsolute(y){S(y,"path");const p=y.length;if(p===0)return!1;const l=y.charCodeAt(0);return u(l)||p>2&&d(l)&&y.charCodeAt(1)===P&&u(y.charCodeAt(2))},join(...y){if(y.length===0)return".";let p,l;for(let r=0;r<y.length;++r){const t=y[r];S(t,"path"),t.length>0&&(p===void 0?p=l=t:p+=`\\${t}`)}if(p===void 0)return".";let i=!0,a=0;if(typeof l=="string"&&u(l.charCodeAt(0))){++a;const r=l.length;r>1&&u(l.charCodeAt(1))&&(++a,r>2&&(u(l.charCodeAt(2))?++a:i=!1))}if(i){for(;a<p.length&&u(p.charCodeAt(a));)a++;a>=2&&(p=`\\${p.slice(a)}`)}return e.win32.normalize(p)},relative(y,p){if(S(y,"from"),S(p,"to"),y===p)return"";const l=e.win32.resolve(y),i=e.win32.resolve(p);if(l===i||(y=l.toLowerCase(),p=i.toLowerCase(),y===p))return"";let a=0;for(;a<y.length&&y.charCodeAt(a)===E;)a++;let r=y.length;for(;r-1>a&&y.charCodeAt(r-1)===E;)r--;const t=r-a;let o=0;for(;o<p.length&&p.charCodeAt(o)===E;)o++;let s=p.length;for(;s-1>o&&p.charCodeAt(s-1)===E;)s--;const c=s-o,h=t<c?t:c;let g=-1,R=0;for(;R<h;R++){const U=y.charCodeAt(a+R);if(U!==p.charCodeAt(o+R))break;U===E&&(g=R)}if(R!==h){if(g===-1)return i}else{if(c>h){if(p.charCodeAt(o+R)===E)return i.slice(o+R+1);if(R===2)return i.slice(o+R)}t>h&&(y.charCodeAt(a+R)===E?g=R:R===2&&(g=3)),g===-1&&(g=0)}let _="";for(R=a+g+1;R<=r;++R)(R===r||y.charCodeAt(R)===E)&&(_+=_.length===0?"..":"\\..");return o+=g,_.length>0?`${_}${i.slice(o,s)}`:(i.charCodeAt(o)===E&&++o,i.slice(o,s))},toNamespacedPath(y){if(typeof y!="string")return y;if(y.length===0)return"";const p=e.win32.resolve(y);if(p.length<=2)return y;if(p.charCodeAt(0)===E){if(p.charCodeAt(1)===E){const l=p.charCodeAt(2);if(l!==C&&l!==I)return`\\\\?\\UNC\\${p.slice(2)}`}}else if(d(p.charCodeAt(0))&&p.charCodeAt(1)===P&&p.charCodeAt(2)===E)return`\\\\?\\${p}`;return y},dirname(y){S(y,"path");const p=y.length;if(p===0)return".";let l=-1,i=0;const a=y.charCodeAt(0);if(p===1)return u(a)?y:".";if(u(a)){if(l=i=1,u(y.charCodeAt(1))){let o=2,s=o;for(;o<p&&!u(y.charCodeAt(o));)o++;if(o<p&&o!==s){for(s=o;o<p&&u(y.charCodeAt(o));)o++;if(o<p&&o!==s){for(s=o;o<p&&!u(y.charCodeAt(o));)o++;if(o===p)return y;o!==s&&(l=i=o+1)}}}}else d(a)&&y.charCodeAt(1)===P&&(l=p>2&&u(y.charCodeAt(2))?3:2,i=l);let r=-1,t=!0;for(let o=p-1;o>=i;--o)if(u(y.charCodeAt(o))){if(!t){r=o;break}}else t=!1;if(r===-1){if(l===-1)return".";r=l}return y.slice(0,r)},basename(y,p){p!==void 0&&S(p,"ext"),S(y,"path");let l=0,i=-1,a=!0,r;if(y.length>=2&&d(y.charCodeAt(0))&&y.charCodeAt(1)===P&&(l=2),p!==void 0&&p.length>0&&p.length<=y.length){if(p===y)return"";let t=p.length-1,o=-1;for(r=y.length-1;r>=l;--r){const s=y.charCodeAt(r);if(u(s)){if(!a){l=r+1;break}}else o===-1&&(a=!1,o=r+1),t>=0&&(s===p.charCodeAt(t)?--t==-1&&(i=r):(t=-1,i=o))}return l===i?i=o:i===-1&&(i=y.length),y.slice(l,i)}for(r=y.length-1;r>=l;--r)if(u(y.charCodeAt(r))){if(!a){l=r+1;break}}else i===-1&&(a=!1,i=r+1);return i===-1?"":y.slice(l,i)},extname(y){S(y,"path");let p=0,l=-1,i=0,a=-1,r=!0,t=0;y.length>=2&&y.charCodeAt(1)===P&&d(y.charCodeAt(0))&&(p=i=2);for(let o=y.length-1;o>=p;--o){const s=y.charCodeAt(o);if(u(s)){if(!r){i=o+1;break}continue}a===-1&&(r=!1,a=o+1),s===I?l===-1?l=o:t!==1&&(t=1):l!==-1&&(t=-1)}return l===-1||a===-1||t===0||t===1&&l===a-1&&l===i+1?"":y.slice(l,a)},format:w.bind(null,"\\"),parse(y){S(y,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return p;const l=y.length;let i=0,a=y.charCodeAt(0);if(l===1)return u(a)?(p.root=p.dir=y,p):(p.base=p.name=y,p);if(u(a)){if(i=1,u(y.charCodeAt(1))){let g=2,R=g;for(;g<l&&!u(y.charCodeAt(g));)g++;if(g<l&&g!==R){for(R=g;g<l&&u(y.charCodeAt(g));)g++;if(g<l&&g!==R){for(R=g;g<l&&!u(y.charCodeAt(g));)g++;g===l?i=g:g!==R&&(i=g+1)}}}}else if(d(a)&&y.charCodeAt(1)===P){if(l<=2)return p.root=p.dir=y,p;if(i=2,u(y.charCodeAt(2))){if(l===3)return p.root=p.dir=y,p;i=3}}i>0&&(p.root=y.slice(0,i));let r=-1,t=i,o=-1,s=!0,c=y.length-1,h=0;for(;c>=i;--c){if(a=y.charCodeAt(c),u(a)){if(!s){t=c+1;break}continue}o===-1&&(s=!1,o=c+1),a===I?r===-1?r=c:h!==1&&(h=1):r!==-1&&(h=-1)}return o!==-1&&(r===-1||h===0||h===1&&r===o-1&&r===t+1?p.base=p.name=y.slice(t,o):(p.name=y.slice(t,r),p.base=y.slice(t,o),p.ext=y.slice(r,o))),t>0&&t!==i?p.dir=y.slice(0,t-1):p.dir=p.root,p},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...y){let p="",l=!1;for(let i=y.length-1;i>=-1&&!l;i--){const a=i>=0?y[i]:D.cwd();S(a,"path"),a.length!==0&&(p=`${a}/${p}`,l=a.charCodeAt(0)===b)}return p=m(p,!l,"/",v),l?`/${p}`:p.length>0?p:"."},normalize(y){if(S(y,"path"),y.length===0)return".";const p=y.charCodeAt(0)===b,l=y.charCodeAt(y.length-1)===b;return y=m(y,!p,"/",v),y.length===0?p?"/":l?"./":".":(l&&(y+="/"),p?`/${y}`:y)},isAbsolute(y){return S(y,"path"),y.length>0&&y.charCodeAt(0)===b},join(...y){if(y.length===0)return".";let p;for(let l=0;l<y.length;++l){const i=y[l];S(i,"path"),i.length>0&&(p===void 0?p=i:p+=`/${i}`)}return p===void 0?".":e.posix.normalize(p)},relative(y,p){if(S(y,"from"),S(p,"to"),y===p||(y=e.posix.resolve(y),p=e.posix.resolve(p),y===p))return"";const l=1,i=y.length,a=i-l,r=1,t=p.length-r,o=a<t?a:t;let s=-1,c=0;for(;c<o;c++){const g=y.charCodeAt(l+c);if(g!==p.charCodeAt(r+c))break;g===b&&(s=c)}if(c===o)if(t>o){if(p.charCodeAt(r+c)===b)return p.slice(r+c+1);if(c===0)return p.slice(r+c)}else a>o&&(y.charCodeAt(l+c)===b?s=c:c===0&&(s=0));let h="";for(c=l+s+1;c<=i;++c)(c===i||y.charCodeAt(c)===b)&&(h+=h.length===0?"..":"/..");return`${h}${p.slice(r+s)}`},toNamespacedPath(y){return y},dirname(y){if(S(y,"path"),y.length===0)return".";const p=y.charCodeAt(0)===b;let l=-1,i=!0;for(let a=y.length-1;a>=1;--a)if(y.charCodeAt(a)===b){if(!i){l=a;break}}else i=!1;return l===-1?p?"/":".":p&&l===1?"//":y.slice(0,l)},basename(y,p){p!==void 0&&S(p,"ext"),S(y,"path");let l=0,i=-1,a=!0,r;if(p!==void 0&&p.length>0&&p.length<=y.length){if(p===y)return"";let t=p.length-1,o=-1;for(r=y.length-1;r>=0;--r){const s=y.charCodeAt(r);if(s===b){if(!a){l=r+1;break}}else o===-1&&(a=!1,o=r+1),t>=0&&(s===p.charCodeAt(t)?--t==-1&&(i=r):(t=-1,i=o))}return l===i?i=o:i===-1&&(i=y.length),y.slice(l,i)}for(r=y.length-1;r>=0;--r)if(y.charCodeAt(r)===b){if(!a){l=r+1;break}}else i===-1&&(a=!1,i=r+1);return i===-1?"":y.slice(l,i)},extname(y){S(y,"path");let p=-1,l=0,i=-1,a=!0,r=0;for(let t=y.length-1;t>=0;--t){const o=y.charCodeAt(t);if(o===b){if(!a){l=t+1;break}continue}i===-1&&(a=!1,i=t+1),o===I?p===-1?p=t:r!==1&&(r=1):p!==-1&&(r=-1)}return p===-1||i===-1||r===0||r===1&&p===i-1&&p===l+1?"":y.slice(p,i)},format:w.bind(null,"/"),parse(y){S(y,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return p;const l=y.charCodeAt(0)===b;let i;l?(p.root="/",i=1):i=0;let a=-1,r=0,t=-1,o=!0,s=y.length-1,c=0;for(;s>=i;--s){const h=y.charCodeAt(s);if(h===b){if(!o){r=s+1;break}continue}t===-1&&(o=!1,t=s+1),h===I?a===-1?a=s:c!==1&&(c=1):a!==-1&&(c=-1)}if(t!==-1){const h=r===0&&l?1:r;a===-1||c===0||c===1&&a===t-1&&a===r+1?p.base=p.name=y.slice(h,t):(p.name=y.slice(h,a),p.base=y.slice(h,t),p.ext=y.slice(a,t))}return r>0?p.dir=y.slice(0,r-1):l&&(p.dir="/"),p},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[102],ne([0,1,10]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var n;(function(C){C.text="text/plain",C.binary="application/octet-stream",C.unknown="application/unknown",C.markdown="text/markdown",C.latex="text/latex"})(n=e.Mimes||(e.Mimes={}));const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(C){const f=(0,D.extname)(C),S=L[f.toLowerCase()];return S!==void 0?S:I(C)}e.getMediaOrTextMime=A;function I(C){const f=(0,D.extname)(C);return T[f.toLowerCase()]}e.getMediaMime=I;function b(C){for(const f in T)if(T[f]===C)return f}e.getExtensionForMimeType=b;const E=/^(.+)\/(.+?)(;.+)?$/;function P(C,f){const S=E.exec(C);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:f?void 0:C}e.normalizeMimeType=P}),define(te[103],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(D=e.Source||(e.Source={}));var n;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(T,...A){const I=A.reduce((P,C)=>(P[C]=!0,P),{}),b=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(P=>!I[P]).forEach(P=>{for(let C=0;C<b.length;C++)if(P.search(b[C])!==-1){delete T[P];break}})}e.sanitizeProcessEnvironment=L}),function(Y,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var n in D)(typeof exports=="object"?exports:Y)[n]=D[n]}}(typeof self!="undefined"?self:this,function(){return function(Y){var e={};function D(n){if(e[n])return e[n].exports;var L=e[n]={i:n,l:!1,exports:{}};return Y[n].call(L.exports,L,L.exports,D),L.l=!0,L.exports}return D.m=Y,D.c=e,D.d=function(n,L,T){D.o(n,L)||Object.defineProperty(n,L,{enumerable:!0,get:T})},D.r=function(n){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},D.t=function(n,L){if(1&L&&(n=D(n)),8&L||4&L&&typeof n=="object"&&n&&n.__esModule)return n;var T=Object.create(null);if(D.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:n}),2&L&&typeof n!="string")for(var A in n)D.d(T,A,function(I){return n[I]}.bind(null,A));return T},D.n=function(n){var L=n&&n.__esModule?function(){return n.default}:function(){return n};return D.d(L,"a",L),L},D.o=function(n,L){return Object.prototype.hasOwnProperty.call(n,L)},D.p="",D(D.s=0)}([function(Y,e,D){(function(n){var L;e=Y.exports=O,L=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var ie=Array.prototype.slice.call(arguments,0);ie.unshift("SEMVER"),console.log.apply(console,ie)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],b=e.src=[],E=0,P=E++;b[P]="0|[1-9]\\d*";var C=E++;b[C]="[0-9]+";var f=E++;b[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=E++;b[S]="("+b[P]+")\\.("+b[P]+")\\.("+b[P]+")";var u=E++;b[u]="("+b[C]+")\\.("+b[C]+")\\.("+b[C]+")";var v=E++;b[v]="(?:"+b[P]+"|"+b[f]+")";var d=E++;b[d]="(?:"+b[C]+"|"+b[f]+")";var m=E++;b[m]="(?:-("+b[v]+"(?:\\."+b[v]+")*))";var w=E++;b[w]="(?:-?("+b[d]+"(?:\\."+b[d]+")*))";var y=E++;b[y]="[0-9A-Za-z-]+";var p=E++;b[p]="(?:\\+("+b[y]+"(?:\\."+b[y]+")*))";var l=E++,i="v?"+b[S]+b[m]+"?"+b[p]+"?";b[l]="^"+i+"$";var a="[v=\\s]*"+b[u]+b[w]+"?"+b[p]+"?",r=E++;b[r]="^"+a+"$";var t=E++;b[t]="((?:<|>)?=?)";var o=E++;b[o]=b[C]+"|x|X|\\*";var s=E++;b[s]=b[P]+"|x|X|\\*";var c=E++;b[c]="[v=\\s]*("+b[s]+")(?:\\.("+b[s]+")(?:\\.("+b[s]+")(?:"+b[m]+")?"+b[p]+"?)?)?";var h=E++;b[h]="[v=\\s]*("+b[o]+")(?:\\.("+b[o]+")(?:\\.("+b[o]+")(?:"+b[w]+")?"+b[p]+"?)?)?";var g=E++;b[g]="^"+b[t]+"\\s*"+b[c]+"$";var R=E++;b[R]="^"+b[t]+"\\s*"+b[h]+"$";var _=E++;b[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=E++;b[U]="(?:~>?)";var F=E++;b[F]="(\\s*)"+b[U]+"\\s+",I[F]=new RegExp(b[F],"g");var k=E++;b[k]="^"+b[U]+b[c]+"$";var M=E++;b[M]="^"+b[U]+b[h]+"$";var $=E++;b[$]="(?:\\^)";var x=E++;b[x]="(\\s*)"+b[$]+"\\s+",I[x]=new RegExp(b[x],"g");var z=E++;b[z]="^"+b[$]+b[c]+"$";var G=E++;b[G]="^"+b[$]+b[h]+"$";var ee=E++;b[ee]="^"+b[t]+"\\s*("+a+")$|^$";var q=E++;b[q]="^"+b[t]+"\\s*("+i+")$|^$";var j=E++;b[j]="(\\s*)"+b[t]+"\\s*("+a+"|"+b[c]+")",I[j]=new RegExp(b[j],"g");var K=E++;b[K]="^\\s*("+b[c]+")\\s+-\\s+("+b[c]+")\\s*$";var V=E++;b[V]="^\\s*("+b[h]+")\\s+-\\s+("+b[h]+")\\s*$";var Q=E++;b[Q]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)L(Z,b[Z]),I[Z]||(I[Z]=new RegExp(b[Z]));function B(ie,ae){if(ie instanceof O)return ie;if(typeof ie!="string"||ie.length>T||!(ae?I[r]:I[l]).test(ie))return null;try{return new O(ie,ae)}catch{return null}}function O(ie,ae){if(ie instanceof O){if(ie.loose===ae)return ie;ie=ie.version}else if(typeof ie!="string")throw new TypeError("Invalid Version: "+ie);if(ie.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof O))return new O(ie,ae);L("SemVer",ie,ae),this.loose=ae;var le=ie.trim().match(ae?I[r]:I[l]);if(!le)throw new TypeError("Invalid Version: "+ie);if(this.raw=ie,this.major=+le[1],this.minor=+le[2],this.patch=+le[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");le[4]?this.prerelease=le[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Ee=+ye;if(Ee>=0&&Ee<A)return Ee}return ye}):this.prerelease=[],this.build=le[5]?le[5].split("."):[],this.format()}e.parse=B,e.valid=function(ie,ae){var le=B(ie,ae);return le?le.version:null},e.clean=function(ie,ae){var le=B(ie.trim().replace(/^[=v]+/,""),ae);return le?le.version:null},e.SemVer=O,O.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},O.prototype.toString=function(){return this.version},O.prototype.compare=function(ie){return L("SemVer.compare",this.version,this.loose,ie),ie instanceof O||(ie=new O(ie,this.loose)),this.compareMain(ie)||this.comparePre(ie)},O.prototype.compareMain=function(ie){return ie instanceof O||(ie=new O(ie,this.loose)),W(this.major,ie.major)||W(this.minor,ie.minor)||W(this.patch,ie.patch)},O.prototype.comparePre=function(ie){if(ie instanceof O||(ie=new O(ie,this.loose)),this.prerelease.length&&!ie.prerelease.length)return-1;if(!this.prerelease.length&&ie.prerelease.length)return 1;if(!this.prerelease.length&&!ie.prerelease.length)return 0;var ae=0;do{var le=this.prerelease[ae],ye=ie.prerelease[ae];if(L("prerelease compare",ae,le,ye),le===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(le===void 0)return-1;if(le!==ye)return W(le,ye)}while(++ae)},O.prototype.inc=function(ie,ae){switch(ie){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var le=this.prerelease.length;--le>=0;)typeof this.prerelease[le]=="number"&&(this.prerelease[le]++,le=-2);le===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+ie)}return this.format(),this.raw=this.version,this},e.inc=function(ie,ae,le,ye){typeof le=="string"&&(ye=le,le=void 0);try{return new O(ie,le).inc(ae,ye).version}catch{return null}},e.diff=function(ie,ae){if(ue(ie,ae))return null;var le=B(ie),ye=B(ae);if(le.prerelease.length||ye.prerelease.length){for(var Ee in le)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&le[Ee]!==ye[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in le)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&le[Ee]!==ye[Ee])return Ee},e.compareIdentifiers=W;var N=/^[0-9]+$/;function W(ie,ae){var le=N.test(ie),ye=N.test(ae);return le&&ye&&(ie=+ie,ae=+ae),le&&!ye?-1:ye&&!le?1:ie<ae?-1:ie>ae?1:0}function H(ie,ae,le){return new O(ie,le).compare(new O(ae,le))}function re(ie,ae,le){return H(ie,ae,le)>0}function se(ie,ae,le){return H(ie,ae,le)<0}function ue(ie,ae,le){return H(ie,ae,le)===0}function de(ie,ae,le){return H(ie,ae,le)!==0}function we(ie,ae,le){return H(ie,ae,le)>=0}function pe(ie,ae,le){return H(ie,ae,le)<=0}function ge(ie,ae,le,ye){var Ee;switch(ae){case"===":typeof ie=="object"&&(ie=ie.version),typeof le=="object"&&(le=le.version),Ee=ie===le;break;case"!==":typeof ie=="object"&&(ie=ie.version),typeof le=="object"&&(le=le.version),Ee=ie!==le;break;case"":case"=":case"==":Ee=ue(ie,le,ye);break;case"!=":Ee=de(ie,le,ye);break;case">":Ee=re(ie,le,ye);break;case">=":Ee=we(ie,le,ye);break;case"<":Ee=se(ie,le,ye);break;case"<=":Ee=pe(ie,le,ye);break;default:throw new TypeError("Invalid operator: "+ae)}return Ee}function be(ie,ae){if(ie instanceof be){if(ie.loose===ae)return ie;ie=ie.value}if(!(this instanceof be))return new be(ie,ae);L("comparator",ie,ae),this.loose=ae,this.parse(ie),this.semver===Re?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(ie,ae){return W(ae,ie)},e.major=function(ie,ae){return new O(ie,ae).major},e.minor=function(ie,ae){return new O(ie,ae).minor},e.patch=function(ie,ae){return new O(ie,ae).patch},e.compare=H,e.compareLoose=function(ie,ae){return H(ie,ae,!0)},e.rcompare=function(ie,ae,le){return H(ae,ie,le)},e.sort=function(ie,ae){return ie.sort(function(le,ye){return e.compare(le,ye,ae)})},e.rsort=function(ie,ae){return ie.sort(function(le,ye){return e.rcompare(le,ye,ae)})},e.gt=re,e.lt=se,e.eq=ue,e.neq=de,e.gte=we,e.lte=pe,e.cmp=ge,e.Comparator=be;var Re={};function Le(ie,ae){if(ie instanceof Le)return ie.loose===ae?ie:new Le(ie.raw,ae);if(ie instanceof be)return new Le(ie.value,ae);if(!(this instanceof Le))return new Le(ie,ae);if(this.loose=ae,this.raw=ie,this.set=ie.split(/\s*\|\|\s*/).map(function(le){return this.parseRange(le.trim())},this).filter(function(le){return le.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ie);this.format()}function Te(ie){return!ie||ie.toLowerCase()==="x"||ie==="*"}function qe(ie,ae,le,ye,Ee,Me,ke,Oe,_e,X,oe,ce,fe){return((ae=Te(le)?"":Te(ye)?">="+le+".0.0":Te(Ee)?">="+le+"."+ye+".0":">="+ae)+" "+(Oe=Te(_e)?"":Te(X)?"<"+(+_e+1)+".0.0":Te(oe)?"<"+_e+"."+(+X+1)+".0":ce?"<="+_e+"."+X+"."+oe+"-"+ce:"<="+Oe)).trim()}function Je(ie,ae){for(var le=0;le<ie.length;le++)if(!ie[le].test(ae))return!1;if(ae.prerelease.length){for(le=0;le<ie.length;le++)if(L(ie[le].semver),ie[le].semver!==Re&&ie[le].semver.prerelease.length>0){var ye=ie[le].semver;if(ye.major===ae.major&&ye.minor===ae.minor&&ye.patch===ae.patch)return!0}return!1}return!0}function Ge(ie,ae,le){try{ae=new Le(ae,le)}catch{return!1}return ae.test(ie)}function je(ie,ae,le,ye){var Ee,Me,ke,Oe,_e;switch(ie=new O(ie,ye),ae=new Le(ae,ye),le){case">":Ee=re,Me=pe,ke=se,Oe=">",_e=">=";break;case"<":Ee=se,Me=we,ke=re,Oe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ge(ie,ae,ye))return!1;for(var X=0;X<ae.set.length;++X){var oe=ae.set[X],ce=null,fe=null;if(oe.forEach(function(me){me.semver===Re&&(me=new be(">=0.0.0")),ce=ce||me,fe=fe||me,Ee(me.semver,ce.semver,ye)?ce=me:ke(me.semver,fe.semver,ye)&&(fe=me)}),ce.operator===Oe||ce.operator===_e||(!fe.operator||fe.operator===Oe)&&Me(ie,fe.semver)||fe.operator===_e&&ke(ie,fe.semver))return!1}return!0}be.prototype.parse=function(ie){var ae=this.loose?I[ee]:I[q],le=ie.match(ae);if(!le)throw new TypeError("Invalid comparator: "+ie);this.operator=le[1],this.operator==="="&&(this.operator=""),le[2]?this.semver=new O(le[2],this.loose):this.semver=Re},be.prototype.toString=function(){return this.value},be.prototype.test=function(ie){return L("Comparator.test",ie,this.loose),this.semver===Re||(typeof ie=="string"&&(ie=new O(ie,this.loose)),ge(ie,this.operator,this.semver,this.loose))},be.prototype.intersects=function(ie,ae){if(!(ie instanceof be))throw new TypeError("a Comparator is required");var le;if(this.operator==="")return le=new Le(ie.value,ae),Ge(this.value,le,ae);if(ie.operator==="")return le=new Le(this.value,ae),Ge(ie.semver,le,ae);var ye=!(this.operator!==">="&&this.operator!==">"||ie.operator!==">="&&ie.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||ie.operator!=="<="&&ie.operator!=="<"),Me=this.semver.version===ie.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||ie.operator!==">="&&ie.operator!=="<="),Oe=ge(this.semver,"<",ie.semver,ae)&&(this.operator===">="||this.operator===">")&&(ie.operator==="<="||ie.operator==="<"),_e=ge(this.semver,">",ie.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(ie.operator===">="||ie.operator===">");return ye||Ee||Me&&ke||Oe||_e},e.Range=Le,Le.prototype.format=function(){return this.range=this.set.map(function(ie){return ie.join(" ").trim()}).join("||").trim(),this.range},Le.prototype.toString=function(){return this.range},Le.prototype.parseRange=function(ie){var ae=this.loose;ie=ie.trim(),L("range",ie,ae);var le=ae?I[V]:I[K];ie=ie.replace(le,qe),L("hyphen replace",ie),ie=ie.replace(I[j],"$1$2$3"),L("comparator trim",ie,I[j]),ie=(ie=(ie=ie.replace(I[F],"$1~")).replace(I[x],"$1^")).split(/\s+/).join(" ");var ye=ae?I[ee]:I[q],Ee=ie.split(" ").map(function(Me){return function(ke,Oe){return L("comp",ke),ke=function(_e,X){return _e.trim().split(/\s+/).map(function(oe){return function(ce,fe){L("caret",ce,fe);var me=fe?I[G]:I[z];return ce.replace(me,function(De,Se,Pe,Ie,Ce){var Ae;return L("caret",ce,De,Se,Pe,Ie,Ce),Te(Se)?Ae="":Te(Pe)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":Te(Ie)?Ae=Se==="0"?">="+Se+"."+Pe+".0 <"+Se+"."+(+Pe+1)+".0":">="+Se+"."+Pe+".0 <"+(+Se+1)+".0.0":Ce?(L("replaceCaret pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),Ae=Se==="0"?Pe==="0"?">="+Se+"."+Pe+"."+Ie+Ce+" <"+Se+"."+Pe+"."+(+Ie+1):">="+Se+"."+Pe+"."+Ie+Ce+" <"+Se+"."+(+Pe+1)+".0":">="+Se+"."+Pe+"."+Ie+Ce+" <"+(+Se+1)+".0.0"):(L("no pr"),Ae=Se==="0"?Pe==="0"?">="+Se+"."+Pe+"."+Ie+" <"+Se+"."+Pe+"."+(+Ie+1):">="+Se+"."+Pe+"."+Ie+" <"+Se+"."+(+Pe+1)+".0":">="+Se+"."+Pe+"."+Ie+" <"+(+Se+1)+".0.0"),L("caret return",Ae),Ae})}(oe,X)}).join(" ")}(ke,Oe),L("caret",ke),ke=function(_e,X){return _e.trim().split(/\s+/).map(function(oe){return function(ce,fe){var me=fe?I[M]:I[k];return ce.replace(me,function(De,Se,Pe,Ie,Ce){var Ae;return L("tilde",ce,De,Se,Pe,Ie,Ce),Te(Se)?Ae="":Te(Pe)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":Te(Ie)?Ae=">="+Se+"."+Pe+".0 <"+Se+"."+(+Pe+1)+".0":Ce?(L("replaceTilde pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),Ae=">="+Se+"."+Pe+"."+Ie+Ce+" <"+Se+"."+(+Pe+1)+".0"):Ae=">="+Se+"."+Pe+"."+Ie+" <"+Se+"."+(+Pe+1)+".0",L("tilde return",Ae),Ae})}(oe,X)}).join(" ")}(ke,Oe),L("tildes",ke),ke=function(_e,X){return L("replaceXRanges",_e,X),_e.split(/\s+/).map(function(oe){return function(ce,fe){ce=ce.trim();var me=fe?I[R]:I[g];return ce.replace(me,function(De,Se,Pe,Ie,Ce,Ae){L("xRange",ce,De,Se,Pe,Ie,Ce,Ae);var Ne=Te(Pe),ze=Ne||Te(Ie),We=ze||Te(Ce);return Se==="="&&We&&(Se=""),Ne?De=Se===">"||Se==="<"?"<0.0.0":"*":Se&&We?(ze&&(Ie=0),We&&(Ce=0),Se===">"?(Se=">=",ze?(Pe=+Pe+1,Ie=0,Ce=0):We&&(Ie=+Ie+1,Ce=0)):Se==="<="&&(Se="<",ze?Pe=+Pe+1:Ie=+Ie+1),De=Se+Pe+"."+Ie+"."+Ce):ze?De=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":We&&(De=">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0"),L("xRange return",De),De})}(oe,X)}).join(" ")}(ke,Oe),L("xrange",ke),ke=function(_e,X){return L("replaceStars",_e,X),_e.trim().replace(I[Q],"")}(ke,Oe),L("stars",ke),ke}(Me,ae)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(Me){return!!Me.match(ye)})),Ee=Ee.map(function(Me){return new be(Me,ae)})},Le.prototype.intersects=function(ie,ae){if(!(ie instanceof Le))throw new TypeError("a Range is required");return this.set.some(function(le){return le.every(function(ye){return ie.set.some(function(Ee){return Ee.every(function(Me){return ye.intersects(Me,ae)})})})})},e.toComparators=function(ie,ae){return new Le(ie,ae).set.map(function(le){return le.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Le.prototype.test=function(ie){if(!ie)return!1;typeof ie=="string"&&(ie=new O(ie,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Je(this.set[ae],ie))return!0;return!1},e.satisfies=Ge,e.maxSatisfying=function(ie,ae,le){var ye=null,Ee=null;try{var Me=new Le(ae,le)}catch{return null}return ie.forEach(function(ke){Me.test(ke)&&(ye&&Ee.compare(ke)!==-1||(Ee=new O(ye=ke,le)))}),ye},e.minSatisfying=function(ie,ae,le){var ye=null,Ee=null;try{var Me=new Le(ae,le)}catch{return null}return ie.forEach(function(ke){Me.test(ke)&&(ye&&Ee.compare(ke)!==1||(Ee=new O(ye=ke,le)))}),ye},e.validRange=function(ie,ae){try{return new Le(ie,ae).range||"*"}catch{return null}},e.ltr=function(ie,ae,le){return je(ie,ae,"<",le)},e.gtr=function(ie,ae,le){return je(ie,ae,">",le)},e.outside=je,e.prerelease=function(ie,ae){var le=B(ie,ae);return le&&le.prerelease.length?le.prerelease:null},e.intersects=function(ie,ae,le){return ie=new Le(ie,le),ae=new Le(ae,le),ie.intersects(ae)},e.coerce=function(ie){if(ie instanceof O)return ie;if(typeof ie!="string")return null;var ae=ie.match(I[_]);return ae==null?null:B((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,D(1))},function(Y,e){var D,n,L=Y.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function I(d){if(D===setTimeout)return setTimeout(d,0);if((D===T||!D)&&setTimeout)return D=setTimeout,setTimeout(d,0);try{return D(d,0)}catch{try{return D.call(null,d,0)}catch{return D.call(this,d,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:T}catch{D=T}try{n=typeof clearTimeout=="function"?clearTimeout:A}catch{n=A}})();var b,E=[],P=!1,C=-1;function f(){P&&b&&(P=!1,b.length?E=b.concat(E):C=-1,E.length&&S())}function S(){if(!P){var d=I(f);P=!0;for(var m=E.length;m;){for(b=E,E=[];++C<m;)b&&b[C].run();C=-1,m=E.length}b=null,P=!1,function(w){if(n===clearTimeout)return clearTimeout(w);if((n===A||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(w);try{n(w)}catch{try{return n.call(null,w)}catch{return n.call(this,w)}}}(d)}}function u(d,m){this.fun=d,this.array=m}function v(){}L.nextTick=function(d){var m=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)m[w-1]=arguments[w];E.push(new u(d,m)),E.length!==1||P||I(S)},u.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=v,L.addListener=v,L.once=v,L.off=v,L.removeListener=v,L.removeAllListeners=v,L.emit=v,L.prependListener=v,L.prependOnceListener=v,L.listeners=function(d){return[]},L.binding=function(d){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(d){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(te[104],ne([0,1]),function(Y,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(I,b,E){this.level=I,this.key=b,this.value=E,this.forward=[]}}const L=void 0;class T{constructor(I,b=2**16){this.comparator=I,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(b)|0),this._header=new n(this._maxLevel,L,L)}get size(){return this._size}clear(){this._header=new n(this._maxLevel,L,L)}has(I){return Boolean(T._search(this,I,this.comparator))}get(I){return T._search(this,I,this.comparator)?.value}set(I,b){return T._insert(this,I,b,this.comparator)&&(this._size+=1),this}delete(I){const b=T._delete(this,I,this.comparator);return b&&(this._size-=1),b}forEach(I,b){let E=this._header.forward[0];for(;E;)I.call(b,E.value,E.key,this),E=E.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",b=this._header.forward[0];for(;b;)I+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return I}static _search(I,b,E){let P=I._header;for(let C=I._level-1;C>=0;C--)for(;P.forward[C]&&E(P.forward[C].key,b)<0;)P=P.forward[C];if(P=P.forward[0],P&&E(P.key,b)===0)return P}static _insert(I,b,E,P){let C=[],f=I._header;for(let S=I._level-1;S>=0;S--){for(;f.forward[S]&&P(f.forward[S].key,b)<0;)f=f.forward[S];C[S]=f}if(f=f.forward[0],f&&P(f.key,b)===0)return f.value=E,!1;{let S=T._randomLevel(I);if(S>I._level){for(let u=I._level;u<S;u++)C[u]=I._header;I._level=S}f=new n(S,b,E);for(let u=0;u<S;u++)f.forward[u]=C[u].forward[u],C[u].forward[u]=f;return!0}}static _randomLevel(I,b=.5){let E=1;for(;Math.random()<b&&E<I._maxLevel;)E+=1;return E}static _delete(I,b,E){let P=[],C=I._header;for(let f=I._level-1;f>=0;f--){for(;C.forward[f]&&E(C.forward[f].key,b)<0;)C=C.forward[f];P[f]=C}if(C=C.forward[0],!C||E(C.key,b)!==0)return!1;for(let f=0;f<I._level&&P[f].forward[f]===C;f++)P[f].forward[f]=C.forward[f];for(;I._level>0&&I._header.forward[I._level-1]===L;)I._level-=1;return!0}}e.SkipList=T}),define(te[105],ne([0,1,4]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=D.globals.performance&&typeof D.globals.performance.now=="function";class L{constructor(A){this._highResolution=n&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new L(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=L}),define(te[3],ne([0,1,9,68,2,101,105]),function(Y,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(p){p.None=()=>L.Disposable.None;function l(ee){return(q,j=null,K)=>{let V=!1,Q;return Q=ee(Z=>{if(!V)return Q?Q.dispose():V=!0,q.call(j,Z)},null,K),V&&Q.dispose(),Q}}p.once=l;function i(ee,q){return c((j,K=null,V)=>ee(Q=>j.call(K,q(Q)),null,V))}p.map=i;function a(ee,q){return c((j,K=null,V)=>ee(Q=>{q(Q),j.call(K,Q)},null,V))}p.forEach=a;function r(ee,q){return c((j,K=null,V)=>ee(Q=>q(Q)&&j.call(K,Q),null,V))}p.filter=r;function t(ee){return ee}p.signal=t;function o(...ee){return(q,j=null,K)=>(0,L.combinedDisposable)(...ee.map(V=>V(Q=>q.call(j,Q),null,K)))}p.any=o;function s(ee,q,j){let K=j;return i(ee,V=>(K=q(K,V),K))}p.reduce=s;function c(ee){let q;const j=new f({onFirstListenerAdd(){q=ee(j.fire,j)},onLastListenerRemove(){q.dispose()}});return j.event}function h(ee,q,j,K=100,V=!1){let Q,Z,B=0;return ee(O=>{B++,Q=j(Q,O),V&&!Z&&(q(Q),Q=void 0),clearTimeout(Z),Z=setTimeout(()=>{const N=Q;Q=void 0,Z=void 0,(!V||B>1)&&q(N),B=0},K)})}p.debouncedListener=h;function g(ee,q,j=100,K=!1,V){let Q,Z,B,O=0;const N=new f({leakWarningThreshold:V,onFirstListenerAdd(){Q=ee(W=>{O++,Z=q(Z,W),K&&!B&&(N.fire(Z),Z=void 0),clearTimeout(B),B=setTimeout(()=>{const H=Z;Z=void 0,B=void 0,(!K||O>1)&&N.fire(H),O=0},j)})},onLastListenerRemove(){Q.dispose()}});return N.event}p.debounce=g;function R(ee,q=(j,K)=>j===K){let j=!0,K;return r(ee,V=>{const Q=j||!q(V,K);return j=!1,K=V,Q})}p.latch=R;function _(ee,q){return[p.filter(ee,q),p.filter(ee,j=>!q(j))]}p.split=_;function U(ee,q=!1,j=[]){let K=j.slice(),V=ee(B=>{K?K.push(B):Z.fire(B)});const Q=()=>{K&&K.forEach(B=>Z.fire(B)),K=null},Z=new f({onFirstListenerAdd(){V||(V=ee(B=>Z.fire(B)))},onFirstListenerDidAdd(){K&&(q?setTimeout(Q):Q())},onLastListenerRemove(){V&&V.dispose(),V=null}});return Z.event}p.buffer=U;class F{constructor(q){this.event=q}map(q){return new F(i(this.event,q))}forEach(q){return new F(a(this.event,q))}filter(q){return new F(r(this.event,q))}reduce(q,j){return new F(s(this.event,q,j))}latch(){return new F(R(this.event))}debounce(q,j=100,K=!1,V){return new F(g(this.event,q,j,K,V))}on(q,j,K){return this.event(q,j,K)}once(q,j,K){return l(this.event)(q,j,K)}}function k(ee){return new F(ee)}p.chain=k;function M(ee,q,j=K=>K){const K=(...B)=>Z.fire(j(...B)),V=()=>ee.on(q,K),Q=()=>ee.removeListener(q,K),Z=new f({onFirstListenerAdd:V,onLastListenerRemove:Q});return Z.event}p.fromNodeEventEmitter=M;function $(ee,q,j=K=>K){const K=(...B)=>Z.fire(j(...B)),V=()=>ee.addEventListener(q,K),Q=()=>ee.removeEventListener(q,K),Z=new f({onFirstListenerAdd:V,onLastListenerRemove:Q});return Z.event}p.fromDOMEventEmitter=$;function x(ee){return new Promise(q=>l(ee)(q))}p.toPromise=x;function z(ee,q){return q(void 0),ee(j=>q(j))}p.runAndSubscribe=z;function G(ee,q){let j=null;function K(Q){j?.dispose(),j=new L.DisposableStore,q(Q,j)}K(void 0);const V=ee(Q=>K(Q));return(0,L.toDisposable)(()=>{V.dispose(),j?.dispose()})}p.runAndSubscribeWithStore=G})(I=e.Event||(e.Event={}));class b{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${b._idPool++}`}start(l){this._stopWatch=new A.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}b._idPool=0;let E=-1;function P(p){const l=E;return E=p,{dispose(){E=l}}}e.setGlobalLeakWarningThreshold=P;class C{constructor(l,i=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=i,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let i=E;if(typeof this.customThreshold=="number"&&(i=this.customThreshold),i<=0||l<i)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(a)||0;if(this._stacks.set(a,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=i*.5;let t,o=0;for(const[s,c]of this._stacks)(!t||o<c)&&(t=s,o=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${o}):`),console.warn(t)}return()=>{const t=this._stacks.get(a)||0;this._stacks.set(a,t-1)}}}class f{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=E>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new b(this._options._profName):void 0}get event(){return this._event||(this._event=(l,i,a)=>{this._listeners||(this._listeners=new T.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(i?[l,i]:l);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,i);const o=this._leakageMon?.check(this._listeners.size),s=(0,L.toDisposable)(()=>{o&&o(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof L.DisposableStore?a.add(s):Array.isArray(a)&&a.push(s),s}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let i of this._listeners)this._deliveryQueue.push([i,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[i,a]=this._deliveryQueue.shift();try{typeof i=="function"?i.call(void 0,a):i[0].call(i[1],a)}catch(r){(0,D.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=f;class S extends f{async fireAsync(l,i,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,l]);for(;this._asyncDeliveryQueue.size>0&&!i.isCancellationRequested;){const[r,t]=this._asyncDeliveryQueue.shift(),o=[],s={...t,token:i,waitUntil:c=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");a&&(c=a(c,typeof r=="function"?r:r[0])),o.push(c)}};try{typeof r=="function"?r.call(void 0,s):r[0].call(r[1],s)}catch(c){(0,D.onUnexpectedError)(c);continue}Object.freeze(o),await Promise.allSettled(o).then(c=>{for(const h of c)h.status==="rejected"&&(0,D.onUnexpectedError)(h.reason)})}}}}e.AsyncEmitter=S;class u extends f{constructor(l){super(l);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=u;class v extends u{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=v;class d extends f{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(i=>super.fire(i)),this._queuedEvents=[]})}}e.MicrotaskEmitter=d;class m{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const i={event:l,listener:null};this.events.push(i),this.hasListeners&&this.hook(i);const a=()=>{this.hasListeners&&this.unhook(i);const r=this.events.indexOf(i);this.events.splice(r,1)};return(0,L.toDisposable)((0,n.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(i=>this.emitter.fire(i))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=m;class w{constructor(){this.buffers=[]}wrapEvent(l){return(i,a,r)=>l(t=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>i.call(a,t)):i.call(a,t)},void 0,r)}bufferEvents(l){const i=[];this.buffers.push(i);const a=l();return this.buffers.pop(),i.forEach(r=>r()),a}}e.EventBufferer=w;class y{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=L.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=y}),define(te[23],ne([0,1,3]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(I,b){const E=setTimeout(I.bind(b),0);return{dispose(){clearTimeout(E)}}});var L;(function(I){function b(E){return E===I.None||E===I.Cancelled||E instanceof T?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}I.isCancellationToken=b,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(L=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=L.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=A}),define(te[106],ne([0,1,23]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(A){this.task=A,this.result=null}get(){if(this.result)return this.result;const A=new D.CancellationTokenSource,I=this.task(A.token);return this.result={promise:I,dispose:()=>{this.result=null,A.cancel(),A.dispose()}},this.result}}e.Cache=n;class L{constructor(A){this.computeFn=A,this.lastCache=void 0,this.lastArgKey=void 0}get(A){const I=JSON.stringify(A);return this.lastArgKey!==I&&(this.lastArgKey=I,this.lastCache=this.computeFn(A)),this.lastCache}}e.LRUCachedComputed=L}),define(te[40],ne([0,1,9,2]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(y){const p=y;return p?[p.on,p.pause,p.resume,p.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=L;function T(y){const p=y;return p?L(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=T;function A(y,p){return new I(y,p)}e.newWriteableStream=A;class I{constructor(p,l){this.reducer=p,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(l=>l(p))}emitError(p){this.listeners.error.length===0?(0,D.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(l=>l(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,l){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(p,l){if(this.state.destroyed)return;let i;switch(p){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const a=i.indexOf(l);a>=0&&i.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(y,p){const l=[];let i;for(;(i=y.read())!==null;)l.push(i);return p(l)}e.consumeReadable=b;function E(y,p,l){const i=[];let a;for(;(a=y.read())!==null&&i.length<l;)i.push(a);return a===null&&i.length>0?p(i):{read:()=>{if(i.length>0)return i.shift();if(typeof a!="undefined"){const r=a;return a=void 0,r}return y.read()}}}e.peekReadable=E;function P(y,p){return new Promise((l,i)=>{const a=[];C(y,{onData:r=>{p&&a.push(r)},onError:r=>{p?i(r):l(void 0)},onEnd:()=>{l(p?p(a):void 0)}})})}e.consumeStream=P;function C(y,p){let l=!1;return y.on("error",i=>{l||p.onError(i)}),y.on("end",()=>{l||p.onEnd()}),y.on("data",i=>{l||p.onData(i)}),(0,n.toDisposable)(()=>l=!0)}e.listenStream=C;function f(y,p){return new Promise((l,i)=>{const a=new n.DisposableStore,r=[],t=c=>{if(r.push(c),r.length>p)return a.dispose(),y.pause(),l({stream:y,buffer:r,ended:!1})},o=c=>i(c),s=()=>l({stream:y,buffer:r,ended:!0});a.add((0,n.toDisposable)(()=>y.removeListener("error",o))),y.on("error",o),a.add((0,n.toDisposable)(()=>y.removeListener("end",s))),y.on("end",s),a.add((0,n.toDisposable)(()=>y.removeListener("data",t))),y.on("data",t)})}e.peekStream=f;function S(y,p){const l=A(p);return l.end(y),l}e.toStream=S;function u(){const y=A(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=u;function v(y){let p=!1;return{read:()=>p?null:(p=!0,y)}}e.toReadable=v;function d(y,p,l){const i=A(l);return C(y,{onData:a=>i.write(p.data(a)),onError:a=>i.error(p.error?p.error(a):a),onEnd:()=>i.end()}),i}e.transform=d;function m(y,p,l){let i=!1;return{read:()=>{const a=p.read();return i?a:(i=!0,a!==null?l([y,a]):y)}}}e.prefixedReadable=m;function w(y,p,l){let i=!1;const a=A(l);return C(p,{onData:r=>i?a.write(r):(i=!0,a.write(l([y,r]))),onError:r=>a.error(r),onEnd:()=>{i||(i=!0,a.write(y)),a.end()}}),a}e.prefixedStream=w}),define(te[17],ne([0,1,40]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let L,T;class A{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return n?new A(Buffer.allocUnsafe(h)):new A(new Uint8Array(h))}static wrap(h){return n&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new A(h)}static fromString(h,g){return!(g?.dontUseNodeBuffer||!1)&&n?new A(Buffer.from(h)):(L||(L=new TextEncoder),new A(L.encode(h)))}static fromByteArray(h){const g=A.alloc(h.length);for(let R=0,_=h.length;R<_;R++)g.buffer[R]=h[R];return g}static concat(h,g){if(typeof g=="undefined"){g=0;for(let U=0,F=h.length;U<F;U++)g+=h[U].byteLength}const R=A.alloc(g);let _=0;for(let U=0,F=h.length;U<F;U++){const k=h[U];R.set(k,_),_+=k.byteLength}return R}clone(){const h=A.alloc(this.byteLength);return h.set(this),h}toString(){return n?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(h,g){return new A(this.buffer.subarray(h,g))}set(h,g){if(h instanceof A)this.buffer.set(h.buffer,g);else if(h instanceof Uint8Array)this.buffer.set(h,g);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),g);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),g);else throw new Error("Unkown argument 'array'")}readUInt32BE(h){return E(this.buffer,h)}writeUInt32BE(h,g){P(this.buffer,h,g)}readUInt32LE(h){return C(this.buffer,h)}writeUInt32LE(h,g){f(this.buffer,h,g)}readUInt8(h){return S(this.buffer,h)}writeUInt8(h,g){u(this.buffer,h,g)}}e.VSBuffer=A;function I(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0}e.readUInt16LE=I;function b(c,h,g){c[g+0]=h&255,h=h>>>8,c[g+1]=h&255}e.writeUInt16LE=b;function E(c,h){return c[h]*2**24+c[h+1]*2**16+c[h+2]*2**8+c[h+3]}e.readUInt32BE=E;function P(c,h,g){c[g+3]=h,h=h>>>8,c[g+2]=h,h=h>>>8,c[g+1]=h,h=h>>>8,c[g]=h}e.writeUInt32BE=P;function C(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0|c[h+2]<<16>>>0|c[h+3]<<24>>>0}e.readUInt32LE=C;function f(c,h,g){c[g+0]=h&255,h=h>>>8,c[g+1]=h&255,h=h>>>8,c[g+2]=h&255,h=h>>>8,c[g+3]=h&255}e.writeUInt32LE=f;function S(c,h){return c[h]}e.readUInt8=S;function u(c,h,g){c[g]=h}e.writeUInt8=u;function v(c){return D.consumeReadable(c,h=>A.concat(h))}e.readableToBuffer=v;function d(c){return D.toReadable(c)}e.bufferToReadable=d;function m(c){return D.consumeStream(c,h=>A.concat(h))}e.streamToBuffer=m;async function w(c){return c.ended?A.concat(c.buffer):A.concat([...c.buffer,await m(c.stream)])}e.bufferedStreamToBuffer=w;function y(c){return D.toStream(c,h=>A.concat(h))}e.bufferToStream=y;function p(c){return D.transform(c,{data:h=>typeof h=="string"?A.fromString(h):A.wrap(h)},h=>A.concat(h))}e.streamToBufferReadableStream=p;function l(c){return D.newWriteableStream(h=>A.concat(h),c)}e.newWriteableBufferStream=l;function i(c,h){return D.prefixedReadable(c,h,g=>A.concat(g))}e.prefixedBufferReadable=i;function a(c,h){return D.prefixedStream(c,h,g=>A.concat(g))}e.prefixedBufferStream=a;function r(c){let h=0,g=0,R=0;const _=new Uint8Array(Math.floor(c.length/4*3)),U=k=>{switch(g){case 3:_[R++]=h|k,g=0;break;case 2:_[R++]=h|k>>>2,h=k<<6,g=3;break;case 1:_[R++]=h|k>>>4,h=k<<4,g=2;break;default:h=k<<2,g=1}};for(let k=0;k<c.length;k++){const M=c.charCodeAt(k);if(M>=65&&M<=90)U(M-65);else if(M>=97&&M<=122)U(M-97+26);else if(M>=48&&M<=57)U(M-48+52);else if(M===43||M===45)U(62);else if(M===47||M===95)U(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${c[k]}`)}}const F=R;for(;g>0;)U(0);return A.wrap(_).slice(0,F)}e.decodeBase64=r;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:c},h=!0,g=!1){const R=g?o:t;let _="";const U=c.byteLength%3;let F=0;for(;F<c.byteLength-U;F+=3){const k=c[F+0],M=c[F+1],$=c[F+2];_+=R[k>>>2],_+=R[(k<<4|M>>>4)&63],_+=R[(M<<2|$>>>6)&63],_+=R[$&63]}if(U===1){const k=c[F+0];_+=R[k>>>2],_+=R[k<<4&63],h&&(_+="==")}else if(U===2){const k=c[F+0],M=c[F+1];_+=R[k>>>2],_+=R[(k<<4|M>>>4)&63],_+=R[M<<2&63],h&&(_+="=")}return _}e.encodeBase64=s}),define(te[27],ne([0,1,106,100]),function(Y,e,D,n){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=T;const A=/{(\d+)}/g;function I(X,...oe){return oe.length===0?X:X.replace(A,function(ce,fe){const me=parseInt(fe,10);return isNaN(me)||me<0||me>=oe.length?ce:oe[me]})}e.format=I;const b=/{([^}]+)}/g;function E(X,oe){return X.replace(b,(ce,fe)=>oe[fe]??ce)}e.format2=E;function P(X){return X.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=P;function C(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function f(X,oe){let ce=0;const fe=oe.charCodeAt(0);for(let me=X.length-1;me>=0;me--)X.charCodeAt(me)===fe&&ce++;return ce}e.count=f;function S(X,oe,ce="\u2026"){return X.length<=oe?X:`${X.substr(0,oe)}${ce}`}e.truncate=S;function u(X,oe=" "){const ce=v(X,oe);return d(ce,oe)}e.trim=u;function v(X,oe){if(!X||!oe)return X;const ce=oe.length;if(ce===0||X.length===0)return X;let fe=0;for(;X.indexOf(oe,fe)===fe;)fe=fe+ce;return X.substring(fe)}e.ltrim=v;function d(X,oe){if(!X||!oe)return X;const ce=oe.length,fe=X.length;if(ce===0||fe===0)return X;let me=fe,De=-1;for(;De=X.lastIndexOf(oe,me-1),!(De===-1||De+ce!==me);){if(De===0)return"";me=De}return X.substring(0,me)}e.rtrim=d;function m(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function w(X){return X.replace(/\*/g,"")}e.stripWildcards=w;function y(X,oe,ce={}){if(!X)throw new Error("Cannot create regex from empty string");oe||(X=C(X)),ce.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let fe="";return ce.global&&(fe+="g"),ce.matchCase||(fe+="i"),ce.multiline&&(fe+="m"),ce.unicode&&(fe+="u"),new RegExp(X,fe)}e.createRegExp=y;function p(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function l(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function i(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=i;function a(X){return X.split(/\r\n|\r|\n/)}e.splitLines=a;function r(X){for(let oe=0,ce=X.length;oe<ce;oe++){const fe=X.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.firstNonWhitespaceIndex=r;function t(X,oe=0,ce=X.length){for(let fe=oe;fe<ce;fe++){const me=X.charCodeAt(fe);if(me!==32&&me!==9)return X.substring(oe,fe)}return X.substring(oe,ce)}e.getLeadingWhitespace=t;function o(X,oe=X.length-1){for(let ce=oe;ce>=0;ce--){const fe=X.charCodeAt(ce);if(fe!==32&&fe!==9)return ce}return-1}e.lastNonWhitespaceIndex=o;function s(X,oe){return X<oe?-1:X>oe?1:0}e.compare=s;function c(X,oe,ce=0,fe=X.length,me=0,De=oe.length){for(;ce<fe&&me<De;ce++,me++){let Ie=X.charCodeAt(ce),Ce=oe.charCodeAt(me);if(Ie<Ce)return-1;if(Ie>Ce)return 1}const Se=fe-ce,Pe=De-me;return Se<Pe?-1:Se>Pe?1:0}e.compareSubstring=c;function h(X,oe){return g(X,oe,0,X.length,0,oe.length)}e.compareIgnoreCase=h;function g(X,oe,ce=0,fe=X.length,me=0,De=oe.length){for(;ce<fe&&me<De;ce++,me++){let Ie=X.charCodeAt(ce),Ce=oe.charCodeAt(me);if(Ie===Ce)continue;if(Ie>=128||Ce>=128)return c(X.toLowerCase(),oe.toLowerCase(),ce,fe,me,De);R(Ie)&&(Ie-=32),R(Ce)&&(Ce-=32);const Ae=Ie-Ce;if(Ae!==0)return Ae}const Se=fe-ce,Pe=De-me;return Se<Pe?-1:Se>Pe?1:0}e.compareSubstringIgnoreCase=g;function R(X){return X>=97&&X<=122}e.isLowerAsciiLetter=R;function _(X){return X>=65&&X<=90}e.isUpperAsciiLetter=_;function U(X,oe){return X.length===oe.length&&g(X,oe)===0}e.equalsIgnoreCase=U;function F(X,oe){const ce=oe.length;return oe.length>X.length?!1:g(X,oe,0,ce)===0}e.startsWithIgnoreCase=F;function k(X,oe){let ce,fe=Math.min(X.length,oe.length);for(ce=0;ce<fe;ce++)if(X.charCodeAt(ce)!==oe.charCodeAt(ce))return ce;return fe}e.commonPrefixLength=k;function M(X,oe){let ce,fe=Math.min(X.length,oe.length);const me=X.length-1,De=oe.length-1;for(ce=0;ce<fe;ce++)if(X.charCodeAt(me-ce)!==oe.charCodeAt(De-ce))return ce;return fe}e.commonSuffixLength=M;function $(X){return 55296<=X&&X<=56319}e.isHighSurrogate=$;function x(X){return 56320<=X&&X<=57343}e.isLowSurrogate=x;function z(X,oe){return(X-55296<<10)+(oe-56320)+65536}e.computeCodePoint=z;function G(X,oe,ce){const fe=X.charCodeAt(ce);if($(fe)&&ce+1<oe){const me=X.charCodeAt(ce+1);if(x(me))return z(fe,me)}return fe}e.getNextCodePoint=G;function ee(X,oe){const ce=X.charCodeAt(oe-1);if(x(ce)&&oe>1){const fe=X.charCodeAt(oe-2);if($(fe))return z(fe,ce)}return ce}class q{constructor(oe,ce=0){this._str=oe,this._len=oe.length,this._offset=ce}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=ee(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=G(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=q;class j{constructor(oe,ce=0){this._iterator=new q(oe,ce)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=ae.getInstance(),ce=this._iterator,fe=ce.offset;let me=oe.getGraphemeBreakType(ce.nextCodePoint());for(;!ce.eol();){const De=ce.offset,Se=oe.getGraphemeBreakType(ce.nextCodePoint());if(je(me,Se)){ce.setOffset(De);break}me=Se}return ce.offset-fe}prevGraphemeLength(){const oe=ae.getInstance(),ce=this._iterator,fe=ce.offset;let me=oe.getGraphemeBreakType(ce.prevCodePoint());for(;ce.offset>0;){const De=ce.offset,Se=oe.getGraphemeBreakType(ce.prevCodePoint());if(je(Se,me)){ce.setOffset(De);break}me=Se}return fe-ce.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=j;function K(X,oe){return new j(X,oe).nextGraphemeLength()}e.nextCharLength=K;function V(X,oe){return new j(X,oe).prevGraphemeLength()}e.prevCharLength=V;function Q(X,oe){oe>0&&x(X.charCodeAt(oe))&&oe--;const ce=oe+K(X,oe);return[ce-V(X,ce),ce]}e.getCharContainingOffset=Q;const Z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function B(X){return Z.test(X)}e.containsRTL=B;const O=/^[\t\n\r\x20-\x7E]*$/;function N(X){return O.test(X)}e.isBasicASCII=N,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function W(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=W;function H(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=H;function re(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=re;function se(X,oe){if(X.length<oe)return X;const ce=/\b/g;let fe=0;for(;ce.test(X)&&!(X.length-ce.lastIndex<oe);)fe=ce.lastIndex,ce.lastIndex+=1;return X.substring(fe).replace(/^\s/,"")}e.lcut=se;const ue=/\x1B\x5B[12]?K/g,de=/\x1b\[\d+m/g,we=/\x1b\[0?m/g;function pe(X){return X&&(X=X.replace(ue,""),X=X.replace(de,""),X=X.replace(we,"")),X}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ge(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ge;function be(X){return ge(X)?X.substr(1):X}e.stripUTF8BOM=be;function Re(X,oe){if(!X||!oe||X.length<oe.length)return!1;const ce=oe.length,fe=X.toLowerCase();let me=0,De=-1;for(;me<ce;){const Se=fe.indexOf(oe[me],De+1);if(Se<0)return!1;De=Se,me++}return!0}e.fuzzyContains=Re;function Le(X,oe=!1){return X?(oe&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=Le;function Te(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=Te;function qe(X,oe=1){if(oe===0)return"";let ce=-1;do ce=X.indexOf(`
`,ce+1),oe--;while(oe>0&&ce>=0);return ce===-1?X:(X[ce-1]==="\r"&&ce--,X.substr(0,ce))}e.getNLines=qe;function Je(X){const oe=90-65+1;return X=X%(2*oe),X<oe?String.fromCharCode(97+X):String.fromCharCode(65+X-oe)}e.singleLetterHash=Je;function Ge(X){return ae.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=Ge;function je(X,oe){return X===0?oe!==5&&oe!==7:X===2&&oe===3?!1:X===4||X===2||X===3||oe===4||oe===2||oe===3?!0:!(X===8&&(oe===8||oe===9||oe===11||oe===12)||(X===11||X===9)&&(oe===9||oe===10)||(X===12||X===10)&&oe===10||oe===5||oe===13||oe===7||X===1||X===13&&oe===14||X===6&&oe===6)}var ie;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=le()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const ce=this._data,fe=ce.length/3;let me=1;for(;me<=fe;)if(oe<ce[3*me])me=2*me;else if(oe>ce[3*me+1])me=2*me+1;else return ce[3*me+2];return 0}}ae._INSTANCE=null;function le(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ye(X,oe){if(X===0)return 0;const ce=Ee(X,oe);if(ce!==void 0)return ce;const fe=new q(oe,X);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=ye;function Ee(X,oe){const ce=new q(oe,X);let fe=ce.prevCodePoint();for(;Me(fe)||fe===65039||fe===8419;){if(ce.offset===0)return;fe=ce.prevCodePoint()}if(!re(fe))return;let me=ce.offset;return me>0&&ce.prevCodePoint()===8205&&(me=ce.offset),me}function Me(X){return 127995<=X&&X<=127999}var ke;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(ke||(ke={})),e.noBreakWhitespace="\xA0";class Oe{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return Oe.cache.get(Array.from(oe))}static getLocales(){return Oe._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Oe,L=Oe,Oe.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Oe.cache=new D.LRUCachedComputed(X=>{function oe(Ce){const Ae=new Map;for(let Ne=0;Ne<Ce.length;Ne+=2)Ae.set(Ce[Ne],Ce[Ne+1]);return Ae}function ce(Ce,Ae){const Ne=new Map(Ce);for(const[ze,We]of Ae)Ne.set(ze,We);return Ne}function fe(Ce,Ae){if(!Ce)return Ae;const Ne=new Map;for(const[ze,We]of Ce)Ae.has(ze)&&Ne.set(ze,We);return Ne}const me=L.ambiguousCharacterData.getValue();let De=X.filter(Ce=>!Ce.startsWith("_")&&Ce in me);De.length===0&&(De=["_default"]);let Se;for(const Ce of De){const Ae=oe(me[Ce]);Se=fe(Se,Ae)}const Pe=oe(me._common),Ie=ce(Pe,Se);return new Oe(Ie)}),Oe._locales=new n.Lazy(()=>Object.keys(Oe.ambiguousCharacterData.getValue()).filter(X=>!X.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(oe){return _e.getData().has(oe)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(te[70],ne([0,1,27]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(m){return L(m,0)}e.hash=n;function L(m,w){switch(typeof m){case"object":return m===null?T(349,w):Array.isArray(m)?b(m,w):E(m,w);case"string":return I(m,w);case"boolean":return A(m,w);case"number":return T(m,w);case"undefined":return T(937,w);default:return T(617,w)}}e.doHash=L;function T(m,w){return(w<<5)-w+m|0}e.numberHash=T;function A(m,w){return T(m?433:863,w)}function I(m,w){w=T(149417,w);for(let y=0,p=m.length;y<p;y++)w=T(m.charCodeAt(y),w);return w}e.stringHash=I;function b(m,w){return w=T(104579,w),m.reduce((y,p)=>L(p,y),w)}function E(m,w){return w=T(181387,w),Object.keys(m).sort().reduce((y,p)=>(y=I(p,y),L(m[p],y)),w)}class P{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=L(w,this._value),this._value}}e.Hasher=P;var C;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function f(m,w,y=32){const p=y-w,l=~((1<<p)-1);return(m<<w|(l&m)>>>p)>>>0}function S(m,w=0,y=m.byteLength,p=0){for(let l=0;l<y;l++)m[w+l]=p}function u(m,w,y="0"){for(;m.length<w;)m=y+m;return m}function v(m,w=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(y=>y.toString(16).padStart(2,"0")).join(""):u((m>>>0).toString(16),w/4)}e.toHexString=v;class d{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const y=w.length;if(y===0)return;const p=this._buff;let l=this._buffLen,i=this._leftoverHighSurrogate,a,r;for(i!==0?(a=i,r=-1,i=0):(a=w.charCodeAt(0),r=0);;){let t=a;if(D.isHighSurrogate(a))if(r+1<y){const o=w.charCodeAt(r+1);D.isLowSurrogate(o)?(r++,t=D.computeCodePoint(a,o)):t=65533}else{i=a;break}else D.isLowSurrogate(a)&&(t=65533);if(l=this._push(p,l,t),r++,r<y)a=w.charCodeAt(r);else break}this._buffLen=l,this._leftoverHighSurrogate=i}_push(w,y,p){return p<128?w[y++]=p:p<2048?(w[y++]=192|(p&1984)>>>6,w[y++]=128|(p&63)>>>0):p<65536?(w[y++]=224|(p&61440)>>>12,w[y++]=128|(p&4032)>>>6,w[y++]=128|(p&63)>>>0):(w[y++]=240|(p&1835008)>>>18,w[y++]=128|(p&258048)>>>12,w[y++]=128|(p&4032)>>>6,w[y++]=128|(p&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=d._bigBlock32,y=this._buffDV;for(let c=0;c<64;c+=4)w.setUint32(c,y.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)w.setUint32(c,f(w.getUint32(c-12,!1)^w.getUint32(c-32,!1)^w.getUint32(c-56,!1)^w.getUint32(c-64,!1),1),!1);let p=this._h0,l=this._h1,i=this._h2,a=this._h3,r=this._h4,t,o,s;for(let c=0;c<80;c++)c<20?(t=l&i|~l&a,o=1518500249):c<40?(t=l^i^a,o=1859775393):c<60?(t=l&i|l&a|i&a,o=2400959708):(t=l^i^a,o=3395469782),s=f(p,5)+t+r+o+w.getUint32(c*4,!1)&4294967295,r=a,a=i,i=f(l,30),l=p,p=s;this._h0=this._h0+p&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=d,d._bigBlock32=new DataView(new ArrayBuffer(320))});var Pt=this&&this.__classPrivateFieldSet||function(Y,e,D,n,L){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?L.call(Y,D):L?L.value=D:e.set(Y,D),D},He=this&&this.__classPrivateFieldGet||function(Y,e,D,n){if(D==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!n:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?n:D==="a"?n.call(Y):n?n.value:e.get(Y)};define(te[39],ne([0,1,16,27]),function(Y,e,D,n){"use strict";var L,T,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(r,t,o){let s=r.get(t);return s===void 0&&(s=o,r.set(t,s)),s}e.getOrSet=I;function b(r){const t=[];return r.forEach((o,s)=>{t.push(`${s} => ${o}`)}),`Map(${r.size}) {${t.join(", ")}}`}e.mapToString=b;function E(r){const t=[];return r.forEach(o=>{t.push(o)}),`Set(${r.size}) {${t.join(", ")}}`}e.setToString=E;class P{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const o=t.charCodeAt(0),s=this._value.charCodeAt(this._pos);return o-s}value(){return this._value[this._pos]}}e.StringIterator=P;class C{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class f{constructor(t=!0,o=!0){this._splitOnBackslash=t,this._caseSensitive=o}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let o=t.length-1;o>=0;o--,this._valueLen--){const s=this._value.charCodeAt(o);if(!(s===47||this._splitOnBackslash&&s===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var S;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(S||(S={}));class u{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,n.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(d||(d={}));class m{constructor(t){this._iter=t}static forUris(t=()=>!1){return new m(new u(t))}static forPaths(t=!1){return new m(new f(void 0,!t))}static forStrings(){return new m(new P)}static forConfigKeys(){return new m(new C)}clear(){this._root=void 0}fill(t,o){if(o){const s=o.slice(0);(0,D.shuffle)(s);for(let c of s)this.set(c,t)}else{const s=t.slice(0);(0,D.shuffle)(s);for(let c of s)this.set(c[0],c[1])}}set(t,o){const s=this._iter.reset(t);let c;this._root||(this._root=new v,this._root.segment=s.value());const h=[];for(c=this._root;;){const R=s.cmp(c.segment);if(R>0)c.left||(c.left=new v,c.left.segment=s.value()),h.push([-1,c]),c=c.left;else if(R<0)c.right||(c.right=new v,c.right.segment=s.value()),h.push([1,c]),c=c.right;else if(s.hasNext())s.next(),c.mid||(c.mid=new v,c.mid.segment=s.value()),h.push([0,c]),c=c.mid;else break}const g=c.value;c.value=o,c.key=t;for(let R=h.length-1;R>=0;R--){const _=h[R][1];_.updateHeight();const U=_.balanceFactor();if(U<-1||U>1){const F=h[R][0],k=h[R+1][0];if(F===1&&k===1)h[R][1]=_.rotateLeft();else if(F===-1&&k===-1)h[R][1]=_.rotateRight();else if(F===1&&k===-1)_.right=h[R+1][1]=h[R+1][1].rotateRight(),h[R][1]=_.rotateLeft();else if(F===-1&&k===1)_.left=h[R+1][1]=h[R+1][1].rotateLeft(),h[R][1]=_.rotateRight();else throw new Error;if(R>0)switch(h[R-1][0]){case-1:h[R-1][1].left=h[R][1];break;case 1:h[R-1][1].right=h[R][1];break;case 0:h[R-1][1].mid=h[R][1];break}else this._root=h[0][1]}}return g}get(t){return this._getNode(t)?.value}_getNode(t){const o=this._iter.reset(t);let s=this._root;for(;s;){const c=o.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else break}return s}has(t){const o=this._getNode(t);return!(o?.value===void 0&&o?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,o){const s=this._iter.reset(t),c=[];let h=this._root;for(;h;){const g=s.cmp(h.segment);if(g>0)c.push([-1,h]),h=h.left;else if(g<0)c.push([1,h]),h=h.right;else if(s.hasNext())s.next(),c.push([0,h]),h=h.mid;else break}if(!!h){if(o?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const g=this._min(h.right),{key:R,value:_,segment:U}=g;this._delete(g.key,!1),h.key=R,h.value=_,h.segment=U}else{const g=h.left??h.right;if(c.length>0){const[R,_]=c[c.length-1];switch(R){case-1:_.left=g;break;case 0:_.mid=g;break;case 1:_.right=g;break}}else this._root=g}for(let g=c.length-1;g>=0;g--){const R=c[g][1];R.updateHeight();const _=R.balanceFactor();if(_>1?(R.right.balanceFactor()>=0||(R.right=R.right.rotateRight()),c[g][1]=R.rotateLeft()):_<-1&&(R.left.balanceFactor()<=0||(R.left=R.left.rotateLeft()),c[g][1]=R.rotateRight()),g>0)switch(c[g-1][0]){case-1:c[g-1][1].left=c[g][1];break;case 1:c[g-1][1].right=c[g][1];break;case 0:c[g-1][1].mid=c[g][1];break}else this._root=c[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const o=this._iter.reset(t);let s=this._root,c;for(;s;){const h=o.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(o.hasNext())o.next(),c=s.value||c,s=s.mid;else break}return s&&s.value||c}findSuperstr(t){const o=this._iter.reset(t);let s=this._root;for(;s;){const c=o.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(t){for(const[o,s]of this)t(s,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=o=>{if(!o)return!0;const s=o.balanceFactor();return s<-1||s>1?!1:t(o.left)&&t(o.right)};return t(this._root)}}e.TernarySearchTree=m;class w{constructor(t,o){this.uri=t,this.value=o}}class y{constructor(t,o){this[L]="ResourceMap",t instanceof y?(this.map=new Map(t.map),this.toKey=o??y.defaultToKey):(this.map=new Map,this.toKey=t??y.defaultToKey)}set(t,o){return this.map.set(this.toKey(t),new w(t,o)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,o){typeof o!="undefined"&&(t=t.bind(o));for(let[s,c]of this.map)t(c.value,c.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=y,y.defaultToKey=r=>r.toString();var p;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class l{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,o=0){const s=this._map.get(t);if(!!s)return o!==0&&this.touch(s,o),s.value}set(t,o,s=0){let c=this._map.get(t);if(c)c.value=o,s!==0&&this.touch(c,s);else{switch(c={key:t,value:o,next:void 0,previous:void 0},s){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(t,c),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this._map.get(t);if(!!o)return this._map.delete(t),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,o){const s=this._state;let c=this._head;for(;c;){if(o?t.bind(o)(c.value,c.key,this):t(c.value,c.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,o=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:s.key,done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return c}values(){const t=this,o=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:s.value,done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return c}entries(){const t=this,o=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:[s.key,s.value],done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return c}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this._head,s=this.size;for(;o&&s>t;)this._map.delete(o.key),o=o.next,s--;this._head=o,this._size=s,o&&(o.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const o=t.next,s=t.previous;if(!o||!s)throw new Error("Invalid list");o.previous=s,s.next=o}t.next=void 0,t.previous=void 0,this._state++}touch(t,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this._head)return;const s=t.next,c=t.previous;t===this._tail?(c.next=void 0,this._tail=c):(s.previous=c,c.next=s),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(o===2){if(t===this._tail)return;const s=t.next,c=t.previous;t===this._head?(s.previous=void 0,this._head=s):(s.previous=c,c.next=s),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((o,s)=>{t.push([s,o])}),t}fromJSON(t){this.clear();for(const[o,s]of t)this.set(o,s)}}e.LinkedMap=l;class i extends l{constructor(t,o=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class a{constructor(t){A.set(this,void 0),Pt(this,A,t,"f")}get size(){return He(this,A,"f").size}forEach(t,o){He(this,A,"f").forEach(t,o)}get(t){return He(this,A,"f").get(t)}has(t){return He(this,A,"f").has(t)}entries(){return He(this,A,"f").entries()}keys(){return He(this,A,"f").keys()}values(){return He(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return He(this,A,"f").entries()}}e.ReadonlyMapView=a}),define(te[71],ne([0,1,39]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new D.LRUCache(1e4);function L(E){return b(E,"NFC",n)}e.normalizeNFC=L;const T=new D.LRUCache(1e4);function A(E){return b(E,"NFD",T)}e.normalizeNFD=A;const I=/[^\u0000-\u0080]/;function b(E,P,C){if(!E)return E;const f=C.get(E);if(f)return f;let S;return I.test(E)?S=E.normalize(P):S=E,C.set(E,S),S}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(P){return A(P).replace(E,"")}}()}),define(te[15],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(s){return Array.isArray(s)}e.isArray=D;function n(s){return typeof s=="string"}e.isString=n;function L(s){return Array.isArray(s)&&s.every(c=>n(c))}e.isStringArray=L;function T(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=T;function A(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=A;function I(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=I;function b(s){return s===!0||s===!1}e.isBoolean=b;function E(s){return typeof s=="undefined"}e.isUndefined=E;function P(s){return!C(s)}e.isDefined=P;function C(s){return E(s)||s===null}e.isUndefinedOrNull=C;function f(s,c){if(!s)throw new Error(c?`Unexpected type, expected '${c}'`:"Unexpected type")}e.assertType=f;function S(s){if(C(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=S;function u(...s){const c=[];for(let h=0;h<s.length;h++){const g=s[h];if(C(g))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);c.push(g)}return c}e.assertAllDefined=u;const v=Object.prototype.hasOwnProperty;function d(s){if(!T(s))return!1;for(let c in s)if(v.call(s,c))return!1;return!0}e.isEmptyObject=d;function m(s){return typeof s=="function"}e.isFunction=m;function w(...s){return s.length>0&&s.every(m)}e.areFunctions=w;function y(s,c){const h=Math.min(s.length,c.length);for(let g=0;g<h;g++)p(s[g],c[g])}e.validateConstraints=y;function p(s,c){if(n(c)){if(typeof s!==c)throw new Error(`argument does not match constraint: typeof ${c}`)}else if(m(c)){try{if(s instanceof c)return}catch{}if(!C(s)&&s.constructor===c||c.length===1&&c.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=p;function l(s){let c=[],h=Object.getPrototypeOf(s);for(;Object.prototype!==h;)c=c.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return c}e.getAllPropertyNames=l;function i(s){const c=[];for(const h of l(s))typeof s[h]=="function"&&c.push(h);return c}e.getAllMethodNames=i;function a(s,c){const h=R=>function(){const _=Array.prototype.slice.call(arguments,0);return c(R,_)};let g={};for(const R of s)g[R]=h(R);return g}e.createProxyObject=a;function r(s){return s===null?void 0:s}e.withNullAsUndefined=r;function t(s){return typeof s=="undefined"?null:s}e.withUndefinedAsNull=t;function o(s,c="Unreachable"){throw new Error(c)}e.assertNever=o}),define(te[41],ne([0,1,10,4,27,15]),function(Y,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(o){return o===47||o===92}e.isPathSeparator=A;function I(o){return o.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=I;function b(o){return o.indexOf("/")===-1&&(o=I(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=b;function E(o,s=D.posix.sep){if(!o)return"";const c=o.length,h=o.charCodeAt(0);if(A(h)){if(A(o.charCodeAt(1))&&!A(o.charCodeAt(2))){let R=3;const _=R;for(;R<c&&!A(o.charCodeAt(R));R++);if(_!==R&&!A(o.charCodeAt(R+1))){for(R+=1;R<c;R++)if(A(o.charCodeAt(R)))return o.slice(0,R+1).replace(/[\\/]/g,s)}}return s}else if(m(h)&&o.charCodeAt(1)===58)return A(o.charCodeAt(2))?o.slice(0,2)+s:o.slice(0,2);let g=o.indexOf("://");if(g!==-1){for(g+=3;g<c;g++)if(A(o.charCodeAt(g)))return o.slice(0,g+1)}return""}e.getRoot=E;function P(o){if(!n.isWindows||!o||o.length<5)return!1;let s=o.charCodeAt(0);if(s!==92||(s=o.charCodeAt(1),s!==92))return!1;let c=2;const h=c;for(;c<o.length&&(s=o.charCodeAt(c),s!==92);c++);return!(h===c||(s=o.charCodeAt(c+1),isNaN(s)||s===92))}e.isUNC=P;const C=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(o,s=n.isWindows){const c=s?C:f;return!(!o||o.length===0||/^\s+$/.test(o)||(c.lastIndex=0,c.test(o))||s&&S.test(o)||o==="."||o===".."||s&&o[o.length-1]==="."||s&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=u;function v(o,s,c){const h=o===s;return!c||h?h:!o||!s?!1:(0,L.equalsIgnoreCase)(o,s)}e.isEqual=v;function d(o,s,c,h=D.sep){if(o===s)return!0;if(!o||!s||s.length>o.length)return!1;if(c){if(!(0,L.startsWithIgnoreCase)(o,s))return!1;if(s.length===o.length)return!0;let R=s.length;return s.charAt(s.length-1)===h&&R--,o.charAt(R)===h}return s.charAt(s.length-1)!==h&&(s+=h),o.indexOf(s)===0}e.isEqualOrParent=d;function m(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=m;function w(o,s){return n.isWindows&&o.endsWith(":")&&(o+=D.sep),(0,D.isAbsolute)(o)||(o=(0,D.join)(s,o)),o=(0,D.normalize)(o),n.isWindows?(o=(0,L.rtrim)(o,D.sep),o.endsWith(":")&&(o+=D.sep)):(o=(0,L.rtrim)(o,D.sep),o||(o=D.sep)),o}e.sanitizeFilePath=w;function y(o){const s=(0,D.normalize)(o);return n.isWindows?o.length>3?!1:p(s)&&(o.length===2||s.charCodeAt(2)===92):s===D.posix.sep}e.isRootOrDriveLetter=y;function p(o,s){return(s!==void 0?s:n.isWindows)?m(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function l(o){return p(o)?o[0]:void 0}e.getDriveLetter=l;function i(o,s,c){return s.length>o.length?-1:o===s?0:(c&&(o=o.toLowerCase(),s=s.toLowerCase()),o.indexOf(s))}e.indexOfPath=i;function a(o){const s=o.split(":");let c,h,g;for(const R of s){const _=Number(R);(0,T.isNumber)(_)?h===void 0?h=_:g===void 0&&(g=_):c=c?[c,R].join(":"):R}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:h!==void 0?h:void 0,column:g!==void 0?g:h!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(o,s,c=8){let h="";for(let R=0;R<c;R++)h+=r.charAt(Math.floor(Math.random()*r.length));let g;return s?g=`${s}-${h}`:g=h,o?(0,D.join)(o,g):g}e.randomPath=t}),define(te[28],ne([0,1,15]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const d=Array.isArray(v)?[]:{};return Object.keys(v).forEach(m=>{v[m]&&typeof v[m]=="object"?d[m]=n(v[m]):d[m]=v[m]}),d}e.deepClone=n;function L(v){if(!v||typeof v!="object")return v;const d=[v];for(;d.length>0;){const m=d.shift();Object.freeze(m);for(const w in m)if(T.call(m,w)){const y=m[w];typeof y=="object"&&!Object.isFrozen(y)&&d.push(y)}}return v}e.deepFreeze=L;const T=Object.prototype.hasOwnProperty;function A(v,d){return I(v,d,new Set)}e.cloneAndChange=A;function I(v,d,m){if((0,D.isUndefinedOrNull)(v))return v;const w=d(v);if(typeof w!="undefined")return w;if((0,D.isArray)(v)){const y=[];for(const p of v)y.push(I(p,d,m));return y}if((0,D.isObject)(v)){if(m.has(v))throw new Error("Cannot clone recursive data-structure");m.add(v);const y={};for(let p in v)T.call(v,p)&&(y[p]=I(v[p],d,m));return m.delete(v),y}return v}function b(v,d,m=!0){return(0,D.isObject)(v)?((0,D.isObject)(d)&&Object.keys(d).forEach(w=>{w in v?m&&((0,D.isObject)(v[w])&&(0,D.isObject)(d[w])?b(v[w],d[w],m):v[w]=d[w]):v[w]=d[w]}),v):d}e.mixin=b;function E(v,d){if(v===d)return!0;if(v==null||d===null||d===void 0||typeof v!=typeof d||typeof v!="object"||Array.isArray(v)!==Array.isArray(d))return!1;let m,w;if(Array.isArray(v)){if(v.length!==d.length)return!1;for(m=0;m<v.length;m++)if(!E(v[m],d[m]))return!1}else{const y=[];for(w in v)y.push(w);y.sort();const p=[];for(w in d)p.push(w);if(p.sort(),!E(y,p))return!1;for(m=0;m<y.length;m++)if(!E(v[y[m]],d[y[m]]))return!1}return!0}e.equals=E;function P(v){const d=new Set;return JSON.stringify(v,(m,w)=>{if((0,D.isObject)(w)||Array.isArray(w)){if(d.has(w))return"[Circular]";d.add(w)}return w})}e.safeStringify=P;function C(v,d,m){const w=d(v);return typeof w=="undefined"?m:w}e.getOrDefault=C;function f(v,d){const m=Object.create(null);return!v||!d||Object.keys(d).forEach(y=>{const p=v[y],l=d[y];E(p,l)||(m[y]=l)}),m}e.distinct=f;function S(v,d){const m=d.toLowerCase(),w=Object.keys(v).find(y=>y.toLowerCase()===m);return w?v[w]:v[d]}e.getCaseInsensitive=S;function u(v,d){const m=Object.create(null);for(const[w,y]of Object.entries(v))d(w,y)&&(m[w]=y);return m}e.filter=u}),define(te[7],ne([0,1,10,4]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,T=/^\//,A=/^\/\//;function I(r,t){if(!r.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!L.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!T.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(r,t){return!r&&!t?"file":r}function E(r,t){switch(r){case"https":case"http":case"file":t?t[0]!==C&&(t=C+t):t=C;break}return t}const P="",C="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{constructor(t,o,s,c,h,g=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=b(t,g),this.authority=o||P,this.path=E(this.scheme,s||P),this.query=c||P,this.fragment=h||P,I(this,g))}static isUri(t){return t instanceof S?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return y(this,!1)}with(t){if(!t)return this;let{scheme:o,authority:s,path:c,query:h,fragment:g}=t;return o===void 0?o=this.scheme:o===null&&(o=P),s===void 0?s=this.authority:s===null&&(s=P),c===void 0?c=this.path:c===null&&(c=P),h===void 0?h=this.query:h===null&&(h=P),g===void 0?g=this.fragment:g===null&&(g=P),o===this.scheme&&s===this.authority&&c===this.path&&h===this.query&&g===this.fragment?this:new v(o,s,c,h,g)}static parse(t,o=!1){const s=f.exec(t);return s?new v(s[2]||P,a(s[4]||P),a(s[5]||P),a(s[7]||P),a(s[9]||P),o):new v(P,P,P,P,P)}static file(t){let o=P;if(n.isWindows&&(t=t.replace(/\\/g,C)),t[0]===C&&t[1]===C){const s=t.indexOf(C,2);s===-1?(o=t.substring(2),t=C):(o=t.substring(2,s),t=t.substring(s)||C)}return new v("file",o,t,P,P)}static from(t){const o=new v(t.scheme,t.authority,t.path,t.query,t.fragment);return I(o,!0),o}static joinPath(t,...o){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return n.isWindows&&t.scheme==="file"?s=S.file(D.win32.join(y(t,!0),...o)).path:s=D.posix.join(t.path,...o),t.with({path:s})}toString(t=!1){return p(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof S)return t;{const o=new v(t);return o._formatted=t.external,o._fsPath=t._sep===u?t.fsPath:null,o}}else return t}}e.URI=S;const u=n.isWindows?1:void 0;class v extends S{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(t=!1){return t?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=u),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(r,t){let o,s=-1;for(let c=0;c<r.length;c++){const h=r.charCodeAt(c);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||t&&h===47)s!==-1&&(o+=encodeURIComponent(r.substring(s,c)),s=-1),o!==void 0&&(o+=r.charAt(c));else{o===void 0&&(o=r.substr(0,c));const g=d[h];g!==void 0?(s!==-1&&(o+=encodeURIComponent(r.substring(s,c)),s=-1),o+=g):s===-1&&(s=c)}}return s!==-1&&(o+=encodeURIComponent(r.substring(s))),o!==void 0?o:r}function w(r){let t;for(let o=0;o<r.length;o++){const s=r.charCodeAt(o);s===35||s===63?(t===void 0&&(t=r.substr(0,o)),t+=d[s]):t!==void 0&&(t+=r[o])}return t!==void 0?t:r}function y(r,t){let o;return r.authority&&r.path.length>1&&r.scheme==="file"?o=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?t?o=r.path.substr(1):o=r.path[1].toLowerCase()+r.path.substr(2):o=r.path,n.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=y;function p(r,t){const o=t?w:m;let s="",{scheme:c,authority:h,path:g,query:R,fragment:_}=r;if(c&&(s+=c,s+=":"),(h||c==="file")&&(s+=C,s+=C),h){let U=h.indexOf("@");if(U!==-1){const F=h.substr(0,U);h=h.substr(U+1),U=F.indexOf(":"),U===-1?s+=o(F,!1):(s+=o(F.substr(0,U),!1),s+=":",s+=o(F.substr(U+1),!1)),s+="@"}h=h.toLowerCase(),U=h.indexOf(":"),U===-1?s+=o(h,!1):(s+=o(h.substr(0,U),!1),s+=h.substr(U))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const U=g.charCodeAt(1);U>=65&&U<=90&&(g=`/${String.fromCharCode(U+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const U=g.charCodeAt(0);U>=65&&U<=90&&(g=`${String.fromCharCode(U+32)}:${g.substr(2)}`)}s+=o(g,!0)}return R&&(s+="?",s+=o(R,!1)),_&&(s+="#",s+=t?_:m(_,!1)),s}function l(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+l(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(r){return r.match(i)?r.replace(i,t=>l(t)):r}}),define(te[107],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(E){const P=E;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=n;function L(E){const P=[];let C;try{const f=JSON.parse(E.arguments),S=f[f.length-1];S&&S.__$stack&&(f.pop(),C=S.__$stack),P.push(...f)}catch{P.push("Unable to log remote console arguments",E.arguments)}return{args:P,stack:C}}e.parse=L;function T(E){if(typeof E!="string")return T(L(E).stack);const P=E;if(P){const C=A(P),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(f&&f.length===4)return{uri:D.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.getFirstFrame=T;function A(E){if(!E)return E;const P=E.indexOf(`
`);return P===-1?E:E.substring(0,P)}function I(E,P){const{args:C,stack:f}=L(E),S=typeof C[0]=="string"&&C.length===1;let u=A(f);u&&(u=`(${u.trim()})`);let v=[];if(typeof C[0]=="string"?u&&S?v=[`%c[${P}] %c${C[0]} %c${u}`,b("blue"),b(""),b("grey")]:v=[`%c[${P}] %c${C[0]}`,b("blue"),b(""),...C.slice(1)]:v=[`%c[${P}]%`,b("blue"),...C],u&&!S&&v.push(u),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,v)}e.log=I;function b(E){return`color: ${E}`}}),define(te[108],ne([0,1,17,27,7]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(P){return JSON.stringify(P,b)}e.stringify=T;function A(P){let C=JSON.parse(P);return C=E(C),C}e.parse=A;var I;(function(P){P[P.Uri=1]="Uri",P[P.Regexp=2]="Regexp",P[P.ScmResource=3]="ScmResource",P[P.ScmResourceGroup=4]="ScmResourceGroup",P[P.ScmProvider=5]="ScmProvider",P[P.CommentController=6]="CommentController",P[P.CommentThread=7]="CommentThread",P[P.CommentThreadReply=8]="CommentThreadReply",P[P.CommentNode=9]="CommentNode",P[P.CommentThreadNode=10]="CommentThreadNode",P[P.TimelineActionContext=11]="TimelineActionContext",P[P.NotebookCellActionContext=12]="NotebookCellActionContext",P[P.TestItemContext=13]="TestItemContext",P[P.Date=14]="Date"})(I=e.MarshalledId||(e.MarshalledId={}));function b(P,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,n.regExpFlags)(C)}:C}function E(P,C=0){if(!P||C>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return L.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof D.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let f=0;f<P.length;++f)P[f]=E(P[f],C+1);else for(const f in P)Object.hasOwnProperty.call(P,f)&&(P[f]=E(P[f],C+1))}return P}e.revive=E}),define(te[18],ne([0,1,4,7]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var L;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(L=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}set(b,E,P){this._hosts[b]=E,this._ports[b]=P}setConnectionToken(b,E){this._connectionTokens[b]=E}rewrite(b){if(this._delegate)return this._delegate(b);const E=b.authority;let P=this._hosts[E];P&&P.indexOf(":")!==-1&&(P=`[${P}]`);const C=this._ports[E],f=this._connectionTokens[E];let S=`path=${encodeURIComponent(b.path)}`;return typeof f=="string"&&(S+=`&tkn=${encodeURIComponent(f)}`),n.URI.from({scheme:D.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${P}:${C}`,path:"/vscode-remote-resource",query:S})}}e.RemoteAuthorities=new T;class A{asBrowserUri(b,E){const P=this.toUri(b,E);return P.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===L.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${L.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?P.with({scheme:L.vscodeFileResource,authority:P.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(b,E){const P=this.toUri(b,E);return P.scheme===L.vscodeFileResource?P.with({scheme:L.file,authority:P.authority!==A.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(b,E){return n.URI.isUri(b)?b:n.URI.parse(E.toUrl(b))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(te[19],ne([0,1,41,18,10,4,27,7]),function(Y,e,D,n,L,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(S){return(0,I.uriToFsPath)(S,!0)}e.originalFSPath=b;class E{constructor(u){this._ignorePathCasing=u}compare(u,v,d=!1){return u===v?0:(0,A.compare)(this.getComparisonKey(u,d),this.getComparisonKey(v,d))}isEqual(u,v,d=!1){return u===v?!0:!u||!v?!1:this.getComparisonKey(u,d)===this.getComparisonKey(v,d)}getComparisonKey(u,v=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,v,d=!1){if(u.scheme===v.scheme){if(u.scheme===n.Schemas.file)return D.isEqualOrParent(b(u),b(v),this._ignorePathCasing(u))&&u.query===v.query&&(d||u.fragment===v.fragment);if((0,e.isEqualAuthority)(u.authority,v.authority))return D.isEqualOrParent(u.path,v.path,this._ignorePathCasing(u),"/")&&u.query===v.query&&(d||u.fragment===v.fragment)}return!1}joinPath(u,...v){return I.URI.joinPath(u,...v)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return L.posix.basename(u.path)}extname(u){return L.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let v;return u.scheme===n.Schemas.file?v=I.URI.file(L.dirname(b(u))).path:(v=L.posix.dirname(u.path),u.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),v="/")),u.with({path:v})}normalizePath(u){if(!u.path.length)return u;let v;return u.scheme===n.Schemas.file?v=I.URI.file(L.normalize(b(u))).path:v=L.posix.normalize(u.path),u.with({path:v})}relativePath(u,v){if(u.scheme!==v.scheme||!(0,e.isEqualAuthority)(u.authority,v.authority))return;if(u.scheme===n.Schemas.file){const w=L.relative(b(u),b(v));return T.isWindows?D.toSlashes(w):w}let d=u.path||"/",m=v.path||"/";if(this._ignorePathCasing(u)){let w=0;for(const y=Math.min(d.length,m.length);w<y&&!(d.charCodeAt(w)!==m.charCodeAt(w)&&d.charAt(w).toLowerCase()!==m.charAt(w).toLowerCase());w++);d=m.substr(0,w)+d.substr(w)}return L.posix.relative(d,m)}resolvePath(u,v){if(u.scheme===n.Schemas.file){const d=I.URI.file(L.resolve(b(u),v));return u.with({authority:d.authority,path:d.path})}return v=D.toPosixPath(v),u.with({path:L.posix.resolve(u.path,v)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,v){return u===v||u!==void 0&&v!==void 0&&(0,A.equalsIgnoreCase)(u,v)}hasTrailingPathSeparator(u,v=L.sep){if(u.scheme===n.Schemas.file){const d=b(u);return d.length>D.getRoot(d).length&&d[d.length-1]===v}else{const d=u.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,v=L.sep){return(0,e.hasTrailingPathSeparator)(u,v)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,v=L.sep){let d=!1;if(u.scheme===n.Schemas.file){const m=b(u);d=m!==void 0&&m.length===D.getRoot(m).length&&m[m.length-1]===v}else{v="/";const m=u.path;d=m.length===1&&m.charCodeAt(m.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(u,v)?u.with({path:u.path+"/"}):u}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(S=>S.scheme===n.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new E(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(S,u){const v=[];for(let d=0;d<S.length;d++){const m=u(S[d]);S.some((w,y)=>y===d?!1:(0,e.isEqualOrParent)(m,u(w)))||v.push(S[d])}return v}e.distinctParents=P;var C;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function u(v){const d=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(y=>{const[p,l]=y.split(":");p&&l&&d.set(p,l)});const w=v.path.substring(0,v.path.indexOf(";"));return w&&d.set(S.META_DATA_MIME,w),d}S.parseMetaData=u})(C=e.DataUri||(e.DataUri={}));function f(S,u,v){if(u){let d=S.path;return d&&d[0]!==L.posix.sep&&(d=L.posix.sep+d),S.with({scheme:v,authority:u,path:d})}return S.with({scheme:v})}e.toLocalResource=f}),define(te[5],ne([0,1,23,9,3,2,19,4]),function(Y,e,D,n,L,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(B){return!!B&&typeof B.then=="function"}e.isThenable=b;function E(B){const O=new D.CancellationTokenSource,N=B(O.token),W=new Promise((H,re)=>{const se=O.token.onCancellationRequested(()=>{se.dispose(),O.dispose(),re(new n.CancellationError)});Promise.resolve(N).then(ue=>{se.dispose(),O.dispose(),H(ue)},ue=>{se.dispose(),O.dispose(),re(ue)})});return new class{cancel(){O.cancel()}then(H,re){return W.then(H,re)}catch(H){return this.then(void 0,H)}finally(H){return W.finally(H)}}}e.createCancelablePromise=E;function P(B,O,N){return new Promise((W,H)=>{const re=O.onCancellationRequested(()=>{re.dispose(),W(N)});B.then(W,H).finally(()=>re.dispose())})}e.raceCancellation=P;function C(B,O){return new Promise((N,W)=>{const H=O.onCancellationRequested(()=>{H.dispose(),W(new n.CancellationError)});B.then(N,W).finally(()=>H.dispose())})}e.raceCancellationError=C;async function f(B){let O=-1;const N=B.map((H,re)=>H.then(se=>(O=re,se))),W=await Promise.race(N);return B.forEach((H,re)=>{re!==O&&H.cancel()}),W}e.raceCancellablePromises=f;function S(B,O,N){let W;const H=setTimeout(()=>{W?.(void 0),N?.()},O);return Promise.race([B.finally(()=>clearTimeout(H)),new Promise(re=>W=re)])}e.raceTimeout=S;function u(B){return new Promise((O,N)=>{const W=B();b(W)?W.then(O,N):O(W)})}e.asPromise=u;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(O){if(this.activePromise){if(this.queuedPromiseFactory=O,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then(N,N).then(W)})}return new Promise((N,W)=>{this.queuedPromise.then(N,W)})}return this.activePromise=O(),new Promise((N,W)=>{this.activePromise.then(H=>{this.activePromise=null,N(H)},H=>{this.activePromise=null,W(H)})})}}e.Throttler=v;class d{constructor(){this.current=Promise.resolve(null)}queue(O){return this.current=this.current.then(()=>O(),()=>O())}}e.Sequencer=d;class m{constructor(){this.promiseMap=new Map}queue(O,N){const H=(this.promiseMap.get(O)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(O)===H&&this.promiseMap.delete(O)});return this.promiseMap.set(O,H),H}}e.SequencerByKey=m;const w=(B,O)=>{let N=!0;const W=setTimeout(()=>{N=!1,O()},B);return{isTriggered:()=>N,dispose:()=>{clearTimeout(W),N=!1}}},y=B=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,B())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class p{constructor(O){this.defaultDelay=O,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(O,N=this.defaultDelay){this.task=O,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((H,re)=>{this.doResolve=H,this.doReject=re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const H=this.task;return this.task=null,H()}}));const W=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=N===e.MicrotaskDelay?y(W):w(N,W),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=p;class l{constructor(O){this.delayer=new p(O),this.throttler=new v}trigger(O,N){return this.delayer.trigger(()=>this.throttler.queue(O),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class i{constructor(){this._isOpen=!1,this._promise=new Promise((O,N)=>{this._completePromise=O})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class a extends i{constructor(O){super();this._timeout=setTimeout(()=>this.open(),O)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function r(B,O){return O?new Promise((N,W)=>{const H=setTimeout(()=>{re.dispose(),N()},B),re=O.onCancellationRequested(()=>{clearTimeout(H),re.dispose(),W(new n.CancellationError)})}):E(N=>r(B,N))}e.timeout=r;function t(B,O=0){const N=setTimeout(B,O);return(0,T.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=t;function o(B){const O=[];let N=0;const W=B.length;function H(){return N<W?B[N++]():null}function re(se){se!=null&&O.push(se);const ue=H();return ue?ue.then(re):Promise.resolve(O)}return Promise.resolve(null).then(re)}e.sequence=o;function s(B,O=W=>!!W,N=null){let W=0;const H=B.length,re=()=>{if(W>=H)return Promise.resolve(N);const se=B[W++];return Promise.resolve(se()).then(de=>O(de)?Promise.resolve(de):re())};return re()}e.first=s;function c(B,O=W=>!!W,N=null){if(B.length===0)return Promise.resolve(N);let W=B.length;const H=()=>{W=-1;for(const re of B)re.cancel?.()};return new Promise((re,se)=>{for(const ue of B)ue.then(de=>{--W>=0&&O(de)?(H(),re(de)):W===0&&re(N)}).catch(de=>{--W>=0&&(H(),se(de))})})}e.firstParallel=c;class h{constructor(O){this._size=0,this.maxDegreeOfParalellism=O,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(O){return this._size++,new Promise((N,W)=>{this.outstandingPromises.push({factory:O,c:N,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const O=this.outstandingPromises.shift();this.runningPromises++;const N=O.factory();N.then(O.c,O.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=h;class g extends h{constructor(){super(1)}}e.Queue=g;class R{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const O=new q;return this.drainers.add(O),O.p}isDrained(){for(const[,O]of this.queues)if(O.size>0)return!1;return!0}queueFor(O,N=A.extUri){const W=N.getComparisonKey(O);let H=this.queues.get(W);return H||(H=new g,L.Event.once(H.onFinished)(()=>{H?.dispose(),this.queues.delete(W),this.onDidQueueFinish()}),this.queues.set(W,H)),H}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const O of this.drainers)O.complete();this.drainers.clear()}dispose(){for(const[,O]of this.queues)O.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=R;class _{constructor(O,N){this._token=-1,typeof O=="function"&&typeof N=="number"&&this.setIfNotSet(O,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(O,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,O()},N)}setIfNotSet(O,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,O()},N))}}e.TimeoutTimer=_;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(O,N){this.cancel(),this._token=setInterval(()=>{O()},N)}}e.IntervalTimer=U;class F{constructor(O,N){this.timeoutToken=-1,this.runner=O,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(O=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,O)}get delay(){return this.timeout}set delay(O){this.timeout=O}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class k{constructor(O,N){N%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.runner=O,this.timeout=N,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(O=this.timeout){O%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(O/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=k;class M extends F{constructor(O,N){super(O,N);this.units=[]}work(O){this.units.push(O),this.isScheduled()||this.schedule()}doRun(){const O=this.units;this.units=[],this.runner&&this.runner(O)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=M;class $ extends T.Disposable{constructor(O,N){super();this.options=O,this.handler=N,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(O){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+O.length>this.options.maxBufferedWork)return!1}else if(this.pending+O.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...O),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new F(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=B=>{(0,I.setTimeout0)(()=>{if(O)return;const N=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let O=!1;return{dispose(){O||(O=!0)}}}:e.runWhenIdle=(B,O)=>{const N=requestIdleCallback(B,typeof O=="number"?{timeout:O}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(N))}}}}();class x{constructor(O){this._didRun=!1,this._executor=()=>{try{this._value=O()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=x;async function z(B,O,N){let W;for(let H=0;H<N;H++)try{return await B()}catch(re){W=re,await r(O)}throw W}e.retry=z;class G{hasPending(O){return this._pending?typeof O=="number"?this._pending.taskId===O:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(O,N,W){return this._pending={taskId:O,cancel:()=>W?.(),promise:N},N.then(()=>this.donePending(O),()=>this.donePending(O)),N}donePending(O){this._pending&&O===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const O=this._next;this._next=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}setNext(O){if(this._next)this._next.run=O;else{let N,W;const H=new Promise((re,se)=>{N=re,W=se});this._next={run:O,promise:H,promiseResolve:N,promiseReject:W}}return this._next.promise}}e.TaskSequentializer=G;class ee{constructor(O,N=()=>Date.now()){this.interval=O,this.nowFn=N,this.lastIncrementTime=0,this.value=0}increment(){const O=this.nowFn();return O-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=O,this.value=0),this.value++,this.value}}e.IntervalCounter=ee;class q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((O,N)=>{this.completeCallback=O,this.errorCallback=N})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(O){return new Promise(N=>{this.completeCallback(O),this.resolved=!0,N()})}error(O){return new Promise(N=>{this.errorCallback(O),this.rejected=!0,N()})}cancel(){new Promise(O=>{this.errorCallback(new n.CancellationError),this.rejected=!0,O()})}}e.DeferredPromise=q;var j;(function(B){async function O(W){let H;const re=await Promise.all(W.map(se=>se.then(ue=>ue,ue=>{H||(H=ue)})));if(typeof H!="undefined")throw H;return re}B.settled=O;function N(W){return new Promise(async(H,re)=>{try{await W(H,re)}catch(se){re(se)}})}B.withAsyncBody=N})(j=e.Promises||(e.Promises={}));var K;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(K||(K={}));class V{constructor(O){this._state=0,this._results=[],this._error=null,this._onStateChanged=new L.Emitter,queueMicrotask(async()=>{const N={emitOne:W=>this.emitOne(W),emitMany:W=>this.emitMany(W),reject:W=>this.reject(W)};try{await Promise.resolve(O(N)),this.resolve()}catch(W){this.reject(W)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}static fromArray(O){return new V(N=>{N.emitMany(O)})}static fromPromise(O){return new V(async N=>{N.emitMany(await O)})}static fromPromises(O){return new V(async N=>{await Promise.all(O.map(async W=>N.emitOne(await W)))})}static merge(O){return new V(async N=>{await Promise.all(O.map(async W=>{for await(const H of W)N.emitOne(H)}))})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(O<this._results.length)return{done:!1,value:this._results[O++]};if(this._state===1)return{done:!0,value:void 0};await L.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(O,N){return new V(async W=>{for await(const H of O)W.emitOne(N(H))})}map(O){return V.map(this,O)}static filter(O,N){return new V(async W=>{for await(const H of O)N(H)&&W.emitOne(H)})}filter(O){return V.filter(this,O)}static coalesce(O){return V.filter(O,N=>!!N)}coalesce(){return V.coalesce(this)}static async toPromise(O){const N=[];for await(const W of O)N.push(W);return N}toPromise(){return V.toPromise(this)}emitOne(O){this._state===0&&(this._results.push(O),this._onStateChanged.fire())}emitMany(O){this._state===0&&(this._results=this._results.concat(O),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(O){this._state===0&&(this._state=2,this._error=O,this._onStateChanged.fire())}}e.AsyncIterableObject=V,V.EMPTY=V.fromArray([]);class Q extends V{constructor(O,N){super(N);this._source=O}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Q;function Z(B){const O=new D.CancellationTokenSource,N=B(O.token);return new Q(O,async W=>{const H=O.token.onCancellationRequested(()=>{H.dispose(),O.dispose(),W.reject(new n.CancellationError)});try{for await(const re of N){if(O.token.isCancellationRequested)return;W.emitOne(re)}H.dispose(),O.dispose()}catch(re){H.dispose(),O.dispose(),W.reject(re)}})}e.createCancelableAsyncIterable=Z}),define(te[109],ne([0,1,5,41,39,10,4,27]),function(Y,e,D,n,L,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function b(){return Object.create(null)}e.getEmptyExpression=b,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const E="[/\\\\]",P="[^/\\\\]",C=/\//g;function f(q){switch(q){case 0:return"";case 1:return`${P}*?`;default:return`(?:${E}|${P}+${E}|${E}${P}+)*?`}}function S(q,j){if(!q)return[];const K=[];let V=!1,Q=!1,Z="";for(const B of q){switch(B){case j:if(!V&&!Q){K.push(Z),Z="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}Z+=B}return Z&&K.push(Z),K}e.splitGlobAware=S;function u(q){if(!q)return"";let j="";const K=S(q,e.GLOB_SPLIT);if(K.every(V=>V===e.GLOBSTAR))j=".*";else{let V=!1;K.forEach((Q,Z)=>{if(Q===e.GLOBSTAR){V||(j+=f(2),V=!0);return}let B=!1,O="",N=!1,W="";for(const H of Q){if(H!=="}"&&B){O+=H;continue}if(N&&(H!=="]"||!W)){let re;H==="-"?re=H:(H==="^"||H==="!")&&!W?re="^":H===e.GLOB_SPLIT?re="":re=(0,I.escapeRegExpCharacters)(H),W+=re;continue}switch(H){case"{":B=!0;continue;case"[":N=!0;continue;case"}":{j+=`(?:${S(O,",").map(ue=>u(ue)).join("|")})`,B=!1,O="";break}case"]":j+="["+W+"]",N=!1,W="";break;case"?":j+=P;continue;case"*":j+=f(1);continue;default:j+=(0,I.escapeRegExpCharacters)(H)}}Z<K.length-1&&(K[Z+1]!==e.GLOBSTAR||Z+2<K.length)&&(j+=E),V=!1})}return j}const v=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,w=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new L.LRUCache(1e4),i=function(){return!1},a=function(){return null};function r(q,j){if(!q)return a;let K;typeof q!="string"?K=q.pattern:K=q,K=K.trim();const V=`${K}_${!!j.trimForExclusions}`;let Q=l.get(V);if(Q)return t(Q,q);let Z;if(v.test(K)){const B=K.substr(4);Q=function(O,N){return typeof O=="string"&&O.endsWith(B)?K:null}}else(Z=d.exec(o(K,j)))?Q=s(Z[1],K):(j.trimForExclusions?w:m).test(K)?Q=c(K,j):(Z=y.exec(o(K,j)))?Q=h(Z[1].substr(1),K,!0):(Z=p.exec(o(K,j)))?Q=h(Z[1],K,!1):Q=g(K);return l.set(V,Q),t(Q,q)}function t(q,j){return typeof j=="string"?q:function(K,V){return(0,n.isEqualOrParent)(K,j.base,!A.isLinux)?q(K.substr(j.base.length+1),V):null}}function o(q,j){return j.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function s(q,j){const K=`/${q}`,V=`\\${q}`,Q=function(B,O){return typeof B!="string"?null:O?O===q?j:null:B===q||B.endsWith(K)||B.endsWith(V)?j:null},Z=[q];return Q.basenames=Z,Q.patterns=[j],Q.allBasenames=Z,Q}function c(q,j){const K=ee(q.slice(1,-1).split(",").map(O=>r(O,j)).filter(O=>O!==a),q),V=K.length;if(!V)return a;if(V===1)return K[0];const Q=function(O,N){for(let W=0,H=K.length;W<H;W++)if(K[W](O,N))return q;return null},Z=K.find(O=>!!O.allBasenames);Z&&(Q.allBasenames=Z.allBasenames);const B=K.reduce((O,N)=>N.allPaths?O.concat(N.allPaths):O,[]);return B.length&&(Q.allPaths=B),Q}function h(q,j,K){const V=T.sep===T.posix.sep,Q=V?q:q.replace(C,T.sep),Z=T.sep+Q,B=T.posix.sep+q,O=K?function(N,W){return typeof N=="string"&&(N===Q||N.endsWith(Z)||!V&&(N===q||N.endsWith(B)))?j:null}:function(N,W){return typeof N=="string"&&(N===Q||!V&&N===q)?j:null};return O.allPaths=[(K?"*/":"./")+q],O}function g(q){try{const j=new RegExp(`^${u(q)}$`);return function(K){return j.lastIndex=0,typeof K=="string"&&j.test(K)?q:null}}catch{return a}}function R(q,j,K){return!q||typeof j!="string"?!1:_(q)(j,void 0,K)}e.match=R;function _(q,j={}){if(!q)return i;if(typeof q=="string"||M(q)){const K=r(q,j);if(K===a)return i;const V=function(Q,Z){return!!K(Q,Z)};return K.allBasenames&&(V.allBasenames=K.allBasenames),K.allPaths&&(V.allPaths=K.allPaths),V}return z(q,j)}e.parse=_;function U(q){if(!q)return;let j;return K=>(j||(j=(q()||Promise.resolve([])).then(V=>V?k(V):{})),j.then(V=>!!V[K]))}e.hasSiblingPromiseFn=U;function F(q){if(!q)return;let j;return K=>{if(!j){const V=q();j=V?k(V):{}}return!!j[K]}}e.hasSiblingFn=F;function k(q){const j={};for(const K of q)j[K]=!0;return j}function M(q){const j=q;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}e.isRelativePattern=M;function $(q){return q.allBasenames||[]}e.getBasenameTerms=$;function x(q){return q.allPaths||[]}e.getPathTerms=x;function z(q,j){const K=ee(Object.getOwnPropertyNames(q).map(O=>G(O,q[O],j)).filter(O=>O!==a)),V=K.length;if(!V)return a;if(!K.some(O=>!!O.requiresSiblings)){if(V===1)return K[0];const O=function(H,re){for(let se=0,ue=K.length;se<ue;se++){const de=K[se](H,re);if(de)return de}return null},N=K.find(H=>!!H.allBasenames);N&&(O.allBasenames=N.allBasenames);const W=K.reduce((H,re)=>re.allPaths?H.concat(re.allPaths):H,[]);return W.length&&(O.allPaths=W),O}const Q=function(O,N,W){let H;for(let re=0,se=K.length;re<se;re++){const ue=K[re];ue.requiresSiblings&&W&&(N||(N=(0,T.basename)(O)),H||(H=N.substr(0,N.length-(0,T.extname)(O).length)));const de=ue(O,N,H,W);if(de)return de}return null},Z=K.find(O=>!!O.allBasenames);Z&&(Q.allBasenames=Z.allBasenames);const B=K.reduce((O,N)=>N.allPaths?O.concat(N.allPaths):O,[]);return B.length&&(Q.allPaths=B),Q}function G(q,j,K){if(j===!1)return a;const V=r(q,K);if(V===a)return a;if(typeof j=="boolean")return V;if(j){const Q=j.when;if(typeof Q=="string"){const Z=(B,O,N,W)=>{if(!W||!V(B,O))return null;const H=Q.replace("$(basename)",N),re=W(H);return(0,D.isThenable)(re)?re.then(se=>se?q:null):re?q:null};return Z.requiresSiblings=!0,Z}}return V}function ee(q,j){const K=q.filter(O=>!!O.basenames);if(K.length<2)return q;const V=K.reduce((O,N)=>{const W=N.basenames;return W?O.concat(W):O},[]);let Q;if(j){Q=[];for(let O=0,N=V.length;O<N;O++)Q.push(j)}else Q=K.reduce((O,N)=>{const W=N.patterns;return W?O.concat(W):O},[]);const Z=function(O,N){if(typeof O!="string")return null;if(!N){let H;for(H=O.length;H>0;H--){const re=O.charCodeAt(H-1);if(re===47||re===92)break}N=O.substr(H)}const W=V.indexOf(N);return W!==-1?Q[W]:null};Z.basenames=V,Z.patterns=Q,Z.allBasenames=V;const B=q.filter(O=>!O.basenames);return B.push(Z),B}}),define(te[110],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(P){return P.toJSON()}class L{constructor(C){this._uriTransformer=C}transformIncoming(C){const f=this._uriTransformer.transformIncoming(C);return f===C?C:n(D.URI.from(f))}transformOutgoing(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:n(D.URI.from(f))}transformOutgoingURI(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:D.URI.from(f)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function T(P,C,f){if(!P||f>200)return null;if(typeof P=="object"){if(P instanceof D.URI)return C.transformOutgoing(P);for(let S in P)if(Object.hasOwnProperty.call(P,S)){const u=T(P[S],C,f+1);u!==null&&(P[S]=u)}}return null}function A(P,C){const f=T(P,C,0);return f===null?P:f}e.transformOutgoingURIs=A;function I(P,C,f,S){if(!P||S>200)return null;if(typeof P=="object"){if(P.$mid===1)return f?D.URI.revive(C.transformIncoming(P)):C.transformIncoming(P);for(let u in P)if(Object.hasOwnProperty.call(P,u)){const v=I(P[u],C,f,S+1);v!==null&&(P[u]=v)}}return null}function b(P,C){const f=I(P,C,!1,0);return f===null?P:f}e.transformIncomingURIs=b;function E(P,C){const f=I(P,C,!0,0);return f===null?P:f}e.transformAndReviveIncomingURIs=E}),define(te[29],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(b){return D.test(b)}e.isUUID=n;const L=new Uint8Array(16),T=[];for(let b=0;b<256;b++)T.push(b.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(b){for(let E=0;E<b.length;E++)b[E]=Math.floor(Math.random()*256);return b};function I(){A(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let b=0,E="";return E+=T[L[b++]],E+=T[L[b++]],E+=T[L[b++]],E+=T[L[b++]],E+="-",E+=T[L[b++]],E+=T[L[b++]],E+="-",E+=T[L[b++]],E+=T[L[b++]],E+="-",E+=T[L[b++]],E+=T[L[b++]],E+="-",E+=T[L[b++]],E+=T[L[b++]],E+=T[L[b++]],E+=T[L[b++]],E+=T[L[b++]],E+=T[L[b++]],E}e.generateUuid=I}),define(te[111],ne([0,1,251]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(T="utf8"){this.stringDecoder=new D.StringDecoder(T),this.remaining=null}write(T){const A=[],I=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(I.length<1)return A;let b=0,E,P=b;for(;P<I.length;)if(E=I.charCodeAt(P),E===13||E===10){if(A.push(I.substring(b,P)),P++,P<I.length){const C=E;E=I.charCodeAt(P),(C===13&&E===10||C===10&&E===13)&&P++}b=P}else P++;return this.remaining=b<I.length?I.substr(b):null,A}end(){return this.remaining}}e.LineDecoder=n}),define(te[112],ne([0,1,33]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(A){const I=A.replace(/\-/g,":").toLowerCase();return!n.has(I)}function T(){const A=(0,D.networkInterfaces)();for(let I in A){const b=A[I];if(b){for(const{mac:E}of b)if(L(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(te[113],ne([0,1,33,9,39,29,112]),function(Y,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(P){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(P)}value(){if(this._value===void 0){let P=0,C=0;const f=(0,D.networkInterfaces)();for(let S in f){const u=f[S];if(u)for(const{mac:v,internal:d}of u)d||(C+=1,this._isVirtualMachineMacAddress(v.toUpperCase())&&(P+=1))}this._value=C>0?P/C:0}return this._value}};let I;async function b(){return I||(I=(async()=>await E()||T.generateUuid())()),I}e.getMachineId=b;async function E(){try{const P=await new Promise((f,S)=>{Y(["crypto"],f,S)}),C=(0,A.getMac)();return P.createHash("sha256").update(C,"utf8").digest("hex")}catch(P){n.onUnexpectedError(P);return}}}),define(te[22],ne([0,1,50,33,252,5,41,71,10,4,19,7]),function(Y,e,D,n,L,T,A,I,b,E,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function S($,x=f.UNLINK){if((0,A.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return x===f.UNLINK?v($):u($)}async function u($){try{const x=(0,A.randomPath)((0,n.tmpdir)());try{await D.promises.rename($,x)}catch{return v($)}v(x).catch(z=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function v($){return e.Promises.rmdir($,{recursive:!0,maxRetries:3})}function d($){if((0,A.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");D.rmdirSync($,{recursive:!0})}e.rimrafSync=d;async function m($,x){return p(await(x?w($):(0,L.promisify)(D.readdir)($)))}async function w($){try{return await(0,L.promisify)(D.readdir)($,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const x=[],z=await m($);for(const G of z){let ee=!1,q=!1,j=!1;try{const K=await e.Promises.lstat((0,b.join)($,G));ee=K.isFile(),q=K.isDirectory(),j=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}x.push({name:G,isFile:()=>ee,isDirectory:()=>q,isSymbolicLink:()=>j})}return x}function y($){return p(D.readdirSync($))}e.readdirSync=y;function p($){return $.map(x=>typeof x=="string"?E.isMacintosh?(0,I.normalizeNFC)(x):x:(x.name=E.isMacintosh?(0,I.normalizeNFC)(x.name):x.name,x))}async function l($){const x=await m($),z=[];for(const G of x)await a.existsDirectory((0,b.join)($,G))&&z.push(G);return z}function i($,x=1e3){return new Promise(z=>{let G=!1;const ee=setInterval(()=>{G||(G=!0,D.access($,q=>{G=!1,q&&(clearInterval(ee),z(void 0))}))},x)})}e.whenDeleted=i;var a;(function($){async function x(ee){let q;try{if(q=await e.Promises.lstat(ee),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(ee),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(E.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ee)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw K}throw j}}$.stat=x;async function z(ee){try{const{stat:q,symbolicLink:j}=await $.stat(ee);return q.isFile()&&j?.dangling!==!0}catch{}return!1}$.existsFile=z;async function G(ee){try{const{stat:q,symbolicLink:j}=await $.stat(ee);return q.isDirectory()&&j?.dangling!==!0}catch{}return!1}$.existsDirectory=G})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new T.ResourceQueue;function t($,x,z){return r.queueFor(C.URI.file($),P.extUriBiasedIgnorePathCase).queue(()=>{const G=h(z);return new Promise((ee,q)=>s($,x,G,j=>j?q(j):ee()))})}let o=!0;function s($,x,z,G){if(!o)return D.writeFile($,x,{mode:z.mode,flag:z.flag},G);D.open($,z.flag,z.mode,(ee,q)=>{if(ee)return G(ee);D.writeFile(q,x,j=>{if(j)return D.close(q,()=>G(j));D.fdatasync(q,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),o=!1),D.close(q,V=>G(V))))})})}function c($,x,z){const G=h(z);if(!o)return D.writeFileSync($,x,{mode:G.mode,flag:G.flag});const ee=D.openSync($,G.flag,G.mode);try{D.writeFileSync(ee,x);try{D.fdatasyncSync(ee)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),o=!1}}finally{D.closeSync(ee)}}e.writeFileSync=c;function h($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function g($,x){if($===x)return;async function z(G){try{const ee=await e.Promises.lstat(G);if(ee.isDirectory()||ee.isSymbolicLink())return;await e.Promises.utimes(G,ee.atime,new Date)}catch{}}try{await e.Promises.rename($,x),await z(x)}catch(G){if($.toLowerCase()!==x.toLowerCase()&&G.code==="EXDEV"||$.endsWith("."))await R($,x,{preserveSymlinks:!1}),await S($,f.MOVE),await z(x);else throw G}}async function R($,x,z){return U($,x,{root:{source:$,target:x},options:z,handledSourcePaths:new Set})}const _=511;async function U($,x,z){if(z.handledSourcePaths.has($))return;z.handledSourcePaths.add($);const{stat:G,symbolicLink:ee}=await a.stat($);if(ee){if(z.options.preserveSymlinks)try{return await M($,x,z)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(ee.dangling)return}return G.isDirectory()?F($,x,G.mode&_,z):k($,x,G.mode&_)}async function F($,x,z,G){await e.Promises.mkdir(x,{recursive:!0,mode:z});const ee=await m($);for(const q of ee)await U((0,b.join)($,q),(0,b.join)(x,q),G)}async function k($,x,z){await e.Promises.copyFile($,x),await e.Promises.chmod(x,z)}async function M($,x,z){let G=await e.Promises.readlink($);(0,A.isEqualOrParent)(G,z.root.source,!E.isLinux)&&(G=(0,b.join)(z.root.target,G.substr(z.root.source.length+1))),await e.Promises.symlink(G,x)}e.Promises=new class{get access(){return(0,L.promisify)(D.access)}get stat(){return(0,L.promisify)(D.stat)}get lstat(){return(0,L.promisify)(D.lstat)}get utimes(){return(0,L.promisify)(D.utimes)}get read(){return($,x,z,G,ee)=>new Promise((q,j)=>{D.read($,x,z,G,ee,(K,V,Q)=>K?j(K):q({bytesRead:V,buffer:Q}))})}get readFile(){return(0,L.promisify)(D.readFile)}get write(){return($,x,z,G,ee)=>new Promise((q,j)=>{D.write($,x,z,G,ee,(K,V,Q)=>K?j(K):q({bytesWritten:V,buffer:Q}))})}get appendFile(){return(0,L.promisify)(D.appendFile)}get fdatasync(){return(0,L.promisify)(D.fdatasync)}get truncate(){return(0,L.promisify)(D.truncate)}get rename(){return(0,L.promisify)(D.rename)}get copyFile(){return(0,L.promisify)(D.copyFile)}get open(){return(0,L.promisify)(D.open)}get close(){return(0,L.promisify)(D.close)}get symlink(){return(0,L.promisify)(D.symlink)}get readlink(){return(0,L.promisify)(D.readlink)}get chmod(){return(0,L.promisify)(D.chmod)}get mkdir(){return(0,L.promisify)(D.mkdir)}get unlink(){return(0,L.promisify)(D.unlink)}get rmdir(){return(0,L.promisify)(D.rmdir)}get realpath(){return(0,L.promisify)(D.realpath)}async exists($){try{return await e.Promises.access($),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return l}get writeFile(){return t}get rm(){return S}get move(){return g}get copy(){return R}}}),define(te[114],ne([0,1,50,10,4,27,22]),function(Y,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(f){if(L.isLinux)return f;const S=(0,n.dirname)(f);if(f===S)return f;const u=((0,n.basename)(f)||f).toLowerCase();try{const d=(0,A.readdirSync)(S).filter(m=>m.toLowerCase()===u);if(d.length===1){const m=I(S);if(m)return(0,n.join)(m,d[0])}else if(d.length>1){const m=d.indexOf(u);if(m>=0){const w=I(S);if(w)return(0,n.join)(w,d[m])}}}catch{}return null}e.realcaseSync=I;async function b(f){if(L.isLinux)return f;const S=(0,n.dirname)(f);if(f===S)return f;const u=((0,n.basename)(f)||f).toLowerCase();try{const d=(await A.Promises.readdir(S)).filter(m=>m.toLowerCase()===u);if(d.length===1){const m=await b(S);if(m)return(0,n.join)(m,d[0])}else if(d.length>1){const m=d.indexOf(u);if(m>=0){const w=await b(S);if(w)return(0,n.join)(w,d[m])}}}catch{}return null}e.realcase=b;async function E(f){try{return await A.Promises.realpath(f)}catch{const u=C(f);return await A.Promises.access(u,D.constants.R_OK),u}}e.realpath=E;function P(f){try{return D.realpathSync(f)}catch{const u=C(f);return D.accessSync(u,D.constants.R_OK),u}}e.realpathSync=P;function C(f){return(0,T.rtrim)((0,n.normalize)(f),n.sep)}}),define(te[115],ne([0,1,56]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(I,b,E,P=1){let C=!1;return new Promise(f=>{const S=setTimeout(()=>{if(!C)return C=!0,f(0)},E);L(I,b,P,u=>{if(!C)return C=!0,clearTimeout(S),f(u)})})}e.findFreePort=n;function L(I,b,E,P){if(b===0)return P(0);const C=new D.Socket;C.once("connect",()=>(A(C),L(I+E,b-1,E,P))),C.once("data",()=>{}),C.once("error",f=>(A(C),f.code!=="ECONNREFUSED"?L(I+E,b-1,E,P):P(I))),C.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(I,b,E){let P=!1,C,f=1;const S=D.createServer({pauseOnConnect:!0});function u(v,d){P||(P=!0,S.removeAllListeners(),S.close(),C&&clearTimeout(C),d(v))}return new Promise(v=>{C=setTimeout(()=>{u(0,v)},E),S.on("listening",()=>{u(I,v)}),S.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&f<b?(I++,f++,S.listen(I,"127.0.0.1")):u(0,v)}),S.on("close",()=>{u(0,v)}),S.listen(I,"127.0.0.1")})}e.findFreePortFaster=T;function A(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(b){console.error(b)}}}),define(te[72],ne([0,1,33,10,22]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,A=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var b;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(b||(b={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class C{constructor(l,i,a){this.exePath=l,this.displayName=i,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await L.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:p=!1}={}){return p?E===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:p=!1,findPreview:l=!1}={}){const i=f({useAlternateBitness:p});if(!i)return null;const a=n.join(i,"PowerShell");if(!await L.SymlinkSupport.existsDirectory(a))return null;let r=-1,t=null;for(const c of await L.Promises.readdir(a)){let h=-1;if(l){const R=c.indexOf("-");if(R<0)continue;const _=c.substring(0,R);if(!T.test(_)||c.substring(R+1)!=="preview")continue;h=parseInt(_,10)}else{if(!T.test(c))continue;h=parseInt(c,10)}if(h<=r)continue;const g=n.join(a,c,"pwsh.exe");!await L.SymlinkSupport.existsFile(g)||(t=g,r=h)}if(!t)return null;const o=i.includes("x86")?" (x86)":"",s=l?" Preview":"";return new C(t,`PowerShell${s}${o}`,!0)}async function u({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const l=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await L.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:i,pwshMsixName:a}=p?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const r of await L.Promises.readdir(l))if(i.test(r)){const t=n.join(l,r,"pwsh.exe");return new C(t,a)}return null}function v(){const p=n.join(D.homedir(),".dotnet","tools","pwsh.exe");return new C(p,".NET Core PowerShell Global Tool")}function d(){const p=n.join(process.env.windir,E===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(p,"Windows PowerShell",!0)}async function*m(){let p=await S();p&&(yield p),p=await S({useAlternateBitness:!0}),p&&(yield p),p=await u(),p&&(yield p),p=v(),p&&(yield p),p=await S({findPreview:!0}),p&&(yield p),p=await u({findPreview:!0}),p&&(yield p),p=await S({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=d(),p&&(yield p)}async function*w(){for await(const p of m())await p.exists()&&(yield p)}e.enumeratePowerShellInstallations=w;async function y(){for await(const p of w())return p;return null}e.getFirstAvailablePowerShellInstallation=y}),define(te[116],ne([0,1,45,18]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(A){return new Promise((I,b)=>{let E;const P=new Map;function C(S,u,v,d,m){const w=P.get(u);if(S===A||w){const y={name:f(v),cmd:v,pid:S,ppid:u,load:d,mem:m};P.set(S,y),S===A&&(E=y),w&&(w.children||(w.children=[]),w.children.push(y),w.children.length>1&&(w.children=w.children.sort((p,l)=>p.pid-l.pid)))}}function f(S){const u=/--vscode-window-kind=shared-process/,v=/--vscode-window-kind=issue-reporter/,d=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,w=/--crashes-directory/,y=/\\pipe\\winpty-control/,p=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(w.exec(S))return"electron-crash-reporter";if(y.exec(S))return"winpty-process";if(p.exec(S))return"console-window-host (Windows internal process)";let i=l.exec(S);if(i&&i.length===2)return i[1]==="renderer"?u.exec(S)?"shared-process":v.exec(S)?"issue-reporter":d.exec(S)?"process-explorer":"window":i[1]==="utility"&&m.exec(S)?"utility-network-service":i[1];const a=/[a-zA-Z-]+\.js/g;let r="";do i=a.exec(S),i&&(r+=i+" ");while(i);return r&&S.indexOf("node ")<0&&S.indexOf("node.exe")<0?`electron_node ${r}`:S}if(process.platform==="win32"){const S=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,v)=>{Y(["windows-process-tree"],u,v)}).then(u=>{u.getProcessList(A,v=>{u.getProcessCpuUsage(v,d=>{const m=new Map;d.forEach(w=>{const y=S(w.commandLine||"");m.set(w.pid,{name:f(y),cmd:y,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),E=m.get(A),E?(m.forEach(w=>{const y=m.get(w.ppid);y&&(y.children||(y.children=[]),y.children.push(w))}),m.forEach(w=>{w.children&&(w.children=w.children.sort((y,p)=>y.pid-p.pid))}),I(E)):b(new Error(`Root process ${A} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let S=function(){let u=[E];const v=[];for(;u.length;){const m=u.shift();m&&(v.push(m.pid),m.children&&(u=u.concat(m.children)))}let d=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Y).fsPath);d+=" "+v.join(" "),(0,D.exec)(d,{},(m,w,y)=>{if(m||y)b(m||new Error(y.toString()));else{const p=w.toString().split(`
`);for(let l=0;l<v.length;l++){const i=P.get(v[l]);i.load=parseFloat(p[l])}if(!E){b(new Error(`Root process ${A} not found`));return}I(E)}})};(0,D.exec)("which ps",{},(u,v,d)=>{if(u||d)if(process.platform!=="linux")b(u||new Error(d.toString()));else{const m=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",Y).fsPath);(0,D.exec)(m,{},(w,y,p)=>{w||p?b(w||new Error(p.toString())):(T(y,C),S())})}else{const m=v.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${m} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(y,p,l)=>{y||l&&!l.includes("screen size is bogus")?b(y||new Error(l.toString())):(T(p,C),process.platform==="linux"?S():E?I(E):b(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=L;function T(A,I){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=A.toString().split(`
`);for(const P of E){const C=b.exec(P.trim());C&&C.length===6&&I(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}});var he=this&&this.__decorate||function(Y,e,D,n){var L=arguments.length,T=L<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,D):n,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(Y,e,D,n);else for(var I=Y.length-1;I>=0;I--)(A=Y[I])&&(T=(L<3?A(T):L>3?A(e,D,T):A(e,D))||T);return L>3&&T&&Object.defineProperty(e,D,T),T};define(te[36],ne([0,1,16,5,17,23,54,9,3,2,108,27,15]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var S;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(S=e.RequestType||(e.RequestType={}));function u(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function d(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(m||(m={}));class w{constructor(j){this.buffer=j,this.pos=0}read(j){const K=this.buffer.slice(this.pos,this.pos+j);return this.pos+=K.byteLength,K}}class y{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(j){this.buffers.push(j)}}var p;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(p||(p={}));function l(q){const j=L.VSBuffer.alloc(4);return j.writeUInt32BE(q,0),j}function i(q){return q.read(4).readUInt32BE(0)}function a(q){const j=L.VSBuffer.alloc(1);return j.writeUInt8(q,0),j}const r={Undefined:a(p.Undefined),String:a(p.String),Buffer:a(p.Buffer),VSBuffer:a(p.VSBuffer),Array:a(p.Array),Object:a(p.Object)},t=typeof Buffer!="undefined";function o(q,j){if(typeof j=="undefined")q.write(r.Undefined);else if(typeof j=="string"){const K=L.VSBuffer.fromString(j);q.write(r.String),q.write(l(K.byteLength)),q.write(K)}else if(t&&Buffer.isBuffer(j)){const K=L.VSBuffer.wrap(j);q.write(r.Buffer),q.write(l(K.byteLength)),q.write(K)}else if(j instanceof L.VSBuffer)q.write(r.VSBuffer),q.write(l(j.byteLength)),q.write(j);else if(Array.isArray(j)){q.write(r.Array),q.write(l(j.length));for(const K of j)o(q,K)}else{const K=L.VSBuffer.fromString(JSON.stringify(j));q.write(r.Object),q.write(l(K.byteLength)),q.write(K)}}function s(q){switch(q.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return q.read(i(q)).toString();case p.Buffer:return q.read(i(q)).buffer;case p.VSBuffer:return q.read(i(q));case p.Array:{const K=i(q),V=[];for(let Q=0;Q<K;Q++)V.push(s(q));return V}case p.Object:return JSON.parse(q.read(i(q)).toString())}}class c{constructor(j,K,V=null,Q=1e3){this.protocol=j,this.ctx=K,this.logger=V,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Z=>this.onRawMessage(Z)),this.sendResponse({type:200})}registerChannel(j,K){this.channels.set(j,K),setTimeout(()=>this.flushPendingRequests(j),0)}sendResponse(j){switch(j.type){case 200:{const K=this.send([j.type]);this.logger&&this.logger.logOutgoing(K,0,1,d(j.type));return}case 201:case 202:case 204:case 203:{const K=this.send([j.type,j.id],j.data);this.logger&&this.logger.logOutgoing(K,j.id,1,d(j.type),j.data);return}}}send(j,K=void 0){const V=new y;return o(V,j),o(V,K),this.sendBuffer(V.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onRawMessage(j){const K=new w(j),V=s(K),Q=s(K),Z=V[0];switch(Z){case 100:return this.logger&&this.logger.logIncoming(j.byteLength,V[1],1,`${u(Z)}: ${V[2]}.${V[3]}`,Q),this.onPromise({type:Z,id:V[1],channelName:V[2],name:V[3],arg:Q});case 102:return this.logger&&this.logger.logIncoming(j.byteLength,V[1],1,`${u(Z)}: ${V[2]}.${V[3]}`,Q),this.onEventListen({type:Z,id:V[1],channelName:V[2],name:V[3],arg:Q});case 101:return this.logger&&this.logger.logIncoming(j.byteLength,V[1],1,`${u(Z)}`),this.disposeActiveRequest({type:Z,id:V[1]});case 103:return this.logger&&this.logger.logIncoming(j.byteLength,V[1],1,`${u(Z)}`),this.disposeActiveRequest({type:Z,id:V[1]})}}onPromise(j){const K=this.channels.get(j.channelName);if(!K){this.collectPendingRequest(j);return}const V=new T.CancellationTokenSource;let Q;try{Q=K.call(this.ctx,j.name,j.arg,V.token)}catch(O){Q=Promise.reject(O)}const Z=j.id;Q.then(O=>{this.sendResponse({id:Z,data:O,type:201}),this.activeRequests.delete(j.id)},O=>{O instanceof Error?this.sendResponse({id:Z,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.sendResponse({id:Z,data:O,type:203}),this.activeRequests.delete(j.id)});const B=(0,E.toDisposable)(()=>V.cancel());this.activeRequests.set(j.id,B)}onEventListen(j){const K=this.channels.get(j.channelName);if(!K){this.collectPendingRequest(j);return}const V=j.id,Z=K.listen(this.ctx,j.name,j.arg)(B=>this.sendResponse({id:V,data:B,type:204}));this.activeRequests.set(j.id,Z)}disposeActiveRequest(j){const K=this.activeRequests.get(j.id);K&&(K.dispose(),this.activeRequests.delete(j.id))}collectPendingRequest(j){let K=this.pendingRequests.get(j.channelName);K||(K=[],this.pendingRequests.set(j.channelName,K));const V=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.sendResponse({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:j,timeoutTimer:V})}flushPendingRequests(j){const K=this.pendingRequests.get(j);if(K){for(const V of K)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(j)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(j=>j.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var h;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class g{constructor(j,K=null){this.protocol=j,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=K}getChannel(j){const K=this;return{call(V,Q,Z){return K.isDisposed?Promise.reject(I.canceled()):K.requestPromise(j,V,Q,Z)},listen(V,Q){return K.isDisposed?Promise.reject(I.canceled()):K.requestEvent(j,V,Q)}}}requestPromise(j,K,V,Q=T.CancellationToken.None){const Z=this.lastRequestId++,O={id:Z,type:100,channelName:j,name:K,arg:V};if(Q.isCancellationRequested)return Promise.reject(I.canceled());let N;return new Promise((H,re)=>{if(Q.isCancellationRequested)return re(I.canceled());const se=()=>{const pe=ge=>{switch(ge.type){case 201:this.handlers.delete(Z),H(ge.data);break;case 202:{this.handlers.delete(Z);const be=new Error(ge.data.message);be.stack=ge.data.stack,be.name=ge.data.name,re(be);break}case 203:this.handlers.delete(Z),re(ge.data);break}};this.handlers.set(Z,pe),this.sendRequest(O)};let ue=null;this.state===m.Idle?se():(ue=(0,n.createCancelablePromise)(pe=>this.whenInitialized()),ue.then(()=>{ue=null,se()}));const de=()=>{ue?(ue.cancel(),ue=null):this.sendRequest({id:Z,type:101}),re(I.canceled())},we=Q.onCancellationRequested(de);N=(0,E.combinedDisposable)((0,E.toDisposable)(de),we),this.activeRequests.add(N)}).finally(()=>{this.activeRequests.delete(N)})}requestEvent(j,K,V){const Q=this.lastRequestId++,B={id:Q,type:102,channelName:j,name:K,arg:V};let O=null;const N=new b.Emitter({onFirstListenerAdd:()=>{O=(0,n.createCancelablePromise)(H=>this.whenInitialized()),O.then(()=>{O=null,this.activeRequests.add(N),this.sendRequest(B)})},onLastListenerRemove:()=>{O?(O.cancel(),O=null):(this.activeRequests.delete(N),this.sendRequest({id:Q,type:103}))}}),W=H=>N.fire(H.data);return this.handlers.set(Q,W),N.event}sendRequest(j){switch(j.type){case 100:case 102:{const K=this.send([j.type,j.id,j.channelName,j.name],j.arg);this.logger&&this.logger.logOutgoing(K,j.id,0,`${u(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const K=this.send([j.type,j.id]);this.logger&&this.logger.logOutgoing(K,j.id,0,u(j.type));return}}}send(j,K=void 0){const V=new y;return o(V,j),o(V,K),this.sendBuffer(V.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onBuffer(j){const K=new w(j),V=s(K),Q=s(K),Z=V[0];switch(Z){case 200:return this.logger&&this.logger.logIncoming(j.byteLength,0,0,d(Z)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(j.byteLength,V[1],0,d(Z),Q),this.onResponse({type:V[0],id:V[1],data:Q})}}onResponse(j){if(j.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const K=this.handlers.get(j.id);K&&K(j)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(j=>j.dispose()),this.activeRequests.clear()}}he([A.memoize],g.prototype,"onDidInitializePromise",null),e.ChannelClient=g;class R{constructor(j){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,j(({protocol:K,onDidClientDisconnect:V})=>{b.Event.once(K.onMessage)(Z=>{const B=new w(Z),O=s(B),N=new c(K,O),W=new g(K);this.channels.forEach((re,se)=>N.registerChannel(se,re));const H={channelServer:N,channelClient:W,ctx:O};this._connections.add(H),this._onDidAddConnection.fire(H),V(()=>{N.dispose(),W.dispose(),this._connections.delete(H),this._onDidRemoveConnection.fire(H)})})})}get connections(){const j=[];return this._connections.forEach(K=>j.push(K)),j}getChannel(j,K){const V=this;return{call(Q,Z,B){let O;if((0,f.isFunction)(K)){let W=(0,D.getRandomElement)(V.connections.filter(K));O=W?Promise.resolve(W):b.Event.toPromise(b.Event.filter(V.onDidAddConnection,K))}else O=K.routeCall(V,Q,Z);const N=O.then(W=>W.channelClient.getChannel(j));return U(N).call(Q,Z,B)},listen(Q,Z){if((0,f.isFunction)(K))return V.getMulticastEvent(j,K,Q,Z);const B=K.routeEvent(V,Q,Z).then(O=>O.channelClient.getChannel(j));return U(B).listen(Q,Z)}}}getMulticastEvent(j,K,V,Q){const Z=this;let B=new E.DisposableStore;const O=new b.Emitter({onFirstListenerAdd:()=>{B=new E.DisposableStore;const N=new b.EventMultiplexer,W=new Map,H=se=>{const de=se.channelClient.getChannel(j).listen(V,Q),we=N.add(de);W.set(se,we)},re=se=>{const ue=W.get(se);!ue||(ue.dispose(),W.delete(se))};Z.connections.filter(K).forEach(H),b.Event.filter(Z.onDidAddConnection,K)(H,void 0,B),Z.onDidRemoveConnection(re,void 0,B),N.event(O.fire,O,B),B.add(N)},onLastListenerRemove:()=>{B.dispose()}});return O.event}registerChannel(j,K){this.channels.set(j,K),this._connections.forEach(V=>{V.channelServer.registerChannel(j,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=R;class _{constructor(j,K,V=null){const Q=new y;o(Q,K),j.send(Q.buffer),this.channelClient=new g(j,V),this.channelServer=new c(j,K,V)}getChannel(j){return this.channelClient.getChannel(j)}registerChannel(j,K){this.channelServer.registerChannel(j,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function U(q){return{call(j,K,V){return q.then(Q=>Q.call(j,K,V))},listen(j,K){const V=new b.Relay;return q.then(Q=>V.input=Q.listen(j,K)),V.event}}}e.getDelayedChannel=U;function F(q){let j=!1;return{call(K,V,Q){return j?q.call(K,V,Q):(0,n.timeout)(0).then(()=>j=!0).then(()=>q.call(K,V,Q))},listen(K,V){if(j)return q.listen(K,V);const Q=new b.Relay;return(0,n.timeout)(0).then(()=>j=!0).then(()=>Q.input=q.listen(K,V)),Q.event}}}e.getNextTickChannel=F;class k{constructor(j){this.fn=j}routeCall(j){return this.route(j)}routeEvent(j){return this.route(j)}async route(j){for(const K of j.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await b.Event.toPromise(j.onDidAddConnection),await this.route(j)}}e.StaticRouter=k;var M;(function(q){function j(Z,B){const O=Z,N=B&&B.disableMarshalling,W=new Map;for(const H in O)V(H)&&W.set(H,b.Event.buffer(O[H],!0));return new class{listen(H,re,se){const ue=W.get(re);if(ue)return ue;if(Q(re)){const de=O[re];if(typeof de=="function")return de.call(O,se)}throw new Error(`Event not found: ${re}`)}call(H,re,se){const ue=O[re];if(typeof ue=="function"){if(!N&&Array.isArray(se))for(let de=0;de<se.length;de++)se[de]=(0,P.revive)(se[de]);return ue.apply(O,se)}throw new Error(`Method not found: ${re}`)}}}q.fromService=j;function K(Z,B){const O=B&&B.disableMarshalling;return new Proxy({},{get(N,W){if(typeof W=="string")return B?.properties?.has(W)?B.properties.get(W):Q(W)?function(H){return Z.listen(W,H)}:V(W)?Z.listen(W):async function(...H){let re;B&&!(0,f.isUndefinedOrNull)(B.context)?re=[B.context,...H]:re=H;const se=await Z.call(W,re);return O?se:(0,P.revive)(se)};throw new Error(`Property not found: ${String(W)}`)}})}q.toService=K;function V(Z){return Z[0]==="o"&&Z[1]==="n"&&C.isUpperAsciiLetter(Z.charCodeAt(2))}function Q(Z){return/^onDynamic/.test(Z)&&C.isUpperAsciiLetter(Z.charCodeAt(9))}})(M=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){let j=q.toString();if(j!=="[object Object]")return j}return q}function z(q){return Array.isArray(q)?q.map(x):x(q)}function G(q,j,K,V,Q,Z,B){B=z(B);const O=$[Q],N=O[V%O.length];let W=[`%c[${q}]%c[${String(j).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${Z}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(Z)?(W=W.concat(B),W.push(")")):W.push(B),console.log.apply(console,W)}e.logWithColors=G;class ee{constructor(j,K){this._outgoingPrefix=j,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(j,K,V,Q,Z){this._totalOutgoing+=j,G(this._outgoingPrefix,this._totalOutgoing,j,K,V,Q,Z)}logIncoming(j,K,V,Q,Z){this._totalIncoming+=j,G(this._incomingPrefix,this._totalIncoming,j,K,V,Q,Z)}}e.IPCLogger=ee}),define(te[117],ne([0,1,17,3,36]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(b){this.port=b,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",E=>D.VSBuffer.wrap(E.data)),b.start()}send(b){this.port.postMessage(b.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class A extends L.IPCClient{constructor(b,E){const P=new T(b);super(P,E);this.protocol=P}dispose(){this.protocol.disconnect()}}e.Client=A}),define(te[73],ne([0,1,17,3,2,36]),function(Y,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(t){t.enableDiagnostics=!1,t.records=[];const o=new WeakMap;let s=0;function c(g,R){if(!o.has(g)){const _=String(++s);o.set(g,_)}return o.get(g)}function h(g,R,_,U){if(!t.enableDiagnostics)return;const F=c(g,R);if(U instanceof D.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const k=D.VSBuffer.alloc(U.byteLength);k.set(U),t.records.push({timestamp:Date.now(),id:F,label:R,type:_,buff:k})}else t.records.push({timestamp:Date.now(),id:F,label:R,type:_,data:U})}t.traceSocketEvent=h})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var b;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b=e.SocketCloseEventType||(e.SocketCloseEventType={}));let E=null;function P(){return E||(E=D.VSBuffer.alloc(0)),E}class C{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,s){if(o===0)return P();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const R=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=o),R}if(this._chunks[0].byteLength>o){const R=this._chunks[0].slice(0,o);return s&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),R}let c=D.VSBuffer.alloc(o),h=0,g=0;for(;o>0;){const R=this._chunks[g];if(R.byteLength>o){const _=R.slice(0,o);c.set(_,h),h+=o,s&&(this._chunks[g]=R.slice(o),this._totalLength-=o),o-=o}else c.set(R,h),h+=R.byteLength,s?(this._chunks.shift(),this._totalLength-=R.byteLength):g++,o-=R.byteLength}return c}}e.ChunkStream=C;var f;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(f||(f={}));function S(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var u;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(u=e.ProtocolConstants||(e.ProtocolConstants={}));class v{constructor(o,s,c,h){this.type=o,this.id=s,this.ack=c,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends L.Disposable{constructor(o){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:S(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,h=this._state.id,g=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",s),this._onMessage.fire(new v(c,h,g,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=D.VSBuffer.alloc(13);s.writeUInt8(o.type,0),s.writeUInt32BE(o.id,1),s.writeUInt32BE(o.ack,5),s.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:S(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(s,o.data)}_bufferAdd(o,s){const c=this._totalLength===0;return this._data.push(o,s),this._totalLength+=o.byteLength+s.byteLength,c}_bufferTake(){const o=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,s){this._bufferAdd(o,s)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class w extends L.Disposable{constructor(o){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new v(1,0,0,o))}}e.Protocol=w;class y extends T.IPCClient{constructor(o,s,c=null){super(o,s,c);this.protocol=o}static fromSocket(o,s){return new y(new w(o),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=y;class p{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=p;class l{constructor(o){this.data=o,this.next=null}}class i{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],s=0,c=this._first;for(;c;)o[s++]=c.data,c=c.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const s=new l(o);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class a{constructor(){this.lastRuns=[];const o=Date.now();for(let s=0;s<a._HISTORY_LENGTH;s++)this.lastRuns[s]=o-1e3*s;setInterval(()=>{for(let s=a._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const o=Date.now(),s=(1+a._HISTORY_LENGTH)*1e3;let c=0;for(let h=0;h<a._HISTORY_LENGTH;h++)o-this.lastRuns[h]<=s&&c++;return 1-c/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class r{constructor(o,s=null,c=a.getInstance()){this._onControlMessage=new p,this.onControlMessage=this._onControlMessage.event,this._onMessage=new p,this.onMessage=this._onMessage.event,this._onDidDispose=new p,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new p,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new p,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),s&&this._socketReader.acceptChunk(s)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new v(5,0,0,P());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new v(7,0,0,P());this._socketWriter.write(o)}sendResume(){const o=new v(8,0,0,P());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,s){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new v(3,0,this._incomingAckId,P());this._socketWriter.write(o);const s=this._outgoingUnackMsg.toArray();for(let c=0,h=s.length;c<h;c++)this._socketWriter.write(s[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new v(6,0,0,P())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const s=this._outgoingUnackMsg.toArray();for(let c=0,h=s.length;c<h;c++)this._socketWriter.write(s[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new v(1,s,this._incomingAckId,o);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(o){const s=new v(2,0,0,o);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),s=Date.now()-o.writtenTime,c=Date.now()-this._socketReader.lastReadTime,h=Date.now()-this._lastSocketTimeoutTime;if(s>=2e4&&c>=2e4&&h>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const g=Math.max(2e4-s,2e4-c,2e4-h,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},g)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new v(3,0,this._incomingAckId,P());this._socketWriter.write(o)}}e.PersistentProtocol=r}),define(te[118],ne([0,1,74,3,36,117]),function(Y,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends L.IPCServer{static getOnDidClientConnect(){const b=n.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(E,P)=>P);return n.Event.map(b,E=>{const{port1:P,port2:C}=new MessageChannel,S={protocol:new T.Protocol(P),onDidClientDisconnect:n.Event.fromDOMEventEmitter(P,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[C]),S})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(te[119],ne([0,1,17,9]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(I,b){I.proxyAuthorization&&(I.headers={...I.headers||{},"Proxy-Authorization":I.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((P,C)=>{E.open(I.type||"GET",I.url||"",!0,I.user,I.password),T(E,I),E.responseType="arraybuffer",E.onerror=f=>C(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=f=>{P({res:{statusCode:E.status,headers:A(E)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=f=>C(new Error(`XHR timeout: ${I.timeout}ms`)),I.timeout&&(E.timeout=I.timeout),E.send(I.data),b.onCancellationRequested(()=>{E.abort(),C((0,n.canceled)())})})}e.request=L;function T(I,b){if(b.headers){e:for(let E in b.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}I.setRequestHeader(E,b.headers[E])}}}function A(I){const b=Object.create(null);for(const E of I.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const P=E.indexOf(":");b[E.substr(0,P).trim().toLowerCase()]=E.substr(P+1).trim()}return b}}),define(te[75],ne([0,1,5,3,2,15]),function(Y,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function I(C){const f=C;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var b;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(b||(b={}));class E extends L.Disposable{constructor(f,S=Object.create(null)){super();this.database=f,this.options=S,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=b.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((S,u)=>this.accept(u,S)),f.deleted?.forEach(S=>this.accept(S,void 0))}accept(f,S){if(this.state===b.Closed)return;let u=!1;(0,T.isUndefinedOrNull)(S)?u=this.cache.delete(f):this.cache.get(f)!==S&&(this.cache.set(f,S),u=!0),u&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===b.None&&(this.state=b.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,S){const u=this.cache.get(f);return(0,T.isUndefinedOrNull)(u)?S:u}getBoolean(f,S){const u=this.get(f);return(0,T.isUndefinedOrNull)(u)?S:u==="true"}getNumber(f,S){const u=this.get(f);return(0,T.isUndefinedOrNull)(u)?S:parseInt(u,10)}async set(f,S){if(this.state===b.Closed)return;if((0,T.isUndefinedOrNull)(S))return this.delete(f);const u=String(S);if(this.cache.get(f)!==u)return this.cache.set(f,u),this.pendingInserts.set(f,u),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async delete(f){if(!(this.state===b.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=b.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(f){if(!!this.hasPending)return this.doFlush(f)}async doFlush(f){return this.flushDelayer.trigger(()=>this.flushPending(),f)}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class P{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((S,u)=>this.items.set(u,S)),f.delete&&f.delete.forEach(S=>this.items.delete(S))}async close(){}}e.InMemoryStorageDatabase=P}),define(te[120],ne([11,12]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(te[57],ne([0,1,120]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,L=n*60,T=L*24,A=T*7,I=T*30,b=T*365;function E(C,f,S){typeof C!="number"&&(C=C.getTime());const u=Math.round((new Date().getTime()-C)/1e3);if(u<-30)return(0,D.localize)(0,null,E(new Date().getTime()+u*1e3,!1));if(u<30)return(0,D.localize)(1,null);let v;return u<n?(v=u,f?v===1?S?(0,D.localize)(2,null,v):(0,D.localize)(3,null,v):S?(0,D.localize)(4,null,v):(0,D.localize)(5,null,v):v===1?S?(0,D.localize)(6,null,v):(0,D.localize)(7,null,v):S?(0,D.localize)(8,null,v):(0,D.localize)(9,null,v)):u<L?(v=Math.floor(u/n),f?v===1?S?(0,D.localize)(10,null,v):(0,D.localize)(11,null,v):S?(0,D.localize)(12,null,v):(0,D.localize)(13,null,v):v===1?S?(0,D.localize)(14,null,v):(0,D.localize)(15,null,v):S?(0,D.localize)(16,null,v):(0,D.localize)(17,null,v)):u<T?(v=Math.floor(u/L),f?v===1?S?(0,D.localize)(18,null,v):(0,D.localize)(19,null,v):S?(0,D.localize)(20,null,v):(0,D.localize)(21,null,v):v===1?S?(0,D.localize)(22,null,v):(0,D.localize)(23,null,v):S?(0,D.localize)(24,null,v):(0,D.localize)(25,null,v)):u<A?(v=Math.floor(u/T),f?v===1?(0,D.localize)(26,null,v):(0,D.localize)(27,null,v):v===1?(0,D.localize)(28,null,v):(0,D.localize)(29,null,v)):u<I?(v=Math.floor(u/A),f?v===1?S?(0,D.localize)(30,null,v):(0,D.localize)(31,null,v):S?(0,D.localize)(32,null,v):(0,D.localize)(33,null,v):v===1?S?(0,D.localize)(34,null,v):(0,D.localize)(35,null,v):S?(0,D.localize)(36,null,v):(0,D.localize)(37,null,v)):u<b?(v=Math.floor(u/I),f?v===1?S?(0,D.localize)(38,null,v):(0,D.localize)(39,null,v):S?(0,D.localize)(40,null,v):(0,D.localize)(41,null,v):v===1?S?(0,D.localize)(42,null,v):(0,D.localize)(43,null,v):S?(0,D.localize)(44,null,v):(0,D.localize)(45,null,v)):(v=Math.floor(u/b),f?v===1?S?(0,D.localize)(46,null,v):(0,D.localize)(47,null,v):S?(0,D.localize)(48,null,v):(0,D.localize)(49,null,v):v===1?S?(0,D.localize)(50,null,v):(0,D.localize)(51,null,v):S?(0,D.localize)(52,null,v):(0,D.localize)(53,null,v))}e.fromNow=E;function P(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(te[121],ne([11,12]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(te[37],ne([0,1,16,15,121]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(E,P){return P&&(E.stack||E.stacktrace)?L.localize(0,null,I(E),A(E.stack)||A(E.stacktrace)):I(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function I(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?L.localize(1,null,E.message):E.message||L.localize(2,null)}function b(E=null,P=!1){if(!E)return L.localize(3,null);if(Array.isArray(E)){const C=D.coalesce(E),f=b(C[0],P);return C.length>1?L.localize(4,null,f,C.length):f}if(n.isString(E))return E;if(E.detail){const C=E.detail;if(C.error)return T(C.error,P);if(C.exception)return T(C.exception,P)}return E.stack?T(E,P):E.message?E.message:L.localize(5,null)}e.toErrorMessage=b}),define(te[122],ne([11,12]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(te[76],ne([0,1,45,41,18,28,10,4,32,103,15,111,22,122]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return E.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return E.TerminateResponseCode}});function u(i){switch(i){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function v(i,a){if(I.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};a&&(r.cwd=a);const t=D.execFile("taskkill",["/T","/F","/PID",i.pid.toString()],r);return new Promise(o=>{t.once("error",s=>{o({success:!1,error:s})}),t.once("exit",(s,c)=>{o(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?u(r.status):1})}else if(I.isLinux||I.isMacintosh)try{const r=L.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(t=>{D.execFile(r,[i.pid.toString()],{encoding:"utf8",shell:!0},(o,s,c)=>{t(o?{success:!1,error:o}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else i.kill("SIGKILL");return Promise.resolve({success:!0})}function d(i){!i||(delete i.DEBUG,I.isMacintosh&&delete i.DYLD_LIBRARY_PATH,I.isLinux&&delete i.LD_PRELOAD)}e.removeDangerousEnvVariables=d;function m(i=b.env){return i.comspec||"cmd.exe"}e.getWindowsShell=m;class w{constructor(a,r,t,o){if(r!==void 0&&t!==void 0&&o!==void 0)this.cmd=a,this.args=r,this.shell=t,this.options=o;else{const s=a;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(b.env).forEach(c=>{s[c]=b.env[c]}),Object.keys(this.options.env).forEach(c=>{s[c]=this.options.env[c]}),this.options.env=s}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const r=a.lastIndexOf(A.sep);return r!==-1&&(a=a.substring(r+1)),w.WellKnowCommands[a]?a:"other"}start(a){return I.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(b.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(r=>{let t,o;const s=new Promise((c,h)=>{t=c,o=h});if(r){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=D.exec(c,this.options,(h,g,R)=>{this.childProcess=null;const _=h;_&&_.killed?o({killed:this.terminateRequested,stdout:g.toString(),stderr:R.toString()}):this.handleExec(t,a,h,g,R)})}else{let c=null;const h=g=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(g,t,a,o);const R={terminated:this.terminateRequested};P.isNumber(g)&&(R.cmdCode=g),t(R)};if(this.shell&&I.isWindows){const g=T.deepClone(this.options);g.windowsVerbatimArguments=!0,g.detached=!1;let R=!1,_=!1;const U=[];let F=this.ensureQuotes(this.cmd);U.push(F.value),R=F.quoted,this.args&&this.args.forEach(M=>{F=this.ensureQuotes(M),U.push(F.value),_=_&&F.quoted});const k=["/s","/c"];R?_?k.push('"'+U.join(" ")+'"'):U.length>1?k.push('"'+U[0]+'" '+U.slice(1).join(" ")):k.push('"'+U[0]+'"'):k.push(U.join(" ")),c=D.spawn(m(),k,g)}else this.cmd&&(c=D.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(P.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",g=>{this.childProcess=null,o({terminated:this.terminateRequested,error:g})}),c.pid&&(this.childProcess.on("close",h),this.handleSpawn(c,t,a,o,!0)))}return s})}handleClose(a,r,t,o){}ensureQuotes(a){return w.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,v(a,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!I.isWindows)return a(!1);const r=D.spawn(m(),["/s","/c"]);r.on("error",t=>a(!0)),r.on("exit",t=>a(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class y extends w{constructor(a,r,t,o){super(a,r,t,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,r,t,o,s){[o,s].forEach((c,h)=>{const g=new C.LineDecoder;g.write(c).forEach(U=>{r({line:U,source:h===0?0:1})});const _=g.end();_&&r({line:_,source:h===0?0:1})}),a({terminated:this.terminateRequested,error:t})}handleSpawn(a,r,t,o,s){const c=new C.LineDecoder,h=new C.LineDecoder;a.stdout.on("data",g=>{c.write(g).forEach(_=>t({line:_,source:0}))}),a.stderr.on("data",g=>{h.write(g).forEach(_=>t({line:_,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=h}handleClose(a,r,t,o){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&t({line:s,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&t({line:c,source:1})}}e.LineProcess=y;function p(i){let a=[],r=!1;const t=function(o){if(r){a.push(o);return}(!i.send(o,c=>{if(c&&console.error(c),r=!1,a.length>0){const h=a.slice(0);a=[],h.forEach(g=>t(g))}})||I.isWindows)&&(r=!0)};return{send:t}}e.createQueuedSender=p;var l;(function(i){async function a(r,t,o){if(A.isAbsolute(r))return r;if(t===void 0&&(t=b.cwd()),A.dirname(r)!=="."||(o===void 0&&P.isString(b.env.PATH)&&(o=b.env.PATH.split(A.delimiter)),o===void 0||o.length===0))return A.join(t,r);async function c(h){if(await f.Promises.exists(h)){let g;try{g=await f.Promises.stat(h)}catch(R){R.message.startsWith("EACCES")&&(g=await f.Promises.lstat(h))}return g?!g.isDirectory():!1}return!1}for(let h of o){let g;if(A.isAbsolute(h)?g=A.join(h,r):g=A.join(t,h,r),await c(g))return g;let R=g+".com";if(await c(R)||(R=g+".exe",await c(R)))return R}return A.join(t,r)}i.findExecutable=a})(l=e.win32||(e.win32={}))}),define(te[123],ne([0,1,33,4,72,76]),function(Y,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(S,u){return S===1?n.isWindows?C():T.getWindowsShell(u):E(S,u)}e.getSystemShell=A;function I(S,u){return S===1?n.isWindows?f(u):T.getWindowsShell(u):E(S,u)}e.getSystemShellSync=I;let b=null;function E(S,u){if(n.isLinux&&S===2||n.isMacintosh&&S===3)return"/bin/bash";if(!b){let v;if(n.isWindows)v="/bin/bash";else{if(v=u.SHELL,!v)try{v=(0,D.userInfo)().shell}catch{}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}b=v}return b}let P=null;async function C(){return P||(P=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),P}function f(S){if(P)return P;const u=n.isWindows&&parseFloat((0,D.release)())>=10,v=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),d=`${S.windir}\\${v?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?d:T.getWindowsShell(S)}}),define(te[58],ne([0,1,45,5,17,23,107,9,3,2,28,76,36]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends f.ChannelServer{constructor(d){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",m=>L.VSBuffer.wrap(Buffer.from(m,"base64")))},d);process.once("disconnect",()=>this.dispose())}}e.Server=S;class u{constructor(d,m){this.modulePath=d,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new b.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new n.Delayer(w),this.child=null,this._client=null}getChannel(d){const m=this;return{call(w,y,p){return m.requestPromise(d,w,y,p)},listen(w,y){return m.requestEvent(d,w,y)}}}requestPromise(d,m,w,y=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const p=this.getCachedChannel(d),l=(0,n.createCancelablePromise)(r=>p.call(m,w,r)),i=y.onCancellationRequested(()=>l.cancel()),a=(0,E.toDisposable)(()=>l.cancel());return this.activeRequests.add(a),l.finally(()=>{i.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(d,m,w){if(!this.disposeDelayer)return b.Event.None;this.disposeDelayer.cancel();let y;const p=new b.Emitter({onFirstListenerAdd:()=>{y=this.getCachedChannel(d).listen(m,w)(p.fire,p),this.activeRequests.add(y)},onLastListenerRemove:()=>{this.activeRequests.delete(y),y.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return p.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,C.removeDangerousEnvVariables)(m.env),this.child=(0,D.fork)(this.modulePath,d,m);const w=new b.Emitter;b.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,A.isRemoteConsoleLog)(t)){(0,A.log)(t,`IPC Library: ${this.options.serverName}`);return}w.fire(L.VSBuffer.wrap(Buffer.from(t,"base64")))});const p=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,l=t=>this.child&&this.child.connected&&p.send(t.buffer.toString("base64")),i=w.event,a={send:l,onMessage:i};this._client=new f.ChannelClient(a);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,o)=>{process.removeListener("exit",r),this.activeRequests.forEach(s=>(0,E.dispose)(s)),this.activeRequests.clear(),t!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:o})})}return this._client}getCachedChannel(d){let m=this.channels.get(d);return m||(m=this.client.getChannel(d),this.channels.set(d,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=u}),define(te[124],ne([11,12]),function(Y,e){return Y.create("vs/base/node/zip",e)}),define(te[125],ne([11,12]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[126],ne([11,12]),function(Y,e){return Y.create("vs/platform/environment/node/argv",e)}),define(te[127],ne([11,12]),function(Y,e){return Y.create("vs/platform/environment/node/argvHelper",e)}),define(te[128],ne([11,12]),function(Y,e){return Y.create("vs/platform/environment/node/shellEnv",e)}),define(te[129],ne([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[130],ne([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[131],ne([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[132],ne([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[133],ne([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[134],ne([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[135],ne([11,12]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[136],ne([11,12]),function(Y,e){return Y.create("vs/platform/files/common/fileService",e)}),define(te[137],ne([11,12]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(te[138],ne([11,12]),function(Y,e){return Y.create("vs/platform/files/common/io",e)}),define(te[139],ne([11,12]),function(Y,e){return Y.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[140],ne([11,12]),function(Y,e){return Y.create("vs/platform/request/common/request",e)}),define(te[141],ne([11,12]),function(Y,e){return Y.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[142],ne([11,12]),function(Y,e){return Y.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[143],ne([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[144],ne([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[145],ne([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[146],ne([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[147],ne([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[148],ne([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[149],ne([0,1,4]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var n;(function(A){A.Team="team",A.Internal="internal",A.Insiders="insider",A.Public="public"})(n=e.TargetPopulation||(e.TargetPopulation={}));var L;(function(A){A.Market="X-MSEdge-Market",A.CorpNet="X-FD-Corpnet",A.ApplicationVersion="X-VSCode-AppVersion",A.Build="X-VSCode-Build",A.ClientId="X-MSEdge-ClientId",A.ExtensionName="X-VSCode-ExtensionName",A.Language="X-VSCode-Language",A.TargetPopulation="X-VSCode-TargetPopulation"})(L=e.Filters||(e.Filters={}));class T{constructor(I,b,E,P){this.version=I,this.appName=b,this.machineId=E,this.targetPopulation=P}getFilterValue(I){switch(I){case L.ApplicationVersion:return this.version;case L.Build:return this.appName;case L.ClientId:return this.machineId;case L.Language:return D.language;case L.ExtensionName:return"vscode-core";case L.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let I=new Map,b=Object.values(L);for(let E of b)I.set(E,this.getFilterValue(E));return I}}e.AssignmentFilterProvider=T}),define(te[77],ne([0,1,57,54,18,10,32,19,7]),function(Y,e,D,n,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{constructor(v,d,m){this._args=v,this.paths=d,this.productService=m}get appRoot(){return(0,T.dirname)(L.FileAccess.asFileUri("",Y).fsPath)}get userHome(){return b.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return b.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.paths.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const v=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",v)}return this.args.logsPath}get userDataSyncLogResource(){return b.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(b.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return b.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return b.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const v=A.env.VSCODE_PORTABLE;return v?b.URI.file((0,T.join)(v,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,I.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const v=this.args["builtin-extensions-dir"];return v?(0,T.resolve)(v):(0,T.normalize)((0,T.join)(L.FileAccess.asFileUri("",Y).fsPath,"..","extensions"))}get extensionsDownloadPath(){const v=this.args["extensions-download-dir"];return v?(0,T.resolve)(v):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const v=this.args["extensions-dir"];if(v)return(0,T.resolve)(v);const d=A.env.VSCODE_EXTENSIONS;if(d)return d;const m=A.env.VSCODE_PORTABLE;return m?(0,T.join)(m,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const v=this.args.extensionDevelopmentPath;if(Array.isArray(v))return v.map(d=>/^[^:/?#]+?:\/\//.test(d)?b.URI.parse(d):b.URI.file((0,T.normalize)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const v=this.args.extensionTestsPath;if(v)return/^[^:/?#]+?:\/\//.test(v)?b.URI.parse(v):b.URI.file((0,T.normalize)(v))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const v=this.args["disable-extension"];if(v){if(typeof v=="string")return[v];if(Array.isArray(v)&&v.length>0)return v}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return b.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([n.memoize],E.prototype,"appRoot",null),he([n.memoize],E.prototype,"userHome",null),he([n.memoize],E.prototype,"userDataPath",null),he([n.memoize],E.prototype,"appSettingsHome",null),he([n.memoize],E.prototype,"tmpDir",null),he([n.memoize],E.prototype,"cacheHome",null),he([n.memoize],E.prototype,"userRoamingDataHome",null),he([n.memoize],E.prototype,"settingsResource",null),he([n.memoize],E.prototype,"userDataSyncHome",null),he([n.memoize],E.prototype,"userDataSyncLogResource",null),he([n.memoize],E.prototype,"sync",null),he([n.memoize],E.prototype,"machineSettingsResource",null),he([n.memoize],E.prototype,"globalStorageHome",null),he([n.memoize],E.prototype,"workspaceStorageHome",null),he([n.memoize],E.prototype,"keybindingsResource",null),he([n.memoize],E.prototype,"keyboardLayoutResource",null),he([n.memoize],E.prototype,"argvResource",null),he([n.memoize],E.prototype,"snippetsHome",null),he([n.memoize],E.prototype,"isExtensionDevelopment",null),he([n.memoize],E.prototype,"untitledWorkspacesHome",null),he([n.memoize],E.prototype,"installSourcePath",null),he([n.memoize],E.prototype,"builtinExtensionsPath",null),he([n.memoize],E.prototype,"extensionsPath",null),he([n.memoize],E.prototype,"extensionDevelopmentLocationURI",null),he([n.memoize],E.prototype,"extensionDevelopmentKind",null),he([n.memoize],E.prototype,"extensionTestsLocationURI",null),he([n.memoize],E.prototype,"debugExtensionHost",null),he([n.memoize],E.prototype,"serviceMachineIdResource",null),he([n.memoize],E.prototype,"telemetryLogResource",null),he([n.memoize],E.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=E;function P(u,v){return S(u["inspect-extensions"],u["inspect-brk-extensions"],5870,v,u.debugId,u.extensionEnvironment)}e.parseExtensionHostPort=P;function C(u,v){return S(u["inspect-search"],u["inspect-brk-search"],5876,v,u.extensionEnvironment)}e.parseSearchPort=C;function f(u,v){return S(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,v,u.extensionEnvironment)}e.parsePtyHostPort=f;function S(u,v,d,m,w,y){const l=Number(v||u)||(m?null:d),i=l?Boolean(!!v):!1;let a;if(y)try{a=JSON.parse(y)}catch{}return{port:l,break:i,debugId:w,env:a}}}),define(te[150],ne([0,1,253,4,126]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,L.localize)(0,null),e:(0,L.localize)(1,null),t:(0,L.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,L.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,L.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,L.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,L.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,L.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,L.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,L.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,L.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,L.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,L.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,L.localize)(14,null)},category:{type:"string",cat:"e",description:(0,L.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,L.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,L.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,L.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,L.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,L.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,L.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,L.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,L.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,L.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,L.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,L.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,L.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,L.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,L.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,L.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,L.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,L.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function I(u,v,d=A){const m={},w=[],y=[];for(let a in v){const r=v[a];r.alias&&(m[a]=r.alias),r.type==="string"||r.type==="string[]"?(w.push(a),r.deprecates&&w.push(...r.deprecates)):r.type==="boolean"&&(y.push(a),r.deprecates&&y.push(...r.deprecates))}const p=D(u,{string:w,boolean:y,alias:m}),l={},i=p;l._=p._.map(a=>String(a)).filter(a=>a.length>0),delete i._;for(let a in v){const r=v[a];r.alias&&delete i[r.alias];let t=i[a];if(r.deprecates)for(const o of r.deprecates)i.hasOwnProperty(o)&&(t||(t=i[o],t&&d.onDeprecatedOption(o,r.deprecationMessage||(0,L.localize)(33,null))),delete i[o]);typeof t!="undefined"&&(r.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):r.type==="string"&&Array.isArray(t)&&(t=t.pop(),d.onMultipleValues(a,t)),l[a]=t,r.deprecationMessage&&d.onDeprecatedOption(a,r.deprecationMessage)),delete i[a]}for(let a in i)d.onUnknownOption(a);return l}e.parseArgs=I;function b(u,v){let d="";return v.args&&(Array.isArray(v.args)?d=` <${v.args.join("> <")}>`:d=` <${v.args}>`),v.alias?`-${v.alias} --${u}${d}`:`--${u}${d}`}function E(u,v){let d=0,m=[];for(const l in u){const i=u[l],a=b(l,i);d=Math.max(d,a.length),m.push([a,i.description])}let w=d+2+1;if(v-w<25)return m.reduce((l,i)=>l.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);let y=v-w-1,p=[];for(const l of m){let i=l[0],a=C(l[1],y),r=P(w-i.length-2);p.push("  "+i+r+a[0]);for(let t=1;t<a.length;t++)p.push(P(w)+a[t])}return p}e.formatOptions=E;function P(u){return" ".repeat(u)}function C(u,v){let d=[];for(;u.length;){let m=u.length<v?u.length:u.lastIndexOf(" ",v),w=u.slice(0,m).trim();u=u.slice(m),d.push(w)}return d}function f(u,v,d,m,w){const y=process.stdout.isTTY&&process.stdout.columns||80,p=w?.noInputFiles!==!0?`[${(0,L.localize)(34,null)}...]`:"",l=[`${u} ${d}`];l.push(""),l.push(`${(0,L.localize)(35,null)}: ${v} [${(0,L.localize)(36,null)}]${p}`),l.push(""),w?.noPipe!==!0&&(n.isWindows?l.push((0,L.localize)(37,null,v)):l.push((0,L.localize)(38,null,v)),l.push(""));const i={};for(const a in m){const r=m[a];if(r.description&&r.cat){let t=i[r.cat];t||(i[r.cat]=t={}),t[a]=r}}for(let a in i){const r=a;let t=i[r];t&&(l.push(T[r]),l.push(...E(t,y)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=f;function S(u,v){return`${u||(0,L.localize)(39,null)}
${v||(0,L.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=S}),function(){"use strict";function Y(e,D,n,L){function T(I){const b=A(I),E=[b];return e.isAbsolute(b)||E.unshift(L),e.resolve(...E)}function A(I){const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,n);const P=I["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(C,"AppData","Roaming")}break;case"darwin":E=e.join(D.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,n)}return{getUserDataPath:T}}if(typeof define=="function")define(te[151],ne([0,152,33,18,19,32]),function(e,D,n,L,T,A){const I=T.dirname(L.FileAccess.asFileUri("",e)),b=e.__$__nodeRequire(T.joinPath(I,"package.json").fsPath);return Y(D,n,b.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),n=require("os");module.exports=Y(D,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[153],ne([0,1,33,77,151]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends n.AbstractNativeEnvironmentService{constructor(I,b){super(I,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,L.getUserDataPath)(I)},b)}}e.NativeEnvironmentService=T}),define(te[154],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const n=/^([^@:]+@)?([^:]+):/,L=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,I=/^\s*url\s*=\s*(.+\S)\s*$/mg,b=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(d){const m=d.match(A);return m?m[1]:null}function P(d){if(d.indexOf("://")===-1){const m=d.match(n);return m?E(m[2]):null}try{const m=D.URI.parse(d);if(m.authority)return E(m.authority)}catch{}return null}function C(d,m){const w=new Set;let y;for(;y=I.exec(d);){const l=P(y[1]);l&&w.add(l)}const p=new Set(m);return Array.from(w).map(l=>p.has(l)?l:l.replace(b,"a"))}e.getDomainsOfRemotes=C;function f(d){const m=d.match(T);return m?m[2]:null}function S(d,m,w){return d&&m?(w&&m.endsWith(".git")&&(m=m.substr(0,m.length-4)),m.indexOf("/")===0?`${d}${m}`:`${d}/${m}`):null}function u(d,m){if(d.indexOf("://")===-1){const w=d.match(L);if(w)return S(w[2],w[3],m)}try{const w=D.URI.parse(d);if(w.authority)return S(f(w.authority),w.path,m)}catch{}return null}function v(d,m=!1){const w=[];let y;for(;y=I.exec(d);){const p=u(y[1],m);p&&w.push(p)}return w}e.getRemotes=v}),define(te[155],ne([0,1,28]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const n=/^%([\w\d.-]+)%$/i;function L(T,A){const I=b=>{if(typeof b!="string")return;const E=n.exec(b);if(!E)return;const P=A[E[1]]??b;return typeof P=="string"?P:typeof P.message=="string"?P.message:b};return(0,D.cloneAndChange)(T,I)}e.localizeManifest=L}),define(te[156],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,A,I,b){return this.channel.call("promptImportantExtensionsInstallNotification",[T,A,I,b])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class n{constructor(T){this.service=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,I){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(I[0],I[1],I[2],I[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=n}),define(te[78],ne([0,1,135]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const n=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,L=/^-(\d{4})(\d{2})(\d{2})$/;function T(f){return f=f.trim(),f==="*"||n.test(f)}e.isValidVersionStr=T;function A(f){if(!T(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=f.match(n);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=A;function I(f){if(!f)return null;let S=f.majorBase,u=f.majorMustEqual,v=f.minorBase,d=f.minorMustEqual,m=f.patchBase,w=f.patchMustEqual;f.hasCaret&&(S===0||(d=!1),w=!1);let y=0;if(f.preRelease){const p=L.exec(f.preRelease);if(p){const[,l,i,a]=p;y=Date.UTC(Number(l),Number(i)-1,Number(a))}}return{majorBase:S,majorMustEqual:u,minorBase:v,minorMustEqual:d,patchBase:m,patchMustEqual:w,isMinimum:f.hasGreaterEquals,notBefore:y}}e.normalizeVersion=I;function b(f,S,u){let v;typeof f=="string"?v=I(A(f)):v=f;let d;S instanceof Date?d=S.getTime():typeof S=="string"&&(d=new Date(S).getTime());let m;if(typeof u=="string"?m=I(A(u)):m=u,!v||!m)return!1;let w=v.majorBase,y=v.minorBase,p=v.patchBase,l=m.majorBase,i=m.minorBase,a=m.patchBase,r=m.notBefore,t=m.majorMustEqual,o=m.minorMustEqual,s=m.patchMustEqual;return m.isMinimum?w>l?!0:w<l?!1:y>i?!0:y<i||d&&d<r?!1:p>=a:(w===1&&l===0&&(!t||!o||!s)&&(l=1,i=0,a=0,t=!0,o=!1,s=!1),w<l?!1:w>l?!t:y<i?!1:y>i?!o:p<a?!1:p>a?!s:!(d&&d<r))}e.isValidVersion=b;function E(f,S,u,v){return u.isBuiltin||typeof u.main=="undefined"?!0:C(f,S,u.engines.vscode,v)}e.isValidExtensionVersion=E;function P(f,S,u){return f==="*"||C(S,u,f)}e.isEngineValid=P;function C(f,S,u,v=[]){let d=I(A(u));if(!d)return v.push(D.localize(0,null,u)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return v.push(D.localize(1,null,u)),!1}else if(!d.majorMustEqual)return v.push(D.localize(2,null,u)),!1;return b(f,S,d)?!0:(v.push(D.localize(3,null,f,u)),!1)}}),define(te[46],ne([0,1,17,29]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(T,A,I){let b=I&&I.get("storage.serviceMachineId",0)||null;if(b)return b;try{const P=(await A.readFile(T.serviceMachineIdResource)).value.toString();b=(0,n.isUUID)(P)?P:null}catch{b=null}if(!b){b=(0,n.generateUuid)();try{await A.writeFile(T.serviceMachineIdResource,D.VSBuffer.fromString(b))}catch{}}return I&&I.store("storage.serviceMachineId",b,0,1),b}e.getServiceMachineId=L}),define(te[51],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(L,T=[],A=!1){this.ctor=L,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=D}),define(te[79],ne([0,1,51]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function L(A,I,b){I instanceof D.SyncDescriptor||(I=new D.SyncDescriptor(I,[],b)),n.push([A,I])}e.registerSingleton=L;function T(){return n}e.getSingletonServiceDescriptors=T}),define(te[157],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=D;class n{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let A of this._nodes.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const I=this.lookupOrInsertNode(T),b=this.lookupOrInsertNode(A);I.outgoing.set(this._hashFn(A),b),b.incoming.set(this._hashFn(T),I)}removeNode(T){const A=this._hashFn(T);this._nodes.delete(A);for(let I of this._nodes.values())I.outgoing.delete(A),I.incoming.delete(A)}lookupOrInsertNode(T){const A=this._hashFn(T);let I=this._nodes.get(A);return I||(I=new D(T),this._nodes.set(A,I)),I}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[A,I]of this._nodes)T.push(`${A}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,A]of this._nodes){const I=new Set([T]),b=this._findCycle(A,I);if(b)return b}}_findCycle(T,A){for(let[I,b]of T.outgoing){if(A.has(I))return[...A,I].join(" -> ");A.add(I);const E=this._findCycle(b,A);if(E)return E;A.delete(I)}}}e.Graph=n}),define(te[6],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function I(b){return b[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=I})(D=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function n(A,I,b,E){I[D.DI_TARGET]===I?I[D.DI_DEPENDENCIES].push({id:A,index:b,optional:E}):(I[D.DI_DEPENDENCIES]=[{id:A,index:b,optional:E}],I[D.DI_TARGET]=I)}function L(A){if(D.serviceIds.has(A))return D.serviceIds.get(A);const I=function(b,E,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(I,b,P,!1)};return I.toString=()=>A,D.serviceIds.set(A,I),I}e.createDecorator=L;function T(A){return A}e.refineServiceDecorator=T}),define(te[158],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(te[20],ne([0,1,15,7,6]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function T(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof n.URI)}e.isConfigurationOverrides=T;function A(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||D.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=A;var I;(function(d){d[d.USER=1]="USER",d[d.USER_LOCAL=2]="USER_LOCAL",d[d.USER_REMOTE=3]="USER_REMOTE",d[d.WORKSPACE=4]="WORKSPACE",d[d.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",d[d.DEFAULT=6]="DEFAULT",d[d.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(d){switch(d){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=b;function E(d,m){const w=Object.create(null);for(let y in d)P(w,y,d[y],m);return w}e.toValuesTree=E;function P(d,m,w,y){const p=m.split("."),l=p.pop();let i=d;for(let a=0;a<p.length;a++){let r=p[a],t=i[r];switch(typeof t){case"undefined":t=i[r]=Object.create(null);break;case"object":break;default:y(`Ignoring ${m} as ${p.slice(0,a+1).join(".")} is ${JSON.stringify(t)}`);return}i=t}if(typeof i=="object"&&i!==null)try{i[l]=w}catch{y(`Ignoring ${m} as ${p.join(".")} is ${JSON.stringify(i)}`)}else y(`Ignoring ${m} as ${p.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=P;function C(d,m){const w=m.split(".");f(d,w)}e.removeFromValueTree=C;function f(d,m){const w=m.shift();if(m.length===0){delete d[w];return}if(Object.keys(d).indexOf(w)!==-1){const y=d[w];typeof y=="object"&&!Array.isArray(y)&&(f(y,m),Object.keys(y).length===0&&delete d[w])}}function S(d,m,w){function y(i,a){let r=i;for(const t of a){if(typeof r!="object"||r===null)return;r=r[t]}return r}const p=m.split("."),l=y(d,p);return typeof l=="undefined"?w:l}e.getConfigurationValue=S;function u(d,m,w){Object.keys(m).forEach(y=>{y!=="__proto__"&&(y in d?D.isObject(d[y])&&D.isObject(m[y])?u(d[y],m[y],w):w&&(d[y]=m[y]):d[y]=m[y])})}e.merge=u;function v(d,m,w){const y=d.inspect(m),p=d.inspect(w);return typeof y.userValue!="undefined"||typeof y.workspaceValue!="undefined"||typeof y.workspaceFolderValue!="undefined"?y.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:y.defaultValue}e.getMigratedSettingValue=v}),define(te[159],ne([0,1,4,27,6]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",D.isMacintosh),T.set("isLinux",D.isLinux),T.set("isWindows",D.isWindows),T.set("isWeb",D.isWeb),T.set("isMacNative",D.isMacintosh&&!D.isWeb),T.set("isEdge",D.isEdge),T.set("isFirefox",D.isFirefox),T.set("isChrome",D.isChrome),T.set("isSafari",D.isSafari);const A=Object.prototype.hasOwnProperty;var I;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return C.INSTANCE}static true(){return f.INSTANCE}static has(k){return S.create(k)}static equals(k,M){return u.create(k,M)}static notEquals(k,M){return m.create(k,M)}static regex(k,M){return r.create(k,M)}static in(k,M){return v.create(k,M)}static not(k){return w.create(k)}static and(...k){return s.create(k,null)}static or(...k){return c.create(k,null,!0)}static greater(k,M){return p.create(k,M)}static greaterEquals(k,M){return l.create(k,M)}static smaller(k,M){return i.create(k,M)}static smallerEquals(k,M){return a.create(k,M)}static deserialize(k,M=!1){if(!!k)return this._deserializeOrExpression(k,M)}static _deserializeOrExpression(k,M){let $=k.split("||");return c.create($.map(x=>this._deserializeAndExpression(x,M)),null,!0)}static _deserializeAndExpression(k,M){let $=k.split("&&");return s.create($.map(x=>this._deserializeOne(x,M)),null)}static _deserializeOne(k,M){if(k=k.trim(),k.indexOf("!=")>=0){let $=k.split("!=");return m.create($[0].trim(),this._deserializeValue($[1],M))}if(k.indexOf("==")>=0){let $=k.split("==");return u.create($[0].trim(),this._deserializeValue($[1],M))}if(k.indexOf("=~")>=0){let $=k.split("=~");return r.create($[0].trim(),this._deserializeRegexValue($[1],M))}if(k.indexOf(" in ")>=0){let $=k.split(" in ");return v.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const $=k.split(">=");return l.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const $=k.split(">");return p.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const $=k.split("<=");return a.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const $=k.split("<");return i.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(k)?w.create(k.substr(1).trim()):S.create(k)}static _deserializeValue(k,M){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;let $=/^'([^']*)'$/.exec(k);return $?$[1].trim():k}static _deserializeRegexValue(k,M){if((0,n.isFalsyOrWhitespace)(k)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let $=k.indexOf("/"),x=k.lastIndexOf("/");if($===x||$<0){if(M)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}let z=k.slice($+1,x),G=k[x+1]==="i"?"i":"";try{return new RegExp(z,G)}catch(ee){if(M)throw new Error(`bad regexp-value '${k}', parse error: ${ee}`);return console.warn(`bad regexp-value '${k}', parse error: ${ee}`),null}}}e.ContextKeyExpr=b;function E(F,k){const M=F?F.substituteConstants():void 0,$=k?k.substituteConstants():void 0;return!M&&!$?!0:!M||!$?!1:M.equals($)}e.expressionsAreEqualWithConstantSubstitution=E;function P(F,k){return F.cmp(k)}class C{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class f{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class S{constructor(k,M){this.key=k,this.negated=M,this.type=2}static create(k,M=null){const $=T.get(k);return typeof $=="boolean"?$?f.INSTANCE:C.INSTANCE:new S(k,M)}cmp(k){return k.type!==this.type?this.type-k.type:g(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?f.INSTANCE:C.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=S;class u{constructor(k,M,$){this.key=k,this.value=M,this.negated=$,this.type=4}static create(k,M,$=null){if(typeof M=="boolean")return M?S.create(k,$):w.create(k,$);const x=T.get(k);return typeof x=="boolean"?M===(x?"true":"false")?f.INSTANCE:C.INSTANCE:new u(k,M,$)}cmp(k){return k.type!==this.type?this.type-k.type:R(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const M=k?"true":"false";return this.value===M?f.INSTANCE:C.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class v{constructor(k,M){this.key=k,this.valueKey=M,this.type=10,this.negated=null}static create(k,M){return new v(k,M)}cmp(k){return k.type!==this.type?this.type-k.type:R(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const M=k.getValue(this.valueKey),$=k.getValue(this.key);return Array.isArray(M)?M.indexOf($)>=0:typeof $=="string"&&typeof M=="object"&&M!==null?A.call(M,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=d.create(this)),this.negated}}e.ContextKeyInExpr=v;class d{constructor(k){this._actual=k,this.type=11}static create(k){return new d(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new d(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotInExpr=d;class m{constructor(k,M,$){this.key=k,this.value=M,this.negated=$,this.type=5}static create(k,M,$=null){if(typeof M=="boolean")return M?w.create(k,$):S.create(k,$);const x=T.get(k);return typeof x=="boolean"?M===(x?"true":"false")?C.INSTANCE:f.INSTANCE:new m(k,M,$)}cmp(k){return k.type!==this.type?this.type-k.type:R(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const M=k?"true":"false";return this.value===M?C.INSTANCE:f.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=m;class w{constructor(k,M){this.key=k,this.negated=M,this.type=3}static create(k,M=null){const $=T.get(k);return typeof $=="boolean"?$?C.INSTANCE:f.INSTANCE:new w(k,M)}cmp(k){return k.type!==this.type?this.type-k.type:g(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?C.INSTANCE:f.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=w;function y(F,k){if(typeof F=="string"){const M=parseFloat(F);isNaN(M)||(F=M)}return typeof F=="string"||typeof F=="number"?k(F):C.INSTANCE}class p{constructor(k,M,$){this.key=k,this.value=M,this.negated=$,this.type=12}static create(k,M,$=null){return y(M,x=>new p(k,x,$))}cmp(k){return k.type!==this.type?this.type-k.type:R(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=p;class l{constructor(k,M,$){this.key=k,this.value=M,this.negated=$,this.type=13}static create(k,M,$=null){return y(M,x=>new l(k,x,$))}cmp(k){return k.type!==this.type?this.type-k.type:R(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class i{constructor(k,M,$){this.key=k,this.value=M,this.negated=$,this.type=14}static create(k,M,$=null){return y(M,x=>new i(k,x,$))}cmp(k){return k.type!==this.type?this.type-k.type:R(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class a{constructor(k,M,$){this.key=k,this.value=M,this.negated=$,this.type=15}static create(k,M,$=null){return y(M,x=>new a(k,x,$))}cmp(k){return k.type!==this.type?this.type-k.type:R(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=a;class r{constructor(k,M){this.key=k,this.regexp=M,this.type=7,this.negated=null}static create(k,M){return new r(k,M)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const M=this.regexp?this.regexp.source:"",$=k.regexp?k.regexp.source:"";return M<$?-1:M>$?1:0}equals(k){if(k.type===this.type){const M=this.regexp?this.regexp.source:"",$=k.regexp?k.regexp.source:"";return this.key===k.key&&M===$}return!1}substituteConstants(){return this}evaluate(k){let M=k.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=t.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class t{constructor(k){this._actual=k,this.type=8}static create(k){return new t(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new t(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=t;function o(F){let k=null;for(let M=0,$=F.length;M<$;M++){const x=F[M].substituteConstants();if(F[M]!==x&&k===null){k=[];for(let z=0;z<M;z++)k[z]=F[z]}k!==null&&(k[M]=x)}return k===null?F:k}class s{constructor(k,M){this.expr=k,this.negated=M,this.type=6}static create(k,M){return s._normalizeArr(k,M)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let M=0,$=this.expr.length;M<$;M++){const x=P(this.expr[M],k.expr[M]);if(x!==0)return x}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].equals(k.expr[M]))return!1;return!0}return!1}substituteConstants(){const k=o(this.expr);return k===this.expr?this:s.create(k,this.negated)}evaluate(k){for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].evaluate(k))return!1;return!0}static _normalizeArr(k,M){const $=[];let x=!1;for(const z of k)if(!!z){if(z.type===1){x=!0;continue}if(z.type===0)return C.INSTANCE;if(z.type===6){$.push(...z.expr);continue}$.push(z)}if($.length===0&&x)return f.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(P);for(let z=1;z<$.length;z++)$[z-1].equals($[z])&&($.splice(z,1),z--);if($.length===1)return $[0];for(;$.length>1;){const z=$[$.length-1];if(z.type!==9)break;$.pop();const G=$.pop(),ee=$.length===0,q=c.create(z.expr.map(j=>s.create([j,G],null)),null,ee);q&&($.push(q),$.sort(P))}return $.length===1?$[0]:new s($,M)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(let M of this.expr)k.push(...M.keys());return k}map(k){return new s(this.expr.map(M=>M.map(k)),null)}negate(){if(!this.negated){const k=[];for(let M of this.expr)k.push(M.negate());this.negated=c.create(k,this,!0)}return this.negated}}class c{constructor(k,M){this.expr=k,this.negated=M,this.type=9}static create(k,M,$){return c._normalizeArr(k,M,$)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let M=0,$=this.expr.length;M<$;M++){const x=P(this.expr[M],k.expr[M]);if(x!==0)return x}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].equals(k.expr[M]))return!1;return!0}return!1}substituteConstants(){const k=o(this.expr);return k===this.expr?this:c.create(k,this.negated,!1)}evaluate(k){for(let M=0,$=this.expr.length;M<$;M++)if(this.expr[M].evaluate(k))return!0;return!1}static _normalizeArr(k,M,$){let x=[],z=!1;if(k){for(let G=0,ee=k.length;G<ee;G++){const q=k[G];if(!!q){if(q.type===0){z=!0;continue}if(q.type===1)return f.INSTANCE;if(q.type===9){x=x.concat(q.expr);continue}x.push(q)}}if(x.length===0&&z)return C.INSTANCE;x.sort(P)}if(x.length!==0){if(x.length===1)return x[0];for(let G=1;G<x.length;G++)x[G-1].equals(x[G])&&(x.splice(G,1),G--);if(x.length===1)return x[0];if($){for(let G=0;G<x.length;G++)for(let ee=G+1;ee<x.length;ee++)_(x[G],x[ee])&&(x.splice(ee,1),ee--);if(x.length===1)return x[0]}return new c(x,M)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(let M of this.expr)k.push(...M.keys());return k}map(k){return new c(this.expr.map(M=>M.map(k)),null)}negate(){if(!this.negated){let k=[];for(let M of this.expr)k.push(M.negate());for(;k.length>1;){const M=k.shift(),$=k.shift(),x=[];for(const G of U(M))for(const ee of U($))x.push(s.create([G,ee],null));const z=k.length===0;k.unshift(c.create(x,null,z))}this.negated=k[0]}return this.negated}}class h extends S{constructor(k,M,$){super(k,null);this._defaultValue=M,typeof $=="object"?h._info.push({...$,key:k}):$!==!0&&h._info.push({key:k,description:$,type:M!=null?typeof M:void 0})}static all(){return h._info.values()}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return u.create(this.key,k)}notEqualsTo(k){return m.create(this.key,k)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function g(F,k){return F<k?-1:F>k?1:0}function R(F,k,M,$){return F<M?-1:F>M?1:k<$?-1:k>$?1:0}function _(F,k){if(k.type===6&&F.type!==9&&F.type!==6){for(const x of k.expr)if(F.equals(x))return!0}const M=F.negate(),$=U(M).concat(U(k));$.sort(P);for(let x=0;x<$.length;x++){const G=$[x].negate();for(let ee=x+1;ee<$.length;ee++){const q=$[ee];if(G.equals(q))return!0}}return!1}e.implies=_;function U(F){return F.type===9?F.expr:[F]}}),define(te[80],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function n(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=n}),define(te[81],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(te[13],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(te[82],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var n;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(n=e.RecommendationSource||(e.RecommendationSource={}));function L(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=L;var T;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[14],ne([0,1,39,10,27,15,7,137,6]),function(Y,e,D,n,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function E(z){return z.create===!0}e.isFileOpenForWriteOptions=E;var P;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(P=e.FileType||(e.FileType={}));var C;(function(z){z[z.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var f;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function S(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=S;function u(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=u;function v(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function d(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=d;function m(z){return S(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=m;var w;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class y extends Error{constructor(G,ee){super(G);this.code=ee}}e.FileSystemProviderError=y;function p(z,G){const ee=new y(z.toString(),G);return i(ee,G),ee}e.createFileSystemProviderError=p;function l(z){return z||p((0,I.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=l;function i(z,G){return z.name=G?`${G} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=i;function a(z){if(!z)return w.Unknown;if(z instanceof y)return z.code;const G=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!G)return w.Unknown;switch(G[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=a;function r(z){if(z instanceof g)return z.fileOperationResult;switch(a(z)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var t;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class o{constructor(G,ee,q){this.resource=G,this.operation=ee,this.target=q}isOperation(G){return this.operation===G}}e.FileOperationEvent=o;var s;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class c{constructor(G,ee){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=G;const q=new Map;for(const j of G){const K=q.get(j.type);switch(K?K.push([j.resource,j]):q.set(j.type,[[j.resource,j]]),j.type){case 1:this.rawAdded.push(j.resource);break;case 0:this.rawUpdated.push(j.resource);break;case 2:this.rawDeleted.push(j.resource);break}}for(const[j,K]of q)switch(j){case 1:this.added=D.TernarySearchTree.forUris(()=>ee),this.added.fill(K);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>ee),this.updated.fill(K);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>ee),this.deleted.fill(K);break}}contains(G,...ee){return this.doContains(G,{includeChildren:!1},...ee)}affects(G,...ee){return this.doContains(G,{includeChildren:!0},...ee)}doContains(G,ee,...q){if(!G)return!1;const j=q.length>0;return!!((!j||q.includes(1))&&(this.added?.get(G)||ee.includeChildren&&this.added?.findSuperstr(G))||(!j||q.includes(0))&&(this.updated?.get(G)||ee.includeChildren&&this.updated?.findSuperstr(G))||(!j||q.includes(2))&&(this.deleted?.findSubstr(G)||ee.includeChildren&&this.deleted?.findSuperstr(G)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=c;function h(z,G,ee){return!z||!G||z===G||G.length>z.length?!1:(G.charAt(G.length-1)!==n.sep&&(G+=n.sep),ee?(0,L.startsWithIgnoreCase)(z,G):z.indexOf(G)===0)}e.isParent=h;class g extends Error{constructor(G,ee,q){super(G);this.fileOperationResult=ee,this.options=q}}e.FileOperationError=g;class R extends g{constructor(G,ee,q){super(G,2,q);this.stat=ee}}e.NotModifiedSinceFileOperationError=R;var _;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=F;async function k(z,G){if(!G.hasProvider(A.URI.from({scheme:z.scheme})))return new Promise(ee=>{const q=G.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===z.scheme&&j.added&&(q.dispose(),ee())})})}e.whenProviderRegistered=k,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(G){return(0,T.isNumber)(G)||(G=0),G<M.KB?(0,I.localize)(1,null,G.toFixed(0)):G<M.MB?(0,I.localize)(2,null,(G/M.KB).toFixed(2)):G<M.GB?(0,I.localize)(3,null,(G/M.MB).toFixed(2)):G<M.TB?(0,I.localize)(4,null,(G/M.GB).toFixed(2)):(0,I.localize)(5,null,(G/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var $;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})($=e.Arch||(e.Arch={}));function x(z){return{maxFileSize:z===0?300*M.MB:16*M.GB,maxHeapSize:z===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=x});var J=this&&this.__param||function(Y,e){return function(D,n){e(D,n,Y)}};define(te[160],ne([0,1,83,40,14]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(I){this.fileService=I}async checksum(I){const b=(await this.fileService.readFileStream(I)).value;return new Promise((E,P)=>{const C=(0,D.createHash)("md5");(0,n.listenStream)(b,{onData:f=>C.update(f.buffer),onError:f=>P(f),onEnd:()=>E(C.digest("base64").replace(/=+$/,""))})})}};T=he([J(0,L.IFileService)],T),e.ChecksumService=T}),define(te[161],ne([0,1,254,127,150,14]),function(Y,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function A(f,S){const u={onUnknownOption:d=>{console.warn((0,n.localize)(0,null,d))},onMultipleValues:(d,m)=>{console.warn((0,n.localize)(1,null,d,m))},onDeprecatedOption:(d,m)=>{console.warn((0,n.localize)(2,null,d,m))}},v=(0,L.parseArgs)(f,L.OPTIONS,S?u:void 0);return v.goto&&v._.forEach(d=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(d),(0,n.localize)(3,null))),v["max-memory"]&&D(parseInt(v["max-memory"])>=T.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${T.MIN_MAX_MEMORY_SIZE_MB} MB.`),v}function I(f){const S=f.findIndex(u=>!/^-/.test(u));if(S>-1)return[...f.slice(0,S),...f.slice(S+1)]}function b(f){let[,...S]=f;process.env.VSCODE_DEV&&(S=I(S)||[]);const u=!C(process.env);return A(S,u)}e.parseMainProcessArgv=b;function E(f){const[,,...S]=f;return A(S,!0)}e.parseCLIProcessArgv=E;function P(f,...S){const u=f.indexOf("--");return u===-1?f.push(...S):f.splice(u,0,...S),f}e.addArg=P;function C(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),define(te[162],ne([0,1,45,10,128,23,37,9,4,29,123,161,5]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const S=1e4;let u;async function v(m,w,y){return w["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(y)&&!w["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(y)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=f.Promises.withAsyncBody(async(p,l)=>{const i=new T.CancellationTokenSource,a=setTimeout(()=>{i.dispose(!0),l(new Error((0,L.localize)(0,null)))},S);try{p(await d(m,i.token))}catch(r){!(0,I.isCancellationError)(r)&&!i.token.isCancellationRequested?l(new Error((0,L.localize)(1,null,(0,A.toErrorMessage)(r)))):p({})}finally{clearTimeout(a),i.dispose()}})),u)}e.getResolvedShellEnv=v;async function d(m,w){const y=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",y);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",p);const l=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(l+"(.*)"+l),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",a);const r=await(0,P.getSystemShell)(b.OS,a);return m.trace("getUnixShellEnvironment#shell",r),new Promise((t,o)=>{if(w.isCancellationRequested)return o((0,I.canceled)());const s=(0,n.basename)(r);let c,h;const g=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(c=`& '${process.execPath}' ${g} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,h=["-Login","-Command"]):(c=`'${process.execPath}' ${g} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,s==="tcsh"?h=["-ic"]:h=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),c);const R=(0,D.spawn)(r,[...h,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});w.onCancellationRequested(()=>(R.kill(),o((0,I.canceled)()))),R.on("error",F=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(F)),o(F)});const _=[];R.stdout.on("data",F=>_.push(F));const U=[];R.stderr.on("data",F=>U.push(F)),R.on("close",(F,k)=>{const M=Buffer.concat(_).toString("utf8");m.trace("getUnixShellEnvironment#raw",M);const $=Buffer.concat(U).toString("utf8");if($.trim()&&m.trace("getUnixShellEnvironment#stderr",$),F||k)return o(new Error((0,L.localize)(2,null,F,k)));const x=i.exec(M),z=x?x[1]:"{}";try{const G=JSON.parse(z);y?G.ELECTRON_RUN_AS_NODE=y:delete G.ELECTRON_RUN_AS_NODE,p?G.ELECTRON_NO_ATTACH_CONSOLE=p:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",G),t(G)}catch(G){m.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(G)),o(G)}})})}}),define(te[163],ne([0,1,17,37,9,3,2,40,7,29,14]),function(Y,e,D,n,L,T,A,I,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class C extends A.Disposable{constructor(S,u){super();this.channel=S,this.extraCapabilities=u,this.onDidChangeCapabilities=T.Event.None,this._onDidChange=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,E.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(S){return this.channel.call("stat",[S])}readdir(S){return this.channel.call("readdir",[S])}async readFile(S,u){const{buffer:v}=await this.channel.call("readFile",[S,u]);return v}readFileStream(S,u,v){const d=(0,I.newWriteableStream)(w=>D.VSBuffer.concat(w.map(y=>D.VSBuffer.wrap(y))).buffer),m=this.channel.listen("readFileStream",[S,u])(w=>{if(w instanceof D.VSBuffer)d.write(w.buffer);else{if(w==="end")d.end();else{let y=w;y instanceof Error||(y=(0,P.createFileSystemProviderError)((0,n.toErrorMessage)(y),P.FileSystemProviderErrorCode.Unknown)),d.error(y),d.end()}m.dispose()}});return v.onCancellationRequested(()=>{d.error((0,L.canceled)()),d.end(),m.dispose()}),d}writeFile(S,u,v){return this.channel.call("writeFile",[S,D.VSBuffer.wrap(u),v])}open(S,u){return this.channel.call("open",[S,u])}close(S){return this.channel.call("close",[S])}async read(S,u,v,d,m){const[w,y]=await this.channel.call("read",[S,u,m]);return v.set(w.buffer.slice(0,y),d),y}write(S,u,v,d,m){return this.channel.call("write",[S,u,D.VSBuffer.wrap(v),d,m])}mkdir(S){return this.channel.call("mkdir",[S])}delete(S,u){return this.channel.call("delete",[S,u])}rename(S,u,v){return this.channel.call("rename",[S,u,v])}copy(S,u,v){return this.channel.call("copy",[S,u,v])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(S=>{if(Array.isArray(S)){const u=S;this._onDidChange.fire(u.map(v=>({resource:b.URI.revive(v.resource),type:v.type})))}else{const u=S;this._onDidWatchError.fire(u)}}))}watch(S,u){const v=(0,E.generateUuid)();return this.channel.call("watch",[this.sessionId,v,S,u]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,v]))}}e.DiskFileSystemProviderClient=C}),define(te[84],ne([0,1,17,9,138,14]),function(Y,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(P,C,f,S,u,v){let d;try{await I(P,C,f,S,u,v)}catch(m){d=m}finally{d&&u.errorTransformer&&(d=u.errorTransformer(d)),typeof d!="undefined"&&f.error(d),f.end()}}e.readFileIntoStream=A;async function I(P,C,f,S,u,v){b(v);const d=await P.open(C,{create:!1});try{b(v);let m=0,w=0,y=u&&typeof u.length=="number"?u.length:void 0,p=D.VSBuffer.alloc(Math.min(u.bufferSize,typeof y=="number"?y:u.bufferSize)),l=u&&typeof u.position=="number"?u.position:0,i=0;do w=await P.read(d,l,p.buffer,i,p.byteLength-i),l+=w,i+=w,m+=w,typeof y=="number"&&(y-=w),i===p.byteLength&&(await f.write(S(p)),p=D.VSBuffer.alloc(Math.min(u.bufferSize,typeof y=="number"?y:u.bufferSize)),i=0);while(w>0&&(typeof y!="number"||y>0)&&b(v)&&E(m,u));if(i>0){let a=i;typeof y=="number"&&(a=Math.min(i,y)),f.write(S(p.slice(0,a)))}}catch(m){throw(0,T.ensureFileSystemProviderError)(m)}finally{await P.close(d)}}function b(P){if(P.isCancellationRequested)throw(0,n.canceled)();return!0}function E(P,C){if(C?.limits){if(typeof C.limits.memory=="number"&&P>C.limits.memory)throw(0,T.createFileSystemProviderError)((0,L.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&P>C.limits.size)throw(0,T.createFileSystemProviderError)((0,L.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[52],ne([0,1,2,4,7,14]),function(Y,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function A(S){return S.recursive===!0}e.isRecursiveWatchRequest=A;class I extends D.Disposable{constructor(u,v,d,m){super();this.onFileChanges=u,this.onLogMessage=v,this.verboseLogging=d,this.options=m,this.watcherDisposables=this._register(new D.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const u=new D.DisposableStore;this.watcherDisposables.value=u,this.watcher=this.createWatcher(u),this.watcher.setVerboseLogging(this.verboseLogging),u.add(this.watcher.onDidChangeFile(v=>this.onFileChanges(v))),u.add(this.watcher.onDidLogMessage(v=>this.onLogMessage(v))),u.add(this.watcher.onDidError(v=>this.onError(v)))}onError(u){this.options.restartOnError?this.restartCounter<I.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${u}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${u}`):this.error(u)}restart(u){this.restartCounter++,this.init(),this.watch(u)}async watch(u){this.requests=u,await this.watcher?.watch(u)}async setVerboseLogging(u){this.verboseLogging=u,await this.watcher?.setVerboseLogging(u)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${u}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=I,I.MAX_RESTARTS=5;class b extends I{constructor(u,v,d){super(u,v,d,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class E extends I{constructor(u,v,d){super(u,v,d,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function P(S){return S.map(u=>({type:u.type,resource:L.URI.file(u.path)}))}e.toFileChanges=P;function C(S){const u=new f;for(const v of S)u.processEvent(v);return u.coalesce()}e.coalesceEvents=C;class f{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(u){return n.isLinux?u.path:u.path.toLowerCase()}processEvent(u){const v=this.mapPathToChange.get(this.toKey(u));let d=!1;if(v){const m=v.type,w=u.type;v.path!==u.path&&(u.type===2||u.type===1)?d=!0:m===1&&w===2?(this.mapPathToChange.delete(this.toKey(u)),this.coalesced.delete(v)):m===2&&w===1?v.type=0:m===1&&w===0||(v.type=w)}else d=!0;d&&(this.coalesced.add(u),this.mapPathToChange.set(this.toKey(u),u))}coalesce(){const u=[],v=[];return Array.from(this.coalesced).filter(d=>d.type!==2?(u.push(d),!1):!0).sort((d,m)=>d.path.length-m.path.length).filter(d=>v.some(m=>(0,T.isParent)(d.path,m,!n.isLinux))?!1:(v.push(d.path),!0)).concat(u)}}}),define(te[164],ne([0,1,50,5,23,41,109,2,71,10,4,114,22,52]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class u extends I.Disposable{constructor(m,w,y,p){super();this.request=m,this.onDidFilesChange=w,this.onLogMessage=y,this.verboseLogging=p,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.onDidFilesChange(l)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(u.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(l=>(0,A.parse)(l)),this.cts=new L.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const m=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const w=await f.Promises.stat(m);this._register(await this.doWatch(m,w.isDirectory()))}catch(m){m.code!=="ENOENT"?this.error(m):this.trace(m)}}async normalizePath(m){let w=m.path;try{w=await f.Promises.realpath(m.path),m.path===w&&(w=await(0,C.realcase)(m.path)??m.path),m.path!==w&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${m.path}, real: ${w})`)}catch{}return w}async doWatch(m,w){if(P.isMacintosh&&(0,T.isEqualOrParent)(m,"/Volumes/",!0))return this.error(`Refusing to watch ${m} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),I.Disposable.None;const y=new L.CancellationTokenSource(this.cts.token);let p=new I.DisposableStore;try{const l=(0,E.basename)(m),i=(0,D.watch)(m);p.add((0,I.toDisposable)(()=>{i.removeAllListeners(),i.close()})),this.trace(`Started watching: '${m}'`);const a=new Set;if(w)try{for(const t of await f.Promises.readdir(m))a.add(t)}catch(t){this.error(t)}const r=new Map;p.add((0,I.toDisposable)(()=>{for(const[,t]of r)t.dispose();r.clear()})),i.on("error",(t,o)=>{this.error(`Failed to watch ${m} for changes using fs.watch() (${t}, ${o})`),this.dispose()}),i.on("change",(t,o)=>{if(y.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${o}`);let s="";if(o&&(s=o.toString(),P.isMacintosh&&(s=(0,b.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(w)if(t==="rename"){r.get(s)?.dispose();const c=setTimeout(async()=>{if(r.delete(s),s===l&&!await f.Promises.exists(m)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const h=await this.existsChildStrictCase((0,E.join)(m,s));if(y.token.isCancellationRequested)return;let g;h?a.has(s)?g=0:(g=1,a.add(s)):(a.delete(s),g=2),this.onFileChange({path:(0,E.join)(this.request.path,s),type:g})},u.FILE_DELETE_HANDLER_DELAY);r.set(s,(0,I.toDisposable)(()=>clearTimeout(c)))}else{let c;a.has(s)?c=0:(c=1,a.add(s)),this.onFileChange({path:(0,E.join)(this.request.path,s),type:c})}else if(t==="rename"||s!==l){const c=setTimeout(async()=>{const h=await f.Promises.exists(m);y.token.isCancellationRequested||(h?(this.onFileChange({path:this.request.path,type:0},!0),p.add(await this.doWatch(m,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},u.FILE_DELETE_HANDLER_DELAY);p.clear(),p.add((0,I.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(l){await f.Promises.exists(m)&&!y.token.isCancellationRequested&&this.error(`Failed to watch ${m} for changes using fs.watch() (${l.toString()})`)}return(0,I.toDisposable)(()=>{y.dispose(!0),p.dispose()})}async onFileChange(m,w=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`),!w&&this.excludes.some(y=>y(m.path))?this.verboseLogging&&this.trace(` >> ignored ${m.path}`):this.fileChangesBuffer.push(m);try{await this.fileChangesDelayer.trigger(async()=>{const y=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,S.coalesceEvents)(y);if(p.length>0){if(this.verboseLogging)for(const i of p)this.trace(`>> normalized ${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.path}`);this.throttledFileChangesWorker.work(p)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${p[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${p.length}, most recent change: ${p[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(m){if(P.isLinux)return f.Promises.exists(m);try{const w=(0,E.basename)(m);return(await f.Promises.readdir((0,E.dirname)(m))).some(p=>p===w)}catch(w){return this.trace(w),!1}}setVerboseLogging(m){this.verboseLogging=m}error(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${m}`})}warn(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${m}`})}trace(m){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=u,u.FILE_DELETE_HANDLER_DELAY=100,u.FILE_CHANGES_HANDLER_DELAY=50;async function v(d,m,w,y,p=512){const l=await f.Promises.open(d,"r"),i=Buffer.allocUnsafe(p),a=new L.CancellationTokenSource(y);let r,t=!1;const o={path:d,excludes:[],recursive:!1},s=new u(o,c=>{(async()=>{for(const{type:h}of c)if(h===0){if(t)return;t=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:g}=await f.Promises.read(l,i,0,p,null);if(!g||a.token.isCancellationRequested)break;m(i.slice(0,g))}}catch(g){r=new Error(g),a.dispose(!0)}finally{t=!1}}})()});return await s.ready,w(),new Promise((c,h)=>{a.token.onCancellationRequested(async()=>{s.dispose();try{await f.Promises.close(l)}catch(g){r=new Error(g)}r?h(r):c()})})}e.watchFileContents=v}),define(te[165],ne([0,1,16,3,2,4,164]),function(Y,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends L.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new n.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=n.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(E){const P=this.normalizeRequests(E),C=P.filter(S=>{const u=this.watchers.get(S.path);return u?!(0,D.equals)(u.request.excludes,S.excludes):!0}),f=Array.from(this.watchers.values()).filter(({request:S})=>!P.find(u=>u.path===S.path&&(0,D.equals)(u.excludes,S.excludes))).map(({request:S})=>S.path);C.length&&this.trace(`Request to start watching: ${C.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"})`).join(",")}`),f.length&&this.trace(`Request to stop watching: ${f.join(",")}`);for(const S of f)this.stopWatching(S);for(const S of C)this.startWatching(S)}startWatching(E){const P=new A.NodeJSFileWatcherLibrary(E,f=>this._onDidChangeFile.fire(f),f=>this._onDidLogMessage.fire(f),this.verboseLogging),C={request:E,instance:P};this.watchers.set(E.path,C)}async stop(){for(const[E]of this.watchers)this.stopWatching(E);this.watchers.clear()}stopWatching(E){const P=this.watchers.get(E);P&&(this.watchers.delete(E),P.instance.dispose())}normalizeRequests(E){const P=new Map;for(const C of E){const f=T.isLinux?C.path:C.path.toLowerCase();P.set(f,C)}return Array.from(P.values())}async setVerboseLogging(E){this.verboseLogging=E;for(const[,P]of this.watchers)P.instance.setVerboseLogging(E)}trace(E){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(E)})}toMessage(E,P){return P?`[File Watcher (node.js)] ${E} (path: ${P.request.path})`:`[File Watcher (node.js)] ${E}`}}e.NodeJSWatcher=I}),define(te[166],ne([0,1,52,165]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class L extends D.AbstractNonRecursiveWatcherClient{constructor(A,I,b){super(A,I,b);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=L}),define(te[167],ne([0,1,18,36,58,52]),function(Y,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends T.AbstractUniversalWatcherClient{constructor(b,E,P){super(b,E,P);this.init()}createWatcher(b){const E=b.add(new L.Client(D.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(E.onDidProcessExit(({code:P,signal:C})=>this.onError(`terminated by itself with code ${P}, signal: ${C}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(te[85],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...L){this._entries=new Map;for(let[T,A]of L)this.set(T,A)}set(L,T){const A=this._entries.get(L);return this._entries.set(L,T),A}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=D}),define(te[168],ne([0,1,5,9,51,157,6,85]),function(Y,e,D,n,L,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class E extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class P{constructor(u=new I.ServiceCollection,v=!1,d){this._activeInstantiations=new Set,this._services=u,this._strict=v,this._parent=d,this._services.set(A.IInstantiationService,this)}createChild(u){return new P(u,this._strict,this)}invokeFunction(u,...v){let d=f.traceInvocation(u),m=!1;try{return u({get:y=>{if(m)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(y,d);if(!p)throw new Error(`[invokeFunction] unknown service '${y}'`);return p}},...v)}finally{m=!0,d.stop()}}createInstance(u,...v){let d,m;return u instanceof L.SyncDescriptor?(d=f.traceCreation(u.ctor),m=this._createInstance(u.ctor,u.staticArguments.concat(v),d)):(d=f.traceCreation(u),m=this._createInstance(u,v,d)),d.stop(),m}_createInstance(u,v=[],d){let m=A._util.getServiceDependencies(u).sort((p,l)=>p.index-l.index),w=[];for(const p of m){let l=this._getOrCreateServiceInstance(p.id,d);if(!l&&this._strict&&!p.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${p.id}.`);w.push(l)}let y=m.length>0?m[0].index:v.length;if(v.length!==y){console.warn(`[createInstance] First service dependency of ${u.name} at position ${y+1} conflicts with ${v.length} static arguments`);let p=y-v.length;p>0?v=v.concat(new Array(p)):v=v.slice(0,y)}return new u(...[...v,...w])}_setServiceInstance(u,v){if(this._services.get(u)instanceof L.SyncDescriptor)this._services.set(u,v);else if(this._parent)this._parent._setServiceInstance(u,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let v=this._services.get(u);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):v}_getOrCreateServiceInstance(u,v){let d=this._getServiceInstanceOrDescriptor(u);return d instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,d,v.branch(u,!0)):(v.branch(u,!1),d)}_safeCreateAndCacheServiceInstance(u,v,d){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,v,d)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,v,d){const m=new T.Graph(p=>p.id.toString());let w=0;const y=[{id:u,desc:v,_trace:d}];for(;y.length;){const p=y.pop();if(m.lookupOrInsertNode(p),w++>1e3)throw new E(m);for(let l of A._util.getServiceDependencies(p.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(l.id);if(!i&&!l.optional&&console.warn(`[createInstance] ${u} depends on ${l.id} which is NOT registered.`),i instanceof L.SyncDescriptor){const a={id:l.id,desc:i,_trace:p._trace.branch(l.id,!0)};m.insertEdge(p,a),y.push(a)}}}for(;;){const p=m.roots();if(p.length===0){if(!m.isEmpty())throw new E(m);break}for(const{data:l}of p){if(this._getServiceInstanceOrDescriptor(l.id)instanceof L.SyncDescriptor){const a=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,a)}m.removeNode(l)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,v,d=[],m,w){if(this._services.get(u)instanceof L.SyncDescriptor)return this._createServiceInstance(v,d,m,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,v,d,m,w);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(u,v=[],d,m){if(d){const w=new D.IdleValue(()=>this._createInstance(u,v,m));return new Proxy(Object.create(null),{get(y,p){if(p in y)return y[p];let l=w.value,i=l[p];return typeof i!="function"||(i=i.bind(l),y[p]=i),i},set(y,p,l){return w.value[p]=l,!0}})}else return this._createInstance(u,v,m)}}e.InstantiationService=P;var C;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(C||(C={}));class f{constructor(u,v){this.type=u,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return b?new f(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(u){return b?new f(0,u.name):f._None}branch(u,v){let d=new f(2,u.toString());return this._dep.push([u,v,d]),d}stop(){let u=Date.now()-this._start;f._totals+=u;let v=!1;function d(w,y){let p=[],l=new Array(w+1).join("	");for(const[i,a,r]of y._dep)if(a&&r){v=!0,p.push(`${l}CREATES -> ${i}`);let t=d(w+1,r);t&&p.push(t)}else p.push(`${l}uses -> ${i}`);return p.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(u>2||v)&&console.log(m.join(`
`))}}e.Trace=f,f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(te[169],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(L,T){this.server=L,this.router=T}getChannel(L){return this.server.getChannel(L,this.router)}registerChannel(L,T){this.server.registerChannel(L,T)}}e.MessagePortMainProcessService=D}),define(te[170],ne([0,1,36,51,79,6]),function(Y,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(S,u,v){const d=v.getChannel(S);return I(u)?new u.channelClientCtor(d):D.ProxyChannel.toService(d,u?.proxyOptions)}}function I(f){return!!f?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let b=class extends A{constructor(S,u,v){super(S,u,v)}};b=he([J(2,e.IMainProcessService)],b);function E(f,S,u){(0,L.registerSingleton)(f,new n.SyncDescriptor(b,[S,u],u?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let P=class extends A{constructor(S,u,v){super(S,u,v)}};P=he([J(2,e.ISharedProcessService)],P);function C(f,S,u){(0,L.registerSingleton)(f,new n.SyncDescriptor(P,[S,u],u?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=C}),define(te[59],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function n(L){if(typeof L.languageId!="string"||!Array.isArray(L.translations)||L.translations.length===0)return!1;for(const T of L.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(L.languageName&&typeof L.languageName!="string"||L.localizedLanguageName&&typeof L.localizedLanguageName!="string")}e.isValidLocalization=n}),define(te[171],ne([0,1,2,59]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let L=class extends D.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};L=he([J(0,n.ILocalizationsService)],L),e.LocalizationsUpdater=L}),define(te[8],ne([0,1,37,3,2,4,6]),function(Y,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function I(){return new Date().toISOString()}var b;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function E(a,r,t){switch(r){case b.Trace:a.trace(t);break;case b.Debug:a.debug(t);break;case b.Info:a.info(t);break;case b.Warning:a.warn(t);break;case b.Error:a.error(t);break;case b.Critical:a.critical(t);break;default:throw new Error("Invalid log level")}}e.log=E;function P(a){let r="";for(let t=0;t<a.length;t++){let o=a[t];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}r+=(t>0?" ":"")+o}return r}e.format=P;class C extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class f extends C{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...t){this.checkLogLevel(b.Trace)&&this.log(b.Trace,P([r,...t]))}debug(r,...t){this.checkLogLevel(b.Debug)&&this.log(b.Debug,P([r,...t]))}info(r,...t){this.checkLogLevel(b.Info)&&this.log(b.Info,P([r,...t]))}warn(r,...t){this.checkLogLevel(b.Warning)&&this.log(b.Warning,P([r,...t]))}error(r,...t){if(this.checkLogLevel(b.Error))if(r instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=r.stack,this.log(b.Error,P(o))}else this.log(b.Error,P([r,...t]))}critical(r,...t){this.checkLogLevel(b.Critical)&&this.log(b.Critical,P([r,...t]))}flush(){}}e.AbstractMessageLogger=f;class S extends C{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!T.isWindows}trace(r,...t){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...t):console.log(`[main ${I()}]`,r,...t))}debug(r,...t){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...t):console.log(`[main ${I()}]`,r,...t))}info(r,...t){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...t):console.log(`[main ${I()}]`,r,...t))}warn(r,...t){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,r,...t):console.warn(`[main ${I()}]`,r,...t))}error(r,...t){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,r,...t):console.error(`[main ${I()}]`,r,...t))}critical(r,...t){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,r,...t):console.error(`[main ${I()}]`,r,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class u extends C{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...t){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",r,...t)}debug(r,...t){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...t)}info(r,...t){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",r,...t)}warn(r,...t){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",r,...t)}error(r,...t){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",r,...t)}critical(r,...t){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...t)}dispose(){}flush(){}}e.ConsoleLogger=u;class v extends C{constructor(r,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(t)}trace(r,...t){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(r),...t])}debug(r,...t){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(r),...t])}info(r,...t){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(r),...t])}warn(r,...t){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(r),...t])}error(r,...t){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(r),...t])}critical(r,...t){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(r),...t])}extractMessage(r){return typeof r=="string"?r:(0,D.toErrorMessage)(r,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=v;class d extends C{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const t of this.logServices)t.setLevel(r);super.setLevel(r)}trace(r,...t){for(const o of this.logServices)o.trace(r,...t)}debug(r,...t){for(const o of this.logServices)o.debug(r,...t)}info(r,...t){for(const o of this.logServices)o.info(r,...t)}warn(r,...t){for(const o of this.logServices)o.warn(r,...t)}error(r,...t){for(const o of this.logServices)o.error(r,...t)}critical(r,...t){for(const o of this.logServices)o.critical(r,...t)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=d;class m extends L.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...t){this.logger.trace(r,...t)}debug(r,...t){this.logger.debug(r,...t)}info(r,...t){this.logger.info(r,...t)}warn(r,...t){this.logger.warn(r,...t)}error(r,...t){this.logger.error(r,...t)}critical(r,...t){this.logger.critical(r,...t)}flush(){this.logger.flush()}}e.LogService=m;class w extends L.Disposable{constructor(r,t){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(o))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,t){let o=this.loggers.get(r.toString());return o||(o=this.doCreateLogger(r,t?.always?b.Trace:this.logLevel,t),this.loggers.set(r.toString(),o),t?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class y{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(r){}getLevel(){return b.Info}trace(r,...t){}debug(r,...t){}info(r,...t){}warn(r,...t){}error(r,...t){}critical(r,...t){}dispose(){}flush(){}}e.NullLogService=y;function p(a){if(a.verbose)return b.Trace;if(typeof a.logLevel=="string"){const r=l(a.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function l(a){switch(a){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=l;function i(a){switch(a){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=i}),define(te[172],ne([0,1,5,9,2,10,22,13,8]),function(Y,e,D,n,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends L.Disposable{constructor(C,f){super();this.environmentService=C,this.logService=f,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,T.basename)(this.environmentService.logsPath),f=(0,T.dirname)(this.environmentService.logsPath),v=(await A.Promises.readdir(f)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==C),d=v.slice(0,Math.max(0,v.length-9));d.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${d.join(", ")}'`),await Promise.all(d.map(m=>A.Promises.rm((0,T.join)(f,m)))))}catch(C){(0,n.onUnexpectedError)(C)}}};E=he([J(0,I.IEnvironmentService),J(1,b.ILogService)],E),e.LogsDataCleaner=E}),define(te[173],ne([0,1,5,9,2,10,22,13,8]),function(Y,e,D,n,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let E=class gt extends L.Disposable{constructor(C,f,S){super();this.backupWorkspacesPath=C,this.environmentService=f,this.logService=S,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const C=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),S=JSON.parse(C).emptyWorkspaceInfos.map(v=>v.backupFolder),u=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(u.map(async v=>{v.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||v===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||S.indexOf(v)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${v}.`),await A.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,v)))}))}catch(C){(0,n.onUnexpectedError)(C)}}};E.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,E.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",E=he([J(1,I.INativeEnvironmentService),J(2,b.ILogService)],E),e.StorageDataCleaner=E}),define(te[174],ne([0,1,45,5,37,3,2,18,10,22,13,8]),function(Y,e,D,n,L,T,A,I,b,E,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let f=class extends A.Disposable{constructor(u,v){super();this.environmentService=u,this.logService=v,this.processesLimiter=new n.Limiter(5)}async postUninstall(u){const v=this.parseScript(u,"uninstall");return v&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(v.script,"uninstall",v.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),d=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${d}`)))),E.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,d=>this.logService.error("Error while removing extension storage path",d))}parseScript(u,v){const d=`vscode:${v}`;if(u.location.scheme===I.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[d]=="string"){const m=u.manifest.scripts[d].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${d} should be a node script`),null):{script:(0,b.join)(u.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(u,v,d,m,w){return new Promise((y,p)=>{const l=this.start(u,v,d,w);let i;const a=r=>{i&&(clearTimeout(i),i=null),r?p(r):y(void 0)};l.on("error",r=>{a((0,L.toErrorMessage)(r)||"Unknown")}),l.on("exit",(r,t)=>{a(r?`post-${v} process exited with code ${r}`:void 0)}),m&&(i=setTimeout(()=>{i=null,l.kill(),p("timed out")},5e3))})}start(u,v,d,m){const w={silent:!0,execArgv:void 0},y=(0,D.fork)(u,[`--type=extension-post-${v}`,...d],w);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const p=T.Event.fromNodeEventEmitter(y.stdout,"data"),l=T.Event.fromNodeEventEmitter(y.stderr,"data");p(r=>this.logService.info(m.identifier.id,m.manifest.version,`post-${v}`,r)),l(r=>this.logService.error(m.identifier.id,m.manifest.version,`post-${v}`,r));const i=T.Event.any(T.Event.map(p,r=>({data:`%c${r}`,format:[""]})),T.Event.map(l,r=>({data:`%c${r}`,format:["color: red"]})));return T.Event.debounce(i,(r,t)=>r?{data:r.data+t.data,format:[...r.format,...t.format]}:{data:t.data,format:t.format},100)(r=>{console.group(m.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),y}getExtensionStoragePath(u){return(0,b.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};f=he([J(0,P.IEnvironmentService),J(1,C.ILogService)],f),e.ExtensionsLifecycle=f}),define(te[175],ne([0,1,16,5,9,3,2,10,52,8]),function(Y,e,D,n,L,T,A,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends A.Disposable{constructor(f,S){super();this.logService=f,this.options=S,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(f,S){return S.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(f,S):this.watchNonRecursive(f,S)}watchUniversal(f,S){const u={path:this.toFilePath(f),excludes:S.excludes,recursive:S.recursive},v=(0,D.insert)(this.universalPathsToWatch,u);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{v(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(f=>(0,L.onUnexpectedError)(f))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(S=>this._onDidChangeFile.fire((0,b.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})));const f=this.options?.watcher?.recursive?.usePolling;if(f===!0)for(const S of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(S)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(f))for(const S of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(S)&&f.includes(S.path)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(f,S){const u={path:this.toFilePath(f),excludes:S.excludes,recursive:!1},v=(0,D.insert)(this.nonRecursivePathsToWatch,u);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{v(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(f=>(0,L.onUnexpectedError)(f))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(f=>this._onDidChangeFile.fire((0,b.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(f){f.type==="error"&&this._onDidWatchError.fire(f.message),this.logService[f.type](f.message)}toFilePath(f){return(0,I.normalize)(f.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(te[176],ne([0,1,16,5,17,23,3,70,55,2,39,18,177,19,40,136,14,84,8]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S,u,v,d,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class extends E.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(l,i){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,f.mark)(`code/registerFilesystem/${l}`);const a=new E.DisposableStore;return this.provider.set(l,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:i}),a.add(i.onDidChangeFile(r=>this._onDidFilesChange.fire(new d.FileChangesEvent(r,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&a.add(i.onDidWatchError(r=>this._onDidWatchError.fire(new Error(r)))),a.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:l}))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:i}),this.provider.delete(l),(0,E.dispose)(a)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(a){i.push(a)}}),!this.provider.has(l)&&await n.Promises.settled(i)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,i){const a=this.provider.get(l.scheme);return!!(a&&a.capabilities&i)}listCapabilities(){return b.Iterable.map(this.provider,([l,i])=>({scheme:l,capabilities:i.capabilities}))}async withProvider(l){if(!(0,S.isAbsolutePath)(l))throw new d.FileOperationError((0,v.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const i=this.provider.get(l.scheme);if(!i){const a=new Error;throw a.name="ENOPRO",a.message=(0,v.localize)(1,null,l.toString()),a}return i}async withReadProvider(l){const i=await this.withProvider(l);if((0,d.hasOpenReadWriteCloseCapability)(i)||(0,d.hasReadWriteCapability)(i)||(0,d.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const i=await this.withProvider(l);if((0,d.hasOpenReadWriteCloseCapability)(i)||(0,d.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,i){try{return await this.doResolveFile(l,i)}catch(a){throw(0,d.toFileSystemProviderErrorCode)(a)===d.FileSystemProviderErrorCode.FileNotFound?new d.FileOperationError((0,v.localize)(2,null,this.resourceForError(l)),1):(0,d.ensureFileSystemProviderError)(a)}}async doResolveFile(l,i){const a=await this.withProvider(l),r=this.isPathCaseSensitive(a),t=i?.resolveTo,o=i?.resolveSingleChildDescendants,s=i?.resolveMetadata,c=await a.stat(l);let h;return this.toFileStat(a,l,c,void 0,!!s,(g,R)=>(h||(h=P.TernarySearchTree.forUris(()=>!r),h.set(l,!0),t&&h.fill(!0,t)),h.get(g.resource)||h.findSuperstr(g.resource.with({query:null,fragment:null}))?!0:g.isDirectory&&o?R===1:!1))}async toFileStat(l,i,a,r,t,o){const{providerExtUri:s}=this.getExtUri(l),c={resource:i,name:s.basename(i),isFile:(a.type&d.FileType.File)!=0,isDirectory:(a.type&d.FileType.Directory)!=0,isSymbolicLink:(a.type&d.FileType.SymbolicLink)!=0,mtime:a.mtime,ctime:a.ctime,size:a.size,readonly:Boolean((a.permissions??0)&d.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,d.etag)({mtime:a.mtime,size:a.size})};if(c.isDirectory&&o(c,r)){try{const h=await l.readdir(i),g=await n.Promises.settled(h.map(async([R,_])=>{try{const U=s.joinPath(i,R),F=t?await l.stat(U):{type:_};return await this.toFileStat(l,U,F,h.length,t,o)}catch(U){return this.logService.trace(U),null}}));c.children=(0,D.coalesce)(g)}catch(h){this.logService.trace(h),c.children=[]}return c}return c}async resolveAll(l){return n.Promises.settled(l.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(a){return this.logService.trace(a),{stat:void 0,success:!1}}}))}async exists(l){const i=await this.withProvider(l);try{return!!await i.stat(l)}catch{return!1}}async canCreateFile(l,i){try{await this.doValidateCreateFile(l,i)}catch(a){return a}return!0}async doValidateCreateFile(l,i){if(!i?.overwrite&&await this.exists(l))throw new d.FileOperationError((0,v.localize)(3,null,this.resourceForError(l)),3,i)}async createFile(l,i=L.VSBuffer.fromString(""),a){await this.doValidateCreateFile(l,a);const r=await this.writeFile(l,i);return this._onDidRunOperation.fire(new d.FileOperationEvent(l,0,r)),r}async writeFile(l,i,a){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:t}=this.getExtUri(r);try{await this.validateWriteFile(r,l,a)||await this.mkdirp(r,t.dirname(l));let s;if((0,d.hasReadWriteCapability)(r)&&!(i instanceof L.VSBuffer))if((0,u.isReadableStream)(i)){const c=await(0,u.peekStream)(i,3);c.ended?s=L.VSBuffer.concat(c.buffer):s=c}else s=(0,u.peekReadable)(i,c=>L.VSBuffer.concat(c),3);else s=i;!(0,d.hasOpenReadWriteCloseCapability)(r)||(0,d.hasReadWriteCapability)(r)&&s instanceof L.VSBuffer?await this.doWriteUnbuffered(r,l,a,s):await this.doWriteBuffered(r,l,a,s instanceof L.VSBuffer?(0,L.bufferToReadable)(s):s)}catch(o){throw new d.FileOperationError((0,v.localize)(4,null,this.resourceForError(l),(0,d.ensureFileSystemProviderError)(o).toString()),(0,d.toFileOperationResult)(o),a)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,i,a){if(!!a?.unlock&&!(l.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(i)));let t;try{t=await l.stat(i)}catch{return}if((t.type&d.FileType.Directory)!=0)throw new d.FileOperationError((0,v.localize)(6,null,this.resourceForError(i)),0,a);if(this.throwIfFileIsReadonly(i,t),typeof a?.mtime=="number"&&typeof a.etag=="string"&&a.etag!==d.ETAG_DISABLED&&typeof t.mtime=="number"&&typeof t.size=="number"&&a.mtime<t.mtime&&a.etag!==(0,d.etag)({mtime:a.mtime,size:t.size}))throw new d.FileOperationError((0,v.localize)(7,null),3,a);return t}async readFile(l,i,a){const r=await this.withReadProvider(l);return i?.atomic?this.doReadFileAtomic(r,l,i,a):this.doReadFile(r,l,i,a)}async doReadFileAtomic(l,i,a,r){return new Promise((t,o)=>{this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(l,i,a,r);t(s)}catch(s){o(s)}})})}async doReadFile(l,i,a,r){const t=await this.doReadFileStream(l,i,{...a,preferUnbuffered:!0},r);return{...t,value:await(0,L.streamToBuffer)(t.value)}}async readFileStream(l,i,a){const r=await this.withReadProvider(l);return this.doReadFileStream(r,l,i,a)}async doReadFileStream(l,i,a,r){const t=new T.CancellationTokenSource(r),o=this.validateReadFile(i,a).then(c=>c,c=>{throw t.cancel(),c});let s;try{return typeof a?.etag=="string"&&a.etag!==d.ETAG_DISABLED&&await o,a?.atomic&&(0,d.hasFileAtomicReadCapability)(l)||!((0,d.hasOpenReadWriteCloseCapability)(l)||(0,d.hasFileReadStreamCapability)(l))||(0,d.hasReadWriteCapability)(l)&&a?.preferUnbuffered?s=this.readFileUnbuffered(l,i,a):(0,d.hasFileReadStreamCapability)(l)?s=this.readFileStreamed(l,i,t.token,a):s=this.readFileBuffered(l,i,t.token,a),{...await o,value:s}}catch(c){s&&await(0,u.consumeStream)(s);const h=(0,v.localize)(8,null,this.resourceForError(i),(0,d.ensureFileSystemProviderError)(c).toString());throw c instanceof d.NotModifiedSinceFileOperationError?new d.NotModifiedSinceFileOperationError(h,c.stat,a):new d.FileOperationError(h,(0,d.toFileOperationResult)(c),a)}}readFileStreamed(l,i,a,r=Object.create(null)){const t=l.readFileStream(i,r,a);return(0,u.transform)(t,{data:o=>o instanceof L.VSBuffer?o:L.VSBuffer.wrap(o),error:o=>new d.FileOperationError((0,v.localize)(9,null,this.resourceForError(i),(0,d.ensureFileSystemProviderError)(o).toString()),(0,d.toFileOperationResult)(o),r)},o=>L.VSBuffer.concat(o))}readFileBuffered(l,i,a,r=Object.create(null)){const t=(0,L.newWriteableBufferStream)();return(0,m.readFileIntoStream)(l,i,t,o=>o,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new d.FileOperationError((0,v.localize)(10,null,this.resourceForError(i),(0,d.ensureFileSystemProviderError)(o).toString()),(0,d.toFileOperationResult)(o),r)},a),t}readFileUnbuffered(l,i,a){const r=(0,u.newWriteableStream)(t=>L.VSBuffer.concat(t));return(async()=>{try{let t;a?.atomic&&(0,d.hasFileAtomicReadCapability)(l)?t=await l.readFile(i,{atomic:!0}):t=await l.readFile(i),typeof a?.position=="number"&&(t=t.slice(a.position)),typeof a?.length=="number"&&(t=t.slice(0,a.length)),this.validateReadFileLimits(i,t.byteLength,a),r.end(L.VSBuffer.wrap(t))}catch(t){r.error(t),r.end()}})(),r}async validateReadFile(l,i){const a=await this.resolve(l,{resolveMetadata:!0});if(a.isDirectory)throw new d.FileOperationError((0,v.localize)(11,null,this.resourceForError(l)),0,i);if(typeof i?.etag=="string"&&i.etag!==d.ETAG_DISABLED&&i.etag===a.etag)throw new d.NotModifiedSinceFileOperationError((0,v.localize)(12,null),a,i);return this.validateReadFileLimits(l,a.size,i),a}validateReadFileLimits(l,i,a){if(a?.limits){let r;if(typeof a.limits.memory=="number"&&i>a.limits.memory&&(r=9),typeof a.limits.size=="number"&&i>a.limits.size&&(r=7),typeof r=="number")throw new d.FileOperationError((0,v.localize)(13,null,this.resourceForError(l)),r)}}async canMove(l,i,a){return this.doCanMoveCopy(l,i,"move",a)}async canCopy(l,i,a){return this.doCanMoveCopy(l,i,"copy",a)}async doCanMoveCopy(l,i,a,r){if(l.toString()!==i.toString())try{const t=a==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(t,l,o,i,a,r)}catch(t){return t}return!0}async move(l,i,a){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(r,l,t,i,"move",!!a),s=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(l,o==="move"?2:3,s)),s}async copy(l,i,a){const r=await this.withReadProvider(l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(r,l,t,i,"copy",!!a),s=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(l,o==="copy"?3:2,s)),s}async doMoveCopy(l,i,a,r,t,o){if(i.toString()===r.toString())return t;const{exists:s,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(l,i,a,r,t,o);if(s&&!c&&o&&await this.del(r,{recursive:!0}),await this.mkdirp(a,this.getExtUri(a).providerExtUri.dirname(r)),t==="copy"){if(l===a&&(0,d.hasFileFolderCopyCapability)(l))await l.copy(i,r,{overwrite:o});else{const h=await this.resolve(i);h.isDirectory?await this.doCopyFolder(l,h,a,r):await this.doCopyFile(l,i,a,r)}return t}else return l===a?(await l.rename(i,r,{overwrite:o}),t):(await this.doMoveCopy(l,i,a,r,"copy",o),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(l,i,a,r){if((0,d.hasOpenReadWriteCloseCapability)(l)&&(0,d.hasOpenReadWriteCloseCapability)(a))return this.doPipeBuffered(l,i,a,r);if((0,d.hasOpenReadWriteCloseCapability)(l)&&(0,d.hasReadWriteCapability)(a))return this.doPipeBufferedToUnbuffered(l,i,a,r);if((0,d.hasReadWriteCapability)(l)&&(0,d.hasOpenReadWriteCloseCapability)(a))return this.doPipeUnbufferedToBuffered(l,i,a,r);if((0,d.hasReadWriteCapability)(l)&&(0,d.hasReadWriteCapability)(a))return this.doPipeUnbuffered(l,i,a,r)}async doCopyFolder(l,i,a,r){await a.mkdir(r),Array.isArray(i.children)&&await n.Promises.settled(i.children.map(async t=>{const o=this.getExtUri(a).providerExtUri.joinPath(r,t.name);return t.isDirectory?this.doCopyFolder(l,await this.resolve(t.resource),a,o):this.doCopyFile(l,t.resource,a,o)}))}async doValidateMoveCopy(l,i,a,r,t,o){let s=!1;if(l===a){const{providerExtUri:h,isPathCaseSensitive:g}=this.getExtUri(l);if(g||(s=h.isEqual(i,r)),s&&t==="copy")throw new Error((0,v.localize)(14,null,this.resourceForError(i),this.resourceForError(r)));if(!s&&h.isEqualOrParent(r,i))throw new Error((0,v.localize)(15,null,this.resourceForError(i),this.resourceForError(r)))}const c=await this.exists(r);if(c&&!s){if(!o)throw new d.FileOperationError((0,v.localize)(16,null,this.resourceForError(i),this.resourceForError(r)),4);if(l===a){const{providerExtUri:h}=this.getExtUri(l);if(h.isEqualOrParent(i,r))throw new Error((0,v.localize)(17,null,this.resourceForError(i),this.resourceForError(r)))}}return{exists:c,isSameResourceWithDifferentPathCase:s}}getExtUri(l){const i=this.isPathCaseSensitive(l);return{providerExtUri:i?S.extUri:S.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(i,l);const a=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(l,0,a)),a}async mkdirp(l,i){const a=[],{providerExtUri:r}=this.getExtUri(l);for(;!r.isEqual(i,r.dirname(i));)try{if(((await l.stat(i)).type&d.FileType.Directory)==0)throw new Error((0,v.localize)(18,null,this.resourceForError(i)));break}catch(t){if((0,d.toFileSystemProviderErrorCode)(t)!==d.FileSystemProviderErrorCode.FileNotFound)throw t;a.push(r.basename(i)),i=r.dirname(i)}for(let t=a.length-1;t>=0;t--){i=r.joinPath(i,a[t]);try{await l.mkdir(i)}catch(o){if((0,d.toFileSystemProviderErrorCode)(o)!==d.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(l,i){try{await this.doValidateDelete(l,i)}catch(a){return a}return!0}async doValidateDelete(l,i){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!i?.useTrash&&!(a.capabilities&4096))throw new Error((0,v.localize)(19,null,this.resourceForError(l)));let t;try{t=await a.stat(l)}catch{}if(t)this.throwIfFileIsReadonly(l,t);else throw new d.FileOperationError((0,v.localize)(20,null,this.resourceForError(l)),1);if(!!!i?.recursive){const s=await this.resolve(l);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,v.localize)(21,null,this.resourceForError(l)))}return a}async del(l,i){const a=await this.doValidateDelete(l,i),r=!!i?.useTrash,t=!!i?.recursive;await a.delete(l,{recursive:t,useTrash:r}),this._onDidRunOperation.fire(new d.FileOperationEvent(l,1))}watch(l,i={recursive:!1,excludes:[]}){const a=new E.DisposableStore;let r=!1,t=()=>{r=!0};return a.add((0,E.toDisposable)(()=>t())),(async()=>{try{const o=await this.doWatch(l,i);r?(0,E.dispose)(o):t=()=>(0,E.dispose)(o)}catch(o){this.logService.error(o)}})(),a}async doWatch(l,i){const a=await this.withProvider(l),r=(0,I.hash)([this.getExtUri(a).providerExtUri.getComparisonKey(l),i]);let t=this.activeWatchers.get(r);return t||(t={count:0,disposable:a.watch(l,i)},this.activeWatchers.set(r,t)),t.count+=1,(0,E.toDisposable)(()=>{t&&(t.count--,t.count===0&&((0,E.dispose)(t.disposable),this.activeWatchers.delete(r)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,E.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,i,a,r){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(async()=>{const t=await l.open(i,{create:!0,unlock:a?.unlock??!1});try{(0,u.isReadableStream)(r)||(0,u.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(l,t,r):await this.doWriteReadableBufferedQueued(l,t,r)}catch(o){throw(0,d.ensureFileSystemProviderError)(o)}finally{await l.close(t)}})}async doWriteStreamBufferedQueued(l,i,a){let r=0,t;if((0,u.isReadableBufferedStream)(a)){if(a.buffer.length>0){const o=L.VSBuffer.concat(a.buffer);await this.doWriteBuffer(l,i,o,o.byteLength,r,0),r+=o.byteLength}if(a.ended)return;t=a.stream}else t=a;return new Promise((o,s)=>{(0,u.listenStream)(t,{onData:async c=>{t.pause();try{await this.doWriteBuffer(l,i,c,c.byteLength,r,0)}catch(h){return s(h)}r+=c.byteLength,setTimeout(()=>t.resume())},onError:c=>s(c),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(l,i,a){let r=0,t;for(;(t=a.read())!==null;)await this.doWriteBuffer(l,i,t,t.byteLength,r,0),r+=t.byteLength}async doWriteBuffer(l,i,a,r,t,o){let s=0;for(;s<r;)s+=await l.write(i,t+s,a.buffer,o+s,r-s)}async doWriteUnbuffered(l,i,a,r){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,i,a,r))}async doWriteUnbufferedQueued(l,i,a,r){let t;r instanceof L.VSBuffer?t=r:(0,u.isReadableStream)(r)?t=await(0,L.streamToBuffer)(r):(0,u.isReadableBufferedStream)(r)?t=await(0,L.bufferedStreamToBuffer)(r):t=(0,L.readableToBuffer)(r),await l.writeFile(i,t.buffer,{create:!0,overwrite:!0,unlock:a?.unlock??!1})}async doPipeBuffered(l,i,a,r){return this.writeQueue.queueFor(r,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,i,a,r))}async doPipeBufferedQueued(l,i,a,r){let t,o;try{t=await l.open(i,{create:!1}),o=await a.open(r,{create:!0,unlock:!1});const s=L.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,h=0,g=0;do g=await l.read(t,c,s.buffer,h,s.byteLength-h),await this.doWriteBuffer(a,o,s,g,c,h),c+=g,h+=g,h===s.byteLength&&(h=0);while(g>0)}catch(s){throw(0,d.ensureFileSystemProviderError)(s)}finally{await n.Promises.settled([typeof t=="number"?l.close(t):Promise.resolve(),typeof o=="number"?a.close(o):Promise.resolve()])}}async doPipeUnbuffered(l,i,a,r){return this.writeQueue.queueFor(r,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,i,a,r))}async doPipeUnbufferedQueued(l,i,a,r){return a.writeFile(r,await l.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,i,a,r){return this.writeQueue.queueFor(r,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,i,a,r))}async doPipeUnbufferedToBufferedQueued(l,i,a,r){const t=await a.open(r,{create:!0,unlock:!1});try{const o=await l.readFile(i);await this.doWriteBuffer(a,t,L.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,d.ensureFileSystemProviderError)(o)}finally{await a.close(t)}}async doPipeBufferedToUnbuffered(l,i,a,r){const t=await(0,L.streamToBuffer)(this.readFileBuffered(l,i,T.CancellationToken.None));await this.doWriteUnbuffered(a,r,void 0,t)}throwIfFileSystemIsReadonly(l,i){if(l.capabilities&2048)throw new d.FileOperationError((0,v.localize)(22,null,this.resourceForError(i)),6);return l}throwIfFileIsReadonly(l,i){if((i.permissions??0)&d.FilePermission.Readonly)throw new d.FileOperationError((0,v.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===C.Schemas.file?l.fsPath:l.toString(!0)}};y=he([J(0,w.ILogService)],y),e.FileService=y}),define(te[178],ne([0,1,50,255,5,39,17,3,41,2,10,4,19,40,22,139,14,84,175,37,167,166]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S,u,v,d,m,w,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(D)}catch(a){console.error(`Error enabling graceful-fs: ${(0,y.toErrorMessage)(a)}`)}})();class i extends w.AbstractDiskFileSystemProvider{constructor(r,t){super(r,t);this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new T.ResourceMap(o=>f.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:t,symbolicLink:o}=await u.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(t,o),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(t){throw this.toFileSystemProviderError(t)}}async readdir(r){try{const t=await u.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),o=[];return await Promise.all(t.map(async s=>{try{let c;s.isSymbolicLink()?c=(await this.stat((0,f.joinPath)(r,s.name))).type:c=this.toType(s),o.push([s.name,c])}catch(c){this.logService.trace(c)}})),o}catch(t){throw this.toFileSystemProviderError(t)}}toType(r,t){let o;return t?.dangling?o=d.FileType.Unknown:r.isFile()?o=d.FileType.File:r.isDirectory()?o=d.FileType.Directory:o=d.FileType.Unknown,t&&(o|=d.FileType.SymbolicLink),o}async createResourceLock(r){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(r)})`);let t;for(;t=this.resourceLocks.get(r);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(r)})`),await t.wait();const o=new L.Barrier;return this.resourceLocks.set(r,o),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(r)})`),(0,E.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(r)})`),this.resourceLocks.delete(r),o.open()})}async readFile(r,t){let o;try{t?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(r)})`),o=await this.createResourceLock(r));const s=this.toFilePath(r);return await u.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{o?.dispose()}}readFileStream(r,t,o){const s=(0,S.newWriteableStream)(c=>A.VSBuffer.concat(c.map(h=>A.VSBuffer.wrap(h))).buffer);return(0,m.readFileIntoStream)(this,r,s,c=>c.buffer,{...t,bufferSize:256*1024},o),s}async writeFile(r,t,o){let s;try{const c=this.toFilePath(r);if(!o.create||!o.overwrite){if(await u.Promises.exists(c)){if(!o.overwrite)throw(0,d.createFileSystemProviderError)((0,v.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,d.createFileSystemProviderError)((0,v.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(r,{create:!0,unlock:o.unlock}),await this.write(s,0,t,0,t.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(r,c)}finally{typeof s=="number"&&await this.close(s)}}async open(r,t){let o;(0,d.isFileOpenForWriteOptions)(t)&&(o=await this.createResourceLock(r));let s;try{const c=this.toFilePath(r);if((0,d.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:g}=await u.SymlinkSupport.stat(c);g.mode&128||await u.Promises.chmod(c,g.mode|128)}catch(g){this.logService.trace(g)}let h;if((0,d.isFileOpenForWriteOptions)(t)){if(C.isWindows)try{await u.Promises.truncate(c,0),h="r+"}catch(g){g.code!=="ENOENT"&&this.logService.trace(g)}h||(h="w")}else h="r";s=await u.Promises.open(c,h)}catch(c){throw o?.dispose(),(0,d.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(r,c):this.toFileSystemProviderError(c)}return this.mapHandleToPos.set(s,0),(0,d.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(s,r),o&&this.mapHandleToLock.set(s,o),s}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await u.Promises.fdatasync(r)}catch(t){this.canFlush=!1,this.logService.error(t)}return await u.Promises.close(r)}catch(t){throw this.toFileSystemProviderError(t)}finally{const t=this.mapHandleToLock.get(r);t&&(this.mapHandleToLock.delete(r),t.dispose())}}async read(r,t,o,s,c){const h=this.normalizePos(r,t);let g=null;try{const{bytesRead:R}=await u.Promises.read(r,o,s,c,h);return R}catch(R){throw this.toFileSystemProviderError(R)}finally{this.updatePos(r,h,g)}}normalizePos(r,t){return t===this.mapHandleToPos.get(r)?null:t}updatePos(r,t,o){const s=this.mapHandleToPos.get(r);typeof s=="number"&&(typeof t=="number"||(typeof o=="number"?this.mapHandleToPos.set(r,s+o):this.mapHandleToPos.delete(r)))}async write(r,t,o,s,c){return(0,L.retry)(()=>this.doWrite(r,t,o,s,c),100,3)}async doWrite(r,t,o,s,c){const h=this.normalizePos(r,t);let g=null;try{const{bytesWritten:R}=await u.Promises.write(r,o,s,c,h);return R}catch(R){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),R)}finally{this.updatePos(r,h,g)}}async mkdir(r){try{await u.Promises.mkdir(this.toFilePath(r))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(r,t){try{const o=this.toFilePath(r);t.recursive?await u.Promises.rm(o,u.RimRafMode.MOVE):await u.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(r,t,o){const s=this.toFilePath(r),c=this.toFilePath(t);if(s!==c)try{await this.validateTargetDeleted(r,t,"move",o.overwrite),await u.Promises.move(s,c)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,v.localize)(2,null,(0,P.basename)(s),(0,P.basename)((0,P.dirname)(c)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(r,t,o){const s=this.toFilePath(r),c=this.toFilePath(t);if(s!==c)try{await this.validateTargetDeleted(r,t,"copy",o.overwrite),await u.Promises.copy(s,c,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,v.localize)(3,null,(0,P.basename)(s),(0,P.basename)((0,P.dirname)(c)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(r,t,o,s){const c=this.toFilePath(r),h=this.toFilePath(t);let g=!1;if(!!(this.capabilities&1024)||(g=(0,b.isEqual)(c,h,!0)),g&&o==="copy")throw(0,d.createFileSystemProviderError)((0,v.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(!g&&await u.Promises.exists(h)){if(!s)throw(0,d.createFileSystemProviderError)((0,v.localize)(5,null),d.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}createUniversalWatcher(r,t,o){return new p.UniversalWatcherClient(s=>r(s),s=>t(s),o)}createNonRecursiveWatcher(r,t,o){return new l.NodeJSWatcherClient(s=>r(s),s=>t(s),o)}toFileSystemProviderError(r){if(r instanceof d.FileSystemProviderError)return r;let t;switch(r.code){case"ENOENT":t=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=d.FileSystemProviderErrorCode.NoPermissions;break;default:t=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(r,t)}async toFileSystemProviderWriteError(r,t){let o=this.toFileSystemProviderError(t);if(r&&o.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await u.SymlinkSupport.stat(this.toFilePath(r));s.mode&128||(o=(0,d.createFileSystemProviderError)(t,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return o}}e.DiskFileSystemProvider=i}),define(te[86],ne([0,1,3,7,8]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(f){this.service=f,this.onDidChangeLogLevel=D.Event.buffer(f.onDidChangeLogLevel,!0)}listen(f,S){switch(S){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${S}`)}async call(f,S,u){switch(S){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${S}`)}}e.LogLevelChannel=T;class A{constructor(f){this.channel=f}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(f){A.setLevel(this.channel,f)}static setLevel(f,S){return f.call("setLevel",S)}}e.LogLevelChannelClient=A;class I{constructor(f){this.loggerService=f,this.loggers=new Map}listen(f,S){throw new Error(`Event not found: ${S}`)}async call(f,S,u){switch(S){case"createLogger":this.createLogger(n.URI.revive(u[0]),u[1]);return;case"log":return this.log(n.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${S}`)}createLogger(f,S){this.loggers.set(f.toString(),this.loggerService.createLogger(f,S))}consoleLog(f,S){let u=console.log;switch(f){case L.LogLevel.Error:u=console.error;break;case L.LogLevel.Warning:u=console.warn;break;case L.LogLevel.Info:u=console.info;break}u.call(console,...S)}log(f,S){const u=this.loggers.get(f.toString());if(!u)throw new Error("Create the logger before logging");for(const[v,d]of S)(0,L.log)(u,v,d)}}e.LoggerChannel=I;class b extends L.AbstractLoggerService{constructor(f,S,u){super(f,S);this.channel=u}createConsoleMainLogger(){return new L.AdapterLogger({log:(f,S)=>{this.channel.call("consoleLog",[f,S])}})}doCreateLogger(f,S,u){return new E(this.channel,f,S,u)}}e.LoggerChannelClient=b;class E extends L.AbstractMessageLogger{constructor(f,S,u,v){super(v?.always);this.channel=f,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[S,v]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,S){const u=[[f,S]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(f){this.channel.call("log",[this.file,f])}}class P extends L.LogService{constructor(f,S){super(S);this.parent=f,this._register(f.onDidChangeLogLevel(u=>S.setLevel(u)))}setLevel(f){super.setLevel(f),this.parent.setLevel(f)}}e.FollowerLogService=P}),define(te[60],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(te[87],ne([0,1,18,4,32,19]),function(Y,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const I=n.globals.vscode.context.configuration();if(I)A=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const I=(0,T.dirname)(D.FileAccess.asFileUri("",Y));A=Y.__$__nodeRequire((0,T.joinPath)(I,"product.json").fsPath);const b=Y.__$__nodeRequire((0,T.joinPath)(I,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:b.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A}),define(te[26],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[179],ne([0,1,5,9,2,10,22,8,26]),function(Y,e,D,n,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends L.Disposable{constructor(C,f,S){super();this.productService=f,this.logService=S,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},30*1e3)).schedule()}async cleanUpCodeCaches(C){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),S=(0,T.dirname)(C),u=(0,T.basename)(C),v=await A.Promises.readdir(S);await Promise.all(v.map(async d=>{if(d===u)return;const m=(0,T.join)(S,d),w=await A.Promises.stat(m);if(w.isDirectory()&&f-w.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${d}.`),A.Promises.rm(m)}))}catch(f){(0,n.onUnexpectedError)(f)}}};E=he([J(1,b.IProductService),J(2,I.ILogService)],E),e.CodeCacheCleaner=E}),define(te[180],ne([0,1,5,9,2,10,22,13,8,26]),function(Y,e,D,n,L,T,A,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends L.Disposable{constructor(f,S,u){super();this.environmentService=f,this.logService=S,this.productService=u,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),S=JSON.parse(await A.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let w of Object.keys(S)){const y=S[w];f[`${y.hash}.${w}`]=!0}const u=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(u))return;const d=await A.Promises.readdir(u);for(const w of d){if(f[w]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${w}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${w}`),await A.Promises.rm((0,T.join)(u,w))}const m=Date.now();for(const w of Object.keys(f)){const y=(0,T.join)(u,w),p=await A.Promises.readdir(y);for(const l of p){if(l==="tcf.json")continue;const i=(0,T.join)(y,l),a=await A.Promises.stat(i);a.isDirectory()&&m-a.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(w,l)}`),await A.Promises.rm(i))}}}catch(f){(0,n.onUnexpectedError)(f)}}};P=he([J(0,I.INativeEnvironmentService),J(1,b.ILogService),J(2,E.IProductService)],P),e.LanguagePackCachedDataCleaner=P}),define(te[181],ne([0,1,10,6]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,n.createDecorator)("IV8InspectProfilingService");var L;(function(T){function A(I,b="noAbsolutePaths"){for(const E of I.nodes)E.callFrame&&E.callFrame.url&&((0,D.isAbsolute)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(E.callFrame.url))&&(E.callFrame.url=(0,D.join)(b,(0,D.basename)(E.callFrame.url)));return I}T.rewriteAbsolutePaths=A})(L=e.Utils||(e.Utils={}))}),define(te[182],ne([0,1,29]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class n{constructor(){this._sessions=new Map}async startProfiling(T){const I=await(await new Promise((E,P)=>{Y(["v8-inspect-profiler"],E,P)})).startProfiling({port:T.port,checkForPaused:!0}),b=(0,D.generateUuid)();return this._sessions.set(b,I),b}async stopProfiling(T){const A=this._sessions.get(T);if(!A)throw new Error(`UNKNOWN session '${T}'`);const I=await A.stop();return this._sessions.delete(T),I.profile}}e.InspectProfilingService=n}),define(te[38],ne([0,1,99,15]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(A,I){D.ok(n.isString(A)),D.ok(n.isObject(I)),D.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,I)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new L}),define(te[88],ne([0,1,3,38]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class T{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,E){this.schemasById[L(b)]=E,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new T;n.Registry.add(e.Extensions.JSONContribution,A)}),define(te[42],ne([0,1,16,3,15,125,88,38]),function(Y,e,D,n,L,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=I.Registry.as(A.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,i=!0){this.registerConfigurations([l],i)}registerConfigurations(l,i=!0){const a=this.doRegisterConfigurations(l,i);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}deregisterConfigurations(l){const i=this.doDeregisterConfigurations(l);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}updateConfigurations({add:l,remove:i}){const a=[];a.push(...this.doDeregisterConfigurations(i)),a.push(...this.doRegisterConfigurations(l,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(a)})}registerDefaultConfigurations(l){const i=[],a=[];for(const{overrides:r,source:t}of l)for(const o in r)if(i.push(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const s={...this.configurationDefaultsOverrides.get(o)?.value||{},...r[o]};this.configurationDefaultsOverrides.set(o,{source:t,value:s});const c={type:"object",default:s,description:T.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:s,source:L.isString(t)?void 0:t};a.push(...u(o)),this.configurationProperties[o]=c,this.defaultLanguageConfigurationOverridesNode.properties[o]=c}else{this.configurationDefaultsOverrides.set(o,{value:r[o],source:t});const s=this.configurationProperties[o];s&&(this.updatePropertyDefaultValue(o,s),this.updateSchema(o,s))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:!0})}deregisterDefaultConfigurations(l){const i=[];for(const{overrides:a,source:r}of l)for(const t in a){const o=this.configurationDefaultsOverrides.get(t),s=L.isString(r)?r:r?.id,c=L.isString(o?.source)?o?.source:o?.source?.id;if(s===c)if(i.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const h=this.configurationProperties[t];h&&(this.updatePropertyDefaultValue(t,h),this.updateSchema(t,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const i of l)this.overrideIdentifiers.add(i);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,i){const a=[];return l.forEach(r=>{a.push(...this.validateAndRegisterProperties(r,i,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),a}doDeregisterConfigurations(l){const i=[],a=r=>{if(r.properties)for(const t in r.properties)i.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,r.properties[t]);r.allOf&&r.allOf.forEach(t=>a(t))};for(const r of l){a(r);const t=this.configurationContributors.indexOf(r);t!==-1&&this.configurationContributors.splice(t,1)}return i}validateAndRegisterProperties(l,i=!0,a,r,t=3){t=L.isUndefinedOrNull(l.scope)?t:l.scope;let o=[],s=l.properties;if(s)for(let h in s){if(i&&w(h)){delete s[h];continue}const g=s[h];if(g.source=a,g.defaultDefaultValue=s[h].default,this.updatePropertyDefaultValue(h,g),e.OVERRIDE_PROPERTY_REGEX.test(h)?g.scope=void 0:(g.scope=L.isUndefinedOrNull(g.scope)?t:g.scope,g.restricted=L.isUndefinedOrNull(g.restricted)?!!r?.includes(h):g.restricted),s[h].hasOwnProperty("included")&&!s[h].included){this.excludedConfigurationProperties[h]=s[h],delete s[h];continue}else this.configurationProperties[h]=s[h];!s[h].deprecationMessage&&s[h].markdownDeprecationMessage&&(s[h].deprecationMessage=s[h].markdownDeprecationMessage),o.push(h)}let c=l.allOf;if(c)for(let h of c)o.push(...this.validateAndRegisterProperties(h,i,a,r,t));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const i=a=>{let r=a.properties;if(r)for(const o in r)this.updateSchema(o,r[o]);let t=a.allOf;t&&t.forEach(i)};i(l)}updateSchema(l,i){switch(e.allSettings.properties[l]=i,i.scope){case 1:e.applicationSettings.properties[l]=i;break;case 2:e.machineSettings.properties[l]=i;break;case 6:e.machineOverridableSettings.properties[l]=i;break;case 3:e.windowSettings.properties[l]=i;break;case 4:e.resourceSettings.properties[l]=i;break;case 5:e.resourceSettings.properties[l]=i,this.resourceLanguageSettingsSchema.properties[l]=i;break}}removeFromSchema(l,i){switch(delete e.allSettings.properties[l],i.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const i=`[${l}]`,a={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(i,a),e.allSettings.properties[i]=a,e.applicationSettings.properties[i]=a,e.machineSettings.properties[i]=a,e.machineOverridableSettings.properties[i]=a,e.windowSettings.properties[i]=a,e.resourceSettings.properties[i]=a}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,i){const a=this.configurationDefaultsOverrides.get(l);let r=a?.value,t=a?.source;L.isUndefined(r)&&(r=i.defaultDefaultValue,t=void 0),L.isUndefined(r)&&(r=d(i.type)),i.default=r,i.defaultValueSource=t}}const f="\\[([^\\]]+)\\]",S=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function u(p){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let i=S.exec(p);for(;i?.length;){const a=i[1].trim();a&&l.push(a),i=S.exec(p)}}return(0,D.distinct)(l)}e.overrideIdentifiersFromKey=u;function v(p){return p.reduce((l,i)=>`${l}[${i}]`,"")}e.keyFromOverrideIdentifiers=v;function d(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const m=new C;I.Registry.add(e.Extensions.Configuration,m);function w(p){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?T.localize(7,null,p):m.getConfigurationProperties()[p]!==void 0?T.localize(8,null,p):null:T.localize(6,null)}e.validateProperty=w;function y(){const p=[],l=m.getConfigurationProperties();for(const i of Object.keys(l))p.push([i,l[i].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=y}),define(te[89],ne([0,1,16,3,35,2,39,28,15,7,20,42,38]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class S{constructor(r={},t=[],o=[]){this._contents=r,this._keys=t,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,P.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,t){const o=this.getContentsForOverrideIdentifer(t);return o?r?(0,P.getConfigurationValue)(o,r):o:void 0}getKeysForOverrideIdentifier(r){const t=[];for(const o of this.overrides)o.identifiers.includes(r)&&t.push(...o.keys);return D.distinct(t)}getAllOverrideIdentifiers(){const r=[];for(const t of this.overrides)r.push(...t.identifiers);return D.distinct(r)}override(r){let t=this.overrideConfigurations.get(r);return t||(t=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,t)),t}merge(...r){const t=I.deepClone(this.contents),o=I.deepClone(this.overrides),s=[...this.keys];for(const c of r){this.mergeContents(t,c.contents);for(const h of c.overrides){const[g]=o.filter(R=>D.equals(R.identifiers,h.identifiers));g?(this.mergeContents(g.contents,h.contents),g.keys.push(...h.keys),g.keys=D.distinct(g.keys)):o.push(I.deepClone(h))}for(const h of c.keys)s.indexOf(h)===-1&&s.push(h)}return new S(t,s,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const t=this.getContentsForOverrideIdentifer(r);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let o={};for(const s of D.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[s],h=t[s];h&&(typeof c=="object"&&typeof h=="object"?(c=I.deepClone(c),this.mergeContents(c,h)):c=h),o[s]=c}return new S(o,this.keys,this.overrides)}mergeContents(r,t){for(const o of Object.keys(t)){if(o in r&&b.isObject(r[o])&&b.isObject(t[o])){this.mergeContents(r[o],t[o]);continue}r[o]=I.deepClone(t[o])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?I.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let t=null,o=null;const s=c=>{c&&(o?this.mergeContents(o,c):o=I.deepClone(c))};for(const c of this.overrides)D.equals(c.identifiers,[r])?t=c.contents:c.identifiers.includes(r)&&s(c.contents);return s(t),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,t){this.addKey(r),(0,P.addToValueTree)(this.contents,r,t,o=>{throw new Error(o)})}removeValue(r){this.removeKey(r)&&(0,P.removeFromValueTree)(this.contents,r)}addKey(r){let t=this.keys.length;for(let o=0;o<t;o++)r.indexOf(this.keys[o])===0&&(t=o);this.keys.splice(t,1,r)}removeKey(r){let t=this.keys.indexOf(r);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=S;class u extends S{constructor(r={}){const t=f.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(t),s=Object.create(null),c=[];for(const h in t){const g=r[h],R=g!==void 0?g:t[h].default;(0,P.addToValueTree)(s,h,R,_=>console.error(`Conflict in default settings: ${_}`))}for(const h of Object.keys(s))C.OVERRIDE_PROPERTY_REGEX.test(h)&&c.push({identifiers:(0,C.overrideIdentifiersFromKey)(h),keys:Object.keys(s[h]),contents:(0,P.toValuesTree)(s[h],g=>console.error(`Conflict in default settings file: ${g}`))});super(s,o,c)}}e.DefaultConfigurationModel=u;class v{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,t){if(!b.isUndefinedOrNull(r)){const o=this.doParseContent(r);this.parseRaw(o,t)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,t){this._raw=r;const{contents:o,keys:s,overrides:c,restricted:h}=this.doParseRaw(r,t);this._configurationModel=new S(o,s,c),this._restrictedConfigurations=h||[]}doParseContent(r){let t={},o=null,s=[],c=[],h=[];function g(_){Array.isArray(s)?s.push(_):o!==null&&(s[o]=_)}let R={onObjectBegin:()=>{let _={};g(_),c.push(s),s=_,o=null},onObjectProperty:_=>{o=_},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{let _=[];g(_),c.push(s),s=_,o=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:g,onError:(_,U,F)=>{h.push({error:_,offset:U,length:F})}};if(r)try{L.visit(r,R),t=s[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return t}doParseRaw(r,t){const o=f.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),s=this.filter(r,o,!0,t);r=s.raw;const c=(0,P.toValuesTree)(r,R=>console.error(`Conflict in settings file ${this._name}: ${R}`)),h=Object.keys(r),g=this.toOverrides(r,R=>console.error(`Conflict in settings file ${this._name}: ${R}`));return{contents:c,keys:h,overrides:g,restricted:s.restricted}}filter(r,t,o,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:r,restricted:[]};const c={},h=[];for(let g in r)if(C.OVERRIDE_PROPERTY_REGEX.test(g)&&o){const R=this.filter(r[g],t,!1,s);c[g]=R.raw,h.push(...R.restricted)}else{const R=t[g],_=R?typeof R.scope!="undefined"?R.scope:3:void 0;R?.restricted&&h.push(g),(_===void 0||s.scopes===void 0||s.scopes.includes(_))&&(s.skipRestricted&&R?.restricted||(c[g]=r[g]))}return{raw:c,restricted:h}}toOverrides(r,t){const o=[];for(const s of Object.keys(r))if(C.OVERRIDE_PROPERTY_REGEX.test(s)){const c={};for(const h in r[s])c[h]=r[s][h];o.push({identifiers:(0,C.overrideIdentifiersFromKey)(s),keys:Object.keys(c),contents:(0,P.toValuesTree)(c,t)})}return o}}e.ConfigurationModelParser=v;class d extends T.Disposable{constructor(r,t,o,s){super();this.userSettingsResource=r,this.scopes=t,this.fileService=s,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=d;class m{constructor(r,t,o=new S,s=new S,c=new A.ResourceMap,h=new S,g=new A.ResourceMap,R=!0){this._defaultConfiguration=r,this._localUserConfiguration=t,this._remoteUserConfiguration=o,this._workspaceConfiguration=s,this._folderConfigurations=c,this._memoryConfiguration=h,this._memoryConfigurationByResource=g,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(r,t,o){return this.getConsolidateConfigurationModel(t,o).getValue(r)}updateValue(r,t,o={}){let s;o.resource?(s=this._memoryConfigurationByResource.get(o.resource),s||(s=new S,this._memoryConfigurationByResource.set(o.resource,s))):s=this._memoryConfiguration,t===void 0?s.removeValue(r):s.setValue(r,t),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,t,o){const s=this.getConsolidateConfigurationModel(t,o),c=this.getFolderConfigurationModelForResource(t.resource,o),h=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,g=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),R=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),_=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),U=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),F=o?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,k=c?t.overrideIdentifier?c.freeze().override(t.overrideIdentifier).getValue(r):c.freeze().getValue(r):void 0,M=t.overrideIdentifier?h.override(t.overrideIdentifier).getValue(r):h.getValue(r),$=s.getValue(r),x=D.distinct(D.flatten(s.overrides.map(z=>z.identifiers))).filter(z=>s.getOverrideValue(r,z)!==void 0);return{defaultValue:g,userValue:R,userLocalValue:_,userRemoteValue:U,workspaceValue:F,workspaceFolderValue:k,memoryValue:M,value:$,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,workspaceFolder:k!==void 0?{value:c?.freeze().getValue(r),override:t.overrideIdentifier?c?.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,memory:M!==void 0?{value:h.getValue(r),override:t.overrideIdentifier?h.getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:x.length?x:void 0}}keys(r){const t=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,t){this._folderConfigurations.set(r,t),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,t){const o=[];if(!t){const{added:s,updated:c,removed:h}=l(this._defaultConfiguration,r);t=[...s,...c,...h]}for(const s of t)for(const c of(0,C.overrideIdentifiersFromKey)(s)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(c),g=r.getKeysForOverrideIdentifier(c),R=[...g.filter(_=>h.indexOf(_)===-1),...h.filter(_=>g.indexOf(_)===-1),...h.filter(_=>!I.equals(this._defaultConfiguration.override(c).getValue(_),r.override(c).getValue(_)))];o.push([c,R])}return this.updateDefaultConfiguration(r),{keys:t,overrides:o}}compareAndUpdateLocalUserConfiguration(r){const{added:t,updated:o,removed:s,overrides:c}=l(this.localUserConfiguration,r),h=[...t,...o,...s];return h.length&&this.updateLocalUserConfiguration(r),{keys:h,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:t,updated:o,removed:s,overrides:c}=l(this.remoteUserConfiguration,r);let h=[...t,...o,...s];return h.length&&this.updateRemoteUserConfiguration(r),{keys:h,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:t,updated:o,removed:s,overrides:c}=l(this.workspaceConfiguration,r);let h=[...t,...o,...s];return h.length&&this.updateWorkspaceConfiguration(r),{keys:h,overrides:c}}compareAndUpdateFolderConfiguration(r,t){const o=this.folderConfigurations.get(r),{added:s,updated:c,removed:h,overrides:g}=l(o,t);let R=[...s,...c,...h];return(R.length||!o)&&this.updateFolderConfiguration(r,t),{keys:R,overrides:g}}compareAndDeleteFolderConfiguration(r){const t=this.folderConfigurations.get(r);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:o,updated:s,removed:c,overrides:h}=l(t,void 0);return{keys:[...o,...s,...c],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,t){let o=this.getConsolidatedConfigurationModelForResource(r,t);return r.overrideIdentifier?o.override(r.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:r},t){let o=this.getWorkspaceConsolidatedConfiguration();if(t&&r){const s=t.getFolder(r);s&&(o=this.getFolderConsolidatedConfiguration(s.uri)||o);const c=this._memoryConfigurationByResource.get(r);c&&(o=o.merge(c))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let t=this._foldersConsolidatedConfigurations.get(r);if(!t){const o=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(r);s?(t=o.merge(s),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(r,t)):t=o}return t}getFolderConfigurationModelForResource(r,t){if(t&&r){const o=t.getFolder(r);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,t)=>{const{contents:o,overrides:s,keys:c}=this._folderConfigurations.get(t);return r.push([t,{contents:o,overrides:s,keys:c}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>r.add(t)),this.userConfiguration.freeze().keys.forEach(t=>r.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>r.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(o=>r.add(o))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>t.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>t.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>t.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(r).forEach(s=>t.add(s))),[...t.values()]}static parse(r){const t=this.parseConfigurationModel(r.defaults),o=this.parseConfigurationModel(r.user),s=this.parseConfigurationModel(r.workspace),c=r.folders.reduce((h,g)=>(h.set(E.URI.revive(g[0]),this.parseConfigurationModel(g[1])),h),new A.ResourceMap);return new m(t,o,new S,s,c,new S,new A.ResourceMap,!1)}static parseConfigurationModel(r){return new S(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=m;function w(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const r=new Set,t=new Map;for(const s of a)s.keys.forEach(c=>r.add(c)),s.overrides.forEach(([c,h])=>{const g=(0,A.getOrSet)(t,c,new Set);h.forEach(R=>g.add(R))});const o=[];return t.forEach((s,c)=>o.push([c,[...s.values()]])),{keys:[...r.values()],overrides:o}}e.mergeChanges=w;class y{constructor(r,t,o,s){this.change=r,this.previous=t,this.currentConfiguraiton=o,this.currentWorkspace=s,this._previousConfiguration=void 0;const c=new Set;r.keys.forEach(g=>c.add(g)),r.overrides.forEach(([,g])=>g.forEach(R=>c.add(R))),this.affectedKeys=[...c.values()];const h=new S;this.affectedKeys.forEach(g=>h.setValue(g,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(t){const o=this.previousConfiguration?this.previousConfiguration.getValue(r,t,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(r,t,this.currentWorkspace);return!I.equals(o,s)}return!0}return!1}doesAffectedKeysTreeContains(r,t){let o=(0,P.toValuesTree)({[t]:!0},()=>{}),s;for(;typeof o=="object"&&(s=Object.keys(o)[0]);){if(r=r[s],!r)return!1;o=o[s]}return!0}}e.ConfigurationChangeEvent=y;class p extends y{constructor(r,t,o,s){super({keys:r.allKeys(),overrides:[]},void 0,r,t);this.source=o,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=p;function l(a,r){const{added:t,removed:o,updated:s}=i(r,a),c=[],h=a?.getAllOverrideIdentifiers()||[],g=r?.getAllOverrideIdentifiers()||[];if(r){const R=g.filter(_=>!h.includes(_));for(const _ of R)c.push([_,r.getKeysForOverrideIdentifier(_)])}if(a){const R=h.filter(_=>!g.includes(_));for(const _ of R)c.push([_,a.getKeysForOverrideIdentifier(_)])}if(r&&a){for(const R of h)if(g.includes(R)){const _=i({contents:a.getOverrideValue(void 0,R)||{},keys:a.getKeysForOverrideIdentifier(R)},{contents:r.getOverrideValue(void 0,R)||{},keys:r.getKeysForOverrideIdentifier(R)});c.push([R,[..._.added,..._.removed,..._.updated]])}}return{added:t,removed:o,updated:s,overrides:c}}function i(a,r){const t=a?r?a.keys.filter(c=>r.keys.indexOf(c)===-1):[...a.keys]:[],o=r?a?r.keys.filter(c=>a.keys.indexOf(c)===-1):[...r.keys]:[],s=[];if(a&&r){for(const c of r.keys)if(a.keys.indexOf(c)!==-1){const h=(0,P.getConfigurationValue)(r.contents,c),g=(0,P.getConfigurationValue)(a.contents,c);I.equals(h,g)||s.push(c)}}return{added:t,removed:o,updated:s}}}),define(te[183],ne([0,1,5,3,2,19,20,89,42,38]),function(Y,e,D,n,L,T,A,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends L.Disposable{constructor(f,S){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,S)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:u})=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,S){const u=typeof f=="string"?f:void 0,v=(0,A.isConfigurationOverrides)(f)?f:(0,A.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(u,v,void 0)}updateValue(f,S,u,v){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const S=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(u,S,1)}onDidDefaultConfigurationChange(f){const S=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,f);this.trigger(u,S,6)}trigger(f,S,u){const v=new I.ConfigurationChangeEvent(f,{data:S},this.configuration);v.source=u,v.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(v)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(te[184],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,D.createDecorator)("remoteAuthorityResolverService");var n;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends Error{constructor(A,I=n.Unknown,b){super(A);this._message=A,this._code=I,this._detail=b,this.isHandled=I===n.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(A){return A instanceof L&&A._code===n.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof L&&A._code===n.NoResolverFound}static isHandled(A){return A instanceof L&&A.isHandled}}e.RemoteAuthorityResolverError=L}),define(te[185],ne([0,1,5,17,23,9,3,2,29,73,184]),function(Y,e,D,n,L,T,A,I,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const C=30*1e3;var f;(function(V){V[V.Management=1]="Management",V[V.ExtensionHost=2]="ExtensionHost",V[V.Tunnel=3]="Tunnel"})(f=e.ConnectionType||(e.ConnectionType={}));function S(V){switch(V){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(V){const Q=new L.CancellationTokenSource;return setTimeout(()=>Q.cancel(),V),Q.token}function v(V,Q){if(V.isCancellationRequested||Q.isCancellationRequested)return L.CancellationToken.Cancelled;const Z=new L.CancellationTokenSource;return V.onCancellationRequested(()=>Z.cancel()),Q.onCancellationRequested(()=>Z.cancel()),Z.token}class d{constructor(Q){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((Z,B)=>{this._resolvePromise=Z,this._rejectPromise=B}),Q.isCancellationRequested?this._timeout():this._disposables.add(Q.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(Q){this._state==="pending"?this._disposables.add(Q):Q.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Q=new Error("Time limit reached");return Q.code="ETIMEDOUT",Q.syscall="connect",Q}resolve(Q){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Q))}reject(Q){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Q))}}function m(V,Q){const Z=new d(Q);return Z.registerDisposable(V.onControlMessage(B=>{const O=JSON.parse(B.toString()),N=G(O);N?Z.reject(N):Z.resolve(O)})),Z.promise}function w(V,Q,Z,B,O,N,W){const H=new d(W);return Q.connect(Z,B,O,N,(re,se)=>{H.didTimeout?(re&&V.error(re),se?.dispose()):re||!se?H.reject(re):H.resolve(se)}),H.promise}function y(V,Q){const Z=new d(Q);return V.then(B=>{Z.didTimeout||Z.resolve(B)},B=>{Z.didTimeout||Z.reject(B)}),Z.promise}async function p(V,Q,Z,B){const O=j(V,Q);V.logService.trace(`${O} 1/6. invoking socketFactory.connect().`);let N;try{N=await w(V.logService,V.socketFactory,V.host,V.port,`reconnectionToken=${V.reconnectionToken}&reconnection=${V.reconnectionProtocol?"true":"false"}`,`renderer-${S(Q)}-${V.reconnectionToken}`,B)}catch(ue){throw V.logService.error(`${O} socketFactory.connect() failed or timed out. Error:`),V.logService.error(ue),ue}V.logService.trace(`${O} 2/6. socketFactory.connect() was successful.`);let W,H;V.reconnectionProtocol?(V.reconnectionProtocol.beginAcceptReconnection(N,null),W=V.reconnectionProtocol,H=!1):(W=new E.PersistentProtocol(N,null),H=!0),V.logService.trace(`${O} 3/6. sending AuthRequest control message.`);const re=await y(V.signService.createNewMessage((0,b.generateUuid)()),B),se={type:"auth",auth:V.connectionToken||"00000000000000000000",data:re.data};W.sendControl(n.VSBuffer.fromString(JSON.stringify(se)));try{const ue=await m(W,v(B,u(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const ge=new Error("Unexpected handshake message");throw ge.code="VSCODE_CONNECTION_ERROR",ge}if(V.logService.trace(`${O} 4/6. received SignRequest control message.`),!await y(V.signService.validate(re,ue.signedData),B)){const ge=new Error("Refused to connect to unsupported server");throw ge.code="VSCODE_CONNECTION_ERROR",ge}const we=await y(V.signService.sign(ue.data),B),pe={type:"connectionType",commit:V.commit,signedData:we,desiredConnectionType:Q};return Z&&(pe.args=Z),V.logService.trace(`${O} 5/6. sending ConnectionTypeRequest control message.`),W.sendControl(n.VSBuffer.fromString(JSON.stringify(pe))),{protocol:W,ownsProtocol:H}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(V.logService.error(`${O} the handshake timed out. Error:`),V.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(V.logService.error(`${O} received error control message when negotiating connection. Error:`),V.logService.error(ue)),H&&z(W),ue}}async function l(V,Q,Z,B){const O=Date.now(),N=j(V,Q),{protocol:W,ownsProtocol:H}=await p(V,Q,Z,B),re=new d(B);return re.registerDisposable(W.onControlMessage(se=>{const ue=JSON.parse(se.toString()),de=G(ue);de?(V.logService.error(`${N} received error control message when negotiating connection. Error:`),V.logService.error(de),H&&z(W),re.reject(de)):(V.reconnectionProtocol&&V.reconnectionProtocol.endAcceptReconnection(),V.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${K(O)}!`),re.resolve({protocol:W,firstMessage:ue}))})),re.promise}async function i(V,Q){const{protocol:Z}=await l(V,1,void 0,Q);return{protocol:Z}}async function a(V,Q,Z){const{protocol:B,firstMessage:O}=await l(V,2,Q,Z),N=O&&O.debugPort;return{protocol:B,debugPort:N}}async function r(V,Q,Z){const B=Date.now(),O=j(V,3),{protocol:N}=await p(V,3,Q,Z);return V.logService.trace(`${O} 6/6. handshake finished, connection is up and running after ${K(B)}!`),N}async function t(V,Q,Z){const{host:B,port:O,connectionToken:N}=await V.addressProvider.getAddress();return{commit:V.commit,host:B,port:O,connectionToken:N,reconnectionToken:Q,reconnectionProtocol:Z,socketFactory:V.socketFactory,signService:V.signService,logService:V.logService}}async function o(V,Q,Z){try{const B=(0,b.generateUuid)(),O=await t(V,B,null),{protocol:N}=await i(O,L.CancellationToken.None);return new $(V,Q,Z,B,N)}catch(B){throw V.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),V.logService.error(B),M.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(B)),B}}e.connectRemoteAgentManagement=o;async function s(V,Q){try{const Z=(0,b.generateUuid)(),B=await t(V,Z,null),{protocol:O,debugPort:N}=await a(B,Q,L.CancellationToken.None);return new x(V,Q,Z,O,N)}catch(Z){throw V.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),V.logService.error(Z),M.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(Z)),Z}}e.connectRemoteAgentExtensionHost=s;async function c(V,Q,Z){const B=await t(V,(0,b.generateUuid)(),null);return await r(B,{host:Q,port:Z},L.CancellationToken.None)}e.connectRemoteAgentTunnel=c;function h(V){return(0,D.createCancelablePromise)(Q=>new Promise((Z,B)=>{const O=setTimeout(Z,V*1e3);Q.onCancellationRequested(()=>{clearTimeout(O),Z()})}))}var g;(function(V){V[V.ConnectionLost=0]="ConnectionLost",V[V.ReconnectionWait=1]="ReconnectionWait",V[V.ReconnectionRunning=2]="ReconnectionRunning",V[V.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",V[V.ConnectionGain=4]="ConnectionGain"})(g=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class R{constructor(Q,Z){this.reconnectionToken=Q,this.millisSinceLastIncomingData=Z,this.type=0}}e.ConnectionLostEvent=R;class _{constructor(Q,Z,B,O){this.reconnectionToken=Q,this.millisSinceLastIncomingData=Z,this.durationSeconds=B,this.cancellableTimer=O,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class U{constructor(Q,Z,B){this.reconnectionToken=Q,this.millisSinceLastIncomingData=Z,this.attempt=B,this.type=2}}e.ReconnectionRunningEvent=U;class F{constructor(Q,Z,B){this.reconnectionToken=Q,this.millisSinceLastIncomingData=Z,this.attempt=B,this.type=4}}e.ConnectionGainEvent=F;class k{constructor(Q,Z,B,O){this.reconnectionToken=Q,this.millisSinceLastIncomingData=Z,this.attempt=B,this.handled=O,this.type=3}}e.ReconnectionPermanentFailureEvent=k;class M extends I.Disposable{constructor(Q,Z,B,O){super();this._connectionType=Q,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=Z,this.reconnectionToken=B,this.protocol=O,this._isReconnecting=!1,this._onDidStateChange.fire(new F(this.reconnectionToken,0,0)),this._register(O.onSocketClose(N=>{const W=q(this._connectionType,this.reconnectionToken,!0);N?N.type===0?(this._options.logService.info(`${W} received socket close event (hadError: ${N.hadError}).`),N.error&&this._options.logService.error(N.error)):(this._options.logService.info(`${W} received socket close event (wasClean: ${N.wasClean}, code: ${N.code}, reason: ${N.reason}).`),N.event&&this._options.logService.error(N.event)):this._options.logService.info(`${W} received socket close event.`),this._beginReconnecting()})),this._register(O.onSocketTimeout(()=>{const N=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${N} received socket timeout event.`),this._beginReconnecting()})),M._instances.push(this),M._permanentFailure&&this._gotoPermanentFailure(M._permanentFailureMillisSinceLastIncomingData,M._permanentFailureAttempt,M._permanentFailureHandled)}static triggerPermanentFailure(Q,Z,B){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Q,this._permanentFailureAttempt=Z,this._permanentFailureHandled=B,this._instances.forEach(O=>O._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Q=>Q._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Q=>Q._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(M._permanentFailure)return;const Q=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Q} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new R(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const Z=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const O=B<Z.length?Z[B]:Z[Z.length-1];try{if(O>0){const W=h(O);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O,W)),this._options.logService.info(`${Q} waiting for ${O} seconds before reconnecting...`);try{await W}catch{}}if(M._permanentFailure){this._options.logService.error(`${Q} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this._options.logService.info(`${Q} resolving connection...`);const N=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Q} connecting to ${N.host}:${N.port}...`),await this._reconnect(N,u(C)),this._options.logService.info(`${Q} reconnected!`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(N){if(N.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(N),M.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this._options.logService.error(`${Q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(N),M.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(P.RemoteAuthorityResolverError.isTemporarilyNotAvailable(N)){this._options.logService.info(`${Q} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(N);continue}if((N.code==="ETIMEDOUT"||N.code==="ENETUNREACH"||N.code==="ECONNREFUSED"||N.code==="ECONNRESET")&&N.syscall==="connect"){this._options.logService.info(`${Q} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(N);continue}if((0,T.isCancellationError)(N)){this._options.logService.info(`${Q} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(N);continue}if(N instanceof P.RemoteAuthorityResolverError){this._options.logService.error(`${Q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(N),M.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,P.RemoteAuthorityResolverError.isHandled(N));break}this._options.logService.error(`${Q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(N),M.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!M._permanentFailure)}_gotoPermanentFailure(Q,Z,B){this._onDidStateChange.fire(new k(this.reconnectionToken,Q,Z,B)),z(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=M,M._permanentFailure=!1,M._permanentFailureMillisSinceLastIncomingData=0,M._permanentFailureAttempt=0,M._permanentFailureHandled=!1,M._instances=[];class $ extends M{constructor(Q,Z,B,O,N){super(1,Q,O,N);this.client=this._register(new E.Client(N,{remoteAuthority:Z,clientId:B},Q.ipcLogger))}async _reconnect(Q,Z){await i(Q,Z)}}e.ManagementPersistentConnection=$;class x extends M{constructor(Q,Z,B,O,N){super(2,Q,B,O);this._startArguments=Z,this.debugPort=N}async _reconnect(Q,Z){await a(Q,this._startArguments,Z)}}e.ExtensionHostPersistentConnection=x;function z(V){try{V.acceptDisconnect();const Q=V.getSocket();V.dispose(),Q.dispose()}catch(Q){(0,T.onUnexpectedError)(Q)}}function G(V){if(V&&V.type==="error"){const Q=new Error(`Connection error: ${V.reason}`);return Q.code="VSCODE_CONNECTION_ERROR",Q}return null}function ee(V,Q){for(;V.length<Q;)V+=" ";return V}function q(V,Q,Z){return`[remote-connection][${ee(S(V),13)}][${Q.substr(0,5)}\u2026][${Z?"reconnect":"initial"}]`}function j(V,Q){return`${q(Q,V.reconnectionToken,!!V.reconnectionProtocol)}[${V.host}:${V.port}]`}function K(V){return`${Date.now()-V} ms`}}),define(te[186],ne([0,1,18]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function n(E){return E.scheme===D.Schemas.vscodeRemote?E.authority:void 0}e.getRemoteAuthority=n;function L(E){if(!E)return;const P=E.indexOf("+");return P<0?E:E.substr(0,P)}e.getRemoteName=L;function T(E){return E.scheme!==D.Schemas.file&&E.scheme!==D.Schemas.vscodeRemote}e.isVirtualResource=T;function A(E){if(E.folders.length)return E.folders.every(P=>T(P.uri))?E.folders[0].uri:void 0;if(E.configuration&&T(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=A;function I(E){return A(E)?.scheme}e.getVirtualWorkspaceScheme=I;function b(E){return A(E)!==void 0}e.isVirtualWorkspace=b}),define(te[90],ne([0,1,27,6,186]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=T;function A(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class b{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,u){if(typeof S=="undefined"||S===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof S=="string"||typeof u=="string"){let v=typeof S=="string"?S:S.value,d=typeof u=="string"?u:u.value;return D.equalsIgnoreCase(v,d)}return S._lower===u._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=b;function E(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function P(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=P;function C(f,S){if(S){const u=`onResolveRemoteAuthority:${(0,L.getRemoteName)(S)}`;return f.activationEvents?.indexOf(u)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[31],ne([0,1,27,90]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(u,v){return u.uuid&&v.uuid?u.uuid===v.uuid:u.id===v.id?!0:(0,D.compareIgnoreCase)(u.id,v.id)===0}e.areSameExtensions=L;class T{constructor(v,d){this.version=d,this.id=v.id,this.uuid=v.uuid}key(){return`${this.id}-${this.version}`}equals(v){return v instanceof T?L(this,v)&&this.version===v.version:!1}}e.ExtensionIdentifierWithVersion=T;function A(u,v){return`${u}.${v}`}e.getExtensionId=A;function I(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function b(u,v){return I(A(u,v))}e.getGalleryExtensionId=b;function E(u,v){const d=[],m=w=>{for(const y of d)if(y.some(p=>L(v(p),v(w))))return y;return null};for(const w of u){const y=m(w);y?y.push(w):d.push([w])}return d}e.groupByExtension=E;function P(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=P;function C(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function f(u){const v=new Set;if(u.malicious)for(const d of u.malicious)v.add(d.id);return v}e.getMaliciousExtensionsSet=f;function S(u,v){const d=[],m=v.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const w=m.shift();if(w&&d.every(y=>!L(y.identifier,{id:w}))){const y=u.filter(p=>L(p.identifier,{id:w}));y.length===1&&(d.push(y[0]),m.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}e.getExtensionDependencies=S}),define(te[30],ne([0,1,18,130,31,6]),function(Y,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const A=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function I(i){const a=A.exec(i);return a&&a[1]?[(0,L.adoptToGalleryExtensionId)(a[1]),a[2]]:[(0,L.adoptToGalleryExtensionId)(i),void 0]}e.getIdAndVersion=I;var b;(function(i){i.WIN32_X64="win32-x64",i.WIN32_IA32="win32-ia32",i.WIN32_ARM64="win32-arm64",i.LINUX_X64="linux-x64",i.LINUX_ARM64="linux-arm64",i.LINUX_ARMHF="linux-armhf",i.ALPINE_X64="alpine-x64",i.ALPINE_ARM64="alpine-arm64",i.DARWIN_X64="darwin-x64",i.DARWIN_ARM64="darwin-arm64",i.WEB="web",i.UNIVERSAL="universal",i.UNKNOWN="unknown",i.UNDEFINED="undefined"})(b=e.TargetPlatform||(e.TargetPlatform={}));function E(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=E;function P(i){switch(i){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function C(i,a){switch(i){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function f(i,a){return a==="web"&&!i.includes("web")}e.isNotWebExtensionInWebTargetPlatform=f;function S(i,a,r){return f(a,r)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===r?!0:u(r).includes(i)}e.isTargetPlatformCompatible=S;function u(i){switch(i){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=u;function v(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=v;var d;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(d=e.SortBy||(e.SortBy={}));var m;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var w;(function(i){i.Install="install",i.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var y;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var p;(function(i){i.Unsupported="Unsupported",i.UnsupportedPreRelease="UnsupportedPreRelease",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatiblePreRelease="IncompatiblePreRelease",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.Extract="Extract",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Internal="Internal"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class l extends Error{constructor(a,r){super(a);this.code=r,this.name=r}}e.ExtensionManagementError=l,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,n.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,T.createDecorator)("IExtensionManagementCLIService")}),define(te[187],ne([0,1,3,2,28,7,110,30]),function(Y,e,D,n,L,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(v,d){return T.URI.revive(d?d.transformIncoming(v):v)}function E(v,d){return d?d.transformOutgoingURI(v):v}function P(v,d){d=d||A.DefaultURITransformer;const m=v.manifest;return{...(0,A.transformAndReviveIncomingURIs)({...v,manifest:void 0},d),manifest:m}}function C(v,d){return d?(0,L.cloneAndChange)(v,m=>m instanceof T.URI?d.transformOutgoingURI(m):void 0):v}class f{constructor(d,m){this.service=d,this.getUriTransformer=m,this.onInstallExtension=D.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(d.onDidUninstallExtension,!0)}listen(d,m){const w=this.getUriTransformer(d);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,y=>y.map(p=>({...p,local:p.local?C(p.local,w):p.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(d,m,w){const y=this.getUriTransformer(d);switch(m){case"zip":return this.service.zip(P(w[0],y)).then(p=>E(p,y));case"unzip":return this.service.unzip(b(w[0],y));case"install":return this.service.install(b(w[0],y),w[1]);case"getManifest":return this.service.getManifest(b(w[0],y));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(P(w[0],y),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(P(w[0],y));case"getInstalled":return this.service.getInstalled(w[0]).then(p=>p.map(l=>C(l,y)));case"updateMetadata":return this.service.updateMetadata(P(w[0],y),w[1]).then(p=>C(p,y));case"updateExtensionScope":return this.service.updateExtensionScope(P(w[0],y),w[1]).then(p=>C(p,y));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class S extends n.Disposable{constructor(d){super();this.channel=d,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?T.URI.revive(m.source):m.source}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(w=>({...w,local:w.local?P(w.local,null):w.local,source:this.isUriComponents(w.source)?T.URI.revive(w.source):w.source}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire(m))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire(m)))}isUriComponents(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(d){const m=await this.getTargetPlatform();return d.allTargetPlatforms.some(w=>(0,I.isTargetPlatformCompatible)(w,d.allTargetPlatforms,m))}zip(d){return Promise.resolve(this.channel.call("zip",[d]).then(m=>T.URI.revive(m)))}unzip(d){return Promise.resolve(this.channel.call("unzip",[d]))}install(d,m){return Promise.resolve(this.channel.call("install",[d,m])).then(w=>P(w,null))}getManifest(d){return Promise.resolve(this.channel.call("getManifest",[d]))}installFromGallery(d,m){return Promise.resolve(this.channel.call("installFromGallery",[d,m])).then(w=>P(w,null))}uninstall(d,m){return Promise.resolve(this.channel.call("uninstall",[d,m]))}reinstallFromGallery(d){return Promise.resolve(this.channel.call("reinstallFromGallery",[d]))}getInstalled(d=null){return Promise.resolve(this.channel.call("getInstalled",[d])).then(m=>m.map(w=>P(w,null)))}updateMetadata(d,m){return Promise.resolve(this.channel.call("updateMetadata",[d,m])).then(w=>P(w,null))}updateExtensionScope(d,m){return Promise.resolve(this.channel.call("updateExtensionScope",[d,m])).then(w=>P(w,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=S;class u{constructor(d){this.service=d}listen(d,m){throw new Error("Invalid listen")}call(d,m,w){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=u}),define(te[188],ne([0,1,23,31]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function L(T,A,I,b,E){try{const P=await T.getExtensionsControlManifest();if(!P.unsupportedPreReleaseExtensions)return;const C=await T.getInstalled(1);for(const[f,{id:S,migrateStorage:u}]of Object.entries(P.unsupportedPreReleaseExtensions)){const v=C.find(m=>(0,n.areSameExtensions)(m.identifier,{id:f}));if(!v)continue;const d=(await A.getExtensions([{id:S,includePreRelease:!0}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!d){E.info(`Skipping migrating '${v.identifier.id}' extension because, the comaptible target '${S}' extension is not found`);continue}try{E.info(`Migrating '${v.identifier.id}' extension to '${S}' extension...`);const m=!b.getDisabledExtensions().some(y=>(0,n.areSameExtensions)(y,v.identifier));await T.uninstall(v),E.info(`Uninstalled the unsupported extension '${v.identifier.id}'`);let w=C.find(y=>(0,n.areSameExtensions)(y.identifier,{id:S}));(!w||!w.isPreReleaseVersion&&m)&&(w=await T.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:v.isMachineScoped,operation:4}),E.info(`Installed the pre-release extension '${w.identifier.id}'`),m||(await b.disableExtension(w.identifier),E.info(`Disabled the pre-release extension '${w.identifier.id}' because the unsupported extension '${v.identifier.id}' is disabled`)),u&&(I.addToMigrationList((0,n.getExtensionId)(v.manifest.publisher,v.manifest.name),(0,n.getExtensionId)(w.manifest.publisher,w.manifest.name)),E.info("Added pre-release extension to the storage migration list"))),E.info(`Migrated '${v.identifier.id}' extension to '${S}' extension.`)}catch(m){E.error(m)}}}catch(P){E.error(P)}}e.migrateUnsupportedExtensions=L}),define(te[189],ne([0,1,5,9,2,4,19,61,7,29,22,13,30,31,14,8]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const d=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends L.Disposable{constructor(y,p,l,i){super();this.fileService=p,this.extensionGalleryService=l,this.logService=i,this.extensionsDownloadDir=b.URI.file(y.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(y,p){await this.cleanUpPromise;const l=this.getName(y),i=(0,A.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(i)){const a=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(a)||await this.extensionGalleryService.download(y,a,p);try{await this.rename(a,i,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(a)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",y.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,a.path),r}}return i}async delete(y){await this.cleanUpPromise,await this.fileService.del(y)}async rename(y,p,l){try{await P.Promises.rename(y.fsPath,p.fsPath)}catch(i){if(T.isWindows&&i&&i.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${y} to ${p} with 'EPERM' error. Trying again...`),this.rename(y,p,l);throw i}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const y=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(y.children){const p=[],l=[];for(const r of y.children){const t=this.parse(r.name);t&&l.push([t,r])}const i=(0,S.groupByExtension)(l,([r])=>r),a=[];for(const r of i)r.sort((t,o)=>I.rcompare(t[0].version,o[0].version)),p.push(...r.slice(1).map(t=>t[1].resource)),a.push(r[0][1]);a.sort((r,t)=>r.mtime-t.mtime),p.push(...a.slice(0,Math.max(0,a.length-this.cache)).map(r=>r.resource)),await D.Promises.settled(p.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(y){this.logService.error(y)}}getName(y){return this.cache?`${new S.ExtensionIdentifierWithVersion(y.identifier,y.version).key().toLowerCase()}${y.properties.targetPlatform!=="undefined"?`-${y.properties.targetPlatform}`:""}`:(0,E.generateUuid)()}parse(y){const p=d.exec(y);return p&&p[1]&&p[2]?new S.ExtensionIdentifierWithVersion({id:p[1]},p[2]):null}};m=he([J(0,C.INativeEnvironmentService),J(1,u.IFileService),J(2,f.IExtensionGalleryService),J(3,v.ILogService)],m),e.ExtensionsDownloader=m}),define(te[190],ne([0,1,2,10,22,90]),function(Y,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends D.Disposable{constructor(b,E){super();this.environmentService=b,this.extensionsManifestCache=(0,n.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(P=>this.onDidInstallExtensions(P))),this._register(E.onDidUninstallExtension(P=>this.onDidUnInstallExtension(P)))}onDidInstallExtensions(b){b.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(b){b.error||this.invalidate()}invalidate(){L.Promises.rm(this.extensionsManifestCache,L.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(te[191],ne([0,1,83,16,5,2,18,10,22,13,30,31,59,8]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let u=class extends T.Disposable{constructor(m,w,y){super();this.extensionManagementService=m,this.logService=y,this.cache=this._register(new v(w,y)),this.extensionManagementService.registerParticipant({postInstall:async p=>this.postInstallExtension(p),postUninstall:async p=>this.postUninstallExtension(p)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),w=["en",...Object.keys(m)];return(0,n.distinct)(w)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const w=await this.cache.getLanguagePacks();Object.keys(w).some(y=>w[y]&&w[y].extensions.some(p=>(0,C.areSameExtensions)(p.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),y=await this.cache.update(w);return!(0,n.equals)(Object.keys(m),Object.keys(y))}};u=he([J(0,P.IExtensionManagementService),J(1,E.INativeEnvironmentService),J(2,S.ILogService)],u),e.LocalizationsService=u;let v=class extends T.Disposable{constructor(m,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,I.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new L.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(w=>{Object.keys(w).forEach(y=>delete w[y]),this.createLanguagePacksFromExtensions(w,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...w){for(const y of w)y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,y);Object.keys(m).forEach(y=>this.updateHash(m[y]))}createLanguagePacksFromExtension(m,w){const y=w.identifier,p=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const l of p)if(w.location.scheme===A.Schemas.file&&(0,f.isValidLocalization)(l)){let i=m[l.languageId];i||(i={hash:"",extensions:[],translations:{}},m[l.languageId]=i);let a=i.extensions.filter(r=>(0,C.areSameExtensions)(r.extensionIdentifier,y))[0];a?a.version=w.manifest.version:i.extensions.push({extensionIdentifier:y,version:w.manifest.version});for(const r of l.translations)i.translations[r.id]=(0,I.join)(w.location.fsPath,r.path)}}updateHash(m){if(m){const w=(0,D.createHash)("md5");for(const y of m.extensions)w.update(y.extensionIdentifier.uuid||y.extensionIdentifier.id).update(y.version);m.hash=w.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return b.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,y=>y.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(y)).then(y=>{try{return JSON.parse(y)}catch{return{}}}).then(y=>(w=m(y),y)).then(y=>{for(const l of Object.keys(y))y[l]||delete y[l];this.languagePacks=y,this.initializedCache=!0;const p=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",p),b.Promises.writeFile(this.languagePacksFilePath,p)}).then(()=>w,y=>this.logService.error(y))})}};v=he([J(0,E.INativeEnvironmentService),J(1,S.ILogService)],v)}),define(te[192],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[62],ne([0,1,3,4,6,8]),function(Y,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,L.createDecorator)("sharedTunnelsService");var A;(function(u){u.Http="http",u.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(!!v)return{address:v[1],port:+v[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(u){return e.LOCALHOST_ADDRESSES.indexOf(u)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(u){return e.ALL_INTERFACES_ADDRESSES.indexOf(u)>=0}e.isAllInterfaces=C;function f(u,v){return v?v!==1&&u<1024:!n.isWindows&&u<1024}e.isPortPrivileged=f;let S=class{constructor(v){this.logService=v,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(v){return this._tunnelProvider=v,v?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(v){this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const v=[],d=Array.from(this._tunnels.values());for(let m of d){const w=Array.from(m.values());for(let y of w){const p=await y.value;p&&v.push(p)}}return v}async dispose(){for(const v of this._tunnels.values()){for(const{value:d}of v.values())await d.then(m=>m?.dispose());v.clear()}this._tunnels.clear()}openTunnel(v,d,m,w,y=!1,p=I.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${m} on local port ${w}.`),!v)return;d||(d="localhost");const i=this.retainOrCreateTunnel(v,d,m,w,y,p,l);return i?i.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(a);return(a.tunnelRemoteHost!==d||a.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,privacy:v.privacy,protocol:v.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemoteHost}:${v.tunnelRemotePort} `);const d=this._tunnels.get(v.tunnelRemoteHost);if(d){const m=d.get(v.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(v.tunnelRemoteHost,v.tunnelRemotePort,m))}}}}async tryDisposeTunnel(v,d,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${d}.`);const w=m.value.then(async y=>{y&&(await y.dispose(!0),this._onTunnelClosed.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this._tunnels.has(v)&&this._tunnels.get(v).delete(d),w}}async closeTunnel(v,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${v}:${d} `);const m=this._tunnels.get(v);if(m&&m.has(d)){const w=m.get(d);w.refcount=0,await this.tryDisposeTunnel(v,d,w)}}addTunnelToMap(v,d,m){this._tunnels.has(v)||this._tunnels.set(v,new Map),this._tunnels.get(v).set(d,{refcount:1,value:m})}async removeEmptyTunnelFromMap(v,d){const m=this._tunnels.get(v);m&&(await m.get(d)||m.delete(d),m.size===0&&this._tunnels.delete(v))}getTunnelFromMap(v,d){let m=[v];P(v)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):C(v)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const w=m.map(y=>this._tunnels.get(y));for(const y of w){const p=y?.get(d);if(p)return p}}canTunnel(v){return!!E(v)}createWithProvider(v,d,m,w,y,p,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${m} on local port ${w}.`);const a={elevationRequired:y?f(w===void 0?m:w):!1},r={remoteAddress:{host:d,port:m},localAddressPort:w,privacy:p,public:p!==I.Private,protocol:l},t=v.forwardPort(r,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(d,m,t),t}};S=he([J(0,T.ILogService)],S),e.AbstractTunnelService=S}),define(te[193],ne([0,1,8,62,2,9,5]),function(Y,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class I extends L.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(P){this._address=P,this._addressPromise&&(this._addressPromise.complete(P),this._addressPromise=null)}setTunnel(P){this._register(P)}}let b=class Ct extends L.Disposable{constructor(P,C){super();this._tunnelService=P,this._logService=C,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++Ct._lastId)}}async startTunnel(P,C,f,S,u,v){const d=new I,m=await Promise.resolve(this._tunnelService.openTunnel(P,d,f,S,u,v));if(!m)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${S} (remote).`),d.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(C))throw this._disposedTunnels.delete(C),d.dispose(),await m.dispose(),(0,T.canceled)();return d.setTunnel(m),this._tunnels.set(C,d),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${C}: ${m.localAddress} (local) to ${f}:${S} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(P,C){const f=this._tunnels.get(P);!f||f.setAddress(C)}async destroyTunnel(P){const C=this._tunnels.get(P);if(C){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this._tunnels.delete(P),await C.dispose();return}this._disposedTunnels.add(P)}};b._lastId=0,b=he([J(0,n.ISharedTunnelsService),J(1,D.ILogService)],b),e.SharedProcessTunnelService=b}),define(te[194],ne([0,1,119,20,8]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(I,b){this.configurationService=I,this.logService=b}request(I,b){return this.logService.trace("RequestService#request",I.url),I.proxyAuthorization||(I.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(I,b)}async resolveProxy(I){}};T=he([J(0,n.IConfigurationService),J(1,L.ILogService)],T),e.RequestService=T}),define(te[43],ne([0,1,17,140,42,6,38]),function(Y,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function I(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.isSuccess=I;function b(u){return u.res.statusCode===204}async function E(u){if(!I(u))throw new Error("Server returned "+u.res.statusCode);return b(u)?null:(await(0,D.streamToBuffer)(u.stream)).toString()}e.asText=E;async function P(u){if(!I(u))throw new Error("Server returned "+u.res.statusCode);if(b(u))return null;const d=(await(0,D.streamToBuffer)(u.stream)).toString();try{return JSON.parse(d)}catch(m){throw m.message+=`:
`+d,m}}e.asJson=P;function C(u){S(u)}e.updateProxyConfigurationsScope=C;let f;function S(u){const v=A.Registry.as(L.Extensions.Configuration),d=f;f={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},v.updateConfigurations({add:[f],remove:d?[d]:[]})}S(2)}),define(te[195],ne([0,1,23,18,14,43]),function(Y,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(b,E){this.requestService=b,this.fileService=E}async download(b,E,P=D.CancellationToken.None){if(b.scheme===n.Schemas.file||b.scheme===n.Schemas.vscodeRemote){await this.fileService.copy(b,E);return}const C={type:"GET",url:b.toString()},f=await this.requestService.request(C,P);if(f.res.statusCode===200)await this.fileService.writeFile(E,f.stream);else{const S=await(0,T.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${S}`)}}};A=he([J(0,T.IRequestService),J(1,L.IFileService)],A),e.DownloadService=A}),define(te[196],ne([0,1,16,23,67,2,19,154,14,8,26,43]),function(Y,e,D,n,L,T,A,I,b,E,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let f=class extends T.Disposable{constructor(u,v,d,m){super();this.fileService=u,this.productService=v,this.requestService=d,this.logService=m,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,L.forEach)(this.productService.configBasedExtensionTips,({value:w})=>this.allConfigBasedTips.set(w.configPath,w))}getConfigBasedTips(u){return this.getValidConfigBasedTips(u)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(u){const v=[];for(const[d,m]of this.allConfigBasedTips)if(!(m.configScheme&&m.configScheme!==u.scheme))try{const w=await this.fileService.readFile((0,A.joinPath)(u,d)),y=new Map;(0,L.forEach)(m.recommendations,({key:l,value:i})=>{if((0,D.isNonEmptyArray)(i.remotes))for(const a of i.remotes)y.set(a,{extensionId:l,extensionName:i.name,configName:m.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack});else v.push({extensionId:l,extensionName:i.name,configName:m.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack})});const p=(0,I.getDomainsOfRemotes)(w.value.toString(),[...y.keys()]);for(const l of p){const i=y.get(l);i&&v.push(i)}}catch{}return v}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const u=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},n.CancellationToken.None);if(u.res.statusCode!==200)return[];const v=await(0,C.asJson)(u);return v?v.workspaceRecommendations||[]:[]}catch(u){return this.logService.error(u),[]}}};f=he([J(0,b.IFileService),J(1,P.IProductService),J(2,C.IRequestService),J(3,E.ILogService)],f),e.ExtensionTipsService=f}),define(te[91],ne([0,1,70,6]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function L(T){return(0,D.hash)({moduleId:T.process.moduleId,windowId:T.reply.windowId})}e.hash=L,e.ISharedProcessWorkerService=(0,n.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(te[197],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(n){n.Spawn="vscode:shared-process->shared-process-worker=spawn",n.Terminate="vscode:shared-process->shared-process-worker=terminate",n.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",n.Ready="vscode:shared-process-worker->shared-process=ready",n.Ack="vscode:shared-process-worker->shared-process=ack",n.Trace="vscode:shared-process-worker->shared-process=trace",n.Info="vscode:shared-process-worker->shared-process=info",n.Warn="vscode:shared-process-worker->shared-process=warn",n.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(te[198],ne([0,1,74,152,5,23,3,2,18,4,29,13,8,26,91,197]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let d=class{constructor(y,p,l){this.logService=y,this.productService=p,this.environmentService=l,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(y){const p=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${p})`);const l=(0,u.hash)(y);this.processeDisposables.has(l)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${p})`),this.doDisposeWorker(y));const i=new T.CancellationTokenSource;let a,r,t;this.processeDisposables.set(l,h=>{i.dispose(!0),a?.terminate(y,T.CancellationToken.None),r?.close(),t?.close(),this.processeDisposables.delete(l);const g=this.processResolvers.get(l);g&&(this.processResolvers.delete(l),g({reason:h}))}),a=await this.getOrCreateWebWorker(y);const o=new Promise(h=>{this.processResolvers.set(l,h)});if(i.token.isCancellationRequested)return o;const{port1:s,port2:c}=new MessageChannel;return r=s,t=c,await a.spawn(y,t,i.token),i.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${p})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",y,[r])),o}getOrCreateWebWorker(y){let p=this.workers.get(y.process.moduleId);if(!p){this.logService.trace(`SharedProcess: creating new web worker (${y.process.moduleId})`);const l=new m(y.process.type,this.logService,this.productService,this.environmentService);p=l.init(),l.onDidProcessSelfTerminate(({configuration:i,reason:a})=>{this.doDisposeWorker(i,a)}),this.workers.set(y.process.moduleId,p)}return p}async disposeWorker(y){return this.doDisposeWorker(y)}doDisposeWorker(y,p){const l=this.processeDisposables.get((0,u.hash)(y));l&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),l(p))}};d=he([J(0,f.ILogService),J(1,S.IProductService),J(2,C.INativeEnvironmentService)],d),e.SharedProcessWorkerService=d;class m extends I.Disposable{constructor(y,p,l,i){super();this.type=y,this.logService=p,this.productService=l,this.environmentService=i,this._onDidProcessSelfTerminate=this._register(new A.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const y=new L.DeferredPromise,p=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return p.onerror=l=>{this.logService.error(`SharedProcess: worker error (${this.type})`,l.message)},p.onmessageerror=l=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,l)},p.onmessage=l=>{const{id:i,message:a,configuration:r,nonce:t}=l.data;switch(i){case v.SharedProcessWorkerMessages.Ready:y.complete(p);break;case v.SharedProcessWorkerMessages.Ack:if(t){const o=this.mapMessageNonceToPendingMessageResolve.get(t);o&&(this.mapMessageNonceToPendingMessageResolve.delete(t),o())}break;case v.SharedProcessWorkerMessages.SelfTerminated:r&&a&&this._onDidProcessSelfTerminate.fire({configuration:r,reason:JSON.parse(a)});break;case v.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,a);break;case v.SharedProcessWorkerMessages.Info:a&&this.logService.info(a);break;case v.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,a);break;case v.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,a);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,l)}},p.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),y.p}async send(y,p,l){const i=await this.workerReady;if(!p.isCancellationRequested)return new Promise(a=>{const r=(0,P.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(r,a);const t={...y,nonce:r};l?i.postMessage(t,[l]):i.postMessage(t),p.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(r)&&a()})})}spawn(y,p,l){const i={id:v.SharedProcessWorkerMessages.Spawn,configuration:y,environment:this.getSharedProcessWorkerEnvironment()};return this.send(i,l,p)}getSharedProcessWorkerEnvironment(){const y={bootstrapPath:b.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,env:Object.create(null)};if(E.isLinux){const p={companyName:this.productService.crashReporter?.companyName||"Microsoft",productName:this.productService.crashReporter?.productName||this.productService.nameShort,submitURL:"",uploadToServer:!1},l=this.environmentService.args["crash-reporter-id"],i=this.productService.appCenter;if(!this.environmentService.args["crash-reporter-directory"]&&i&&l&&(0,P.isUUID)(l)){const t=i["linux-x64"];p.submitURL=t.concat("&uid=",l,"&iid=",l,"&sid=",l),p.uploadToServer=!0}const r=this.environmentService.args["crash-reporter-directory"]||this.environmentService.userDataPath;y.env.BREAKPAD_DUMP_LOCATION=(0,n.join)(r,this.type),y.env.VSCODE_CRASH_REPORTER_START_OPTIONS=JSON.stringify(p)}return y}terminate(y,p){const l={id:v.SharedProcessWorkerMessages.Terminate,configuration:y};return this.send(l,p)}}}),define(te[199],ne([0,1,54,18,153]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class T extends L.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:n.Schemas.userData})}}he([D.memoize],T.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=T}),define(te[92],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[200],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((L,T)=>Y(["vsda"],L,T))}async createNewMessage(L){try{const T=await this.vsda(),A=new T.validator;if(A){const I=String(D._nextId++);return this.validators.set(I,A),{id:I,data:A.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,T){if(!L.id)return!0;const A=this.validators.get(L.id);if(!A)return!1;this.validators.delete(L.id);try{return A.validate(T)==="ok"}catch{return!1}}async sign(L){try{const T=await this.vsda(),A=new T.signer;if(A)return A.sign(L)}catch{}return L}}e.SignService=D,D._nextId=1}),define(te[24],ne([0,1,5,3,2,177,15,75,6]),function(Y,e,D,n,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const E="__$__targetStorageMarker";e.IStorageService=(0,b.createDecorator)("storageService");var P;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var C;(function(d){d[d.GLOBAL=0]="GLOBAL",d[d.WORKSPACE=1]="WORKSPACE"})(C=e.StorageScope||(e.StorageScope={}));var f;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class S extends L.Disposable{constructor(m={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,w){w===E?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:w,target:this.getKeyTargets(m)[w]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,w,y){return this.getStorage(w)?.get(m,y)}getBoolean(m,w,y){return this.getStorage(w)?.getBoolean(m,y)}getNumber(m,w,y){return this.getStorage(w)?.getNumber(m,y)}store(m,w,y,p){if((0,A.isUndefinedOrNull)(w)){this.remove(m,y);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,y,p),this.getStorage(y)?.set(m,w)})}remove(m,w){this.withPausedEmitters(()=>{this.updateKeyTarget(m,w,void 0),this.getStorage(w)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,w){const y=[],p=this.getKeyTargets(m);for(const l of Object.keys(p))p[l]===w&&y.push(l);return y}updateKeyTarget(m,w,y){const p=this.getKeyTargets(w);typeof y=="number"?p[m]!==y&&(p[m]=y,this.getStorage(w)?.set(E,JSON.stringify(p))):typeof p[m]=="number"&&(delete p[m],this.getStorage(w)?.set(E,JSON.stringify(p)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const w=this.get(E,m);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=P.NONE){this._onWillSaveState.fire({reason:m});const w=this.getStorage(0),y=this.getStorage(1);switch(m){case P.NONE:await D.Promises.settled([w?.whenFlushed()??Promise.resolve(),y?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await D.Promises.settled([w?.flush(0)??Promise.resolve(),y?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return v(m,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;class u extends S{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}e.InMemoryStorageService=u;async function v(d,m,w,y){const p=s=>{try{return JSON.parse(s)}catch{return s}},l=new Map,i=new Map;d.forEach((s,c)=>{l.set(c,s),i.set(c,p(s))});const a=new Map,r=new Map;m.forEach((s,c)=>{a.set(c,s),r.set(c,p(s))}),console.group(`Storage: Global (path: ${w})`);let t=[];l.forEach((s,c)=>{t.push({key:c,value:s})}),console.table(t),console.groupEnd(),console.log(i),console.group(`Storage: Workspace (path: ${y})`);let o=[];a.forEach((s,c)=>{o.push({key:c,value:s})}),console.table(o),console.groupEnd(),console.log(r)}e.logStorage=v}),define(te[201],ne([0,1,3,2,15,30,31,24]),function(Y,e,D,n,L,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let b=class extends n.Disposable{constructor(C,f){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(C)),this._register(this.storageManger.onDidChange(S=>this._onDidChangeEnablement.fire({extensions:S,source:"storage"}))),this._register(f.onDidInstallExtensions(S=>S.forEach(({local:u,operation:v})=>{u&&v===4&&this._removeFromDisabledExtensions(u.identifier)})))}async enableExtension(C,f){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:f}),!0):!1}async disableExtension(C,f){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:f}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){let f=this.getDisabledExtensions();return f.every(S=>!(0,A.areSameExtensions)(S,C))?(f.push(C),this._setDisabledExtensions(f),!0):!1}_removeFromDisabledExtensions(C){let f=this.getDisabledExtensions();for(let S=0;S<f.length;S++){const u=f[S];if((0,A.areSameExtensions)(u,C))return f.splice(S,1),this._setDisabledExtensions(f),!0}return!1}_setDisabledExtensions(C){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,f){this.storageManger.set(C,f,0)}};b=he([J(0,I.IStorageService),J(1,T.IExtensionManagementService)],b),e.GlobalExtensionEnablementService=b;class E extends n.Disposable{constructor(C){super();this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(f=>this.onDidStorageChange(f)))}get(C,f){let S;return f===0?((0,L.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,f)),S=this.storage[C]):S=this._get(C,f),JSON.parse(S)}set(C,f,S){let u=JSON.stringify(f.map(({id:d,uuid:m})=>({id:d,uuid:m})));this._get(C,S)!==u&&(S===0&&(f.length?this.storage[C]=u:delete this.storage[C]),this._set(C,f.length?u:void 0,S))}onDidStorageChange(C){if(C.scope===0&&!(0,L.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const S=this.get(C.key,C.scope);delete this.storage[C.key];const u=this.get(C.key,C.scope),v=S.filter(m=>!u.some(w=>(0,A.areSameExtensions)(m,w))),d=u.filter(m=>!S.some(w=>(0,A.areSameExtensions)(w,m)));(v.length||d.length)&&this._onDidChange.fire([...v,...d])}}_get(C,f){return this.storageService.get(C,f,"[]")}_set(C,f,S){f?this.storageService.store(C,f,S,1):this.storageService.remove(C,S)}}e.StorageManager=E}),define(te[63],ne([0,1,6,3,2,24,31,26,16,8,15]),function(Y,e,D,n,L,T,A,I,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const C=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let f=class nt extends L.Disposable{constructor(u,v,d){super();this.storageService=u,this.productService=v,this.logService=d,this._onDidChangeExtensionStorageToSync=this._register(new n.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(m=>this.onDidChangeStorageValue(m)))}static toKey(u){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(u.id)}@${u.version}`}static fromKey(u){const v=C.exec(u);if(v&&v[1])return{id:v[1],version:v[2]}}initialize(){const u=this.storageService.keys(0,1);for(const v of u){const d=nt.fromKey(v);d&&this.extensionsWithKeysForSync.add(d.id.toLowerCase())}}onDidChangeStorageValue(u){if(u.scope!==0)return;if(this.extensionsWithKeysForSync.has(u.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const v=nt.fromKey(u.key);if(v){this.extensionsWithKeysForSync.add(v.id.toLowerCase()),this._onDidChangeExtensionStorageToSync.fire();return}}getExtensionId(u){if((0,P.isString)(u))return u;const v=u.manifest?u.manifest.publisher:u.publisher,d=u.manifest?u.manifest.name:u.name;return(0,A.getExtensionId)(v,d)}getExtensionState(u,v){const d=this.getExtensionId(u),m=this.storageService.get(d,v?0:1);if(m)try{return JSON.parse(m)}catch(w){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${d}, global: ${v}): ${w}`)}}setExtensionState(u,v,d){const m=this.getExtensionId(u);v===void 0?this.storageService.remove(m,d?0:1):this.storageService.store(m,JSON.stringify(v),d?0:1,1)}setKeysForSync(u,v){this.storageService.store(nt.toKey(u),JSON.stringify(v),0,1)}getKeysForSync(u){const v=this.productService.extensionSyncedKeys?.[u.id.toLowerCase()],d=this.storageService.get(nt.toKey(u),0),m=d?JSON.parse(d):void 0;return m&&v?(0,b.distinct)([...m,...v]):m||v}addToMigrationList(u,v){if(u!==v){const d=this.migrationList.filter(m=>!m.includes(u)&&!m.includes(v));d.push([u,v]),this.migrationList=d}}getSourceExtensionToMigrate(u){const v=this.migrationList.find(([,d])=>u===d);return v?v[0]:void 0}get migrationList(){const u=this.storageService.get("extensionStorage.migrationList",0,"[]");try{const v=JSON.parse(u);if((0,P.isArray)(v))return v}catch{}return[]}set migrationList(u){u.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(u),0,1):this.storageService.remove("extensionStorage.migrationList",0)}};f=he([J(0,T.IStorageService),J(1,I.IProductService),J(2,E.ILogService)],f),e.ExtensionStorageService=f}),define(te[202],ne([0,1,2,30,63,188,8]),function(Y,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let I=class extends D.Disposable{constructor(E,P,C,f,S){super();E.removeDeprecatedExtensions(),(0,T.migrateUnsupportedExtensions)(E,P,C,f,S)}};I=he([J(0,n.IExtensionManagementService),J(1,n.IExtensionGalleryService),J(2,L.IExtensionStorageService),J(3,n.IGlobalExtensionEnablementService),J(4,A.ILogService)],I),e.ExtensionsCleaner=I}),define(te[203],ne([0,1,3,2]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class L extends n.Disposable{constructor(E,P){super();this.channel=E,this.workspace=P}async getItems(){const E={workspace:this.workspace},P=await this.channel.call("getItems",E);return new Map(P)}updateItems(E){const P={workspace:this.workspace};return E.insert&&(P.insert=Array.from(E.insert.entries())),E.delete&&(P.delete=Array.from(E.delete.values())),this.channel.call("updateItems",P)}}class T extends L{constructor(E){super(E,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(E=>this.onDidChangeGlobalStorage(E)))}onDidChangeGlobalStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}async close(){this.dispose()}}class A extends L{constructor(E,P){super(E,P);this.onDidChangeItemsExternal=D.Event.None}async close(){const E={workspace:this.workspace};return this.channel.call("close",E)}}class I extends n.Disposable{constructor(E,P){super();this.channel=E,this.workspace=P,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=I}),define(te[204],ne([0,1,5,2,19,75,24,203]),function(Y,e,D,n,L,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends A.AbstractStorageService{constructor(P,C,f){super();this.mainProcessService=C,this.environmentService=f,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new n.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(P)}createGlobalStorage(){const P=new I.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),C=new T.Storage(P.globalStorage);return this._register(C.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),C}createWorkspaceStorage(P){const C=new I.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),P);if(C.workspaceStorage){const f=new T.Storage(C.workspaceStorage);return this.workspaceStorageDisposable.value=f.onDidChangeStorage(S=>this.emitDidChangeValue(1,S)),this.workspaceStorageId=P?.id,f}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,L.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(P){const C=this.workspaceStorage,f=C?.items??new Map;C&&(await C.close(),C.dispose()),this.workspaceStorage=this.createWorkspaceStorage(P),await this.workspaceStorage.init();for(const[S,u]of f)this.workspaceStorage.set(S,u)}}e.NativeStorageService=b}),define(te[205],ne([0,1,4,32,7,29]),function(Y,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(E){if(D.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function I(E,P,C,f,S,u,v,d,m,w){const y=Object.create(null);y["common.machineId"]=v,y.sessionID=(0,T.generateUuid)()+Date.now(),y.commitHash=S,y.version=u,y["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=(0,D.PlatformToString)(D.platform),y["common.nodePlatform"]=n.platform,y["common.nodeArch"]=f,y["common.product"]=w||"desktop";const p=b(d||[]);p&&(y["common.msftInternal"]=p);let l=0;const i=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),D.isLinuxSnap&&(y["common.snap"]="true");const a=A(C);a&&(y["common.platformDetail"]=a);try{const r=await E.readFile(L.URI.file(m));y["common.source"]=r.value.toString().slice(0,30)}catch{}return y}e.resolveCommonProperties=I;function b(E){const P=n.env.USERDNSDOMAIN;if(!P)return!1;const C=P.toLowerCase();return E.some(f=>C===f)}e.verifyMicrosoftInternalDomain=b}),define(te[21],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var L;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(L=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[206],ne([0,1,33,55,5,35,18,10,4,7,113,22,116,80,14,26,21]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S,u,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function m(i,a){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],t=new Map,o=new Map,s=2e4;function c(R,_,U,F){const k=_.substring(R.length+1);return L.Promises.withAsyncBody(async M=>{let $;try{$=await C.Promises.readdir(_,{withFileTypes:!0})}catch{M();return}if(F.count>=s){F.count+=$.length,F.maxReached=!0,M();return}let x=$.length;if(x===0){M();return}let z=$;F.count+$.length>s&&(F.maxReached=!0,x=s-F.count,z=$.slice(0,x)),F.count+=$.length;for(const G of z)if(G.isDirectory()){if(U.includes(G.name)||await c(R,(0,I.join)(_,G.name),U,F),--x==0){M();return}}else{const ee=G.name.lastIndexOf(".");if(ee>=0){const q=G.name.substring(ee+1);q&&t.set(q,(t.get(q)??0)+1)}for(const q of r)q.relativePathPattern?.test(k)!==!1&&q.filePattern.test(G.name)&&o.set(q.tag,(o.get(q.tag)??0)+1);if(--x==0){M();return}}})}const h={count:0,maxReached:!1};await c(i,i,a,h);const g=await p(i);return{configFiles:w(o),fileTypes:w(t),fileCount:h.count,maxFilesReached:h.maxReached,launchConfigFiles:g}}e.collectWorkspaceStats=m;function w(i){return[...n.Iterable.map(i.entries(),([a,r])=>({name:a,count:r}))].sort((a,r)=>r.count-a.count)}function y(){const i={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(P.virtualMachineHint.value()*100)}%`},a=D.cpus();return a&&a.length>0&&(i.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),i}e.getMachineInfo=y;async function p(i){try{const a=new Map,r=(0,I.join)(i,".vscode","launch.json"),t=await C.Promises.readFile(r),o=[],s=(0,T.parse)(t.toString(),o);if(o.length)return console.log(`Unable to parse ${r}`),[];if((0,T.getNodeType)(s)==="object"&&s.configurations)for(const c of s.configurations){const h=c.type;h&&(a.has(h)?a.set(h,a.get(h)+1):a.set(h,1))}return w(a)}catch{return[]}}e.collectLaunchConfigs=p;let l=class{constructor(a,r){this.telemetryService=a,this.productService=r}formatMachineInfo(a){const r=[];return r.push(`OS Version:       ${a.os}`),r.push(`CPUs:             ${a.cpus}`),r.push(`Memory (System):  ${a.memory}`),r.push(`VM:               ${a.vmHint}`),r.join(`
`)}formatEnvironment(a){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const t=D.cpus();return t&&t.length>0&&r.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),r.push(`Memory (System):  ${(D.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),b.isWindows||r.push(`Load (avg):       ${D.loadavg().map(o=>Math.round(o)).join(", ")}`),r.push(`VM:               ${Math.round(P.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${a.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(a,r){return Promise.all([(0,f.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async t=>{let[o,s]=t,c=this.formatProcessList(a,o);return r.forEach(h=>{if((0,S.isRemoteDiagnosticError)(h))c+=`
${h.errorMessage}`,s+=`
${h.errorMessage}`;else if(c+=`

Remote: ${h.hostName}`,h.processes&&(c+=`
${this.formatProcessList(a,h.processes)}`),h.workspaceMetadata){s+=`
|  Remote: ${h.hostName}`;for(const g of Object.keys(h.workspaceMetadata)){const R=h.workspaceMetadata[g];let _=`${R.fileCount} files`;R.maxFilesReached&&(_=`more than ${_}`),s+=`|    Folder (${g}): ${_}`,s+=this.formatWorkspaceStats(R)}}}),{processInfo:c,workspaceInfo:s}})}async getSystemInfo(a,r){const{memory:t,vmHint:o,os:s,cpus:c}=y(),h={os:s,memory:t,cpus:c,vmHint:o,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:r};return b.isWindows||(h.load=`${D.loadavg().map(g=>Math.round(g)).join(", ")}`),b.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(a,r){const t=[];return(0,f.listProcesses)(a.mainPID).then(async o=>(t.push(""),t.push(this.formatEnvironment(a)),t.push(""),t.push(this.formatProcessList(a,o)),a.windows.some(s=>s.folderURIs&&s.folderURIs.length>0&&!s.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(a))),r.forEach(s=>{if((0,S.isRemoteDiagnosticError)(s))t.push(`
${s.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${s.hostName}`),t.push(this.formatMachineInfo(s.machineInfo)),s.processes&&t.push(this.formatProcessList(a,s.processes)),s.workspaceMetadata)for(const c of Object.keys(s.workspaceMetadata)){const h=s.workspaceMetadata[c];let g=`${h.fileCount} files`;h.maxFilesReached&&(g=`more than ${g}`),t.push(`Folder (${c}): ${g}`),t.push(this.formatWorkspaceStats(h))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(a){const r=[],t=60;let o=0;const s=(R,_)=>{const U=` ${R}(${_})`;o+U.length>t?(r.push(c),c="|                 ",o=c.length):o+=U.length,c+=U};let c="|      File types:";const h=10;let g=a.fileTypes.length>h?h:a.fileTypes.length;for(let R=0;R<g;R++){const _=a.fileTypes[R];s(_.name,_.count)}if(r.push(c),a.configFiles.length>=0&&(c="|      Conf files:",o=0,a.configFiles.forEach(R=>{s(R.name,R.count)}),r.push(c)),a.launchConfigFiles.length>0){let R="|      Launch Configs:";a.launchConfigFiles.forEach(_=>{R+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),r.push(R)}return r.join(`
`)}expandGPUFeatures(a){const r=Math.max(...Object.keys(a).map(t=>t.length));return Object.keys(a).map(t=>`${t}:  ${" ".repeat(r-t.length)}  ${a[t]}`).join(`
                  `)}formatWorkspaceMetadata(a){const r=[],t=[];return a.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(r.push(`|  Window (${o.title})`),o.folderURIs.forEach(s=>{const c=E.URI.revive(s);if(c.scheme===A.Schemas.file){const h=c.fsPath;t.push(m(h,["node_modules",".git"]).then(g=>{let R=`${g.fileCount} files`;g.maxFilesReached&&(R=`more than ${R}`),r.push(`|    Folder (${(0,I.basename)(h)}): ${R}`),r.push(this.formatWorkspaceStats(g))}).catch(g=>{r.push(`|      Error: Unable to collect workspace stats for folder ${h} (${g.toString()})`)}))}else r.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(o=>r.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(a,r){const t=new Map;a.windows.forEach(s=>t.set(s.pid,s.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(a.mainPID,t,o,r,0),o.join(`
`)}formatProcessItem(a,r,t,o,s){const c=s===0;let h;c?h=o.pid===a?`${this.productService.applicationName} main`:"remote agent":(h=`${"  ".repeat(s)} ${o.name}`,o.name==="window"&&(h=`${h} (${r.get(o.pid)})`));const g=process.platform==="win32"?o.mem:D.totalmem()*(o.mem/100);t.push(`${o.load.toFixed(0).padStart(5," ")}	${(g/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(o.children)&&o.children.forEach(R=>this.formatProcessItem(a,r,t,R,s+1))}async reportWorkspaceStats(a){for(const{uri:r}of a.folders){const t=E.URI.revive(r);if(t.scheme!==A.Schemas.file)continue;const o=t.fsPath;try{const s=await m(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),s.fileTypes.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})}),s.launchConfigFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})}),s.configFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};l=he([J(0,d.ITelemetryService),J(1,v.IProductService)],l),e.DiagnosticsService=l}),define(te[207],ne([0,1,16,5,23,9,3,2,4,15,7,129,30,31,8,26,21]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S,u,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let m=class extends I.Disposable{constructor(a,r,t,o){super();this.galleryService=a,this.telemetryService=r,this.logService=t,this.productService=o,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,I.toDisposable)(()=>{this.installingExtensions.forEach(s=>s.cancel()),this.uninstallingExtensions.forEach(s=>s.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const r=await this.getTargetPlatform();return a.allTargetPlatforms.some(t=>(0,f.isTargetPlatformCompatible)(t,a.allTargetPlatforms,r))}async installFromGallery(a,r={}){try{if(!this.galleryService.isEnabled())throw new f.ExtensionManagementError(C.localize(0,null),f.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(a,!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,r)}catch(t){throw p(this.telemetryService,"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(a),void 0,t),this.logService.error("Failed to install extension.",a.identifier.id),this.logService.error(t),y(t)}}async uninstall(a,r={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,r)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(1,null));const r=await this.findGalleryExtension(a);if(!r)throw new Error(C.localize(2,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(r)}getExtensionsControlManifest(){const a=new Date().getTime();return(!this.extensionsControlManifest||a-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=a),this.extensionsControlManifest}registerParticipant(a){this.participants.push(a)}async installExtension(a,r,t){if(!P.URI.isUri(r)){let g=this.installingExtensions.get(new S.ExtensionIdentifierWithVersion(r.identifier,r.version).key());if(g)return this.logService.info("Extensions is already requested to install",r.identifier.id),g.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const o=[],s=[],c=this.createInstallExtensionTask(a,r,t);P.URI.isUri(r)||this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(c.identifier,a.version).key(),c),this._onInstallExtension.fire({identifier:c.identifier,source:r}),this.logService.info("Installing extension:",c.identifier.id),o.push({task:c,manifest:a});let h=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",c.identifier.id);else try{const R=await this.getAllDepsAndPackExtensionsToInstall(c.identifier,a,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:_,manifest:U}of R)if(h=h||!!U.extensionDependencies?.some(F=>(0,S.areSameExtensions)({id:F},c.identifier)),this.installingExtensions.has(new S.ExtensionIdentifierWithVersion(_.identifier,_.version).key()))this.logService.info("Extension is already requested to install",_.identifier.id);else{const F=this.createInstallExtensionTask(U,_,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(F.identifier,U.version).key(),F),this._onInstallExtension.fire({identifier:F.identifier,source:_}),this.logService.info("Installing extension:",F.identifier.id),o.push({task:F,manifest:U})}}catch(R){if(P.URI.isUri(c.source))(0,D.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",c.identifier.id,R.message),(0,D.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",c.identifier.id,R.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",c.identifier.id),R}const g=o.reduce((R,{task:_,manifest:U})=>(R.set(_.identifier.id.toLowerCase(),{task:_,manifest:U}),R),new Map);for(;g.size;){let R;const _=[...g.values()].filter(({manifest:U})=>!U.extensionDependencies?.some(F=>g.has(F.toLowerCase())));_.length?R=g.size===1?_:_.filter(({task:U})=>!(U===c&&!h)):(this.logService.info("Found extensions with circular dependencies",_.map(({task:U})=>U.identifier.id)),R=[...g.values()]),await this.joinAllSettled(R.map(async({task:U})=>{const F=new Date().getTime(),k=(0,E.isUndefined)(t.operation)?U.operation:t.operation;try{const M=await U.run();if(await this.joinAllSettled(this.participants.map($=>$.postInstall(M,U.source,t,L.CancellationToken.None))),!P.URI.isUri(U.source)&&(p(this.telemetryService,k===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(U.source),new Date().getTime()-F,void 0),b.isWeb&&k!==3))try{await this.galleryService.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,"install")}catch{}s.push({local:M,identifier:U.identifier,operation:k,source:U.source})}catch(M){throw P.URI.isUri(U.source)||p(this.telemetryService,k===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(U.source),new Date().getTime()-F,M),this.logService.error("Error while installing the extension:",U.identifier.id),M}finally{g.delete(U.identifier.id.toLowerCase())}}))}return s.forEach(({identifier:R})=>this.logService.info("Extension installed successfully:",R.id)),this._onDidInstallExtensions.fire(s),s.filter(({identifier:R})=>(0,S.areSameExtensions)(R,c.identifier))[0].local}catch(g){if(o.forEach(({task:R})=>R.cancel()),s.length)try{const R=await Promise.allSettled(s.map(({local:_})=>this.createUninstallExtensionTask(_,{versionOnly:!0}).run()));for(let _=0;_<R.length;_++){const U=R[_],{identifier:F}=s[_];U.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",F.id):this.logService.warn("Rollback: Error while uninstalling extension",F.id,(0,T.getErrorMessage)(U.reason))}}catch(R){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(R),s.map(({identifier:_})=>_.id))}throw this._onDidInstallExtensions.fire(o.map(({task:R})=>({identifier:R.identifier,operation:2,source:R.source}))),g}finally{for(const{task:g,manifest:R}of o)if(!P.URI.isUri(g.source)){const _=new S.ExtensionIdentifierWithVersion(g.identifier,R.version).key();this.installingExtensions.delete(_)||this.logService.warn("Installation task is not found in the cache",_)}}}async joinAllSettled(a){const r=[],t=[],o=await Promise.allSettled(a);for(const s of o)s.status==="fulfilled"?r.push(s.value):t.push(s.reason);if(t.length)throw w(t);return r}async getAllDepsAndPackExtensionsToInstall(a,r,t,o){if(!this.galleryService.isEnabled())return[];let s=await this.getInstalled();const c=[a,...s.map(R=>R.identifier)],h=[],g=async(R,_)=>{const U=_.extensionDependencies||[],F=[...U];if(_.extensionPack){const k=t?s.find(M=>(0,S.areSameExtensions)(M.identifier,R)):void 0;for(const M of _.extensionPack)k&&k.manifest.extensionPack&&k.manifest.extensionPack.some($=>(0,S.areSameExtensions)({id:$},{id:M}))||F.every($=>!(0,S.areSameExtensions)({id:$},{id:M}))&&F.push(M)}if(F.length){const k=[...c,...h.map($=>$.gallery.identifier)],M=F.filter($=>k.every(x=>!(0,S.areSameExtensions)(x,{id:$})));if(M.length){const $=await this.galleryService.query({names:M,pageSize:F.length},L.CancellationToken.None);for(const x of $.firstPage){if(k.find(ee=>(0,S.areSameExtensions)(ee,x.identifier)))continue;const z=U.some(ee=>(0,S.areSameExtensions)({id:ee},x.identifier));let G;try{G=await this.checkAndGetCompatibleVersion(x,!0,o)}catch(ee){if(ee instanceof f.ExtensionManagementError&&ee.code===f.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!z){this.logService.info("Skipping the packed extension as it cannot be installed",x.identifier.id);continue}else throw ee}h.push({gallery:G.extension,manifest:G.manifest}),await g(G.extension.identifier,_)}}}};return await g(a,r),s=await this.getInstalled(),h.filter(R=>!s.some(_=>(0,S.areSameExtensions)(_.identifier,R.gallery.identifier)))}async checkAndGetCompatibleVersion(a,r,t){const o=await this.getExtensionsControlManifest();if((0,S.getMaliciousExtensionsSet)(o).has(a.identifier.id))throw new f.ExtensionManagementError(C.localize(3,null,a.identifier.id),f.ExtensionManagementErrorCode.Malicious);if(!!o.unsupportedPreReleaseExtensions&&!!o.unsupportedPreReleaseExtensions[a.identifier.id])throw new f.ExtensionManagementError(C.localize(4,null,a.identifier.id,o.unsupportedPreReleaseExtensions[a.identifier.id].displayName),f.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(a)){const h=await this.getTargetPlatform();throw new f.ExtensionManagementError(C.localize(5,null,a.identifier.id,this.productService.nameLong,(0,f.TargetPlatformToString)(h)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const s=await this.getCompatibleVersion(a,r,t);if(s){if(t&&r&&a.hasPreReleaseVersion&&!s.properties.isPreReleaseVersion)throw new f.ExtensionManagementError(C.localize(6,null,a.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!t&&a.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([a.identifier],L.CancellationToken.None))[0]?new f.ExtensionManagementError(C.localize(7,null,a.identifier.id),f.ExtensionManagementErrorCode.ReleaseVersionNotFound):new f.ExtensionManagementError(C.localize(8,null,a.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",s.identifier.id);const c=await this.galleryService.getManifest(s,L.CancellationToken.None);if(c===null)throw new f.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(c.version!==s.version)throw new f.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:s,manifest:c}}async getCompatibleVersion(a,r,t){const o=await this.getTargetPlatform();let s=null;return r&&a.hasPreReleaseVersion&&a.properties.isPreReleaseVersion!==t&&(s=(await this.galleryService.getExtensions([{...a.identifier,includePreRelease:t}],{targetPlatform:o,compatible:!0},L.CancellationToken.None))[0]||null),!s&&await this.galleryService.isExtensionCompatible(a,t,o)&&(s=a),!s&&r&&(s=await this.galleryService.getCompatibleExtension(a,t,o)),s}async unininstallExtension(a,r){const t=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),t.waitUntilTaskIsFinished();const o=(g,R)=>{const _=this.createUninstallExtensionTask(g,R);return this.uninstallingExtensions.set(_.extension.identifier.id.toLowerCase(),_),this.logService.info("Uninstalling extension:",g.identifier.id),this._onUninstallExtension.fire(g.identifier),_},s=(g,R)=>{R?this.logService.error("Failed to uninstall extension:",g.identifier.id,R.message):this.logService.info("Successfully uninstalled extension:",g.identifier.id),p(this.telemetryService,"extensionGallery:uninstall",(0,S.getLocalExtensionTelemetryData)(g),void 0,R),this._onDidUninstallExtension.fire({identifier:g.identifier,error:R?.code})},c=[],h=[];try{c.push(o(a,{}));const g=await this.getInstalled(1);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const R=this.getAllPackExtensionsToUninstall(a,g);for(const _ of R)this.uninstallingExtensions.has(_.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",_.identifier.id):c.push(o(_,{}))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(c.map(R=>R.extension),g,a),await this.joinAllSettled(c.map(async R=>{try{if(await R.run(),await this.joinAllSettled(this.participants.map(_=>_.postUninstall(R.extension,r,L.CancellationToken.None))),R.extension.identifier.uuid)try{await this.galleryService.reportStatistic(R.extension.manifest.publisher,R.extension.manifest.name,R.extension.manifest.version,"uninstall")}catch{}s(R.extension)}catch(_){const U=_ instanceof f.ExtensionManagementError?_:new f.ExtensionManagementError((0,T.getErrorMessage)(_),f.ExtensionManagementErrorCode.Internal);throw s(R.extension,U),U}finally{h.push(R)}}))}catch(g){const R=g instanceof f.ExtensionManagementError?g:new f.ExtensionManagementError((0,T.getErrorMessage)(g),f.ExtensionManagementErrorCode.Internal);for(const _ of c){try{_.cancel()}catch{}h.includes(_)||s(_.extension,R)}throw R}finally{for(const g of c)this.uninstallingExtensions.delete(g.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",g.extension.identifier.id)}}checkForDependents(a,r,t){for(const o of a){const s=this.getDependents(o,r);if(s.length){const c=s.filter(h=>!a.some(g=>(0,S.areSameExtensions)(g.identifier,h.identifier)));if(c.length)throw new Error(this.getDependentsErrorMessage(o,c,t))}}}getDependentsErrorMessage(a,r,t){return t===a?r.length===1?C.localize(9,null,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?C.localize(10,null,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):C.localize(11,null,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?C.localize(12,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?C.localize(13,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):C.localize(14,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(a,r,t=[]){if(t.indexOf(a)!==-1)return[];t.push(a);const o=a.manifest.extensionPack?a.manifest.extensionPack:[];if(o.length){const s=r.filter(h=>!h.isBuiltin&&o.some(g=>(0,S.areSameExtensions)({id:g},h.identifier))),c=[];for(const h of s)c.push(...this.getAllPackExtensionsToUninstall(h,r,t));return[...s,...c]}return[]}getDependents(a,r){return r.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(o=>(0,S.areSameExtensions)({id:o},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const r=await this.findGalleryExtensionById(a.identifier.uuid);return r||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},L.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},L.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",a),a}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};m=he([J(0,f.IExtensionGalleryService),J(1,d.ITelemetryService),J(2,u.ILogService),J(3,v.IProductService)],m),e.AbstractExtensionManagementService=m;function w(i){const a=Array.isArray(i)?i:[i];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((r,t)=>new Error(`${r.message}${r.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}e.joinErrors=w;function y(i){if(i instanceof f.ExtensionManagementError)return i;const a=new f.ExtensionManagementError(i.message,f.ExtensionManagementErrorCode.Internal);return a.stack=i.stack,a}function p(i,a,r,t,o){const s=o?o instanceof f.ExtensionManagementError?o.code:f.ExtensionManagementErrorCode.Internal:void 0;i.publicLogError(a,{...r,success:!o,duration:t,errorcode:s})}e.reportTelemetry=p;class l{constructor(){this.barrier=new n.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(a=>new Promise((r,t)=>{const o=a.onCancellationRequested(()=>{o.dispose(),t((0,T.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=l}),define(te[208],ne([0,1,16,5,67,3,10,4,32,7,131,13,30,196,82,14,8,60,26,43,24,21]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S,u,v,d,m,w,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const i="extensionTips/promptedExecutableTips",a="extensionTips/lastPromptedMediumImpExeTime";let r=class extends S.ExtensionTipsService{constructor(o,s,c,h,g,R,_,U,F,k){super(_,U,F,k);this.environmentService=o,this.telemetryService=s,this.extensionManagementService=c,this.storageService=h,this.nativeHostService=g,this.extensionRecommendationNotificationService=R,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,U.exeBasedExtensionTips&&(0,L.forEach)(U.exeBasedExtensionTips,({key:M,value:$})=>{const x=[],z=[],G=[];(0,L.forEach)($.recommendations,({key:ee,value:q})=>{q.important?$.important?x.push({extensionId:ee,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):z.push({extensionId:ee,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):G.push({extensionId:ee,extensionName:q.name,isExtensionPack:!!q.isExtensionPack})}),x.length&&this.highImportanceExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:x}),z.length&&this.mediumImportanceExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:z}),G.length&&this.allOtherExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:G})}),(0,n.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),s=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...o,...s]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),s=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),c=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(o,c),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(s,c)}groupImportantTipsByExe(o,s){const c=new Map;o.forEach(U=>c.set(U.extensionId.toLowerCase(),U));const{installed:h,uninstalled:g}=this.groupByInstalled([...c.keys()],s);for(const U of h){const F=c.get(U);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:U,exeName:F.exeName})}for(const U of g){const F=c.get(U);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:U,exeName:F.exeName})}const R=this.getPromptedExecutableTips(),_=new Map;for(const U of g){const F=c.get(U);if(F&&(!R[F.exeName]||!R[F.exeName].includes(F.extensionId))){let k=_.get(F.exeName);k||(k=[],_.set(F.exeName,k)),k.push(F)}}return _}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[o,s]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(s).then(c=>{switch(c){case"reacted":this.addToRecommendedExecutables(s[0].exeName,s);break;case"ignored":this.highImportanceTipsByExe.delete(o);break;case"incompatibleWindow":{const h=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(h(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const h=this._register((0,n.disposableTimeout)(()=>{h.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const o=this.getLastPromptedMediumExeTime(),s=Date.now()-o,c=7*24*60*60*1e3;if(s<c){const R=this._register((0,n.disposableTimeout)(()=>{R.dispose(),this.promptMediumImportanceExeBasedTip()},c-s));return}const[h,g]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(g).then(R=>{switch(R){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(h),this.addToRecommendedExecutables(g[0].exeName,g);const _=this._register((0,n.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},c));break}case"ignored":this.mediumImportanceTipsByExe.delete(h),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const _=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const _=this._register((0,n.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}promptExeRecommendations(o){const s=o.map(({extensionId:h})=>h.toLowerCase()),c=(0,P.localize)(0,null,o[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(s,c,`@exe:"${o[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let o=this.storageService.getNumber(a,0);return o||(o=Date.now(),this.updateLastPromptedMediumExeTime(o)),o}updateLastPromptedMediumExeTime(o){this.storageService.store(a,o,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(i,0,"{}"))}addToRecommendedExecutables(o,s){const c=this.getPromptedExecutableTips();c[o]=s.map(({extensionId:h})=>h.toLowerCase()),this.storageService.store(i,JSON.stringify(c),0,0)}groupByInstalled(o,s){const c=[],h=[],g=s.reduce((R,_)=>(R.add(_.identifier.id.toLowerCase()),R),new Set);return o.forEach(R=>{g.has(R.toLowerCase())?c.push(R):h.push(R)}),{installed:c,uninstalled:h}}async getValidExecutableBasedExtensionTips(o){const s=[],c=new Map;for(const h of o.keys()){const g=o.get(h);if(!g||!(0,D.isNonEmptyArray)(g.recommendations))continue;const R=[];I.isWindows?g.windowsPath&&R.push(g.windowsPath.replace("%USERPROFILE%",b.env.USERPROFILE).replace("%ProgramFiles(x86)%",b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",b.env.ProgramFiles).replace("%APPDATA%",b.env.APPDATA).replace("%WINDIR%",b.env.WINDIR)):(R.push((0,A.join)("/usr/local/bin",h)),R.push((0,A.join)("/usr/bin",h)),R.push((0,A.join)(this.environmentService.userHome.fsPath,h)));for(const _ of R){let U=c.get(_);if(U===void 0&&(U=await this.fileService.exists(E.URI.file(_)),c.set(_,U)),U)for(const{extensionId:F,extensionName:k,isExtensionPack:M}of g.recommendations)s.push({extensionId:F,extensionName:k,isExtensionPack:M,exeName:h,exeFriendlyName:g.exeFriendlyName,windowsPath:g.windowsPath})}}return s}};r=he([J(0,C.INativeEnvironmentService),J(1,l.ITelemetryService),J(2,f.IExtensionManagementService),J(3,p.IStorageService),J(4,m.INativeHostService),J(5,u.IExtensionRecommendationNotificationService),J(6,v.IFileService),J(7,w.IProductService),J(8,y.IRequestService),J(9,d.ILogService)],r),e.ExtensionTipsService=r}),define(te[93],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(T){this.appenders=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,{eventName:I,data:b}){return this.appenders.forEach(E=>E.log(I,b)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class n{constructor(T){this.channel=T}log(T,A){return this.channel.call("log",{eventName:T,data:A}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(te[44],ne([0,1,28,15,20,21]),function(Y,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class A{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(m,w){return Promise.resolve(void 0)}publicLog2(m,w){return this.publicLog(m,w)}publicLogError(m,w){return Promise.resolve(void 0)}publicLogError2(m,w){return this.publicLogError(m,w)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=A,e.NullTelemetryService=new A;class I{async publicLog(m,w,y){}async publicLogError(m,w,y){}}e.NullEndpointTelemetryService=I,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(d,m){return m.onDidChangeConfiguration(w=>{w.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(w.source),configurationKeys:u(w.sourceConfig)})})}e.configurationTelemetry=b;function E(d,m){return!(m.disableTelemetry||!d.enableTelemetry||m.extensionTestsLocationURI)}e.supportsTelemetry=E;function P(d){const m=d.getValue(T.TELEMETRY_SETTING_ID),w=d.getValue("telemetry.enableCrashReporter");if(d.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||w===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=P;function C(d){const m=Object.create(null),w=Object.create(null),y=Object.create(null);S(d,y);for(let p in y){p=p.length>150?p.substr(p.length-149):p;const l=y[p];typeof l=="number"?w[p]=l:typeof l=="boolean"?w[p]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${p} has been trimmed to 8192, the original length is ${l.length}`),m[p]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(m[p]=l)}return{properties:m,measurements:w}}e.validateTelemetryData=C;function f(d){if(!d)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(y=>{d.indexOf(`${y}+`)===0&&(m=y)}),m}e.cleanRemoteAuthority=f;function S(d,m,w=0,y){if(!!d)for(let p of Object.getOwnPropertyNames(d)){const l=d[p],i=y?y+p:p;Array.isArray(l)?m[i]=(0,D.safeStringify)(l):l instanceof Date?m[i]=l.toISOString():(0,n.isObject)(l)?w<2?S(l,m,w+1,i+"."):m[i]=(0,D.safeStringify)(l):m[i]=l}}function u(d){if(!d)return[];const m=[];return v(m,"",d),m}function v(d,m,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(y=>v(d,m?`${m}.${y}`:y,w[y])):d.push(m)}}),define(te[209],ne([0,1,44,149]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class L{constructor(){}setSharedProperty(b,E){}postEvent(b,E){}}class T{constructor(b,E,P,C,f){this.getMachineId=b,this.configurationService=E,this.productService=P,this.telemetry=C,this.keyValueStorage=f,this.networkInitialized=!1,P.tasConfig&&this.experimentsEnabled&&(0,D.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const S=this.configurationService.getValue("experiments.overrideDelay"),u=typeof S=="number"?S:0;this.overrideInitDelay=new Promise(v=>setTimeout(v,u))}get experimentsEnabled(){return!0}async getTreatment(b){await this.overrideInitDelay;const E=this.configurationService.getValue("experiments.override."+b);if(E!==void 0)return E;if(!this.tasClient||!this.experimentsEnabled)return;let P;const C=await this.tasClient;return this.networkInitialized?P=C.getTreatmentVariable("vscode",b):P=await C.getTreatmentVariableAsync("vscode",b,!0),P=C.getTreatmentVariable("vscode",b),P}async setupTASClient(){const b=this.productService.quality==="stable"?n.TargetPopulation.Public:n.TargetPopulation.Insiders,E=await this.getMachineId(),P=new n.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,E,b),C=this.productService.tasConfig,f=new(await new Promise((S,u)=>{Y(["tas-client-umd"],S,u)})).ExperimentationService({filterProviders:[P],telemetry:this.telemetry,storageKey:n.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:C.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:C.assignmentContextTelemetryPropertyName,telemetryEventName:C.telemetryEventName,endpoint:C.endpoint,refetchInterval:n.ASSIGNMENT_REFETCH_INTERVAL});return await f.initializePromise,f.initialFetch.then(()=>this.networkInitialized=!0),f}}e.BaseAssignmentService=T;class A extends T{constructor(b,E,P){super(()=>Promise.resolve(b),E,P,new L)}}e.AssignmentService=A}),define(te[210],ne([0,1,46,44]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function L(T,A,I,b,E,P){const C={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${A.nameShort})`},f=await(0,D.getServiceMachineId)(I,E,P);return(0,n.supportsTelemetry)(A,I)&&(0,n.getTelemetryLevel)(b)===3&&(C["X-Market-User-Id"]=f),C}e.resolveMarketplaceHeaders=L}),define(te[211],ne([0,1,16,23,9,28,4,32,15,7,20,13,30,31,78,14,8,26,43,210,24,21]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S,u,v,d,m,w,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const i=A.isWeb?"web":(0,f.getTargetPlatform)(A.platform,I.arch);var a;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(a||(a={}));function r(...O){return String(O.reduce((N,W)=>N|W,0))}var t;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},h={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class g{constructor(N=h){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,W=this.state.pageSize){return new g({...this.state,pageNumber:N,pageSize:W})}withFilter(N,...W){const H=[...this.state.criteria,...W.length?W.map(re=>({filterType:N,value:re})):[{filterType:N}]];return new g({...this.state,criteria:H})}withSortBy(N){return new g({...this.state,sortBy:N})}withSortOrder(N){return new g({...this.state,sortOrder:N})}withFlags(...N){return new g({...this.state,flags:N.reduce((W,H)=>W|H,0)})}withAssetTypes(...N){return new g({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:W,pageSize:H,sortBy:re,sortOrder:se,flags:ue,assetTypes:de}=this.state;return{filters:[{criteria:N,pageNumber:W,pageSize:H,sortBy:re,sortOrder:se}],assetTypes:de,flags:ue}}get searchText(){const N=this.state.criteria.filter(W=>W.filterType===t.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function R(O,N){const W=(O||[]).filter(H=>H.statisticName===N)[0];return W?W.value:0}function _(O){const N="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(H=>H.assetType.indexOf(N)===0).reduce((H,re)=>{const se=M(O,re.assetType);return se&&H.push([re.assetType.substring(N.length),se]),H},[])}function U(O){if(O.properties){const N=O.properties.filter(re=>re.key===o.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),H=N.filter(re=>W.test(re.value))[0];return H?{uri:H.value,fallbackUri:H.value}:null}return M(O,o.Repository)}function F(O){return{uri:`${O.fallbackAssetUri}/${o.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${o.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function k(O){const N=M(O,o.Icon);if(N)return N;const W=f.DefaultIconPath;return{uri:W,fallbackUri:W}}function M(O,N){return O.files.filter(H=>H.assetType===N)[0]?{uri:`${O.assetUri}/${N}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${N}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function $(O,N){const W=O.properties?O.properties.filter(re=>re.key===N):[],H=W.length>0&&W[0].value;return H?H.split(",").map(re=>(0,S.adoptToGalleryExtensionId)(re)):[]}function x(O){const N=O.properties?O.properties.filter(W=>W.key===s.Engine):[];return N.length>0&&N[0].value||""}function z(O){const N=O.properties?O.properties.filter(W=>W.key===s.PreRelease):[];return N.length>0&&N[0].value==="true"}function G(O){const N=O.properties?O.properties.filter(H=>H.key===s.LocalizedLanguages):[],W=N.length>0&&N[0].value||"";return W?W.split(","):[]}function ee(O){return O.indexOf("preview")!==-1}function q(O){return O.targetPlatform?(0,f.toTargetPlatform)(O.targetPlatform):"undefined"}function j(O){const N=(0,D.distinct)(O.versions.map(q)),W=!!O.tags?.includes(f.WEB_EXTENSION_TAG),H=N.indexOf("web");return W?H===-1&&N.push("web"):H!==-1&&N.splice(H,1),N}function K(O,N){const W=(0,f.getFallbackTargetPlarforms)(N);for(let H=0;H<O.length;H++){const re=O[H];if(re.version===O[H-1]?.version){let se=H;const ue=q(re);if(ue===N)for(;se>0&&O[se-1].version===re.version;)se--;else if(W.includes(ue))for(;se>0&&O[se-1].version===re.version&&q(O[se-1])!==N;)se--;se!==H&&(O.splice(H,1),O.splice(se,0,re))}}return O}e.sortExtensionVersions=K;function V(O,N,W){const H=O.versions[0],re={manifest:M(N,o.Manifest),readme:M(N,o.Details),changelog:M(N,o.Changelog),license:M(N,o.License),repository:U(N),download:F(N),icon:k(N),coreTranslations:_(N)};return{identifier:{id:(0,S.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:N.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,description:O.shortDescription||"",installCount:R(O.statistics,"install"),rating:R(O.statistics,"averagerating"),ratingCount:R(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:W,assets:re,properties:{dependencies:$(N,s.Dependency),extensionPack:$(N,s.ExtensionPack),engine:x(N),localizedLanguages:G(N),targetPlatform:q(N),isPreReleaseVersion:z(N)},hasPreReleaseVersion:z(H),hasReleaseVersion:!0,preview:ee(O.flags)}}let Q=class{constructor(N,W,H,re,se,ue,de,we){this.requestService=W,this.logService=H,this.environmentService=re,this.telemetryService=se,this.fileService=ue,this.productService=de,this.configurationService=we;const pe=de.extensionsGallery;this.extensionsGalleryUrl=pe&&pe.serviceUrl,this.extensionsControlUrl=pe&&pe.controlUrl,this.commonHeadersPromise=(0,y.resolveMarketplaceHeaders)(de.version,de,this.environmentService,this.configurationService,this.fileService,N)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,W,H){const re=n.CancellationToken.isCancellationToken(W)?{targetPlatform:i}:W,se=n.CancellationToken.isCancellationToken(W)?W:H,ue=[],de=[],we=[],pe=[];for(const Re of N)Re.uuid?de.push(Re.uuid):ue.push(Re.id),we.push({...Re,includePreRelease:!!Re.includePreRelease}),Re.version&&pe.push({...Re,version:Re.version});if(!de.length&&!ue.length)return[];let ge=new g().withPage(1,N.length);de.length&&(ge=ge.withFilter(t.ExtensionId,...de)),ue.length&&(ge=ge.withFilter(t.ExtensionName,...ue));const{extensions:be}=await this.queryGalleryExtensions(ge,{targetPlatform:re.targetPlatform,includePreRelease:we,versions:pe,compatible:!!re.compatible},se);return be}async getCompatibleExtension(N,W,H){if((0,f.isNotWebExtensionInWebTargetPlatform)(N.allTargetPlatforms,H))return null;if(await this.isExtensionCompatible(N,W,H))return N;const re=new g().withFlags(a.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,N.identifier.uuid),{extensions:se}=await this.queryGalleryExtensions(re,{targetPlatform:H,compatible:!0,includePreRelease:W},n.CancellationToken.None);return se[0]||null}async isExtensionCompatible(N,W,H){if(!(0,f.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,H)||!W&&N.properties.isPreReleaseVersion)return!1;let re=N.properties.engine;if(!re){const se=await this.getManifest(N,n.CancellationToken.None);if(!se)throw new Error("Manifest was not found");re=se.engines.vscode}return(0,u.isEngineValid)(re,this.productService.version,this.productService.date)}async isValidVersion(N,W,H,re,se){if(!(0,f.isTargetPlatformCompatible)(q(N),re,se)||W!=="any"&&z(N)!==(W==="prerelease"))return!1;if(H){const ue=await this.getEngine(N);if(!(0,u.isEngineValid)(ue,this.productService.version,this.productService.date))return!1}return!0}async query(N,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let H=N.text||"";const re=(0,T.getOrDefault)(N,ge=>ge.pageSize,50);let se=new g().withPage(1,re);H?(H=H.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,be,Re)=>(se=se.withFilter(t.Category,Re||be),"")),H=H.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,be,Re)=>(se=se.withFilter(t.Tag,Re||be),"")),H=H.replace(/\bfeatured(\s+|\b|$)/g,()=>(se=se.withFilter(t.Featured),"")),H=H.trim(),H&&(H=H.length<200?H:H.substring(0,200),se=se.withFilter(t.SearchText,H)),se=se.withSortBy(0)):N.ids?se=se.withFilter(t.ExtensionId,...N.ids):N.names?se=se.withFilter(t.ExtensionName,...N.names):se=se.withSortBy(4),typeof N.sortBy=="number"&&(se=se.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(se=se.withSortOrder(N.sortOrder));const ue=async(ge,be)=>{const{extensions:Re,total:Le}=await this.queryGalleryExtensions(ge,{targetPlatform:i,compatible:!1,includePreRelease:!!N.includePreRelease},be);return Re.forEach((Te,qe)=>Te.telemetryData={index:(ge.pageNumber-1)*ge.pageSize+qe,querySource:N.source}),{extensions:Re,total:Le}},{extensions:de,total:we}=await ue(se,W),pe=async(ge,be)=>{if(be.isCancellationRequested)throw new L.CancellationError;const{extensions:Re}=await ue(se.withPage(ge+1),be);return Re};return{firstPage:de,total:we,pageSize:se.pageSize,getPage:pe}}async queryGalleryExtensions(N,W,H){const re=N.flags;!!(N.flags&a.IncludeLatestVersionOnly)&&!!(N.flags&a.IncludeVersions)&&(N=N.withFlags(N.flags&~a.IncludeVersions,a.IncludeLatestVersionOnly)),!(N.flags&a.IncludeLatestVersionOnly)&&!(N.flags&a.IncludeVersions)&&(N=N.withFlags(N.flags,a.IncludeLatestVersionOnly)),W.versions?.length&&(N=N.withFlags(N.flags&~a.IncludeLatestVersionOnly,a.IncludeVersions)),N=N.withFlags(N.flags,a.IncludeAssetUri,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeStatistics,a.IncludeVersionProperties);const{galleryExtensions:se,total:ue}=await this.queryRawGalleryExtensions(N,H);if(!(N.flags&a.IncludeLatestVersionOnly)){const ge=[];for(const be of se){const Re=await this.toGalleryExtensionWithCriteria(be,W,!0);Re&&ge.push(Re)}return{extensions:ge,total:ue}}const we=[],pe=new Map;for(let ge=0;ge<se.length;ge++){const be=se[ge],Re={id:(0,S.getGalleryExtensionId)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},Le=(0,b.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(qe=>(0,S.areSameExtensions)(qe,Re))?.includePreRelease;let Te=await this.toGalleryExtensionWithCriteria(be,W,!1);!Te||Te.properties.isPreReleaseVersion&&(!Le||!Te.hasReleaseVersion)||!Te.properties.isPreReleaseVersion&&Te.properties.targetPlatform!==W.targetPlatform&&Te.hasPreReleaseVersion?pe.set(be.extensionId,ge):we.push([ge,Te])}if(pe.size){const ge=new Date().getTime(),be=new g().withFlags(re&~a.IncludeLatestVersionOnly,a.IncludeVersions).withPage(1,pe.size).withFilter(t.ExtensionId,...pe.keys()),{extensions:Re}=await this.queryGalleryExtensions(be,W,H);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ge,count:pe.size});for(const Le of Re){const Te=pe.get(Le.identifier.uuid);we.push([Te,Le])}}return{extensions:we.sort((ge,be)=>ge[0]-be[0]).map(([,ge])=>ge),total:ue}}async toGalleryExtensionWithCriteria(N,W,H){const re={id:(0,S.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},se=W.versions?.find(pe=>(0,S.areSameExtensions)(pe,re))?.version,ue=(0,b.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(pe=>(0,S.areSameExtensions)(pe,re))?.includePreRelease,de=j(N),we=K(N.versions,W.targetPlatform);if(W.compatible&&H&&(0,f.isNotWebExtensionInWebTargetPlatform)(de,W.targetPlatform))return null;for(let pe=0;pe<we.length;pe++){const ge=we[pe];if(!(se&&ge.version!==se)){if(await this.isValidVersion(ge,ue?"any":"release",W.compatible,de,W.targetPlatform))return V(N,ge,de);if(se&&ge.version===se)return null}}return se||W.compatible?null:V(N,N.versions[0],de)}async queryRawGalleryExtensions(N,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,a.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,r(a.Unpublished));const H=await this.commonHeadersPromise,re=JSON.stringify(N.raw),se={...H,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(re.length)},ue=new Date().getTime();let de,we,pe=0;try{if(de=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:re,headers:se},W),de.res.statusCode&&de.res.statusCode>=400&&de.res.statusCode<500)return{galleryExtensions:[],total:pe};const ge=await(0,w.asJson)(de);if(ge){const be=ge.results[0],Re=be.extensions,Le=be.resultMetadata&&be.resultMetadata.filter(Te=>Te.metadataType==="ResultCount")[0];return pe=Le&&Le.metadataItems.filter(Te=>Te.name==="TotalCount")[0].count||0,{galleryExtensions:Re,total:pe}}return{galleryExtensions:[],total:pe}}catch(ge){throw we=ge,ge}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(re.length),duration:new Date().getTime()-ue,success:!!de&&(0,w.isSuccess)(de),responseBodySize:de?.res.headers["Content-Length"],statusCode:de?String(de.res.statusCode):void 0,errorCode:we?(0,L.isCancellationError)(we)?"canceled":(0,L.getErrorMessage)(we).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(pe)})}}async reportStatistic(N,W,H,re){if(!this.isEnabled())return;const se=A.isWeb?this.api(`/itemName/${N}.${W}/version/${H}/statType/${re==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${W}/${H}/stats?statType=${re}`),ue=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",we={...await this.commonHeadersPromise,Accept:ue};try{await this.requestService.request({type:"POST",url:se,headers:we},n.CancellationToken.None)}catch{}}async download(N,W,H){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const re=(0,S.getGalleryExtensionTelemetryData)(N),se=new Date().getTime(),ue=ge=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...re,duration:ge}),de=H===2?"install":H===3?"update":"",we=de?{uri:`${N.assets.download.uri}${E.URI.parse(N.assets.download.uri).query?"&":"?"}${de}=true`,fallbackUri:`${N.assets.download.fallbackUri}${E.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${de}=true`}:N.assets.download,pe=await this.getAsset(we);await this.fileService.writeFile(W,pe.stream),ue(new Date().getTime()-se)}async getReadme(N,W){if(N.assets.readme){const H=await this.getAsset(N.assets.readme,{},W);return await(0,w.asText)(H)||""}return""}async getManifest(N,W){if(N.assets.manifest){const H=await this.getAsset(N.assets.manifest,{},W),re=await(0,w.asText)(H);return re?JSON.parse(re):null}return null}async getManifestFromRawExtensionVersion(N,W){const H=M(N,o.Manifest);if(!H)throw new Error("Manifest was not found");const re={"Accept-Encoding":"gzip"},se=await this.getAsset(H,{headers:re});return await(0,w.asJson)(se)}async getCoreTranslation(N,W){const H=N.assets.coreTranslations.filter(re=>re[0]===W.toUpperCase())[0];if(H){const re=await this.getAsset(H[1]),se=await(0,w.asText)(re);return se?JSON.parse(se):null}return null}async getChangelog(N,W){if(N.assets.changelog){const H=await this.getAsset(N.assets.changelog,{},W);return await(0,w.asText)(H)||""}return""}async getAllCompatibleVersions(N,W,H){let re=new g().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1);N.identifier.uuid?re=re.withFilter(t.ExtensionId,N.identifier.uuid):re=re.withFilter(t.ExtensionName,N.identifier.id);const{galleryExtensions:se}=await this.queryRawGalleryExtensions(re,n.CancellationToken.None);if(!se.length)return[];const ue=j(se[0]);if((0,f.isNotWebExtensionInWebTargetPlatform)(ue,H))return[];const de=[],we=new Set;return await Promise.all(se[0].versions.map(async pe=>{try{if(we.has(pe.version))return;we.add(pe.version),await this.isValidVersion(pe,W?"prerelease":"release",!0,ue,H)&&de.push({version:pe.version,date:pe.lastUpdated,isPreReleaseVersion:z(pe)})}catch{}})),de}async getAsset(N,W={},H=n.CancellationToken.None){const re=await this.commonHeadersPromise,se={type:"GET"},ue={...re,...W.headers||{}};W={...W,...se,headers:ue};const de=N.uri,we=N.fallbackUri,pe={...W,url:de};try{const ge=await this.requestService.request(pe,H);if(ge.res.statusCode===200)return ge;const be=await(0,w.asText)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${be}`)}catch(ge){if((0,L.isCancellationError)(ge))throw ge;const be=(0,L.getErrorMessage)(ge);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:de,message:be});const Re={...W,url:we};return this.requestService.request(Re,H)}}async getEngine(N){let W=x(N);if(!W){const H=await this.getManifestFromRawExtensionVersion(N,n.CancellationToken.None);if(!H)throw new Error("Manifest was not found");W=H.engines.vscode}return W}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,w.asJson)(N),H=[],re={};if(W){for(const se of W.malicious)H.push({id:se});if(W.unsupported)for(const se of Object.keys(W.unsupported)){const ue=W.unsupported[se];(0,b.isBoolean)(ue)||(re[se.toLowerCase()]=ue.preReleaseExtension)}if(W.migrateToPreRelease)for(const[se,ue]of Object.entries(W.migrateToPreRelease))(!ue.engine||(0,u.isEngineValid)(ue.engine,this.productService.version,this.productService.date))&&(re[se.toLowerCase()]=ue)}return{malicious:H,unsupportedPreReleaseExtensions:re}}};Q=he([J(1,w.IRequestService),J(2,d.ILogService),J(3,C.IEnvironmentService),J(4,l.ITelemetryService),J(5,v.IFileService),J(6,m.IProductService),J(7,P.IConfigurationService)],Q);let Z=class extends Q{constructor(N,W,H,re,se,ue,de,we){super(N,W,H,re,se,ue,de,we)}};Z=he([J(0,p.IStorageService),J(1,w.IRequestService),J(2,d.ILogService),J(3,C.IEnvironmentService),J(4,l.ITelemetryService),J(5,v.IFileService),J(6,m.IProductService),J(7,P.IConfigurationService)],Z),e.ExtensionGalleryService=Z;let B=class extends Q{constructor(N,W,H,re,se,ue,de){super(void 0,N,W,H,re,se,ue,de)}};B=he([J(0,w.IRequestService),J(1,d.ILogService),J(2,C.IEnvironmentService),J(3,l.ITelemetryService),J(4,v.IFileService),J(5,m.IProductService),J(6,P.IConfigurationService)],B),e.ExtensionGalleryServiceWithNoStorageService=B}),define(te[94],ne([0,1,2,13,8,44]),function(Y,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends D.Disposable{constructor(b,E,P=""){super();this.prefix=P;const C=b.getLogger(E.telemetryLogResource);C?this.logger=this._register(C):(this.logger=this._register(b.createLogger(E.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(b,E){this.logger.trace(`${this.prefix}telemetry/${b}`,(0,T.validateTelemetryData)(E))}};A=he([J(0,L.ILoggerService),J(1,n.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(te[95],ne([0,1,2,28,4,27,141,20,42,87,38,21,44]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(d,m){this._configurationService=m,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=d.appenders,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(w),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(w=>{const y=/^[a-f0-9]+$/i.test(w["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!y})})}setExperimentProperty(d,m){this._experimentProperties[d]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,f.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const d=await this._commonProperties;let m=d.sessionID,w=d["common.machineId"],y=d["common.firstSessionDate"],p=d["common.msftInternal"];return{sessionId:m,machineId:w,firstSessionDate:y,msftInternal:p}}dispose(){this._disposables.dispose()}_log(d,m,w,y){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(p=>{w=(0,n.mixin)(w,p),w=(0,n.mixin)(w,this._experimentProperties),w=(0,n.cloneAndChange)(w,l=>{if(typeof l=="string")return this._cleanupInfo(l,y)}),this._appenders.forEach(l=>l.log(d,w))},p=>{console.error(p)})}publicLog(d,m,w){return this._log(d,3,m,w)}publicLog2(d,m,w){return this.publicLog(d,m,w)}publicLogError(d,m){return this.sendErrorTelemetry?this._log(d,2,m,!0):Promise.resolve(void 0)}publicLogError2(d,m){return this.publicLogError(d,m)}_anonymizeFilePaths(d){let m=d;const w=[];for(let i of this._cleanupPatterns)for(;;){const a=i.exec(d);if(!a)break;w.push([a.index,i.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(m="";;){const i=p.exec(d);if(!i)break;!y.test(i[0])&&w.every(([a,r])=>i.index<a||i.index>=r)&&(m+=d.substring(l,i.index)+"<REDACTED: user-file-path>",l=p.lastIndex)}return l<d.length&&(m+=d.substr(l)),m}_removePropertiesWithPossibleUserInfo(d){if(!d)return d;const m=d.toLowerCase(),w=/@[a-zA-Z0-9-.]+/,y=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,p=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return y.test(m)?"<REDACTED: secret>":w.test(m)?"<REDACTED: email>":p.test(m)?"<REDACTED: token>":d}_cleanupInfo(d,m){let w=d;m&&(w=this._anonymizeFilePaths(w));for(let y of this._cleanupPatterns)w=w.replace(y,"");return w=this._removePropertiesWithPossibleUserInfo(w),w}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=he([J(1,I.IConfigurationService)],S),e.TelemetryService=S;function u(){const v=(0,A.localize)(0,null,E.default.nameLong),d=E.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=L.isWeb?"":(0,A.localize)(3,null),w=(0,A.localize)(4,null),y=(0,A.localize)(5,null),p=(0,A.localize)(6,null),l=(0,A.localize)(7,null),i=`
|       | ${w} | ${y} | ${p} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,A.localize)(8,null);return`
${v} ${d} ${m}

&nbsp;

${l}
${i}

&nbsp;

${a}
`}P.Registry.as(b.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(9,null),properties:{[C.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:u(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),P.Registry.as(b.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[C.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,A.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,A.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${C.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[212],ne([0,1,9,28,44]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(I,b){const E=await new Promise((C,f)=>{Y(["applicationinsights"],C,f)});let P;return E.defaultClient?(P=new E.TelemetryClient(I),P.channel.setUseDiskRetryCaching(!0)):(E.setup(I).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),P=E.defaultClient),I.indexOf("AIF-")===0&&(P.config.endpointUrl=b?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),P}class A{constructor(b,E,P,C,f){this._eventPrefix=b,this._defaultData=E,this.testCollector=C,this.mirrored=f,this._defaultData||(this._defaultData=Object.create(null)),typeof P=="function"?this._aiClient=P():this._aiClient=P,this._asyncAIClient=null}_withAIClient(b){if(!!this._aiClient){if(typeof this._aiClient!="string"){b(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(E=>{b(E)},E=>{(0,D.onUnexpectedError)(E),console.error(E)})}}log(b,E){if(!!this._aiClient){E=(0,n.mixin)(E,this._defaultData),E=(0,L.validateTelemetryData)(E),this.testCollector&&(E.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++");try{this._withAIClient(P=>P.trackEvent({name:this._eventPrefix+"/"+b,properties:E.properties,measurements:E.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(b=>{this._withAIClient(E=>{try{E.flush({callback:()=>{this._aiClient=void 0,b(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(te[213],ne([0,1,18,58,20,13,8,21,93,94,95]),function(Y,e,D,n,L,T,A,I,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let C=class{constructor(S,u,v,d){this.configurationService=S,this.telemetryService=u,this.loggerService=v,this.environmentService=d,this.customTelemetryServices=new Map}async getCustomTelemetryService(S){if(!this.customTelemetryServices.has(S.id)){const{machineId:u,sessionId:v}=await this.telemetryService.getTelemetryInfo(),d=Object.create(null);d["common.vscodemachineid"]=u,d["common.vscodesessionid"]=v;const m=[S.id,JSON.stringify(d),S.aiKey],y=new n.Client(D.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),p=[new b.TelemetryAppenderClient(y),new E.TelemetryLogAppender(this.loggerService,this.environmentService,`[${S.id}] `)];this.customTelemetryServices.set(S.id,new P.TelemetryService({appenders:p,sendErrorTelemetry:S.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(S.id)}async publicLog(S,u,v){await(await this.getCustomTelemetryService(S)).publicLog(u,v)}async publicLogError(S,u,v){await(await this.getCustomTelemetryService(S)).publicLogError(u,v)}};C=he([J(0,L.IConfigurationService),J(1,I.ITelemetryService),J(2,A.ILoggerService),J(3,T.IEnvironmentService)],C),e.CustomEndpointTelemetryService=C}),define(te[214],ne([0,1,5,23,3,2,8]),function(Y,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let I=class extends T.Disposable{constructor(E,P){super();this._logService=P,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new L.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((P,C)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,P),this._onCreateRequest.fire({requestId:f,...E});const S=new n.CancellationTokenSource;(0,D.timeout)(this._timeout,S.token).then(()=>C(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,T.toDisposable)(()=>S.cancel())])})}acceptReply(E,P){const C=this._pendingRequests.get(E);C?(this._pendingRequests.delete(E),(0,T.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),C(P)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};I=he([J(1,A.ILogService)],I),e.RequestStore=I}),define(te[96],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var L;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.AutomationProfileLinux="terminal.integrated.automationProfile.linux",d.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",d.AutomationProfileWindows="terminal.integrated.automationProfile.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.TerminalTitleSeparator="terminal.integrated.tabs.separator",d.TerminalTitle="terminal.integrated.tabs.title",d.TerminalDescription="terminal.integrated.tabs.description",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoEnabled="terminal.integrated.localEchoEnabled",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",d.CustomGlyphs="terminal.integrated.customGlyphs",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover",d.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",d.AutoReplies="terminal.integrated.autoReplies",d.EnableShellIntegration="terminal.integrated.enableShellIntegration"})(L=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence",d[d.Config=3]="Config"})(A=e.TitleEventSource||(e.TitleEventSource={}));var I;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Log="log",d.Heartbeat="heartbeat"})(I=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var b;(function(d){d.Cwd="cwd",d.InitialCwd="initialCwd",d.FixedDimensions="fixedDimensions",d.Title="title",d.ShellType="shellType",d.HasChildProcesses="hasChildProcesses",d.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",d.OverrideDimensions="overrideDimensions"})(b=e.ProcessPropertyType||(e.ProcessPropertyType={}));var E;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var P;(function(d){d[d.Panel=1]="Panel",d[d.Editor=2]="Editor"})(P=e.TerminalLocation||(e.TerminalLocation={}));var C;(function(d){d.TerminalView="view",d.Editor="editor"})(C=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(d){d[d.CwdDetection=0]="CwdDetection",d[d.NaiveCwdDetection=1]="NaiveCwdDetection",d[d.CommandDetection=2]="CommandDetection",d[d.PartialCommandDetection=3]="PartialCommandDetection"})(f=e.TerminalCapability||(e.TerminalCapability={}));var S;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(S=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var u;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(u=e.FlowControlConstants||(e.FlowControlConstants={}));var v;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(v=e.ProfileSource||(e.ProfileSource={}))}),define(te[215],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(te[216],ne([0,1,33,28,10,4,32,15,22]),function(Y,e,D,n,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let f=0;return C&&C.length===4&&(f=parseInt(C[3])),f}e.getWindowsBuildNumber=E;async function P(C,f,S,u=A.env,v=b.Promises.exists){if(L.isAbsolute(C))return await v(C)?C:void 0;if(f===void 0&&(f=A.cwd()),L.dirname(C)!=="."){const y=L.join(f,C);return await v(y)?y:void 0}const m=(0,n.getCaseInsensitive)(u,"PATH");if(S===void 0&&(0,I.isString)(m)&&(S=m.split(L.delimiter)),S===void 0||S.length===0){const y=L.join(f,C);return await v(y)?y:void 0}for(let y of S){let p;if(L.isAbsolute(y)?p=L.join(y,C):p=L.join(f,y,C),await v(p))return p;if(T.isWindows){let l=p+".com";if(await v(l)||(l=p+".exe",await v(l)))return l}}const w=L.join(f,C);return await v(w)?w:void 0}e.findExecutable=P}),define(te[217],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(te[97],ne([0,1,48,3,2,6,38,217]),function(Y,e,D,n,L,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var b;(function(d){function m(w){return w&&typeof w=="object"&&typeof w.id=="string"}d.isThemeColor=m})(b=e.ThemeColor||(e.ThemeColor={}));function E(d){return{id:d}}e.themeColorFromId=E;var P;(function(d){function m(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||b.isThemeColor(t.color))}d.isThemeIcon=m;const w=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function y(t){const o=w.exec(t);if(!o)return;let[,s]=o;return{id:s}}d.fromString=y;function p(t){return{id:t}}d.fromId=p;function l(t,o){let s=t.id;const c=s.lastIndexOf("~");return c!==-1&&(s=s.substring(0,c)),o&&(s=`${s}~${o}`),{id:s}}d.modify=l;function i(t){const o=t.id.lastIndexOf("~");if(o!==-1)return t.id.substring(o+1)}d.getModifier=i;function a(t,o){return t.id===o.id&&t.color?.id===o.color?.id}d.isEqual=a;function r(t,o){return{id:t.id,color:o?E(o):void 0}}d.asThemeIcon=r,d.asClassNameArray=D.CSSIcon.asClassNameArray,d.asClassName=D.CSSIcon.asClassName,d.asCSSSelector=D.CSSIcon.asCSSSelector})(P=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function C(d){switch(d){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,L.toDisposable)(()=>{const w=this.themingParticipants.indexOf(m);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let S=new f;A.Registry.add(e.Extensions.ThemingContribution,S);function u(d){return S.onColorThemeChange(d)}e.registerThemingParticipant=u;class v extends L.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,w){let y=this.theme.getColor(m);return y&&w&&(y=w(y,this.theme)),y?y.toString():null}}e.Themable=v}),define(te[218],ne([0,1,48,7,97]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(C,f){const S=C.map(u=>({name:u.profileName,description:A(u)}));return f&&S.push(...f.map(u=>({name:u.title,description:I(u)}))),{values:S.map(u=>u.name),markdownDescriptions:S.map(u=>u.description)}}e.createProfileSchemaEnums=T;function A(C){let f=`$(${L.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:D.Codicon.terminal.id}) ${C.profileName}
- path: ${C.path}`;return C.args&&(typeof C.args=="string"?f+=`
- args: "${C.args}"`:f+=`
- args: [${C.args.length===0?"":`'${C.args.join("','")}'`}]`),C.overrideName!==void 0&&(f+=`
- overrideName: ${C.overrideName}`),C.color&&(f+=`
- color: ${C.color}`),C.env&&(f+=`
- env: ${JSON.stringify(C.env)}`),f}function I(C){return`$(${L.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:D.Codicon.terminal.id}) ${C.title}
- extensionIdenfifier: ${C.extensionIdentifier}`}function b(C,f){if(!C&&!f)return!0;if(typeof C=="string"&&typeof f=="string")return C===f;if(Array.isArray(C)&&Array.isArray(f)){if(C.length!==f.length)return!1;for(let S=0;S<C.length;S++)if(C[S]!==f[S])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function E(C,f){if(!C&&!f)return!0;if(!C||!f)return!1;if(L.ThemeIcon.isThemeIcon(C)&&L.ThemeIcon.isThemeIcon(f))return C.id===f.id&&C.color===f.color;if(typeof C=="object"&&C&&"light"in C&&"dark"in C&&typeof f=="object"&&f&&"light"in f&&"dark"in f){const S=C,u=f;if((n.URI.isUri(S.light)||P(S.light))&&(n.URI.isUri(S.dark)||P(S.dark))&&(n.URI.isUri(u.light)||P(u.light))&&(n.URI.isUri(u.dark)||P(u.dark)))return S.light.path===u.light.path&&S.dark.path===u.dark.path}if(n.URI.isUri(C)&&n.URI.isUri(f)||P(C)||P(f)){const S=C,u=f;return S.path===u.path&&S.scheme===u.scheme}return!1}e.terminalIconsEqual=E;function P(C){return C?typeof C.path=="string"&&typeof C.scheme=="string":!1}e.isUriComponents=P}),define(te[219],ne([0,1,48,142,42,38,218]),function(Y,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const I={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),type:"string",enum:Array.from(D.Codicon.getAll(),p=>p.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),p=>`$(${p.id})`)},color:{description:(0,n.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},b={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...I}},E={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...I}},P=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),C=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),f=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),S=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),u=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),v=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),d={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:u},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,n.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,n.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:f},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...I}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...I}},{type:"null"},b]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...I}},{type:"null"},b]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...I}},{type:"null"},b]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){T.Registry.as(L.Extensions.Configuration).registerConfiguration(d),y()}e.registerTerminalPlatformConfiguration=m;let w;function y(p,l){const i=T.Registry.as(L.Extensions.Configuration);let a;p&&(a=(0,A.createProfileSchemaEnums)(p?.profiles,l));const r=w;w={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:p?.os===3?a?.values:void 0,markdownEnumDescriptions:p?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:p?.os===2?a?.values:void 0,markdownEnumDescriptions:p?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:p?.os===1?a?.values:void 0,markdownEnumDescriptions:p?.os===1?a?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[w],remove:r?[r]:[]})}e.registerTerminalDefaultProfileConfiguration=y}),define(te[220],ne([0,1,45,48,10,4,22,72,216,97]),function(Y,e,D,n,L,T,A,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let P,C=!0;function f(a,r,t,o,s=process.env,c,h,g,R){return c=c||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},T.isWindows?S(t,c,s,h,o.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:o.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:o.getValue("terminal.integrated.defaultProfile.windows"),R,g):p(c,h,t,a&&typeof a=="object"?{...a}:o.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:o.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),R,g,s)}e.detectAvailableProfiles=f;async function S(a,r,t,o,s,c,h,g,R){const _=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),U=`${process.env.windir}\\${_?"Sysnative":"System32"}`;let F=!1;(0,b.getWindowsBuildNumber)()>=16299&&(F=!0),await d(g);const k=new Map;a&&(k.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Windows PowerShell",{path:`${U}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),k.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),k.set("Command Prompt",{path:`${U}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0})),l(c,k);const M=await u(k.entries(),h,r,t,o,R);if(a||!a&&s)try{const $=await w(`${U}\\${F?"wsl":"bash"}.exe`,h);for(const x of $)(!c||!(x.profileName in c))&&M.push(x)}catch{C&&(o?.info("WSL is not installed, so could not detect WSL profiles"),C=!1)}return M}async function u(a,r,t,o=process.env,s,c){const h=[];for(const[g,R]of a){if(R===null)continue;let _,U,F;if("source"in R){const $=P?.get(R.source);if(!$)continue;_=$.paths,U=R.args||$.args,R.icon?F=v(R.icon):$.icon&&(F=$.icon)}else _=Array.isArray(R.path)?R.path:[R.path],U=T.isWindows||Array.isArray(R.args)?R.args:void 0,F=v(R.icon);const k=await c?.(_)||_.slice(),M=await i(g,r,k,t,o,U,R.env,R.overrideName,R.isAutoDetected,s);M?(M.isAutoDetected=R.isAutoDetected,M.icon=F,M.color=R.color,h.push(M)):s?.trace("profile not validated",g,_)}return h}function v(a){return typeof a=="string"?{id:a}:a}async function d(a){P&&!a||(P=new Map,P.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),P.set("PowerShell",{profileName:"PowerShell",paths:a||await m(),icon:E.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function m(){const a=[];for await(const r of(0,I.enumeratePowerShellInstallations)())a.push(r.exePath);return a}async function w(a,r){const t=[],o=await new Promise((h,g)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(R,_)=>{if(R)return g("Problem occurred when getting wsl distros");h(_)})});if(!o)return[];const s=new RegExp(/[\r?\n]/),c=o.split(s).filter(h=>h.trim().length>0&&h!=="");for(const h of c){if(h===""||h.startsWith("docker-desktop"))continue;const g=`${h} (WSL)`,R={profileName:g,path:a,args:["-d",`${h}`],isDefault:g===r,icon:y(h),isAutoDetected:!1};t.push(R)}return t}function y(a){return a.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):a.includes("Debian")?E.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function p(a,r,t,o,s,c,h,g){const R=new Map;if(t){const _=(await a.readFile("/etc/shells")).toString(),U=c||_.split(`
`).filter(k=>k.trim().indexOf("#")!==0&&k.trim().length>0),F=new Map;for(const k of U){let M=(0,L.basename)(k),$=F.get(M)||0;$++,$>1&&(M=`${M} (${$})`),F.set(M,$),R.set(M,{path:k,isAutoDetected:!0})}}return l(o,R),await u(R.entries(),s,a,g,r,h)}function l(a,r){if(!!a)for(const[t,o]of Object.entries(a))o===null||!("path"in o)&&!("source"in o)?r.delete(t):(o.icon=o.icon||r.get(t)?.icon,r.set(t,o))}async function i(a,r,t,o,s,c,h,g,R,_){if(t.length===0)return Promise.resolve(void 0);const U=t.shift();if(U==="")return i(a,r,t,o,s,c,h,g,R);const F={profileName:a,path:U,args:c,env:h,overrideName:g,isAutoDetected:R,isDefault:a===r};if((0,L.basename)(U)===U){const M=s.PATH?s.PATH.split(L.delimiter):void 0,$=await(0,b.findExecutable)(U,void 0,M,void 0,o.existsFile);return $?(F.path=$,F.isFromPath=!0,F):i(a,r,t,o,s,c)}return await o.existsFile((0,L.normalize)(U))?F:i(a,r,t,o,s,c,h,g,R)}}),define(te[221],ne([0,1,3,2,18,4,36,58,20,13,77,162,8,86,21,214,96,219,220]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S,u,v,d,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var y;(function(i){i[i.MaxRestarts=5]="MaxRestarts"})(y||(y={}));let p=0,l=class extends n.Disposable{constructor(a,r,t,o,s){super();this._reconnectConstants=a,this._configurationService=r,this._environmentService=t,this._logService=o,this._telemetryService=s,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,m.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,n.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new v.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async c=>{c.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,C.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(a){return this._logService.error("ptyHost was unable to resolve shell environment",a),{}}}_startPtyHost(){const a={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:p,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},r=(0,P.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);r&&(r.break&&r.port?a.debugBrk=r.port:!r.break&&r.port&&(a.debug=r.port));const t=new I.Client(L.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,a);this._onPtyHostStart.fire(),A.ProxyChannel.toService(t.getChannel(d.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(h=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(h.code),this._isDisposed||(this._restartCount<=y.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${h.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${h.code}, giving up`))}));const s=t.getChannel(d.TerminalIpcChannels.Log);S.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{S.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const c=A.ProxyChannel.toService(t.getChannel(d.TerminalIpcChannels.PtyHost));return this._register(c.onProcessData(h=>this._onProcessData.fire(h))),this._register(c.onProcessReady(h=>this._onProcessReady.fire(h))),this._register(c.onProcessExit(h=>this._onProcessExit.fire(h))),this._register(c.onDidChangeProperty(h=>this._onDidChangeProperty.fire(h))),this._register(c.onProcessReplay(h=>this._onProcessReplay.fire(h))),this._register(c.onProcessOrphanQuestion(h=>this._onProcessOrphanQuestion.fire(h))),this._register(c.onDidRequestDetach(h=>this._onDidRequestDetach.fire(h))),[t,c]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,r,t,o,s,c,h,g,R,_,U){const F=setTimeout(()=>this._handleUnresponsiveCreateProcess(),d.HeartbeatConstants.CreateProcessTimeout),k=await this._proxy.createProcess(a,r,t,o,s,c,h,g,R,_,U);return clearTimeout(F),p=Math.max(p,k),k}updateTitle(a,r,t){return this._proxy.updateTitle(a,r,t)}updateIcon(a,r,t){return this._proxy.updateIcon(a,r,t)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,r){return this._proxy.shutdown(a,r)}input(a,r){return this._proxy.input(a,r)}processBinary(a,r){return this._proxy.processBinary(a,r)}resize(a,r,t){return this._proxy.resize(a,r,t)}acknowledgeDataEvent(a,r){return this._proxy.acknowledgeDataEvent(a,r)}setUnicodeVersion(a,r){return this._proxy.setUnicodeVersion(a,r)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}installAutoReply(a,r){return this._proxy.installAutoReply(a,r)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(a){return this._proxy.uninstallAutoReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,r,t,o=!1){const s=await this._shellEnv;return(0,w.detectAvailableProfiles)(r,t,o,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,r){return this._proxy.requestDetachInstance(a,r)}async acceptDetachInstanceReply(a,r){return this._proxy.acceptDetachInstanceReply(a,r)}async serializeTerminalState(a){return this._proxy.serializeTerminalState(a)}async reviveTerminalProcesses(a,r){return this._proxy.reviveTerminalProcesses(a,r)}async refreshProperty(a,r){return this._proxy.refreshProperty(a,r)}async updateProperty(a,r,t){return this._proxy.updateProperty(a,r,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier+d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${d.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,r){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:r})}async acceptPtyHostResolvedVariables(a,r){this._resolveVariablesRequestStore.acceptReply(a,r)}};l=he([J(1,b.IConfigurationService),J(2,E.IEnvironmentService),J(3,f.ILogService),J(4,u.ITelemetryService)],l),e.PtyHostService=l}),define(te[34],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(te[222],ne([0,1,3,2,7,13,31,14,8,34]),function(Y,e,D,n,L,T,A,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let P=class extends n.Disposable{constructor(f,S,u,v,d){super();this.extensionsManagementService=f,this.logService=v,this.uriIdentityService=d,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(y=>y.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(w=>this.onInstallExtension(w))),this._register(f.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(f.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const m=L.URI.file(u.extensionsPath);this._register(S.watch(m)),this._register(D.Event.filter(S.onDidFilesChange,w=>w.rawChanges.some(y=>this.doesChangeAffects(y,m)))(()=>this.onDidChange()))}doesChangeAffects(f,S){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(f.resource),S)?this.uriIdentityService.extUri.isEqual(f.resource,this.uriIdentityService.extUri.joinPath(S,".obsolete"))?!0:!(f.type!==1&&f.type!==2||this.uriIdentityService.extUri.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const S of f)this.removeInstallingExtension(S.identifier),S.local&&this.addInstalledExtension(S.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(S=>!(0,A.areSameExtensions)(S,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(S=>!(0,A.areSameExtensions)(S,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),S=f.filter(v=>[...this.installingExtensions,...this.installedExtensions].some(d=>(0,A.areSameExtensions)(d,v.identifier))?!1:v.installedTimestamp&&v.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",v.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",v.identifier.id),!1)),u=this.installedExtensions.filter(v=>this.installingExtensions.some(d=>(0,A.areSameExtensions)(d,v))?!1:f.every(d=>!(0,A.areSameExtensions)(d.identifier,v))?(this.logService.info("Detected extension removed from another source",v.id),!0):!1);this.installedExtensions=f.map(v=>v.identifier),(S.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S,removed:u})}}};P=he([J(1,I.IFileService),J(2,T.INativeEnvironmentService),J(3,b.ILogService),J(4,E.IUriIdentityService)],P),e.ExtensionsWatcher=P}),define(te[223],ne([0,1,34,79,14,19,104,3,2]),function(Y,e,D,n,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class E{constructor(f){this.uri=f,this.time=E._clock++}touch(){return this.time=E._clock++,this}}E._clock=0;let P=class{constructor(f){this._fileService=f,this._dispooables=new b.DisposableStore,this._limit=2**16;const S=new Map,u=v=>{let d=S.get(v.scheme);return d===void 0&&(d=f.hasProvider(v)&&!this._fileService.hasCapability(v,1024),S.set(v.scheme,d)),d};this._dispooables.add(I.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(v=>{S.delete(v.scheme)})),this.extUri=new T.ExtUri(u),this._canonicalUris=new A.SkipList((v,d)=>this.extUri.compare(v,d,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(f){this._fileService.hasProvider(f)&&(f=(0,T.normalizePath)(f));let S=this._canonicalUris.get(f);return S?S.touch().uri.with({fragment:f.fragment}):(this._canonicalUris.set(f,new E(f)),this._checkTrim(),f)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const f=[...this._canonicalUris.entries()].sort((u,v)=>u[1].touch<v[1].touch?1:u[1].touch>v[1].touch?-1:0);E._clock=0,this._canonicalUris.clear();const S=this._limit*.5;for(let u=0;u<S;u++)this._canonicalUris.set(f[u][0],f[u][1].touch())}};P=he([J(0,L.IFileService)],P),e.UriIdentityService=P,(0,n.registerSingleton)(D.IUriIdentityService,P,!0)}),define(te[224],ne([0,1,3,2,40,39,17]),function(Y,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends n.Disposable{constructor(E,P,C,f,S){super();this.fileSystemScheme=E,this.fileSystemProvider=P,this.userDataScheme=C,this.logService=S,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(f.onDidFilesChange(u=>this.handleFileChanges(u)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(E,P){this.watchResources.set(E,E);const C=this.fileSystemProvider.watch(this.toFileSystemResource(E),P);return(0,n.toDisposable)(()=>{this.watchResources.delete(E),C.dispose()})}stat(E){return this.fileSystemProvider.stat(this.toFileSystemResource(E))}mkdir(E){return this.fileSystemProvider.mkdir(this.toFileSystemResource(E))}rename(E,P,C){return this.fileSystemProvider.rename(this.toFileSystemResource(E),this.toFileSystemResource(P),C)}readFile(E){return this.fileSystemProvider.readFile(this.toFileSystemResource(E),{atomic:!0})}readFileStream(E,P,C){const f=(0,L.newWriteableStream)(S=>A.VSBuffer.concat(S.map(u=>A.VSBuffer.wrap(u))).buffer);return(async()=>{try{const S=await this.readFile(E);f.end(S)}catch(S){f.error(S),f.end()}})(),f}readdir(E){return this.fileSystemProvider.readdir(this.toFileSystemResource(E))}writeFile(E,P,C){return this.fileSystemProvider.writeFile(this.toFileSystemResource(E),P,C)}delete(E,P){return this.fileSystemProvider.delete(this.toFileSystemResource(E),P)}handleFileChanges(E){const P=[];for(const C of E.rawChanges){if(C.resource.scheme!==this.fileSystemScheme)continue;const f=this.toUserDataResource(C.resource);this.watchResources.findSubstr(f)&&P.push({resource:f,type:C.type})}P.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(P))}toFileSystemResource(E){return E.with({scheme:this.fileSystemScheme})}toUserDataResource(E){return E.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=I}),define(te[53],ne([0,1,69]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function n(A,I,b,E){const P=(0,D.setProperty)(A,I,b,E)[0];return P&&(A=A.substring(0,P.offset)+P.content+A.substring(P.offset+P.length)),A}e.edit=n;function L(A,I,b){let E=b;for(;E>=0;){if(A.charAt(E)===I.charAt(I.length-1)&&I.length===1)return E+1;if(E--,I.length===2&&E>=0&&A.charAt(E)===I.charAt(0))return E+2}return 0}e.getLineStartOffset=L;function T(A,I,b){let E=b;for(;E>=0;)if(A.charAt(E)===I.charAt(I.length-1)&&I.length===1||(E++,I.length===2&&E>=0&&A.charAt(E)===I.charAt(1)))return E;return A.length-1}e.getLineEndOffset=T}),define(te[225],ne([0,1,28,61,15]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(f,S,u,v,d){const m=[],w=[],y=[];if(!S){const U=f.filter(({identifier:F})=>d.every(k=>k.toLowerCase()!==F.id.toLowerCase()));return{local:{added:m,removed:w,updated:y},remote:U.length>0?{added:U,updated:[],removed:[],all:U}:null}}f=f.map(P),S=S.map(P),u=u?u.map(P):null;const p=new Map,l=U=>{U.uuid&&p.set(U.id.toLowerCase(),U.uuid)};f.forEach(({identifier:U})=>l(U)),S.forEach(({identifier:U})=>l(U)),u&&u.forEach(({identifier:U})=>l(U));const i=U=>{const F=U.identifier.uuid||p.get(U.identifier.id.toLowerCase());return F?`uuid:${F}`:`id:${U.identifier.id.toLowerCase()}`},a=(U,F)=>(U.set(i(F),F),U),r=f.reduce(a,new Map),t=S.reduce(a,new Map),o=S.reduce((U,F)=>{const k=i(F);F=(0,D.deepClone)(F);const M=r.get(k);return M&&(M.installed&&(F.installed=!0),F.version||(F.version=M.version)),a(U,F)},new Map),s=u?u.reduce(a,new Map):null,c=v.reduce(a,new Map),h=d.reduce((U,F)=>{const k=p.get(F.toLowerCase());return U.add(k?`uuid:${k}`:`id:${F.toLowerCase()}`)},new Set),g=A(r,t,h);if(g.added.size>0||g.removed.size>0||g.updated.size>0){const U=A(s,r,h),F=A(s,t,h),k=(M,$)=>{const x=r.get(M);if(x){const z=t.get(M),G=$?z:x;return{...G,version:(z.version&&n.gt(z.version,x.version),x.version),state:I(x,z,s?.get(M)),preRelease:(0,L.isUndefined)(G.preRelease)?x.preRelease:G.preRelease}}};for(const M of F.removed.values()){const $=r.get(M);$&&w.push($.identifier)}for(const M of F.added.values())if(U.added.has(M)){if(g.updated.has(M)){const $=k(M,!0);$&&(y.push(C($,M)),o.set(M,$))}}else{const $=t.get(M);$.installed&&m.push(C($,M))}for(const M of F.updated.values()){const $=k(M,!0);$&&(y.push(C($,M)),o.set(M,$))}for(const M of U.added.values())F.added.has(M)||o.set(M,r.get(M));for(const M of U.updated.values())if(!F.removed.has(M)&&!F.updated.has(M)){const $=k(M,!1);$&&(o.get(M)?.installed&&($.installed=!0),o.set(M,$))}for(const M of U.removed.values())!c.has(M)&&!F.updated.has(M)&&s?.get(M)?.installed&&o.delete(M)}const R=[],_=A(t,o,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&o.forEach((U,F)=>R.push(C(U,F))),{local:{added:m,removed:w,updated:y},remote:R.length?{added:[..._.added].map(U=>o.get(U)),updated:[..._.updated].map(U=>o.get(U)),removed:[..._.removed].map(U=>t.get(U)),all:R}:null}}e.merge=T;function A(f,S,u,{checkInstalledProperty:v,checkVersionProperty:d}={checkInstalledProperty:!1,checkVersionProperty:!1}){const m=f?[...f.keys()].filter(i=>!u.has(i)):[],w=[...S.keys()].filter(i=>!u.has(i)),y=w.filter(i=>m.indexOf(i)===-1).reduce((i,a)=>(i.add(a),i),new Set),p=m.filter(i=>w.indexOf(i)===-1).reduce((i,a)=>(i.add(a),i),new Set),l=new Set;for(const i of m){if(p.has(i))continue;const a=f.get(i),r=S.get(i);(!r||a.disabled!==r.disabled||a.preRelease!==r.preRelease||!E(a.state,r.state)||d&&a.version!==r.version||v&&a.installed!==r.installed)&&l.add(i)}return{added:y,removed:p,updated:l}}function I(f,S,u){const v=f.state,d=S.state,m=u?.state;if(!S.version||v&&n.gt(f.version,S.version))return v;if(d&&n.gt(S.version,f.version)||!v)return d;if(!d)return v;const w=(0,D.deepClone)(v),y=m?b(m,d):{added:Object.keys(d).reduce((l,i)=>(l.add(i),l),new Set),removed:new Set,updated:new Set},p=m?b(m,v):{added:Object.keys(v).reduce((l,i)=>(l.add(i),l),new Set),removed:new Set,updated:new Set};for(const l of[...y.added.values(),...y.updated.values()])w[l]=d[l];for(const l of y.removed.values())p.updated.has(l)||delete w[l];return w}function b(f,S){const u=Object.keys(f),v=Object.keys(S),d=v.filter(y=>u.indexOf(y)===-1).reduce((y,p)=>(y.add(p),y),new Set),m=u.filter(y=>v.indexOf(y)===-1).reduce((y,p)=>(y.add(p),y),new Set),w=new Set;for(const y of u){if(m.has(y))continue;const p=f[y],l=S[y];(0,D.equals)(p,l)||w.add(y)}return{added:d,removed:m,updated:w}}function E(f={},S={}){const{added:u,removed:v,updated:d}=b(f,S);return u.size===0&&v.size===0&&d.size===0}function P(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function C(f,S){const u={identifier:{id:f.identifier.id,uuid:S.startsWith("uuid:")?S.substring("uuid:".length):void 0},preRelease:!!f.preRelease};return f.version&&(u.version=f.version),f.disabled&&(u.disabled=!0),f.installed&&(u.installed=!0),f.state&&(u.state=f.state),u}}),define(te[98],ne([0,1,16,20,6]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,L.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(I){this.configurationService=I}hasToNeverSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,b){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return E=E.filter(P=>P!==I&&P!==`-${I}`),b&&E.push(I.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}updateSynchronizedExtensions(I,b){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return E=E.filter(P=>P!==I&&P!==`-${I}`),b&&E.push(`-${I.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}getIgnoredExtensions(I){const b=I.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(f=>f.toLowerCase()),P=[],C=[];if(Array.isArray(E))for(const f of E)f.startsWith("-")?C.push(f.substring(1)):P.push(f);return(0,D.distinct)([...b,...P].filter(f=>C.indexOf(f)===-1))}getConfiguredIgnoredExtensions(){let I=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.configurationService.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(b=>b.toLowerCase())}};T=he([J(0,n.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(te[226],ne([0,1,16,35,28,159,53]),function(Y,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function I(p){return(0,n.parse)(p)||[]}e.parseKeybindings=I;async function b(p,l,i,a,r){const t=I(p),o=I(l),s=i?I(i):null,c=[...t,...o,...s||[]].map(z=>z.key),h=await r.resolveUserBindings(c);let g=P(t,o,s,h);if(!g.hasLocalForwarded&&!g.hasRemoteForwarded)return{mergeContent:p,hasChanges:!1,hasConflicts:!1};if(!g.hasLocalForwarded&&g.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(g.hasLocalForwarded&&!g.hasRemoteForwarded)return{mergeContent:p,hasChanges:!0,hasConflicts:!1};const R=f(t),_=f(o),U=s?f(s):null,F=u(R,_,h),k=U?u(U,R,h):{added:[...R.keys()].reduce((z,G)=>(z.add(G),z),new Set),removed:new Set,updated:new Set},M=U?u(U,_,h):{added:[..._.keys()].reduce((z,G)=>(z.add(G),z),new Set),removed:new Set,updated:new Set},$=E(F,k,M);let x=p;for(const z of $.removed.values())$.conflicts.has(z)||(x=w(x,z,a));for(const z of $.added.values()){if($.conflicts.has(z))continue;const G=_.get(z);if(G.some(ee=>ee.command!==`-${z}`&&g.conflicts.has(h[ee.key]))){$.conflicts.add(z);continue}x=m(x,G,a)}for(const z of $.updated.values()){if($.conflicts.has(z))continue;const G=_.get(z);if(G.some(ee=>ee.command!==`-${z}`&&g.conflicts.has(h[ee.key]))){$.conflicts.add(z);continue}x=y(x,z,G,a)}return{mergeContent:x,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=b;function E(p,l,i){const a=new Set,r=new Set,t=new Set,o=new Set;for(const s of l.removed.values())i.updated.has(s)&&o.add(s);for(const s of i.removed.values())o.has(s)||(l.updated.has(s)?o.add(s):r.add(s));for(const s of l.added.values())o.has(s)||i.added.has(s)&&p.updated.has(s)&&o.add(s);for(const s of i.added.values())o.has(s)||(l.added.has(s)?p.updated.has(s)&&o.add(s):a.add(s));for(const s of l.updated.values())o.has(s)||i.updated.has(s)&&p.updated.has(s)&&o.add(s);for(const s of i.updated.values())o.has(s)||(l.updated.has(s)?p.updated.has(s)&&o.add(s):t.add(s));return{added:a,removed:r,updated:t,conflicts:o}}function P(p,l,i,a){const r=new Set,t=C(p,a),o=C(l,a),s=i?C(i,a):null,c=S(t,o);if(c.added.size===0&&c.removed.size===0&&c.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const h=s?S(s,t):{added:[...t.keys()].reduce((k,M)=>(k.add(M),k),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:r,removed:r,updated:r,conflicts:r};const g=s?S(s,o):{added:[...o.keys()].reduce((k,M)=>(k.add(M),k),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const{added:R,removed:_,updated:U,conflicts:F}=E(c,h,g);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:R,removed:_,updated:U,conflicts:F}}function C(p,l){const i=new Map;for(const a of p){const r=l[a.key];let t=i.get(r);t||(t=[],i.set(r,t)),t.push(a)}return i}function f(p){const l=new Map;for(const i of p){const a=i.command[0]==="-"?i.command.substring(1):i.command;let r=l.get(a);r||(r=[],l.set(a,r)),r.push(i)}return l}function S(p,l){const i=[...p.keys()],a=[...l.keys()],r=a.filter(s=>i.indexOf(s)===-1).reduce((s,c)=>(s.add(c),s),new Set),t=i.filter(s=>a.indexOf(s)===-1).reduce((s,c)=>(s.add(c),s),new Set),o=new Set;for(const s of i){if(t.has(s))continue;const c=p.get(s).map(g=>({...g,key:s})),h=l.get(s).map(g=>({...g,key:s}));(0,D.equals)(c,h,(g,R)=>d(g,R))||o.add(s)}return{added:r,removed:t,updated:o}}function u(p,l,i){const a=[...p.keys()],r=[...l.keys()],t=r.filter(c=>a.indexOf(c)===-1).reduce((c,h)=>(c.add(h),c),new Set),o=a.filter(c=>r.indexOf(c)===-1).reduce((c,h)=>(c.add(h),c),new Set),s=new Set;for(const c of a){if(o.has(c))continue;const h=p.get(c).map(R=>({...R,key:i[R.key]})),g=l.get(c).map(R=>({...R,key:i[R.key]}));v(h,g)||s.add(c)}return{added:t,removed:o,updated:s}}function v(p,l){return!(!(0,D.equals)(p.filter(({command:i})=>i[0]!=="-"),l.filter(({command:i})=>i[0]!=="-"),(i,a)=>d(i,a))||!(0,D.equals)(p.filter(({command:i})=>i[0]==="-"),l.filter(({command:i})=>i[0]==="-"),(i,a)=>d(i,a)))}function d(p,l){if(p.command!==l.command||p.key!==l.key)return!1;const i=T.ContextKeyExpr.deserialize(p.when),a=T.ContextKeyExpr.deserialize(l.when);return!(i&&!a||!i&&a||i&&a&&!i.equals(a)||!L.equals(p.args,l.args))}function m(p,l,i){for(const a of l)p=A.edit(p,[-1],a,i);return p}function w(p,l,i){const a=I(p);for(let r=a.length-1;r>=0;r--)(a[r].command===l||a[r].command===`-${l}`)&&(p=A.edit(p,[r],void 0,i));return p}function y(p,l,i,a){const r=I(p),t=r.findIndex(o=>o.command===l||o.command===`-${l}`);for(let o=r.length-1;o>=0;o--)(r[o].command===l||r[o].command===`-${l}`)&&(p=A.edit(p,[o],void 0,a));for(let o=i.length-1;o>=0;o--)p=A.edit(p,[t],i[o],a);return p}}),define(te[227],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(T,A,I){const b={},E={},P=new Set;if(!A)return{local:{added:b,updated:E,removed:[...P.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const C=n(T,A);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:b,updated:E,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=n(I,T),S=n(I,A),u={},v={},d=new Set,m=new Set;for(const w of f.removed.values())S.updated.has(w)?b[w]=A[w]:d.add(w);for(const w of S.removed.values())m.has(w)||(f.updated.has(w)?m.add(w):P.add(w));for(const w of f.updated.values())m.has(w)||(S.updated.has(w)?C.updated.has(w)&&m.add(w):v[w]=T[w]);for(const w of S.updated.values())m.has(w)||(f.updated.has(w)?C.updated.has(w)&&m.add(w):T[w]!==void 0&&(E[w]=A[w]));for(const w of f.added.values())m.has(w)||(S.added.has(w)?C.updated.has(w)&&m.add(w):u[w]=T[w]);for(const w of S.added.values())m.has(w)||(f.added.has(w)?C.updated.has(w)&&m.add(w):b[w]=A[w]);return{local:{added:b,removed:[...P.values()],updated:E},remote:{added:u,removed:[...d.values()],updated:v},conflicts:[...m.values()]}}e.merge=D;function n(T,A){const I=T?Object.keys(T):[],b=A?Object.keys(A):[],E=b.filter(f=>I.indexOf(f)===-1).reduce((f,S)=>(f.add(S),f),new Set),P=I.filter(f=>b.indexOf(f)===-1).reduce((f,S)=>(f.add(S),f),new Set),C=new Set;for(const f of I){if(P.has(f))continue;const S=T[f],u=A[f];S!==u&&C.add(f)}return{added:E,removed:P,updated:C}}function L(T,A){const{added:I,removed:b,updated:E}=n(T,A);return I.size===0&&b.size===0&&E.size===0}e.areSame=L}),define(te[25],ne([0,1,16,19,15,147,42,30,6,88,38]),function(Y,e,D,n,L,T,A,I,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const s=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(c=>!!s[c].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function f(){const s=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(s).filter(R=>!!s[R].ignoreSync),h=Object.keys(s).filter(R=>s[R].scope===2||s[R].scope===6),g=C();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...c,...h,...g])}e.getDefaultIgnoredSettings=f,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function S(){const s="vscode://schemas/ignoredSettings",c=P.Registry.as(A.Extensions.Configuration);c.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:I.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const h=P.Registry.as(E.Extensions.JSONContribution),g=()=>{const R=C(),_=f().filter(M=>M!==e.CONFIGURATION_SYNC_STORE_KEY),U=Object.keys(A.allSettings.properties).filter(M=>_.indexOf(M)===-1),F=_.filter(M=>R.indexOf(M)===-1),k={items:{type:"string",enum:[...U,...F.map(M=>`-${M}`)]}};h.registerSchema(s,k)};return c.onDidUpdateConfiguration(()=>g())}e.registerConfiguration=S;function u(s){return s&&(0,L.isObject)(s)&&(0,L.isString)(s.id)&&(0,L.isArray)(s.scopes)}e.isAuthenticationProvider=u;var v;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Extensions="extensions",s.GlobalState="globalState"})(v=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function d(s,c,h){return h.joinPath(c.userDataSyncHome,s,`lastSync${s}.json`)}e.getLastSyncResourceUri=d,e.IUserDataSyncStoreManagementService=(0,b.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,b.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,b.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function m(s){const c={};return c[e.HEADER_EXECUTION_ID]=s,c}e.createSyncHeaders=m;var w;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(w=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class y extends Error{constructor(c,h,g,R){super(c);this.code=h,this.resource=g,this.operationId=R,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=y;class p extends y{constructor(c,h,g,R,_){super(c,g,void 0,_);this.url=h,this.serverCode=R}}e.UserDataSyncStoreError=p;class l extends y{constructor(c,h){super(c,h)}}e.UserDataAutoSyncError=l,function(s){function c(h){if(h instanceof s)return h;const g=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(h.name);if(g&&g[1]){const R=g[2]==="unknown"?void 0:g[2],_=g[3]==="unknown"?void 0:g[3];return new s(h.message,g[1],R,_)}return new s(h.message,"Unknown")}s.toUserDataSyncError=c}(y=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var a;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(a=e.Change||(e.Change={}));var r;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(r=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(s){return`sync.enable.${s}`}e.getEnablementKey=t,e.IUserDataSyncEnablementService=(0,b.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,b.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,b.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,b.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,b.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(s,c){if(s.scheme!==e.USER_DATA_SYNC_SCHEME)return s=s.with({scheme:c.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(h=>(0,n.isEqualOrParent)(s,(0,n.joinPath)(c.userDataSyncHome,h,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(te[47],ne([0,1,16,5,17,23,3,35,2,27,15,7,143,20,13,14,8,46,24,21,34,25]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S,u,v,d,m,w,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function i(s){return!!(s&&s.version!==void 0&&typeof s.version=="number"&&s.content!==void 0&&typeof s.content=="string"&&(Object.keys(s).length===2||Object.keys(s).length===3&&s.machineId!==void 0&&typeof s.machineId=="string"))}e.isSyncData=i;let a=class extends b.Disposable{constructor(c,h,g,R,_,U,F,k,M,$,x){super();this.resource=c,this.fileService=h,this.environmentService=g,this.userDataSyncStoreService=_,this.userDataSyncBackupStoreService=U,this.userDataSyncEnablementService=F,this.telemetryService=k,this.logService=M,this.configurationService=$,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new n.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,E.uppercaseFirstLetter)(this.resource),this.extUri=x.extUri,this.syncFolder=this.extUri.joinPath(g.userDataSyncHome,c),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(c,g,this.extUri),this.currentMachineIdPromise=(0,m.getServiceMachineId)(g,h,R)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const c=await this.syncPreviewPromise;this.syncPreviewPromise=null;const h=await this.performSync(c.remoteUserData,c.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(h)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const c=await this.getLastSyncUserData();(c?await this.hasRemoteChanged(c):!0)&&this._onDidChangeLocal.fire()}}setStatus(c){if(this._status!==c){const h=this._status;c==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),h==="hasConflicts"&&c==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=c,this._onDidChangStatus.fire(c)}}async sync(c,h={}){await this._sync(c,!0,this.getUserDataSyncConfiguration(),h)}async preview(c,h,g={}){return this._sync(c,!1,h,g)}async apply(c,h={}){try{this.syncHeaders={...h};const g=await this.doApply(c);return this.setStatus(g),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(c,h,g,R){try{if(this.syncHeaders={...R},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const U=await this.getLastSyncUserData(),F=await this.getLatestRemoteUserData(c,U);return _=await this.performSync(F,U,h,g),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(c){const h=await this.resolveContent(c);if(!h)return!1;const g=this.parseSyncData(h);if(!g)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const R=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,R),U=await this.isRemoteDataFromCurrentMachine(_),F=await this.generateSyncPreview({ref:_.ref,syncData:g},R,U,this.getUserDataSyncConfiguration(),T.CancellationToken.None),k=[];for(const M of F){const $=await this.getAcceptResult(M,M.remoteResource,void 0,T.CancellationToken.None),{remoteChange:x}=await this.getAcceptResult(M,M.previewResource,M.remoteContent,T.CancellationToken.None);k.push([M,{...$,remoteChange:x!==0?x:2}])}await this.applyResult(_,R,k,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(c){const h=await this.currentMachineIdPromise;return!!c.syncData?.machineId&&c.syncData.machineId===h}async getLatestRemoteUserData(c,h){if(h){const g=c&&c.latest?c.latest[this.resource]:void 0;if(h.ref===g||g===void 0&&h.syncData===null)return h}return this.getRemoteUserData(h)}async performSync(c,h,g,R){if(c.syncData&&c.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,f.localize)(0,null,this.resource,this.version,c.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(c,h,g,R)}catch(_){if(_ instanceof l.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(c,h,g,R);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),c=await this.getRemoteUserData(null),h=await this.getLastSyncUserData(),this.performSync(c,h,g,R)}throw _}}async doSync(c,h,g,R){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,n.createCancelablePromise)(U=>this.doGenerateSyncResourcePreview(c,h,g,R,U)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:U})=>U==="conflict")?"hasConflicts":g?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(c){return await this.updateSyncResourcePreview(c,async h=>{const g=await this.getMergeResult(h,T.CancellationToken.None);await this.fileService.writeFile(h.previewResource,L.VSBuffer.fromString(g?.content||""));const R=g&&!g.hasConflicts?await this.getAcceptResult(h,h.previewResource,void 0,T.CancellationToken.None):void 0;return h.acceptResult=R,h.mergeState=g.hasConflicts?"conflict":R?"accepted":"preview",h.localChange=R?R.localChange:g.localChange,h.remoteChange=R?R.remoteChange:g.remoteChange,h}),this.syncPreviewPromise}async accept(c,h){return await this.updateSyncResourcePreview(c,async g=>{const R=await this.getAcceptResult(g,c,h,T.CancellationToken.None);return g.acceptResult=R,g.mergeState="accepted",g.localChange=R.localChange,g.remoteChange=R.remoteChange,g}),this.syncPreviewPromise}async discard(c){return await this.updateSyncResourcePreview(c,async h=>{const g=await this.getMergeResult(h,T.CancellationToken.None);return await this.fileService.writeFile(h.previewResource,L.VSBuffer.fromString(g.content||"")),h.acceptResult=void 0,h.mergeState="preview",h.localChange=g.localChange,h.remoteChange=g.remoteChange,h}),this.syncPreviewPromise}async updateSyncResourcePreview(c,h){if(!this.syncPreviewPromise)return;let g=await this.syncPreviewPromise;const R=g.resourcePreviews.findIndex(({localResource:_,remoteResource:U,previewResource:F})=>this.extUri.isEqual(_,c)||this.extUri.isEqual(U,c)||this.extUri.isEqual(F,c));R!==-1&&(this.syncPreviewPromise=(0,n.createCancelablePromise)(async _=>{const U=[...g.resourcePreviews];return U[R]=await h(U[R]),{...g,resourcePreviews:U}}),g=await this.syncPreviewPromise,this.updateConflicts(g.resourcePreviews),g.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(c){if(!this.syncPreviewPromise)return"idle";const h=await this.syncPreviewPromise;return h.resourcePreviews.some(({mergeState:g})=>g==="conflict")?"hasConflicts":h.resourcePreviews.some(({mergeState:g})=>g!=="accepted")?"syncing":(await this.applyResult(h.remoteUserData,h.lastSyncUserData,h.resourcePreviews.map(g=>[g,g.acceptResult]),c),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(c){const h=c.filter(({mergeState:g})=>g==="conflict");(0,D.equals)(this._conflicts,h,(g,R)=>this.extUri.isEqual(g.previewResource,R.previewResource))||(this._conflicts=h,this._onDidChangeConflicts.fire(h))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:h,ref:g})=>({created:h,uri:this.toRemoteBackupResource(g)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:h,ref:g})=>({created:h,uri:this.toLocalBackupResource(g)}))}toRemoteBackupResource(c){return C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${c}`})}toLocalBackupResource(c){return C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${c}`})}async getMachineId({uri:c}){const h=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(h))){const{content:g}=await this.getUserData(h);if(g)return this.parseSyncData(g)?.machineId}}async resolveContent(c){const h=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(h))){const{content:g}=await this.getUserData(h);return g}return this.extUri.isEqual(c,this.toLocalBackupResource(h))?this.userDataSyncBackupStoreService.resolveContent(this.resource,h):null}async resolvePreviewContent(c){const h=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(h)for(const g of h.resourcePreviews){if(this.extUri.isEqual(g.acceptedResource,c))return g.acceptResult?g.acceptResult.content:null;if(this.extUri.isEqual(g.remoteResource,c))return g.remoteContent;if(this.extUri.isEqual(g.localResource,c))return g.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(c,h,g,R,_){const U=await this.isRemoteDataFromCurrentMachine(c),F=await this.generateSyncPreview(c,h,U,R,_),k=[];for(const M of F){const $=M.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(M.localChange===0&&M.remoteChange===0)k.push({...M,acceptedResource:$,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=g?await this.getMergeResult(M,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile(M.previewResource,L.VSBuffer.fromString(x?.content||""));const z=x&&!x.hasConflicts?await this.getAcceptResult(M,M.previewResource,void 0,_):void 0;k.push({...M,acceptResult:z,mergeState:x?.hasConflicts?"conflict":z?"accepted":"preview",localChange:z?z.localChange:x?x.localChange:M.localChange,remoteChange:z?z.remoteChange:x?x.remoteChange:M.remoteChange})}}return{remoteUserData:c,lastSyncUserData:h,resourcePreviews:k,isLastSyncFromCurrentMachine:U}}async getLastSyncUserData(){try{const c=await this.fileService.readFile(this.lastSyncResource),h=JSON.parse(c.value.toString()),g=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=h.version&&g&&h.version!==g,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${h.version} is not compatible with current sync state version ${g}.`),await this.resetLocal(),null;const R=h;if(R.content===null)return{ref:h.ref,syncData:null};const _=JSON.parse(R.content);if(i(_))return{...h,syncData:_,content:void 0}}catch(c){c instanceof v.FileOperationError&&c.fileOperationResult===1||this.logService.error(c)}return null}async updateLastSyncUserData(c,h={}){if(h.ref||h.content||h.version)throw new Error("Cannot have core properties as additional");const g=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),R={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,version:g,...h};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(R)))}async getRemoteUserData(c){const{ref:h,content:g}=await this.getUserData(c);let R=null;return g!==null&&(R=this.parseSyncData(g)),{ref:h,syncData:R}}parseSyncData(c){try{const h=JSON.parse(c);if(i(h))return h}catch(h){this.logService.error(h)}throw new l.UserDataSyncError((0,f.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(c){if((0,P.isString)(c)){const h=await this.userDataSyncStoreService.resolveContent(this.resource,c);return{ref:c,content:h}}else{const h=c?{ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,h,this.syncHeaders)}}async updateRemoteUserData(c,h){const g=await this.currentMachineIdPromise,R={version:this.version,machineId:g,content:c};return h=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(R),h,this.syncHeaders),{ref:h,syncData:R}}async backupLocal(c){const h={version:this.version,content:c};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(h))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};a=he([J(1,v.IFileService),J(2,u.IEnvironmentService),J(3,w.IStorageService),J(4,l.IUserDataSyncStoreService),J(5,l.IUserDataSyncBackupStoreService),J(6,l.IUserDataSyncEnablementService),J(7,y.ITelemetryService),J(8,l.IUserDataSyncLogService),J(9,S.IConfigurationService),J(10,p.IUriIdentityService)],a),e.AbstractSynchroniser=a;let r=class extends a{constructor(c,h,g,R,_,U,F,k,M,$,x,z){super(h,g,R,_,U,F,k,M,$,x,z);this.file=c,this._register(this.fileService.watch(this.extUri.dirname(c))),this._register(this.fileService.onDidFilesChange(G=>this.onFileChanges(G)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(c,h,g){try{h?await this.fileService.writeFile(this.file,L.VSBuffer.fromString(c),g?void 0:h):await this.fileService.createFile(this.file,L.VSBuffer.fromString(c),{overwrite:g})}catch(R){throw R instanceof v.FileOperationError&&R.fileOperationResult===1||R instanceof v.FileOperationError&&R.fileOperationResult===3?new l.UserDataSyncError(R.message,"LocalPreconditionFailed"):R}}onFileChanges(c){!c.contains(this.file)||this.triggerLocalChange()}};r=he([J(2,v.IFileService),J(3,u.IEnvironmentService),J(4,w.IStorageService),J(5,l.IUserDataSyncStoreService),J(6,l.IUserDataSyncBackupStoreService),J(7,l.IUserDataSyncEnablementService),J(8,y.ITelemetryService),J(9,l.IUserDataSyncLogService),J(10,S.IConfigurationService),J(11,p.IUriIdentityService)],r),e.AbstractFileSynchroniser=r;let t=class extends r{constructor(c,h,g,R,_,U,F,k,M,$,x,z,G){super(c,h,g,R,_,U,F,k,M,$,z,G);this.userDataSyncUtilService=x,this._formattingOptions=void 0}hasErrors(c){const h=[];return(0,I.parse)(c,h,{allowEmptyContent:!0,allowTrailingComma:!0}),h.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};t=he([J(2,v.IFileService),J(3,u.IEnvironmentService),J(4,w.IStorageService),J(5,l.IUserDataSyncStoreService),J(6,l.IUserDataSyncBackupStoreService),J(7,l.IUserDataSyncEnablementService),J(8,y.ITelemetryService),J(9,l.IUserDataSyncLogService),J(10,l.IUserDataSyncUtilService),J(11,S.IConfigurationService),J(12,p.IUriIdentityService)],t),e.AbstractJsonFileSynchroniser=t;let o=class{constructor(c,h,g,R,_){this.resource=c,this.environmentService=h,this.logService=g,this.fileService=R,this.extUri=_.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,h,this.extUri)}async initialize({ref:c,content:h}){if(!h){this.logService.info("Remote content does not exist.",this.resource);return}const g=this.parseSyncData(h);if(!!g)try{await this.doInitialize({ref:c,syncData:g})}catch(R){this.logService.error(R)}}parseSyncData(c){try{const h=JSON.parse(c);if(i(h))return h}catch(h){this.logService.error(h)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(c,h={}){const g={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,...h};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(g)))}};o=he([J(1,u.IEnvironmentService),J(2,d.ILogService),J(3,v.IFileService),J(4,p.IUriIdentityService)],o),e.AbstractInitializer=o}),define(te[228],ne([0,1,5,23,9,3,49,27,7,20,13,30,31,63,14,8,24,21,34,47,225,98,25]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S,u,v,d,m,w,y,p,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function a(o,s){const c=JSON.parse(o.content);if(o.version===1||o.version===2){const h=(await s.getInstalled(0)).filter(g=>g.isBuiltin);for(const g of c)o.version===1&&(g.enabled===!1&&(g.disabled=!0),delete g.enabled),o.version===2&&h.every(R=>!(0,f.areSameExtensions)(R.identifier,g.identifier))&&(g.installed=!0)}return c}let r=class mt extends y.AbstractSynchroniser{constructor(s,c,h,g,R,_,U,F,k,M,$,x,z,G,ee){super("extensions",c,s,h,g,R,x,z,k,$,ee);this.extensionManagementService=_,this.extensionEnablementService=U,this.ignoredExtensionsManagementService=F,this.extensionGalleryService=M,this.extensionStorageService=G,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,q=>q.some(({local:j})=>!!j)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,q=>!q.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(s,c){const h=s.syncData?await a(s.syncData,this.extensionManagementService):null,g=c?.skippedExtensions||[],R=c?.syncData?await a(c.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(void 0,!0),U=this.getLocalExtensions(_),F=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);h?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:k,remote:M}=(0,p.merge)(U,h,R,g,F),$={local:k,remote:M,content:this.getPreviewContent(U,k.added,k.updated,k.removed),localChange:k.added.length>0||k.removed.length>0||k.updated.length>0?2:0,remoteChange:M!==null?2:0};return[{skippedExtensions:g,localResource:this.localResource,localContent:this.stringify(U,!1),localExtensions:U,remoteResource:this.remoteResource,remoteContent:h?this.stringify(h,!1):null,previewResource:this.previewResource,previewResult:$,localChange:$.localChange,remoteChange:$.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const c=s.syncData?await a(s.syncData,this.extensionManagementService):null,h=await this.extensionManagementService.getInstalled(void 0,!0),g=this.getLocalExtensions(h),R=this.ignoredExtensionsManagementService.getIgnoredExtensions(h),{remote:_}=(0,p.merge)(g,c,c,s.skippedExtensions||[],R);return _!==null}getPreviewContent(s,c,h,g){const R=[...c,...h],_=new Set,U=F=>{_.add(F.id.toLowerCase()),F.uuid&&_.add(F.uuid)};R.forEach(({identifier:F})=>U(F)),g.forEach(U);for(const F of s)_.has(F.identifier.id.toLowerCase())||F.identifier.uuid&&_.has(F.identifier.uuid)||R.push(F);return this.stringify(R,!1)}async getMergeResult(s,c){return{...s.previewResult,hasConflicts:!1}}async getAcceptResult(s,c,h,g){if(this.extUri.isEqual(c,this.localResource))return this.acceptLocal(s);if(this.extUri.isEqual(c,this.remoteResource))return this.acceptRemote(s);if(this.extUri.isEqual(c,this.previewResource))return s.previewResult;throw new Error(`Invalid Resource: ${c.toString()}`)}async acceptLocal(s){const c=await this.extensionManagementService.getInstalled(),h=this.ignoredExtensionsManagementService.getIgnoredExtensions(c),g=(0,p.merge)(s.localExtensions,null,null,s.skippedExtensions,h),{local:R,remote:_}=g;return{content:s.localContent,local:R,remote:_,localChange:R.added.length>0||R.removed.length>0||R.updated.length>0?2:0,remoteChange:_!==null?2:0}}async acceptRemote(s){const c=await this.extensionManagementService.getInstalled(),h=this.ignoredExtensionsManagementService.getIgnoredExtensions(c),g=s.remoteContent?JSON.parse(s.remoteContent):null;if(g!==null){const R=(0,p.merge)(s.localExtensions,g,s.localExtensions,[],h),{local:_,remote:U}=R;return{content:s.remoteContent,local:_,remote:U,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:s.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(s,c,h,g){let{skippedExtensions:R,localExtensions:_}=h[0][0],{local:U,remote:F,localChange:k,remoteChange:M}=h[0][1];if(k===0&&M===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),k!==0&&(await this.backupLocal(JSON.stringify(_)),R=await this.updateLocalExtensions(U.added,U.removed,U.updated,R)),F){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const $=JSON.stringify(F.all);s=await this.updateRemoteUserData($,g?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${F.added.length?` Added: ${JSON.stringify(F.added.map(x=>x.identifier.id))}.`:""}${F.updated.length?` Updated: ${JSON.stringify(F.updated.map(x=>x.identifier.id))}.`:""}${F.removed.length?` Removed: ${JSON.stringify(F.removed.map(x=>x.identifier.id))}.`:""}`)}c?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(s,{skippedExtensions:R}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${R.length?` Skipped: ${JSON.stringify(R.map($=>$.identifier.id))}.`:""}`))}async getAssociatedResources({uri:s}){return[{resource:this.extUri.joinPath(s,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(s){if(this.extUri.isEqual(s,mt.EXTENSIONS_DATA_URI)){const h=await this.extensionManagementService.getInstalled(),g=this.ignoredExtensionsManagementService.getIgnoredExtensions(h),R=this.getLocalExtensions(h).filter(_=>!g.some(U=>(0,f.areSameExtensions)({id:U},_.identifier)));return this.stringify(R,!0)}if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)){const h=await this.resolvePreviewContent(s);return h&&this.stringify(JSON.parse(h),!0)}let c=await super.resolveContent(s);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(s)),c){const h=this.parseSyncData(c);if(h)switch(this.extUri.basename(s)){case"extensions.json":return this.stringify(this.parseExtensions(h),!0)}}return null}stringify(s,c){return s.sort((h,g)=>!h.identifier.uuid&&g.identifier.uuid?-1:h.identifier.uuid&&!g.identifier.uuid?1:(0,I.compare)(h.identifier.id,g.identifier.id)),c?(0,A.toFormattedString)(s,{}):JSON.stringify(s)}async hasLocalData(){try{const s=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(s).some(h=>h.installed||h.disabled))return!0}catch{}return!1}async updateLocalExtensions(s,c,h,g){const R=[],_=[],U=await this.extensionManagementService.getInstalled();if(c.length){const k=U.filter(({identifier:M,isBuiltin:$})=>!$&&c.some(x=>(0,f.areSameExtensions)(M,x)));await D.Promises.settled(k.map(async M=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,M.identifier.id),await this.extensionManagementService.uninstall(M,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,M.identifier.id),R.push(M.identifier)}))}(s.length||h.length)&&await D.Promises.settled([...s,...h].map(async k=>{const M=U.find(x=>(0,f.areSameExtensions)(x.identifier,k.identifier));if(M&&M.isBuiltin){k.state&&M.manifest.version===k.version&&this.updateExtensionState(k.state,M,M.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(z=>(0,f.areSameExtensions)(z,k.identifier))!==!!k.disabled&&(k.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,k.identifier.id),await this.extensionEnablementService.disableExtension(k.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,k.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,k.identifier.id),await this.extensionEnablementService.enableExtension(k.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,k.identifier.id))),R.push(k.identifier);return}const $=(await this.extensionGalleryService.getExtensions([{...k.identifier,includePreRelease:k.preRelease}],n.CancellationToken.None))[0];if(k.state&&(M?M.manifest.version===k.version:!!$)&&this.updateExtensionState(k.state,M||$,M?.manifest.version),$)try{this.extensionEnablementService.getDisabledExtensions().some(z=>(0,f.areSameExtensions)(z,k.identifier))!==!!k.disabled&&(k.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,k.identifier.id,$.version),await this.extensionEnablementService.disableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,k.identifier.id,$.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,k.identifier.id,$.version),await this.extensionEnablementService.enableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,k.identifier.id,$.version))),(!M||M.preRelease!==k.preRelease)&&(await this.extensionManagementService.canInstall($)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,k.identifier.id,$.version),await this.extensionManagementService.installFromGallery($,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:k.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,k.identifier.id,$.version),R.push($.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,$.displayName||$.identifier.id),_.push(k)))}catch(x){_.push(k),x instanceof C.ExtensionManagementError&&[C.ExtensionManagementErrorCode.Incompatible,C.ExtensionManagementErrorCode.IncompatiblePreRelease,C.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(x.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,$.displayName||$.identifier.id):(this.logService.error(x),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,$.displayName||$.identifier.id))}else _.push(k),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,k.identifier.id)}));const F=[];for(const k of g)R.some(M=>(0,f.areSameExtensions)(M,k.identifier))||F.push(k);for(const k of _)F.some(M=>(0,f.areSameExtensions)(M.identifier,k.identifier))||F.push(k);return F}updateExtensionState(s,c,h){const g=this.extensionStorageService.getExtensionState(c,!0)||{},R=h?this.extensionStorageService.getKeysForSync({id:c.identifier.id,version:h}):void 0;R?R.forEach(_=>{g[_]=s[_]}):Object.keys(s).forEach(_=>g[_]=s[_]),this.extensionStorageService.setExtensionState(c,g,!0)}parseExtensions(s){return JSON.parse(s.content)}getLocalExtensions(s){const c=this.extensionEnablementService.getDisabledExtensions();return s.map(h=>{const{identifier:g,isBuiltin:R,manifest:_,preRelease:U}=h,F={identifier:g,preRelease:U,version:_.version};c.some(k=>(0,f.areSameExtensions)(k,g))&&(F.disabled=!0),R||(F.installed=!0);try{const k=this.extensionStorageService.getKeysForSync({id:g.id,version:_.version});if(k){const M=this.extensionStorageService.getExtensionState(h,!0)||{};F.state=Object.keys(M).reduce(($,x)=>(k.includes(x)&&($[x]=M[x]),$),{})}}catch(k){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,L.getErrorMessage)(k))}return F})}};r.EXTENSIONS_DATA_URI=b.URI.from({scheme:i.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),r=he([J(0,P.IEnvironmentService),J(1,u.IFileService),J(2,d.IStorageService),J(3,i.IUserDataSyncStoreService),J(4,i.IUserDataSyncBackupStoreService),J(5,C.IExtensionManagementService),J(6,C.IGlobalExtensionEnablementService),J(7,l.IIgnoredExtensionsManagementService),J(8,i.IUserDataSyncLogService),J(9,C.IExtensionGalleryService),J(10,E.IConfigurationService),J(11,i.IUserDataSyncEnablementService),J(12,m.ITelemetryService),J(13,S.IExtensionStorageService),J(14,w.IUriIdentityService)],r),e.ExtensionsSynchroniser=r;let t=class extends y.AbstractInitializer{constructor(s,c,h,g,R,_){super("extensions",g,R,h,_);this.extensionManagementService=s,this.ignoredExtensionsManagementService=c}async parseExtensions(s){return s.syncData?await a(s.syncData,this.extensionManagementService):null}generatePreview(s,c){const h=[],g=[],R=[];for(const _ of s){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(_.identifier.id))continue;const U=c.find(F=>(0,f.areSameExtensions)(F.identifier,_.identifier));U?(h.push(U),_.disabled&&R.push(_.identifier)):_.installed&&(g.push(_.identifier),_.disabled&&R.push(_.identifier))}return{installedExtensions:h,newExtensions:g,disabledExtensions:R,remoteExtensions:s}}};t=he([J(0,C.IExtensionManagementService),J(1,l.IIgnoredExtensionsManagementService),J(2,u.IFileService),J(3,P.IEnvironmentService),J(4,v.ILogService),J(5,w.IUriIdentityService)],t),e.AbstractExtensionsInitializer=t}),define(te[229],ne([0,1,28,25]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(I,b,E,P,C){if(!b)return{remote:Object.keys(I).length>0?I:null,local:{added:{},removed:[],updated:{}}};const f=T(I,b);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const S=E?T(E,b):{added:Object.keys(b).reduce((w,y)=>(w.add(y),w),new Set),removed:new Set,updated:new Set},u=E?T(E,I):{added:Object.keys(I).reduce((w,y)=>(w.add(y),w),new Set),removed:new Set,updated:new Set},v={added:{},removed:[],updated:{}},d=D.deepClone(b),m=!E;for(const w of u.added.values())w!==n.SYNC_SERVICE_URL_TYPE&&m&&S.added.has(w)||(d[w]=I[w]);for(const w of u.updated.values())d[w]=I[w];for(const w of u.removed.values())P.unregistered.includes(w)||delete d[w];for(const w of S.added.values()){const y=b[w];if(P.machine.includes(w)){C.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(E&&u.added.has(w))continue;const p=I[w];p&&p.value===y.value||w===n.SYNC_SERVICE_URL_TYPE&&m&&u.added.has(w)||(p?v.updated[w]=y:v.added[w]=y)}for(const w of S.updated.values()){const y=b[w];if(P.machine.includes(w)){C.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(u.updated.has(w)||u.removed.has(w))continue;const p=I[w];p&&p.value===y.value||(v.updated[w]=y)}for(const w of S.removed.values()){if(P.machine.includes(w)){C.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}u.updated.has(w)||u.removed.has(w)||v.removed.push(w)}return{local:v,remote:A(d,b)?null:d}}e.merge=L;function T(I,b){const E=Object.keys(I),P=Object.keys(b),C=P.filter(u=>E.indexOf(u)===-1).reduce((u,v)=>(u.add(v),u),new Set),f=E.filter(u=>P.indexOf(u)===-1).reduce((u,v)=>(u.add(v),u),new Set),S=new Set;for(const u of E){if(f.has(u))continue;const v=I[u],d=b[u];D.equals(v,d)||S.add(u)}return{added:C,removed:f,updated:S}}function A(I,b){const{added:E,removed:P,updated:C}=T(I,b);return E.size===0&&P.size===0&&C.size===0}}),define(te[230],ne([0,1,17,9,3,35,49,4,7,29,20,13,14,8,46,24,21,34,47,53,229,25]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S,u,v,d,m,w,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const i="globalState.argv.",a=["locale"];function r(h,g){const R=h.storage?Object.keys(h.storage).sort():[],_={};return R.forEach(U=>_[U]=h.storage[U]),h.storage=_,g?(0,A.toFormattedString)(h,{}):JSON.stringify(h)}const t=1;let o=class vt extends w.AbstractSynchroniser{constructor(g,R,_,U,F,k,M,$,x,z){super("globalState",g,F,x,R,_,k,M,U,$,z);this.storageService=x,this.version=t,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(g.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(g.onDidFilesChange,G=>G.contains(this.environmentService.argvResource)),L.Event.filter(x.onDidChangeValue,G=>G.scope===0&&G.target!==void 0?G.target===0:x.keys(0,0).includes(G.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(g,R,_){const U=g.syncData?JSON.parse(g.syncData.content):null;R=R===null&&_?g:R;const F=R&&R.syncData?JSON.parse(R.syncData.content):null,k=await this.getLocalGlobalState();U?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const M=this.getStorageKeys(F),{local:$,remote:x}=(0,p.merge)(k.storage,U?U.storage:null,F?F.storage:null,M,this.logService),z={content:null,local:$,remote:x,localChange:Object.keys($.added).length>0||Object.keys($.updated).length>0||$.removed.length>0?2:0,remoteChange:x!==null?2:0};return[{localResource:this.localResource,localContent:r(k,!1),localUserData:k,remoteResource:this.remoteResource,remoteContent:U?r(U,!1):null,previewResource:this.previewResource,previewResult:z,localChange:z.localChange,remoteChange:z.remoteChange,acceptedResource:this.acceptedResource,storageKeys:M}]}async hasRemoteChanged(g){const R=g.syncData?JSON.parse(g.syncData.content):null;if(R===null)return!0;const _=await this.getLocalGlobalState(),U=this.getStorageKeys(R),{remote:F}=(0,p.merge)(_.storage,R.storage,R.storage,U,this.logService);return F!==null}async getMergeResult(g,R){return{...g.previewResult,hasConflicts:!1}}async getAcceptResult(g,R,_,U){if(this.extUri.isEqual(R,this.localResource))return this.acceptLocal(g);if(this.extUri.isEqual(R,this.remoteResource))return this.acceptRemote(g);if(this.extUri.isEqual(R,this.previewResource))return g.previewResult;throw new Error(`Invalid Resource: ${R.toString()}`)}async acceptLocal(g){return{content:g.localContent,local:{added:{},removed:[],updated:{}},remote:g.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(g){if(g.remoteContent!==null){const R=JSON.parse(g.remoteContent),{local:_,remote:U}=(0,p.merge)(g.localUserData.storage,R.storage,null,g.storageKeys,this.logService);return{content:g.remoteContent,local:_,remote:U,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:g.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(g,R,_,U){let{localUserData:F}=_[0][0],{local:k,remote:M,localChange:$,remoteChange:x}=_[0][1];if($===0&&x===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),$!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(F)),await this.writeLocalGlobalState(k),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),x!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const z=JSON.stringify({storage:M});g=await this.updateRemoteUserData(z,U?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}R?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:g}){return[{resource:this.extUri.joinPath(g,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent(g){if(this.extUri.isEqual(g,vt.GLOBAL_STATE_DATA_URI)){const _=await this.getLocalGlobalState();return r(_,!0)}if(this.extUri.isEqual(this.remoteResource,g)||this.extUri.isEqual(this.localResource,g)||this.extUri.isEqual(this.acceptedResource,g)){const _=await this.resolvePreviewContent(g);return _&&r(JSON.parse(_),!0)}let R=await super.resolveContent(g);if(R)return R;if(R=await super.resolveContent(this.extUri.dirname(g)),R){const _=this.parseSyncData(R);if(_)switch(this.extUri.basename(g)){case"globalState.json":return r(JSON.parse(_.content),!0)}}return null}async hasLocalData(){try{const{storage:g}=await this.getLocalGlobalState();if(Object.keys(g).length>1||g[`${i}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const g={},R=await this.getLocalArgvContent(),_=(0,T.parse)(R);for(const U of a)_[U]!==void 0&&(g[`${i}${U}`]={version:1,value:_[U]});for(const U of this.storageService.keys(0,0)){const F=this.storageService.get(U,0);F&&(g[U]={version:1,value:F})}return{storage:g}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const g=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),g.value.toString()}catch(g){this.logService.debug((0,n.getErrorMessage)(g))}return"{}"}async writeLocalGlobalState({added:g,removed:R,updated:_}){const U={},F={},k=($,x)=>{for(const z of $){if(z.startsWith(i)){U[z.substring(i.length)]=x?x[z].value:void 0;continue}if(x){const G=x[z];G.value!==String(this.storageService.get(z,0))&&(F[z]=G.value)}else this.storageService.get(z,0)!==void 0&&(F[z]=void 0)}};if(k(Object.keys(g),g),k(Object.keys(_),_),k(R),Object.keys(U).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(U),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(F).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const $ of Object.keys(F))this.storageService.store($,F[$],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(F))}}async updateArgv(g){const R=await this.getLocalArgvContent();let _=R;for(const U of Object.keys(g))_=(0,y.edit)(_,[U],g[U],{});R!==_&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(_)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(g){const R=this.storageService.keys(0,0),_=this.storageService.keys(0,1),U=[...R,..._],F=g?.storage?Object.keys(g.storage).filter(k=>!k.startsWith(i)&&!U.includes(k)&&this.storageService.get(k,0)!==void 0):[];if(!I.isWeb){const k=[...l.ALL_SYNC_RESOURCES.map(M=>(0,l.getEnablementKey)(M)),l.SYNC_SERVICE_URL_TYPE];F.push(...k),_.push(...k)}return{user:R,machine:_,unregistered:F}}};o.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=he([J(0,f.IFileService),J(1,l.IUserDataSyncStoreService),J(2,l.IUserDataSyncBackupStoreService),J(3,l.IUserDataSyncLogService),J(4,C.IEnvironmentService),J(5,l.IUserDataSyncEnablementService),J(6,d.ITelemetryService),J(7,P.IConfigurationService),J(8,v.IStorageService),J(9,m.IUriIdentityService)],o),e.GlobalStateSynchroniser=o;let s=class extends w.AbstractInitializer{constructor(g,R,_,U,F){super("globalState",_,U,R,F);this.storageService=g}async doInitialize(g){const R=g.syncData?JSON.parse(g.syncData.content):null;if(!R){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const _={},U={};for(const F of Object.keys(R.storage))F.startsWith(i)?_[F.substring(i.length)]=R.storage[F].value:this.storageService.get(F,0)===void 0&&(U[F]=R.storage[F].value);if(Object.keys(_).length){let F="{}";try{F=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const k of Object.keys(_))F=(0,y.edit)(F,[k],_[k],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(F))}if(Object.keys(U).length)for(const F of Object.keys(U))this.storageService.store(F,U[F],0,0)}};s=he([J(0,v.IStorageService),J(1,f.IFileService),J(2,C.IEnvironmentService),J(3,l.IUserDataSyncLogService),J(4,m.IUriIdentityService)],s),e.GlobalStateInitializer=s;let c=class{constructor(g,R,_,U,F){this.userDataSyncStoreClient=g,this.storageService=R,this.environmentService=_,this.fileService=U,this.logService=F}getSyncStoreType(g){return this.parseGlobalState(g)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync(g){const R=(0,l.createSyncHeaders)((0,E.generateUuid)());try{return await this.doSync(g,R)}catch(_){if(_ instanceof l.UserDataSyncError)switch(_.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(g,R)}throw _}}async doSync(g,R){const _=await this.userDataSyncStoreClient.read("globalState",null,R),U=this.parseGlobalState(_)||{storage:{}};U.storage[l.SYNC_SERVICE_URL_TYPE]={value:g,version:t};const F=await(0,u.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),k={version:t,machineId:F,content:r(U,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(k),_.ref,R)}parseGlobalState({content:g}){if(!g)return null;const R=JSON.parse(g);if((0,w.isSyncData)(R))return R?JSON.parse(R.content):null;throw new Error("Invalid remote data")}};c=he([J(1,v.IStorageService),J(2,C.IEnvironmentService),J(3,f.IFileService),J(4,S.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(te[231],ne([0,1,16,17,3,35,4,15,144,20,13,14,24,21,34,47,226,25]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S,u,v,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(l,i,a){try{const r=JSON.parse(l);if(!i)return(0,I.isUndefined)(r.all)?null:r.all;switch(A.OS){case 2:return(0,I.isUndefined)(r.mac)?null:r.mac;case 3:return(0,I.isUndefined)(r.linux)?null:r.linux;case 1:return(0,I.isUndefined)(r.windows)?null:r.windows}}catch(r){return a.error(r),null}}e.getKeybindingsContentFromSyncContent=w;let y=class extends v.AbstractJsonFileSynchroniser{constructor(i,a,r,t,o,s,c,h,g,R,_){super(c.keybindingsResource,"keybindings",s,c,h,i,a,o,R,r,g,t,_);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.filter(t.onDidChangeConfiguration,U=>U.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(i,a,r,t){const o=i.syncData?w(i.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;a=a===null&&r?i:a;const s=a?this.getKeybindingsContentFromLastSyncUserData(a):null,c=await this.getLocalFileContent(),h=await this.getFormattingOptions();let g=null,R=!1,_=!1,U=!1;if(o){let k=c?c.value.toString():"[]";if(k=k||"[]",this.hasErrors(k))throw new m.UserDataSyncError((0,b.localize)(0,null),"LocalInvalidContent",this.resource);if(!s||s!==k||s!==o){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const M=await(0,d.merge)(k,o,s,h,this.userDataSyncUtilService);M.hasChanges&&(g=M.mergeContent,U=M.hasConflicts,R=U||M.mergeContent!==k,_=U||M.mergeContent!==o)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),g=c.value.toString(),_=!0);const F={content:g,localChange:R?c?2:1:0,remoteChange:_?2:0,hasConflicts:U};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:o,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(i){const a=this.getKeybindingsContentFromLastSyncUserData(i);if(a===null)return!0;const r=await this.getLocalFileContent(),t=r?r.value.toString():"",o=await this.getFormattingOptions(),s=await(0,d.merge)(t||"[]",a,a,o,this.userDataSyncUtilService);return s.hasConflicts||s.mergeContent!==a}async getMergeResult(i,a){return i.previewResult}async getAcceptResult(i,a,r,t){if(this.extUri.isEqual(a,this.localResource))return{content:i.fileContent?i.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:i.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return r===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(i,a,r,t){const{fileContent:o}=r[0][0];let{content:s,localChange:c,remoteChange:h}=r[0][1];if(c===0&&h===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),s!==null&&(s=s.trim(),s=s||"[]",this.hasErrors(s)))throw new m.UserDataSyncError((0,b.localize)(1,null),"LocalInvalidContent",this.resource);if(c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),o&&await this.backupLocal(this.toSyncContent(o.value.toString())),await this.updateLocalFileContent(s||"[]",o,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),h!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const g=this.toSyncContent(s||"[]",i.syncData?.content);i=await this.updateRemoteUserData(g,t?null:i.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}a?.ref!==i.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(i,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const i=await this.getLocalFileContent();if(i){const a=(0,T.parse)(i.value.toString());if((0,D.isNonEmptyArray)(a))return!0}}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:i}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(i,"keybindings.json"),comparableResource:a}]}async resolveContent(i){if(this.extUri.isEqual(this.remoteResource,i)||this.extUri.isEqual(this.localResource,i)||this.extUri.isEqual(this.acceptedResource,i))return this.resolvePreviewContent(i);let a=await super.resolveContent(i);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(i)),a){const r=this.parseSyncData(a);if(r)switch(this.extUri.basename(i)){case"keybindings.json":return w(r.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(i){return!i.syncData||i.platformSpecific!==void 0&&i.platformSpecific!==this.syncKeybindingsPerPlatform()?null:w(i.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(i,a){let r={};try{r=JSON.parse(a||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=i,A.OS){case 2:r.mac=i;break;case 3:r.linux=i;break;case 1:r.windows=i;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};y=he([J(0,m.IUserDataSyncStoreService),J(1,m.IUserDataSyncBackupStoreService),J(2,m.IUserDataSyncLogService),J(3,E.IConfigurationService),J(4,m.IUserDataSyncEnablementService),J(5,C.IFileService),J(6,P.IEnvironmentService),J(7,f.IStorageService),J(8,m.IUserDataSyncUtilService),J(9,S.ITelemetryService),J(10,u.IUriIdentityService)],y),e.KeybindingsSynchroniser=y;let p=class extends v.AbstractInitializer{constructor(i,a,r,t){super("keybindings",a,r,i,t)}async doInitialize(i){const a=i.syncData?this.getKeybindingsContentFromSyncContent(i.syncData.content):null;if(!a){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,n.VSBuffer.fromString(a)),await this.updateLastSyncUserData(i)}async isEmpty(){try{const i=await this.fileService.readFile(this.environmentService.settingsResource),a=(0,T.parse)(i.value.toString());return!(0,D.isNonEmptyArray)(a)}catch(i){return i.fileOperationResult===1}}getKeybindingsContentFromSyncContent(i){try{return w(i,!0,this.logService)}catch(a){return this.logService.error(a),null}}};p=he([J(0,C.IFileService),J(1,P.IEnvironmentService),J(2,m.IUserDataSyncLogService),J(3,u.IUriIdentityService)],p),e.KeybindingsInitializer=p}),define(te[232],ne([0,1,16,35,69,49,28,53,25]),function(Y,e,D,n,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function E(s,c,h){let g=[];h?g=C(h):g=P(c);const R=[],_=[...(0,b.getDisallowedIgnoredSettings)()];if(Array.isArray(g))for(const U of g)U.startsWith("-")?_.push(U.substring(1)):R.push(U);return(0,D.distinct)([...s,...R].filter(U=>_.indexOf(U)===-1))}e.getIgnoredSettings=E;function P(s){let c=s.inspect("settingsSync.ignoredSettings").userValue;return c!==void 0||(c=s.inspect("sync.ignoredSettings").userValue,c!==void 0)?c:s.getValue("settingsSync.ignoredSettings")||[]}function C(s){const c=(0,n.parse)(s);return c?c["settingsSync.ignoredSettings"]||c["sync.ignoredSettings"]||[]:[]}function f(s,c,h,g){if(h.length){const R=o(c),_=(0,n.parse)(c),U=(0,n.parse)(s),F=[];for(const k of h){const M=_[k],$=U[k];M===void 0?s=I.edit(s,[k],void 0,g):$!==void 0?s=I.edit(s,[k],M,g):F.push(l(k,R))}F.sort((k,M)=>k.startOffset-M.startOffset),F.forEach(k=>s=m(k.setting.key,c,s,g))}return s}e.updateIgnoredSettings=f;function S(s,c,h,g,R,_){const U=f(s,c,g,_),F=h!==U,k=h!==c;if(!F&&!k)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!k)return{conflictsSettings:[],localContent:null,remoteContent:U,hasConflicts:!1};if(k&&!F)return{conflictsSettings:[],localContent:f(c,s,g,_),remoteContent:null,hasConflicts:!1};if(h===null&&v(s)){const W=u(s,c,g)?null:f(c,s,g,_);return{conflictsSettings:[],localContent:W,remoteContent:null,hasConflicts:!1}}let M=s,$=c;const x=(0,n.parse)(s),z=(0,n.parse)(c),G=h?(0,n.parse)(h):null,ee=g.reduce((W,H)=>(W.add(H),W),new Set),q=d(x,z,ee),j=d(G,x,ee),K=d(G,z,ee),V=new Map,Q=new Set,Z=W=>{Q.add(W);const H=R.filter(({key:re})=>re===W)[0];H?(M=I.edit(M,[W],H.value,_),$=I.edit($,[W],H.value,_)):V.set(W,{key:W,localValue:x[W],remoteValue:z[W]})};for(const W of j.removed.values())K.updated.has(W)?Z(W):$=I.edit($,[W],void 0,_);for(const W of K.removed.values())Q.has(W)||(j.updated.has(W)?Z(W):M=I.edit(M,[W],void 0,_));for(const W of j.updated.values())Q.has(W)||(K.updated.has(W)?q.updated.has(W)&&Z(W):$=I.edit($,[W],x[W],_));for(const W of K.updated.values())Q.has(W)||(j.updated.has(W)?q.updated.has(W)&&Z(W):M=I.edit(M,[W],z[W],_));for(const W of j.added.values())Q.has(W)||(K.added.has(W)?q.updated.has(W)&&Z(W):$=m(W,M,$,_));for(const W of K.added.values())Q.has(W)||(j.added.has(W)?q.updated.has(W)&&Z(W):M=m(W,$,M,_));const B=V.size>0||!u(M,$,g),O=B||!u(M,s,[]),N=B||!u($,c,[]);return{localContent:O?M:null,remoteContent:N?$:null,conflictsSettings:[...V.values()],hasConflicts:B}}e.merge=S;function u(s,c,h){if(s===c)return!0;const g=(0,n.parse)(s),R=(0,n.parse)(c),_=h.reduce((k,M)=>(k.add(M),k),new Set),U=o(s).filter(k=>!(k.setting&&_.has(k.setting.key))),F=o(c).filter(k=>!(k.setting&&_.has(k.setting.key)));if(U.length!==F.length)return!1;for(let k=0;k<U.length;k++){const M=U[k],$=F[k];if(M.setting&&$.setting){if(M.setting.key!==$.setting.key||!A.equals(g[M.setting.key],R[M.setting.key]))return!1}else if(!M.setting&&!$.setting){if(M.value!==$.value)return!1}else return!1}return!0}e.areSame=u;function v(s){return s?o(s).length===0:!0}e.isEmpty=v;function d(s,c,h){const g=s?Object.keys(s).filter(k=>!h.has(k)):[],R=Object.keys(c).filter(k=>!h.has(k)),_=R.filter(k=>g.indexOf(k)===-1).reduce((k,M)=>(k.add(M),k),new Set),U=g.filter(k=>R.indexOf(k)===-1).reduce((k,M)=>(k.add(M),k),new Set),F=new Set;if(s)for(const k of g){if(U.has(k))continue;const M=s[k],$=c[k];A.equals(M,$)||F.add(k)}return{added:_,removed:U,updated:F}}function m(s,c,h,g){const R=(0,n.parse)(c),_=o(c),U=o(h),F=w(s,_,U);return y(h,s,R[s],F,U,g)}e.addSetting=m;function w(s,c,h){const g=c.findIndex(_=>_.setting?.key===s),R=c[g-1];if(R){if(R.setting){const U=l(R.setting.key,h);if(U)return{index:h.indexOf(U),insertAfter:!0}}else{const U=i(g,c);if(U){const F=l(U.setting.key,h);if(F){const k=a(h.indexOf(F),h),M=r(c,U,c[g]);if(k){const $=r(h,F,k),x=t(M,$);return x?{index:h.indexOf(x),insertAfter:!0}:{index:h.indexOf(k),insertAfter:!1}}else{const $=r(h,F,h[h.length-1]),x=t(M,$);return x?{index:h.indexOf(x),insertAfter:!0}:{index:h.length-1,insertAfter:!0}}}}}const _=c[g+1];if(_)if(_.setting){const U=l(_.setting.key,h);if(U)return{index:h.indexOf(U),insertAfter:!1}}else{const U=a(g,c);if(U){const F=l(U.setting.key,h);if(F){const k=i(h.indexOf(F),h),M=r(c,c[g],U);if(k){const $=r(h,k,F),x=t(M.reverse(),$.reverse());return x?{index:h.indexOf(x),insertAfter:!1}:{index:h.indexOf(k),insertAfter:!0}}else{const $=r(h,h[0],F),x=t(M.reverse(),$.reverse());return x?{index:h.indexOf(x),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:h.length-1,insertAfter:!0}}function y(s,c,h,g,R,_){let U;return g.index===-1?U=(0,L.setProperty)(s,[c],h,_):U=p(s,c,h,g,R,_).map(F=>(0,L.withFormatting)(s,F,_)[0]),(0,L.applyEdits)(s,U)}function p(s,c,h,g,R,_){const U=`${JSON.stringify(c)}: ${JSON.stringify(h)}`,F=(0,T.getEOL)(_,s),k=R[g.index];if(g.insertAfter){const M=[];if(k.setting)M.push({offset:k.endOffset,length:0,content:","+U});else{const $=a(g.index,R),x=i(g.index,R),z=x?.setting?.commaOffset;x&&z===void 0&&M.push({offset:x.endOffset,length:0,content:","});const G=z!==void 0&&z>k.endOffset;M.push({offset:G?z+1:k.endOffset,length:0,content:$?F+U+",":F+U})}return M}else{if(k.setting)return[{offset:k.startOffset,length:0,content:U+","}];const M=(R[g.index-1]&&!R[g.index-1].setting?F:"")+U+(a(g.index,R)?",":"")+F;return[{offset:k.startOffset,length:0,content:M}]}}function l(s,c){return c.filter(h=>h.setting?.key===s)[0]}function i(s,c){for(let h=s-1;h>=0;h--)if(c[h].setting)return c[h]}function a(s,c){for(let h=s+1;h<c.length;h++)if(c[h].setting)return c[h]}function r(s,c,h){const g=s.indexOf(c),R=s.indexOf(h);return s.filter((_,U)=>g<U&&U<R)}function t(s,c){if(s.length&&c.length){let h=0;for(;h<c.length&&h<s.length;h++)if(s[h].value!==c[h].value)return c[h-1];return c[h-1]}}function o(s){const c=[];let h=-1,g,R;const _={onObjectBegin:U=>{h++},onObjectProperty:(U,F,k)=>{h===0&&(g=F,R=U)},onObjectEnd:(U,F)=>{h--,h===0&&c.push({startOffset:g,endOffset:U+F,value:s.substring(g,U+F),setting:{key:R,commaOffset:void 0}})},onArrayBegin:(U,F)=>{h++},onArrayEnd:(U,F)=>{h--,h===0&&c.push({startOffset:g,endOffset:U+F,value:s.substring(g,U+F),setting:{key:R,commaOffset:void 0}})},onLiteralValue:(U,F,k)=>{h===0&&c.push({startOffset:g,endOffset:F+k,value:s.substring(g,F+k),setting:{key:R,commaOffset:void 0}})},onSeparator:(U,F,k)=>{if(h===0&&U===","){let M=c.length-1;for(;M>=0&&!c[M].setting;M--);const $=c[M];$&&c.splice(M,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:F}})}},onComment:(U,F)=>{h===0&&c.push({startOffset:U,endOffset:U+F,value:s.substring(U,U+F)})}};return(0,n.visit)(s,_),c}}),define(te[233],ne([0,1,17,3,145,20,89,13,30,14,24,21,34,47,53,232,25]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S,u,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function m(l){return l&&l.settings&&typeof l.settings=="string"&&Object.keys(l).length===1}function w(l){const i=JSON.parse(l);return m(i)?i:{settings:l}}e.parseSettingsSyncContent=w;let y=class extends S.AbstractJsonFileSynchroniser{constructor(i,a,r,t,o,s,c,h,g,R,_,U){super(a.settingsResource,"settings",i,a,r,t,o,g,R,s,c,h,U);this.extensionManagementService=_,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(i){const a=await this.getLastSyncUserData(),r=await this.getLatestRemoteUserData(i,a),t=this.getSettingsSyncContent(r),o=new A.ConfigurationModelParser(d.USER_DATA_SYNC_CONFIGURATION_SCOPE);return t?.settings&&o.parse(t.settings),o.configurationModel.getValue(d.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(i,a,r){const t=await this.getLocalFileContent(),o=await this.getFormattingOptions(),s=this.getSettingsSyncContent(i);a=a===null&&r?i:a;const c=a?this.getSettingsSyncContent(a):null,h=await this.getIgnoredSettings();let g=null,R=!1,_=!1,U=!1;if(s){let k=t?t.value.toString().trim():"{}";k=k||"{}",this.validateContent(k),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const M=(0,v.merge)(k,s.settings,c?c.settings:null,h,[],o);g=M.localContent||M.remoteContent,R=M.localContent!==null,_=M.remoteContent!==null,U=M.hasConflicts}else t&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),g=t.value.toString(),_=!0);const F={content:g,localChange:R?2:0,remoteChange:_?2:0,hasConflicts:U};return[{fileContent:t,localResource:this.localResource,localContent:t?t.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:s?s.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(i){const a=this.getSettingsSyncContent(i);if(a===null)return!0;const r=await this.getLocalFileContent(),t=r?r.value.toString().trim():"",o=await this.getIgnoredSettings(),s=await this.getFormattingOptions();return(0,v.merge)(t||"{}",a.settings,a.settings,o,[],s).remoteContent!==null}async getMergeResult(i,a){const r=await this.getFormattingOptions(),t=await this.getIgnoredSettings();return{...i.previewResult,content:i.previewResult.content?(0,v.updateIgnoredSettings)(i.previewResult.content,"{}",t,r):null}}async getAcceptResult(i,a,r,t){const o=await this.getFormattingOptions(),s=await this.getIgnoredSettings();if(this.extUri.isEqual(a,this.localResource))return{content:i.fileContent?(0,v.updateIgnoredSettings)(i.fileContent.value.toString(),"{}",s,o):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:i.remoteContent!==null?(0,v.updateIgnoredSettings)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",s,o):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return r===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:r!==null?(0,v.updateIgnoredSettings)(r,i.fileContent?i.fileContent.value.toString():"{}",s,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(i,a,r,t){const{fileContent:o}=r[0][0];let{content:s,localChange:c,remoteChange:h}=r[0][1];if(c===0&&h===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),s=s?s.trim():"{}",s=s||"{}",this.validateContent(s),c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),o&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(o.value.toString()))),await this.updateLocalFileContent(s,o,t),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),h!==0){const g=await this.getFormattingOptions(),R=this.getSettingsSyncContent(i),_=await this.getIgnoredSettings(s);s=(0,v.updateIgnoredSettings)(s,R?R.settings:"{}",_,g),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),i=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(s)),t?null:i.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}a?.ref!==i.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(i),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.getLocalFileContent();if(i){const a=await this.getFormattingOptions(),r=(0,u.edit)(i.value.toString(),[d.CONFIGURATION_SYNC_STORE_KEY],void 0,a);return!(0,v.isEmpty)(r)}}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:i}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(i,"settings.json"),comparableResource:a}]}async resolveContent(i){if(this.extUri.isEqual(this.remoteResource,i)||this.extUri.isEqual(this.localResource,i)||this.extUri.isEqual(this.acceptedResource,i))return this.resolvePreviewContent(i);let a=await super.resolveContent(i);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(i)),a){const r=this.parseSyncData(a);if(r){const t=this.parseSettingsSyncContent(r.content);if(t)switch(this.extUri.basename(i)){case"settings.json":return t.settings}}}return null}async resolvePreviewContent(i){let a=await super.resolvePreviewContent(i);if(a){const r=await this.getFormattingOptions(),t=await this.getIgnoredSettings();a=(0,v.updateIgnoredSettings)(a,"{}",t,r)}return a}getSettingsSyncContent(i){return i.syncData?this.parseSettingsSyncContent(i.syncData.content):null}parseSettingsSyncContent(i){try{return w(i)}catch(a){this.logService.error(a)}return null}toSettingsSyncContent(i){return{settings:i}}async getIgnoredSettings(i){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const r=n.Event.any(n.Event.filter(this.extensionManagementService.onDidInstallExtensions,t=>t.some(({local:o})=>!!o)),n.Event.filter(this.extensionManagementService.onDidUninstallExtension,t=>!t.error))(()=>{r.dispose(),this._defaultIgnoredSettings=void 0})}const a=await this._defaultIgnoredSettings;return(0,v.getIgnoredSettings)(a,this.configurationService,i)}validateContent(i){if(this.hasErrors(i))throw new d.UserDataSyncError((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};y=he([J(0,E.IFileService),J(1,I.IEnvironmentService),J(2,P.IStorageService),J(3,d.IUserDataSyncStoreService),J(4,d.IUserDataSyncBackupStoreService),J(5,d.IUserDataSyncLogService),J(6,d.IUserDataSyncUtilService),J(7,T.IConfigurationService),J(8,d.IUserDataSyncEnablementService),J(9,C.ITelemetryService),J(10,b.IExtensionManagementService),J(11,f.IUriIdentityService)],y),e.SettingsSynchroniser=y;let p=class extends S.AbstractInitializer{constructor(i,a,r,t){super("settings",a,r,i,t)}async doInitialize(i){const a=i.syncData?this.parseSettingsSyncContent(i.syncData.content):null;if(!a){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(a.settings)),await this.updateLastSyncUserData(i)}async isEmpty(){try{const i=await this.fileService.readFile(this.environmentService.settingsResource);return(0,v.isEmpty)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}parseSettingsSyncContent(i){try{return w(i)}catch(a){this.logService.error(a)}return null}};p=he([J(0,E.IFileService),J(1,I.IEnvironmentService),J(2,d.IUserDataSyncLogService),J(3,f.IUriIdentityService)],p),e.SettingsInitializer=p}),define(te[234],ne([0,1,17,3,28,20,13,14,24,21,34,47,227,25]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let u=class extends C.AbstractSynchroniser{constructor(m,w,y,p,l,i,a,r,t,o){super("snippets",w,m,y,p,l,r,t,i,a,o);this.version=1,this.snippetsFolder=m.snippetsHome,this._register(this.fileService.watch(m.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(n.Event.filter(this.fileService.onDidFilesChange,s=>s.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,w,y){const p=await this.getSnippetsFileContents(),l=this.toSnippetsContents(p),i=m.syncData?this.parseSnippets(m.syncData):null;w=w===null&&y?m:w;const a=w&&w.syncData?this.parseSnippets(w.syncData):null;i?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const r=(0,f.merge)(l,i,a);return this.getResourcePreviews(r,p,i||{})}async hasRemoteChanged(m){const w=m.syncData?this.parseSnippets(m.syncData):null;if(w===null)return!0;const y=await this.getSnippetsFileContents(),p=this.toSnippetsContents(y),l=(0,f.merge)(p,w,w);return Object.keys(l.remote.added).length>0||Object.keys(l.remote.updated).length>0||l.remote.removed.length>0||l.conflicts.length>0}async getMergeResult(m,w){return m.previewResult}async getAcceptResult(m,w,y,p){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return y===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:y,localChange:y===null?m.fileContent!==null?3:0:2,remoteChange:y===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(m,w,y,p){const l=y.map(([i,a])=>({...i,acceptResult:a}));l.every(({localChange:i,remoteChange:a})=>i===0&&a===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:i})=>i!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,p)),l.some(({remoteChange:i})=>i!==0)&&(m=await this.updateRemoteSnippets(l,m,p)),w?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:i}of l)try{await this.fileService.del(i)}catch{}}getResourcePreviews(m,w,y){const p=new Map;for(const l of Object.keys(m.local.added)){const i={content:m.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};p.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.local.updated)){const i={content:m.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.remote.added)){const i={content:m.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.remote.updated)){const i={content:m.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.conflicts){const i={content:w[l]?w[l].value.toString():null,hasConflicts:!0,localChange:w[l]?2:1,remoteChange:y[l]?2:1};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(w))if(!p.has(l)){const i={content:w[l]?w[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...p.values()]}async getAssociatedResources({uri:m}){let w=await super.resolveContent(m);if(w){const y=this.parseSyncData(w);if(y){const p=this.parseSnippets(y),l=[];for(const i of Object.keys(p)){const a=this.extUri.joinPath(m,i),r=this.extUri.joinPath(this.snippetsFolder,i),t=await this.fileService.exists(r);l.push({resource:a,comparableResource:t?r:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(m){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(m);let w=await super.resolveContent(m);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(m)),w){const y=this.parseSyncData(w);if(y)return this.parseSnippets(y)[this.extUri.basename(m)]||null}return null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch{}return!1}async updateLocalBackup(m){const w={};for(const y of m)y.fileContent&&(w[this.extUri.basename(y.localResource)]=y.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(m,w){for(const{fileContent:y,acceptResult:p,localResource:l,remoteResource:i,localChange:a}of m)if(a!==0){const r=i?this.extUri.basename(i):this.extUri.basename(l),t=this.extUri.joinPath(this.snippetsFolder,r);a===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):a===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,D.VSBuffer.fromString(p.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,D.VSBuffer.fromString(p.content),w?void 0:y),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(m,w,y){const p=w.syncData?this.parseSnippets(w.syncData):{},l=(0,L.deepClone)(p);for(const{acceptResult:i,localResource:a,remoteResource:r,remoteChange:t}of m)if(t!==0){const o=a?this.extUri.basename(a):this.extUri.basename(r);t===3?delete l[o]:l[o]=i.content}return(0,f.areSame)(p,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(l),y?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(m){return JSON.parse(m.content)}toSnippetsContents(m){const w={};for(const y of Object.keys(m))w[y]=m[y].value.toString();return w}async getSnippetsFileContents(){const m={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(y){if(y instanceof I.FileOperationError&&y.fileOperationResult===1)return m;throw y}for(const y of w.children||[]){const p=y.resource,l=this.extUri.extname(p);if(l===".json"||l===".code-snippets"){const i=this.extUri.relativePath(this.snippetsFolder,p),a=await this.fileService.readFile(p);m[i]=a}}return m}};u=he([J(0,A.IEnvironmentService),J(1,I.IFileService),J(2,b.IStorageService),J(3,S.IUserDataSyncStoreService),J(4,S.IUserDataSyncBackupStoreService),J(5,S.IUserDataSyncLogService),J(6,T.IConfigurationService),J(7,S.IUserDataSyncEnablementService),J(8,E.ITelemetryService),J(9,P.IUriIdentityService)],u),e.SnippetsSynchroniser=u;let v=class extends C.AbstractInitializer{constructor(m,w,y,p){super("snippets",w,y,m,p)}async doInitialize(m){const w=m.syncData?JSON.parse(m.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const p of Object.keys(w)){const l=w[p];if(l){const i=this.extUri.joinPath(this.environmentService.snippetsHome,p);await this.fileService.createFile(i,D.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(i))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};v=he([J(0,I.IFileService),J(1,A.IEnvironmentService),J(2,S.IUserDataSyncLogService),J(3,P.IUriIdentityService)],v),e.SnippetsInitializer=v}),define(te[64],ne([0,1,3,2,6,25]),function(Y,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,L.createDecorator)("IUserDataSyncAccountService");let A=class extends n.Disposable{constructor(b,E){super();this.userDataSyncStoreService=b,this.logService=E,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(b.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(b.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(b){(b&&this._account?b.token!==this._account.token||b.authenticationProviderId!==this._account.authenticationProviderId:b!==this._account)&&(this._account=b,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(b))}};A=he([J(0,T.IUserDataSyncStoreService),J(1,T.IUserDataSyncLogService)],A),e.UserDataSyncAccountService=A}),define(te[235],ne([0,1,5,17,57,2,19,20,13,14,25]),function(Y,e,D,n,L,T,A,I,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let C=class extends T.Disposable{constructor(S,u,v,d){super();this.environmentService=S,this.fileService=u,this.configurationService=v,this.logService=d,P.ALL_SYNC_RESOURCES.forEach(m=>this.cleanUpBackup(m))}async getAllRefs(S){const u=(0,A.joinPath)(this.environmentService.userDataSyncHome,S),v=await this.fileService.resolve(u);return v.children?v.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort().reverse().map(m=>({ref:m.name,created:this.getCreationTime(m)})):[]}async resolveContent(S,u){if(!u){const v=await this.getAllRefs(S);v.length&&(u=v[v.length-1].ref)}if(u){const v=(0,A.joinPath)(this.environmentService.userDataSyncHome,S,u);return(await this.fileService.readFile(v)).value.toString()}return null}async backup(S,u){const v=(0,A.joinPath)(this.environmentService.userDataSyncHome,S),d=(0,A.joinPath)(v,`${(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(d,n.VSBuffer.fromString(u))}catch(m){this.logService.error(m)}try{this.cleanUpBackup(S)}catch{}}async cleanUpBackup(S){const u=(0,A.joinPath)(this.environmentService.userDataSyncHome,S);try{try{if(!await this.fileService.exists(u))return}catch{return}const v=await this.fileService.resolve(u);if(v.children){const d=v.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort(),m=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let w=d.filter(p=>Date.now()-this.getCreationTime(p)>m);const y=d.length-w.length;y<10&&(w=w.slice(10-y)),await D.Promises.settled(w.map(async p=>{this.logService.info("Deleting from backup",p.resource.path),await this.fileService.del(p.resource)}))}}catch(v){this.logService.error(v)}}getCreationTime(S){return S.ctime||new Date(parseInt(S.name.substring(0,4)),parseInt(S.name.substring(4,6))-1,parseInt(S.name.substring(6,8)),parseInt(S.name.substring(9,11)),parseInt(S.name.substring(11,13)),parseInt(S.name.substring(13,15))).getTime()}};C=he([J(0,b.IEnvironmentService),J(1,E.IFileService),J(2,I.IConfigurationService),J(3,P.IUserDataSyncLogService)],C),e.UserDataSyncBackupStoreService=C}),define(te[236],ne([0,1,3,2,4,13,24,21,25]),function(Y,e,D,n,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const E="sync.enable";let P=class extends n.Disposable{constructor(f,S,u,v){super();this.storageService=f,this.telemetryService=S,this.environmentService=u,this.userDataSyncStoreManagementService=v,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(f.onDidChangeValue(d=>this.onDidStorageChange(d)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(E,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(f){f&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(E,{enabled:f}),this.storageService.store(E,f,0,1))}isResourceEnabled(f){return this.storageService.getBoolean((0,b.getEnablementKey)(f),0,!0)}setResourceEnablement(f,S){if(this.isResourceEnabled(f)!==S){const u=(0,b.getEnablementKey)(f);this.telemetryService.publicLog2(u,{enabled:S}),this.storeResourceEnablement(u,S)}}getResourceSyncStateVersion(f){}storeResourceEnablement(f,S){this.storageService.store(f,S,0,L.isWeb?0:1)}onDidStorageChange(f){if(f.scope!==0)return;if(E===f.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const S=b.ALL_SYNC_RESOURCES.filter(u=>(0,b.getEnablementKey)(u)===f.key)[0];if(S){this._onDidChangeResourceEnablement.fire([S,this.isResourceEnabled(S)]);return}}};P=he([J(0,A.IStorageService),J(1,I.ITelemetryService),J(2,T.IEnvironmentService),J(3,b.IUserDataSyncStoreManagementService)],P),e.UserDataSyncEnablementService=P}),define(te[237],ne([0,1,2,7]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class L{constructor(f){this.service=f}listen(f,S){switch(S){case"onError":return this.service.onError}throw new Error(`Event not found: ${S}`)}call(f,S,u){switch(S){case"triggerSync":return this.service.triggerSync(u[0],u[1],u[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(u[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=L;class T{constructor(f){this.service=f}listen(f,S){throw new Error(`Event not found: ${S}`)}call(f,S,u){switch(S){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(u[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(n.URI.revive(u[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class A{constructor(f){this.channel=f}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(f){return this.channel.call("resolveUserKeybindings",[f])}async resolveFormattingOptions(f){return this.channel.call("resolveFormattingOptions",[f])}}e.UserDataSyncUtilServiceClient=A;class I{constructor(f){this.service=f}listen(f,S){switch(S){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${S}`)}async call(f,S,u){switch(S){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(u[0],u[1]);case"setEnablement":return this.service.setEnablement(u[0],u[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=I;class b{constructor(f){this.service=f}listen(f,S){switch(S){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${S}`)}call(f,S,u){switch(S){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(u)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=b;class E{constructor(f){this.service=f}listen(f,S){switch(S){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${S}`)}call(f,S,u){switch(S){case"switch":return this.service.switch(u[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class P extends D.Disposable{constructor(f){super();this.channel=f,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(f){return this.channel.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(f)}revive(f){return{url:n.URI.revive(f.url),type:f.type,defaultUrl:n.URI.revive(f.defaultUrl),insidersUrl:n.URI.revive(f.insidersUrl),stableUrl:n.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(te[238],ne([0,1,13,8]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends n.AbstractLogger{constructor(A,I){super();this.logger=this._register(A.createLogger(I.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...I){this.logger.trace(A,...I)}debug(A,...I){this.logger.debug(A,...I)}info(A,...I){this.logger.info(A,...I)}warn(A,...I){this.logger.warn(A,...I)}error(A,...I){this.logger.error(A,...I)}critical(A,...I){this.logger.critical(A,...I)}flush(){this.logger.flush()}};L=he([J(0,n.ILoggerService),J(1,D.IEnvironmentService)],L),e.UserDataSyncLogService=L}),define(te[65],ne([0,1,3,2,4,27,148,13,14,6,26,46,24,25]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const u="sync.currentMachineName",v="Safari",d="Chrome",m="Edge",w="Firefox",y="Android";function p(a){switch(a){case v:case d:case m:case w:case y:case(0,L.PlatformToString)(0):return!0}return!1}e.isWebPlatform=p;function l(){return L.isSafari?v:L.isChrome?d:L.isEdge?m:L.isFirefox?w:L.isAndroid?y:(0,L.PlatformToString)(L.isWeb?0:L.platform)}let i=class Ze extends n.Disposable{constructor(r,t,o,s,c,h){super();this.storageService=o,this.userDataSyncStoreService=s,this.logService=c,this.productService=h,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(r,t,o)}async getMachines(r){const t=await this.currentMachineIdPromise;return(await this.readMachinesData(r)).machines.map(s=>({...s,isCurrent:s.id===t}))}async addCurrentMachine(r){const t=await this.currentMachineIdPromise,o=await this.readMachinesData(r);o.machines.some(({id:s})=>s===t)||(o.machines.push({id:t,name:this.computeCurrentMachineName(o.machines),platform:l()}),await this.writeMachinesData(o))}async removeCurrentMachine(r){const t=await this.currentMachineIdPromise,o=await this.readMachinesData(r),s=o.machines.filter(({id:c})=>c!==t);s.length!==o.machines.length&&(o.machines=s,await this.writeMachinesData(o))}async renameMachine(r,t,o){const s=await this.readMachinesData(o),c=s.machines.find(({id:h})=>h===r);if(c){c.name=t,await this.writeMachinesData(s);const h=await this.currentMachineIdPromise;r===h&&this.storageService.store(u,t,0,1)}}async setEnablement(r,t){const o=await this.readMachinesData(),s=o.machines.find(({id:c})=>c===r);s&&(s.disabled=t?void 0:!0,await this.writeMachinesData(o))}computeCurrentMachineName(r){const t=this.storageService.get(u,0);if(t)return t;const o=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${l()} (${this.productService.nameShort})`,s=new RegExp(`${(0,T.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let c=0;for(const h of r){const g=s.exec(h.name),R=g?parseInt(g[1]):0;c=R>c?R:c}return`${o} #${c+1}`}async readMachinesData(r){this.userData=await this.readUserData(r);const t=this.parse(this.userData);if(t.version!==Ze.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return t}async writeMachinesData(r){const t=JSON.stringify(r),o=await this.userDataSyncStoreService.write(Ze.RESOURCE,t,this.userData?.ref||null);this.userData={ref:o,content:t},this._onDidChange.fire()}async readUserData(r){if(this.userData){const t=r&&r.latest?r.latest[Ze.RESOURCE]:void 0;if(this.userData.ref===t)return this.userData;if(t===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ze.RESOURCE,this.userData)}parse(r){if(r.content!==null)try{return JSON.parse(r.content)}catch(t){this.logService.error(t)}return{version:Ze.VERSION,machines:[]}}};i.VERSION=1,i.RESOURCE="machines",i=he([J(0,I.IEnvironmentService),J(1,b.IFileService),J(2,f.IStorageService),J(3,S.IUserDataSyncStoreService),J(4,S.IUserDataSyncLogService),J(5,P.IProductService)],i),e.UserDataSyncMachinesService=i}),define(te[239],ne([0,1,5,57,37,9,3,2,4,19,7,146,26,24,21,25,64,65]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S,u,v,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const w="sync.disableMachineEventually",y="sync.sessionId",p="sync.storeUrl",l="sync.productQuality";let i=class extends I.Disposable{constructor(t,o,s,c,h,g,R,_,U,F){super();this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=s,this.userDataSyncEnablementService=c,this.userDataSyncService=h,this.logService=g,this.userDataSyncAccountService=R,this.telemetryService=_,this.userDataSyncMachinesService=U,this.storageService=F,this.autoSync=this._register(new I.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=t.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(o.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,o.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(R.onDidChangeAccount(()=>this.updateAutoSync())),this._register(s.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(h.onDidChangeLocal(k=>this.triggerSync([k],!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,k])=>k)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const t=this.storageService.get(p,0);return t?P.URI.parse(t):void 0}set syncUrl(t){t?this.storageService.store(p,t.toString(),0,1):this.storageService.remove(p,0)}get productQuality(){return this.storageService.get(l,0)}set productQuality(t){t?this.storageService.store(l,t,0,1):this.storageService.remove(l,0)}updateAutoSync(){const{enabled:t,message:o}=this.isAutoSyncEnabled();t?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(s=>this.onDidFinishSync(s))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(o&&this.logService.info(o),this.autoSync.clear()):o&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(o))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,n.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(t,o,s){try{this.userDataSyncAccountService.account&&!s&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(y,0),t?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(c){if(o)this.logService.error(c),this.updateEnablement(!1);else throw c}}updateEnablement(t){this.userDataSyncEnablementService.isEnabled()!==t&&(this.userDataSyncEnablementService.setEnablement(t),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(t){if(!t){this.successiveFailures=0;return}const o=v.UserDataSyncError.toUserDataSyncError(t);o instanceof v.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:o.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),o.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):o.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):o.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):o.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):o.code==="UpgradeRequired"||o.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):o.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with newer version than of client. Requires client upgrade.`)):o.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with older version than of client. Requires server reset.`)):o.code==="ServiceChanged"||o.code==="DefaultServiceChanged"?b.isWeb&&o.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(o),this.successiveFailures++),this._onError.fire(o)}async disableMachineEventually(){this.storageService.store(w,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(w,0,!1)}stopDisableMachineEventually(){this.storageService.remove(w,0)}async triggerSync(t,o,s){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(o&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...t),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",s)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};i=he([J(0,f.IProductService),J(1,v.IUserDataSyncStoreManagementService),J(2,v.IUserDataSyncStoreService),J(3,v.IUserDataSyncEnablementService),J(4,v.IUserDataSyncService),J(5,v.IUserDataSyncLogService),J(6,d.IUserDataSyncAccountService),J(7,u.ITelemetryService),J(8,m.IUserDataSyncMachinesService),J(9,S.IStorageService)],i),e.UserDataAutoSyncService=i;class a extends I.Disposable{constructor(t,o,s,c,h,g,R,_){super();this.lastSyncUrl=t,this.interval=o,this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=c,this.userDataSyncService=h,this.userDataSyncMachinesService=g,this.logService=R,this.storageService=_,this.intervalHandler=this._register(new I.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,I.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(t,o){const s=(0,D.createCancelablePromise)(async c=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(h){if((0,T.isCancellationError)(h))return}return this.doSync(t,o,c)});return this.syncPromise=s,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const t=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),o=this.userDataSyncStoreManagementService.userDataSyncStore;return!!o&&!!t&&(!(0,E.isEqual)(o.defaultUrl,t.defaultUrl)||!(0,E.isEqual)(o.insidersUrl,t.insidersUrl)||!(0,E.isEqual)(o.stableUrl,t.stableUrl))}async doSync(t,o,s){this.logService.info(`Auto Sync: Triggered by ${t}`),this._onDidStartSync.fire();let c;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,o),s.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new v.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const h=this.storageService.get(y,0);if(h&&this.manifest&&h!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new v.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const g=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(s.isCancellationRequested)return;const R=g.find(_=>_.isCurrent);if(R?.disabled)throw new v.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(_){throw new v.UserDataAutoSyncError((0,L.toErrorMessage)(_),_ instanceof v.UserDataSyncError?_.code:"Unknown")}if(this.manifest&&this.manifest.session!==h&&this.storageService.store(y,this.manifest.session,0,1),s.isCancellationRequested)return;R||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(h){this.logService.error(h),c=h}this._onDidFinishSync.fire(c)}register(t){return super._register(t)}}a.INTERVAL_SYNCING="Interval"}),define(te[240],ne([0,1,16,5,37,3,2,19,15,29,20,30,6,24,21,228,230,231,233,234,25]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S,u,v,d,m,w,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const l="sync.lastSyncTime";let i=class extends A.Disposable{constructor(s,c,h,g,R,_,U,F){super();this.userDataSyncStoreService=s,this.userDataSyncStoreManagementService=c,this.instantiationService=h,this.configurationService=g,this.logService=R,this.telemetryService=_,this.storageService=U,this.userDataSyncEnablementService=F,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new A.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(l,0,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(s,c){this.checkEnablement();const h=(0,E.generateUuid)();try{const F=(0,p.createSyncHeaders)(h);c&&(F["Cache-Control"]="no-cache"),s=await this.userDataSyncStoreService.manifest(s,F)}catch(F){const k=p.UserDataSyncError.toUserDataSyncError(F);throw this.reportUserDataSyncError(k,h),k}let g=!1;const R=this,_=this.getEnabledSynchronizers();let U;return{manifest:s,async run(){if(g)throw new Error("Can run a task only once");return U=(0,n.createCancelablePromise)(F=>R.sync(_,s,h,F)),U.finally(()=>U=void 0)},async stop(){if(U&&U.cancel(),R.status!=="idle")return R.stop(_)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new p.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const s=(0,E.generateUuid)(),c=(0,p.createSyncHeaders)(s);let h;try{h=await this.userDataSyncStoreService.manifest(null,c)}catch(R){const _=p.UserDataSyncError.toUserDataSyncError(R);throw this.reportUserDataSyncError(_,s),_}await this.resetLocal();const g=this.getEnabledSynchronizers();return new a(s,h,c,g,()=>this.resetLocal(),this.configurationService,this.logService)}async sync(s,c,h,g){if(g.isCancellationRequested||!s.length)return;const R=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const _=(0,p.createSyncHeaders)(h);for(const U of s){if(g.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(U.resource))return;try{await U.sync(c,_)}catch(F){let k=!1;if(F instanceof p.UserDataSyncError)switch(F.code){case"TooLarge":F=new p.UserDataSyncError(F.message,F.code,U.resource),k=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":k=!0;break}const M=p.UserDataSyncError.toUserDataSyncError(F);if(this.reportUserDataSyncError(M,h),k)throw M;this.logService.error(F),this.logService.error(`${U.resource}: ${(0,L.toErrorMessage)(F)}`),this._syncErrors.push([U.resource,M])}}this.logService.info(`Sync done. Took ${new Date().getTime()-R}ms`),this.updateLastSyncTime()}catch(_){const U=p.UserDataSyncError.toUserDataSyncError(_);throw this.reportUserDataSyncError(U,h),U}finally{this.updateStatus(s),this._onSyncErrors.fire(this._syncErrors)}}async stop(s){if(this.status!=="idle")for(const c of s)try{c.status!=="idle"&&await c.stop()}catch(h){this.logService.error(h)}}async replace(s){this.checkEnablement(),await this.performSynchronizerAction(async c=>{if(await c.replace(s))return!0})}async accept(s,c,h,g){this.checkEnablement(),await this.performSynchronizerAction(async R=>{if(R.resource===s)return await R.accept(c,h),g&&await R.apply(!1,(0,p.createSyncHeaders)((0,E.generateUuid)())),!0})}async resolveContent(s){return this.performSynchronizerAction(async c=>{const h=await c.resolveContent(s);if(h)return h})}async getRemoteSyncResourceHandles(s){return await this.performSynchronizerAction(async h=>{if(h.resource===s)return h.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(s){return await this.performSynchronizerAction(async h=>{if(h.resource===s)return h.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(s,c){return await this.performSynchronizerAction(async g=>{if(g.resource===s)return g.getAssociatedResources(c)})||[]}async getMachineId(s,c){return await this.performSynchronizerAction(async g=>{if(g.resource===s)return await g.getMachineId(c)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async c=>{if(c.resource!=="globalState"&&await c.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async c=>{if(await c.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(s){this.logService.error(s)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(l,0),this.synchronizers.value){for(const s of this.synchronizers.value.enabled)try{await s.resetLocal()}catch(c){this.logService.error(`${s.resource}: ${(0,L.toErrorMessage)(c)}`),this.logService.error(c)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(s){const c=new A.DisposableStore;try{const h=this.synchronizers.value||c.add(this.instantiationService.createInstance(r,()=>{},()=>{},()=>{})),g=[...h.enabled,...h.disabled.map(R=>c.add(h.createSynchronizer(R)))];for(const R of g){const _=await s(R);if(!(0,b.isUndefined)(_))return _}return null}finally{c.dispose()}}setStatus(s){const c=this._status;this._status!==s&&(this._status=s,this._onDidChangeStatus.fire(s),c==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(s){this.updateConflicts(s);const c=this.computeStatus(s);this.setStatus(c)}updateConflicts(s){const c=this.computeConflicts(s);(0,D.equals)(this._conflicts,c,([h,g],[R,_])=>h===h&&(0,D.equals)(g,_,(U,F)=>(0,I.isEqual)(U.previewResource,F.previewResource)))||(this._conflicts=this.computeConflicts(s),this._onDidChangeConflicts.fire(c))}computeConflicts(s){return s.filter(c=>c.status==="hasConflicts").map(c=>[c.resource,c.conflicts.map(t)])}computeStatus(s){return this.userDataSyncStoreManagementService.userDataSyncStore?s.some(c=>c.status==="hasConflicts")?"hasConflicts":s.some(c=>c.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(l,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(s,c){this.telemetryService.publicLog2("sync/error",{code:s.code,serverCode:s instanceof p.UserDataSyncStoreError?String(s.serverCode):void 0,url:s instanceof p.UserDataSyncStoreError?s.url:void 0,resource:s.resource,executionId:c,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(r,s=>this.updateStatus(s),s=>this.updateConflicts(s),s=>this._onDidChangeLocal.fire(s))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};i=he([J(0,p.IUserDataSyncStoreService),J(1,p.IUserDataSyncStoreManagementService),J(2,f.IInstantiationService),J(3,P.IConfigurationService),J(4,p.IUserDataSyncLogService),J(5,u.ITelemetryService),J(6,S.IStorageService),J(7,p.IUserDataSyncEnablementService)],i),e.UserDataSyncService=i;class a extends A.Disposable{constructor(s,c,h,g,R,_,U){super();this.id=s,this.manifest=c,this.syncHeaders=h,this.synchronisers=g,this.onStop=R,this.configurationService=_,this.logService=U,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new T.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(s=>s.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(s=>s.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,n.createCancelablePromise)(s=>this.getPreviews(s))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(s){throw this.logService.error(s),s}}async accept(s,c){try{return await this.performAction(s,h=>h.accept(s,c))}catch(h){throw this.logService.error(h),h}}async merge(s){try{return s?await this.performAction(s,c=>c.merge(s)):await this.mergeAll()}catch(c){throw this.logService.error(c),c}}async discard(s){try{return await this.performAction(s,c=>c.discard(s))}catch(c){throw this.logService.error(c),c}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const s=[];for(const[,c]of this.previews)for(const h of c.resourcePreviews)h.mergeState==="conflict"&&s.push(h.previewResource);for(const c of s)await this.discard(c);return this.previews}catch(s){throw this.logService.error(s),s}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const s=[];for(const[c,h]of this.previews){this.synchronizingResources.push([c,h.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const g=this.synchronisers.find(_=>_.resource===c);for(const _ of h.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&await g.merge(_.previewResource);const R=await g.apply(!1,this.syncHeaders);R&&s.push(this.toSyncResourcePreview(g.resource,R)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=s,this.previews}catch(s){throw this.logService.error(s),s}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[s,c]of this.previews){this.synchronizingResources.push([s,c.resourcePreviews.map(g=>g.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(g=>g.resource===s);for(const g of c.resourcePreviews)await h.accept(g.remoteResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(g=>g[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(s){throw this.logService.error(s),s}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[s,c]of this.previews){this.synchronizingResources.push([s,c.resourcePreviews.map(g=>g.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(g=>g.resource===s);for(const g of c.resourcePreviews)await h.accept(g.localResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(g=>g[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(s){throw this.logService.error(s),s}}async stop(){await this.onStop(),this.reset()}async performAction(s,c){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const h=this.previews.findIndex(([,$])=>$.resourcePreviews.some(({localResource:x,previewResource:z,remoteResource:G})=>(0,I.isEqual)(s,x)||(0,I.isEqual)(s,z)||(0,I.isEqual)(s,G)));if(h===-1)return this.previews;const[g,R]=this.previews[h],_=R.resourcePreviews.find(({localResource:$,remoteResource:x,previewResource:z})=>(0,I.isEqual)($,s)||(0,I.isEqual)(x,s)||(0,I.isEqual)(z,s));if(!_)return this.previews;let U=this.synchronizingResources.find($=>$[0]===g);U||(U=[g,[]],this.synchronizingResources.push(U)),U[1].some($=>(0,I.isEqual)($,_.localResource))||(U[1].push(_.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const F=this.synchronisers.find($=>$.resource===this.previews[h][0]),k=await c(F);k?this.previews.splice(h,1,this.toSyncResourcePreview(F.resource,k)):this.previews.splice(h,1);const M=this.synchronizingResources.findIndex($=>$[0]===g);return this.synchronizingResources[M][1].splice(U[1].findIndex($=>(0,I.isEqual)($,_.localResource)),1),U[1].length||(this.synchronizingResources.splice(M,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const s=[];for(const[c,h]of this.previews){this.synchronizingResources.push([c,h.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const g=this.synchronisers.find(_=>_.resource===c);let R=h;for(const _ of h.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&(R=await g.merge(_.previewResource));R&&s.push(this.toSyncResourcePreview(g.resource,R)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=s,this.previews}async getPreviews(s){const c=[],h=await this.getUserDataSyncConfiguration();for(const g of this.synchronisers){if(s.isCancellationRequested)return[];const R=await g.preview(this.manifest,h,this.syncHeaders);R&&c.push(this.toSyncResourcePreview(g.resource,R))}return c}async getUserDataSyncConfiguration(){const s=this.configurationService.getValue(p.USER_DATA_SYNC_CONFIGURATION_SCOPE),c=await this.synchronisers.find(h=>h instanceof w.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...s,...c}}toSyncResourcePreview(s,c){return[s,{isLastSyncFromCurrentMachine:c.isLastSyncFromCurrentMachine,resourcePreviews:c.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let r=class extends A.Disposable{constructor(s,c,h,g,R,_,U){super();this.onDidChangeStatus=s,this.onDidChangeConflicts=c,this.onDidChangeLocal=h,this.userDataSyncEnablementService=g,this.instantiationService=R,this.extensionGalleryService=_,this.logService=U,this._enabled=[],this._register(g.onDidChangeResourceEnablement(([F,k])=>this.onDidChangeResourceEnablement(F,k))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,F])=>F.dispose())));for(const F of p.ALL_SYNC_RESOURCES)g.isResourceEnabled(F)&&this.registerSynchronizer(F)}get enabled(){return this._enabled.sort((s,c)=>s[1]-c[1]).map(([s])=>s)}get disabled(){return p.ALL_SYNC_RESOURCES.filter(s=>!this.userDataSyncEnablementService.isResourceEnabled(s))}onDidChangeResourceEnablement(s,c){c?this.registerSynchronizer(s):this.deRegisterSynchronizer(s)}registerSynchronizer(s){if(this._enabled.some(([R])=>R.resource===s))return;if(s==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const c=new A.DisposableStore,h=c.add(this.createSynchronizer(s));c.add(h.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),c.add(h.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),c.add(h.onDidChangeLocal(()=>this.onDidChangeLocal(s)));const g=this.getOrder(s);this._enabled.push([h,g,c])}deRegisterSynchronizer(s){const c=this._enabled.findIndex(([h])=>h.resource===s);if(c!==-1){const h=this._enabled.splice(c,1);for(const[g,,R]of h){if(g.status!=="idle"){const _=g.conflicts.length>0;g.stop(),_&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}R.dispose()}}}createSynchronizer(s){switch(s){case"settings":return this.instantiationService.createInstance(w.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(m.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(y.SnippetsSynchroniser);case"globalState":return this.instantiationService.createInstance(d.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(v.ExtensionsSynchroniser)}}getOrder(s){switch(s){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"globalState":return 3;case"extensions":return 4}}};r=he([J(3,p.IUserDataSyncEnablementService),J(4,f.IInstantiationService),J(5,C.IExtensionGalleryService),J(6,p.IUserDataSyncLogService)],r);function t(o){return{localResource:o.localResource,previewResource:o.previewResource,remoteResource:o.remoteResource,acceptedResource:o.acceptedResource,localChange:o.localChange,remoteChange:o.remoteChange,mergeState:o.mergeState}}}),define(te[241],ne([0,1,3,2,15,7,25]),function(Y,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class I{constructor(C,f){this.service=C,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(C,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(C,f,S){try{return await this._call(C,f,S)}catch(u){throw this.logService.error(u),u}}async _call(C,f,S){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(S[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(S[0],T.URI.revive(S[1]),S[2],S[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(S[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(S[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(S[0]);case"getAssociatedResources":return this.service.getAssociatedResources(S[0],{created:S[1].created,uri:T.URI.revive(S[1].uri)});case"getMachineId":return this.service.getMachineId(S[0],{created:S[1].created,uri:T.URI.revive(S[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const u=f.substring("manualSync/".length),v=S[0],d=this.getManualSyncTask(v);switch(S=S.slice(1),u){case"preview":return d.preview();case"accept":return d.accept(T.URI.revive(S[0]),S[1]);case"merge":return d.merge(T.URI.revive(S[0]));case"discard":return d.discard(T.URI.revive(S[0]));case"discardConflicts":return d.discardConflicts();case"apply":return d.apply();case"pull":return d.pull();case"push":return d.push();case"stop":return d.stop();case"_getStatus":return d.status;case"dispose":return this.disposeManualSyncTask(d)}}throw new Error("Invalid call")}getManualSyncTask(C){const f=this.manualSyncTasks.get(this.createKey(C));if(!f)throw new Error(`Manual sync taks not found: ${C}`);return f.manualSyncTask}async createManualSyncTask(){const C=new n.DisposableStore,f=C.add(await this.service.createManualSyncTask());return C.add(f.onSynchronizeResources(S=>this.onManualSynchronizeResources.fire({manualSyncTaskId:f.id,data:S}))),this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:C}),{id:f.id,manifest:f.manifest,status:f.status}}disposeManualSyncTask(C){C.dispose();const f=this.createKey(C.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(C){return`manualSyncTask-${C}`}}e.UserDataSyncChannel=I;class b extends n.Disposable{constructor(C){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,S,u){return C.call(f,S,u).then(null,v=>{throw A.UserDataSyncError.toUserDataSyncError(v)})},listen(f,S){return C.listen(f,S)}},this.channel.call("_getInitialData").then(([f,S,u])=>{this.updateStatus(f),this.updateConflicts(S),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(v=>this.updateStatus(v))),this._register(this.channel.listen("onDidChangeLastSyncTime")(v=>this.updateLastSyncTime(v)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(([S,u])=>[S,A.UserDataSyncError.toUserDataSyncError(u)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:C,manifest:f,status:S}=await this.channel.call("createManualSyncTask"),u=this,v=new E(C,f,S,{async call(d,m,w){return u.channel.call(`manualSync/${d}`,[C,...(0,L.isArray)(m)?m:[m]],w)},listen(d,m){return D.Event.map(D.Event.filter(u.channel.listen(`manualSync/${d}`,m),w=>!v.isDiposed()&&w.manualSyncTaskId===C),w=>w.data)}});return v}replace(C){return this.channel.call("replace",[C])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(C,f,S,u){return this.channel.call("accept",[C,f,S,u])}resolveContent(C){return this.channel.call("resolveContent",[C])}async getLocalSyncResourceHandles(C){return(await this.channel.call("getLocalSyncResourceHandles",[C])).map(({created:S,uri:u})=>({created:S,uri:T.URI.revive(u)}))}async getRemoteSyncResourceHandles(C){return(await this.channel.call("getRemoteSyncResourceHandles",[C])).map(({created:S,uri:u})=>({created:S,uri:T.URI.revive(u)}))}async getAssociatedResources(C,f){return(await this.channel.call("getAssociatedResources",[C,f])).map(({resource:u,comparableResource:v})=>({resource:T.URI.revive(u),comparableResource:T.URI.revive(v)}))}async getMachineId(C,f){return this.channel.call("getMachineId",[C,f])}async updateStatus(C){this._status=C,this._onDidChangeStatus.fire(C)}async updateConflicts(C){this._conflicts=C.map(([f,S])=>[f,S.map(u=>({...u,localResource:T.URI.revive(u.localResource),remoteResource:T.URI.revive(u.remoteResource),previewResource:T.URI.revive(u.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(C){this._lastSyncTime!==C&&(this._lastSyncTime=C,this._onDidChangeLastSyncTime.fire(C))}}e.UserDataSyncChannelClient=b;class E extends n.Disposable{constructor(C,f,S,u){super();this.id=C,this.manifest=f,this._disposed=!1,this._status=S;const v=this;this.channel={async call(d,m,w){try{const y=await u.call(d,m,w);return v.isDiposed()||(v._status=await u.call("_getStatus")),y}catch(y){throw A.UserDataSyncError.toUserDataSyncError(y)}},listen(d,m){return u.listen(d,m)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const C=await this.channel.call("preview");return this.deserializePreviews(C)}async accept(C,f){const S=await this.channel.call("accept",[C,f]);return this.deserializePreviews(S)}async merge(C){const f=await this.channel.call("merge",[C]);return this.deserializePreviews(f)}async discard(C){const f=await this.channel.call("discard",[C]);return this.deserializePreviews(f)}async discardConflicts(){const C=await this.channel.call("discardConflicts");return this.deserializePreviews(C)}async apply(){const C=await this.channel.call("apply");return this.deserializePreviews(C)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(C){return C.map(([f,S])=>[f,{isLastSyncFromCurrentMachine:S.isLastSyncFromCurrentMachine,resourcePreviews:S.resourcePreviews.map(u=>({...u,localResource:T.URI.revive(u.localResource),remoteResource:T.URI.revive(u.remoteResource),previewResource:T.URI.revive(u.previewResource),acceptedResource:T.URI.revive(u.acceptedResource)}))}])}}}),define(te[242],ne([0,1,5,23,9,3,2,102,4,19,15,7,29,20,13,14,26,43,46,24,25]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S,u,v,d,m,w,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",i="sync.donot-make-requests-until",a="sync.user-session-id",r="sync.machine-session-id",t=100,o=1e3*60*5;let s=class extends A.Disposable{constructor(U,F,k){super();this.productService=U,this.configurationService=F,this.storageService=k,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(k.onDidChangeValue,M=>M.key===p.SYNC_SERVICE_URL_TYPE&&M.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(p.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(U){this.storageService.store(p.SYNC_SERVICE_URL_TYPE,U,0,b.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[p.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(p.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(U,F){U=b.isWeb&&U?.web?{...U,...U.web}:U;const k={...U||{},...F||{}};if(k&&(0,P.isString)(k.url)&&(0,P.isObject)(k.authenticationProviders)&&Object.keys(k.authenticationProviders).every(M=>(0,P.isArray)(k.authenticationProviders[M].scopes))){const M=k,$=!!M.canSwitch&&!F?.url,x=M.url===M.insidersUrl?"insiders":"stable",z=($?this.userDataSyncStoreType:void 0)||x,G=F?.url||(z==="insiders"?M.insidersUrl:z==="stable"?M.stableUrl:M.url);return{url:C.URI.parse(G),type:z,defaultType:x,defaultUrl:C.URI.parse(M.url),stableUrl:C.URI.parse(M.stableUrl),insidersUrl:C.URI.parse(M.insidersUrl),canSwitch:$,authenticationProviders:Object.keys(M.authenticationProviders).reduce((ee,q)=>(ee.push({id:q,scopes:M.authenticationProviders[q].scopes}),ee),[])}}}};s=he([J(0,d.IProductService),J(1,S.IConfigurationService),J(2,y.IStorageService)],s),e.AbstractUserDataSyncStoreManagementService=s;let c=class extends s{constructor(U,F,k){super(U,F,k);const M=this.storageService.get(l,0);M&&(this.previousConfigurationSyncStore=JSON.parse(M));const $=this.productService[p.CONFIGURATION_SYNC_STORE_KEY];$?this.storageService.store(l,JSON.stringify($),0,1):this.storageService.remove(l,0)}async switch(U){U!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=U,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};c=he([J(0,d.IProductService),J(1,S.IConfigurationService),J(2,y.IStorageService)],c),e.UserDataSyncStoreManagementService=c;let h=class extends A.Disposable{constructor(U,F,k,M,$,x,z){super();this.requestService=k,this.logService=M,this.storageService=z,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(U),this.commonHeadersPromise=(0,w.getServiceMachineId)($,x,z).then(G=>{const ee={"X-Client-Name":`${F.applicationName}${b.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(ee["X-Client-Commit"]=F.commit),ee}),this.session=new R(t,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(U,F){this.authToken={token:U,type:F}}updateUserDataSyncStoreUrl(U){this.userDataSyncStoreUrl=U?(0,E.joinPath)(U,"v1"):void 0}initDonotMakeRequestsUntil(){const U=this.storageService.getNumber(i,0);U&&Date.now()<U&&this.setDonotMakeRequestsUntil(new Date(U))}setDonotMakeRequestsUntil(U){this._donotMakeRequestsUntil?.getTime()!==U?.getTime()&&(this._donotMakeRequestsUntil=U,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(i,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(F=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(i,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",U),k={},M=await this.request(F.toString(),{type:"GET",headers:k},[],n.CancellationToken.None);return(await(0,m.asJson)(M)||[]).map(({url:x,created:z})=>({ref:(0,E.relativePath)(F,F.with({path:x})),created:z*1e3}))}async resolveContent(U,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",U,F).toString(),M={};M["Cache-Control"]="no-cache";const $=await this.request(k,{type:"GET",headers:M},[],n.CancellationToken.None);return await(0,m.asText)($)}async delete(U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",U).toString(),k={};await this.request(F,{type:"DELETE",headers:k},[],n.CancellationToken.None)}async read(U,F,k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",U,"latest").toString();k={...k},k["Cache-Control"]="no-cache",F&&(k["If-None-Match"]=F.ref);const $=await this.request(M,{type:"GET",headers:k},[304],n.CancellationToken.None);let x=null;if($.res.statusCode===304&&(x=F),x===null){const z=$.res.headers.etag;if(!z)throw new p.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",$.res.statusCode,$.res.headers[p.HEADER_OPERATION_ID]);const G=await(0,m.asText)($);if(!G&&$.res.statusCode===304)throw new p.UserDataSyncStoreError("Empty response",M,"EmptyResponse",$.res.statusCode,$.res.headers[p.HEADER_OPERATION_ID]);x={ref:z,content:G}}return x}async write(U,F,k,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",U).toString();M={...M},M["Content-Type"]=I.Mimes.text,k&&(M["If-Match"]=k);const x=await this.request($,{type:"POST",data:F,headers:M},[],n.CancellationToken.None),z=x.res.headers.etag;if(!z)throw new p.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",x.res.statusCode,x.res.headers[p.HEADER_OPERATION_ID]);return z}async manifest(U,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",U&&(F["If-None-Match"]=U.ref);const M=await this.request(k,{type:"GET",headers:F},[304],n.CancellationToken.None);let $=null;if(M.res.statusCode===304&&($=U),!$){const z=M.res.headers.etag;if(!z)throw new p.UserDataSyncStoreError("Server did not return the ref",k,"NoRef",M.res.statusCode,M.res.headers[p.HEADER_OPERATION_ID]);const G=await(0,m.asText)(M);if(!G&&M.res.statusCode===304)throw new p.UserDataSyncStoreError("Empty response",k,"EmptyResponse",M.res.statusCode,M.res.headers[p.HEADER_OPERATION_ID]);G&&($={...JSON.parse(G),ref:z})}const x=this.storageService.get(a,0);return x&&$&&x!==$.session&&this.clearSession(),$===null&&x&&this.clearSession(),$&&this.storageService.store(a,$.session,0,1),$}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":I.Mimes.text};await this.request(U,{type:"DELETE",headers:F},[],n.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(a,0),this.storageService.remove(r,0)}async request(U,F,k,M){if(!this.authToken)throw new p.UserDataSyncStoreError("No Auth Token Available",U,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new p.UserDataSyncStoreError(`${F.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const $=await this.commonHeadersPromise;F.headers={...F.headers||{},...$,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:U,type:F.type,headers:{...F.headers,authorization:void 0}});let x;try{x=await this.session.request(U,F,M)}catch(q){if(!(q instanceof p.UserDataSyncStoreError)){let j="RequestFailed";const K=(0,L.getErrorMessage)(q).toLowerCase();K.includes("xhr timeout")?j="RequestTimeout":K.includes("protocol")&&K.includes("not supported")?j="RequestProtocolNotSupported":K.includes("request path contains unescaped characters")?j="RequestPathNotEscaped":K.includes("headers must be an object")?j="RequestHeadersNotObject":(0,L.isCancellationError)(q)&&(j="RequestCanceled"),q=new p.UserDataSyncStoreError(`Connection refused for the request '${U}'.`,U,j,void 0,void 0)}throw this.logService.info("Request failed",U),q}const z=x.res.headers[p.HEADER_OPERATION_ID],G={url:U,status:x.res.statusCode,"execution-id":F.headers[p.HEADER_EXECUTION_ID],"operation-id":z},ee=(0,m.isSuccess)(x)||x.res.statusCode&&k.indexOf(x.res.statusCode)!==-1;if(ee?this.logService.trace("Request succeeded",G):this.logService.info("Request failed",G),x.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new p.UserDataSyncStoreError(`Request '${U}' failed because of Unauthorized (401).`,U,"Unauthorized",x.res.statusCode,z);if(this._onTokenSucceed.fire(),x.res.statusCode===409)throw new p.UserDataSyncStoreError(`${F.type} request '${U}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,U,"Conflict",x.res.statusCode,z);if(x.res.statusCode===410)throw new p.UserDataSyncStoreError(`${F.type} request '${U}' failed because the requested resource is not longer available (410).`,U,"Gone",x.res.statusCode,z);if(x.res.statusCode===412)throw new p.UserDataSyncStoreError(`${F.type} request '${U}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,U,"PreconditionFailed",x.res.statusCode,z);if(x.res.statusCode===413)throw new p.UserDataSyncStoreError(`${F.type} request '${U}' failed because of too large payload (413).`,U,"TooLarge",x.res.statusCode,z);if(x.res.statusCode===426)throw new p.UserDataSyncStoreError(`${F.type} request '${U}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,U,"UpgradeRequired",x.res.statusCode,z);if(x.res.statusCode===429){const q=x.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new p.UserDataSyncStoreError(`${F.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",x.res.statusCode,z)):new p.UserDataSyncStoreError(`${F.type} request '${U}' failed because of too many requests (429).`,U,"RemoteTooManyRequests",x.res.statusCode,z)}if(!ee)throw new p.UserDataSyncStoreError("Server returned "+x.res.statusCode,U,"Unknown",x.res.statusCode,z);return x}addSessionHeaders(U){let F=this.storageService.get(r,0);F===void 0&&(F=(0,f.generateUuid)(),this.storageService.store(r,F,0,1)),U["X-Machine-Session-Id"]=F;const k=this.storageService.get(a,0);k!==void 0&&(U["X-User-Session-Id"]=k)}};h=he([J(1,d.IProductService),J(2,m.IRequestService),J(3,p.IUserDataSyncLogService),J(4,u.IEnvironmentService),J(5,v.IFileService),J(6,y.IStorageService)],h),e.UserDataSyncStoreClient=h;let g=class extends h{constructor(U,F,k,M,$,x,z){super(U.userDataSyncStore?.url,F,k,M,$,x,z);this._register(U.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(U.userDataSyncStore?.url)))}};g=he([J(0,p.IUserDataSyncStoreManagementService),J(1,d.IProductService),J(2,m.IRequestService),J(3,p.IUserDataSyncLogService),J(4,u.IEnvironmentService),J(5,v.IFileService),J(6,y.IStorageService)],g),e.UserDataSyncStoreService=g;class R{constructor(U,F,k,M){this.limit=U,this.interval=F,this.requestService=k,this.logService=M,this.requests=[],this.startTime=void 0}request(U,F,k){if(this.isExpired()&&this.reset(),F.url=U,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new p.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,U,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(U),this.requestService.request(F,k)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=R}),define(te[243],ne([0,1,3,60,26,24,21,239,25,64,65]),function(Y,e,D,n,L,T,A,I,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends I.UserDataAutoSyncService{constructor(S,u,v,d,m,w,y,p,l,i,a){super(S,u,v,d,m,y,p,l,i,a);this._register(D.Event.debounce(D.Event.any(D.Event.map(w.onDidFocusWindow,()=>"windowFocus"),D.Event.map(w.onDidOpenWindow,()=>"windowOpen")),(r,t)=>r?[...r,t]:[t],1e3)(r=>this.triggerSync(r,!0,!1)))}};C=he([J(0,L.IProductService),J(1,b.IUserDataSyncStoreManagementService),J(2,b.IUserDataSyncStoreService),J(3,b.IUserDataSyncEnablementService),J(4,b.IUserDataSyncService),J(5,n.INativeHostService),J(6,b.IUserDataSyncLogService),J(7,E.IUserDataSyncAccountService),J(8,A.ITelemetryService),J(9,P.IUserDataSyncMachinesService),J(10,T.IStorageService)],C),e.UserDataAutoSyncService=C}),define(te[244],ne([0,1,5,3,2]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends L.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:b,getActiveWindowId:E}){super();this.disposables=this._register(new L.DisposableStore),n.Event.latch(n.Event.any(I,b))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>E()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(te[66],ne([0,1,50,5,10,15,22,124,256,257]),function(Y,e,D,n,L,T,A,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class P extends Error{constructor(i,a){let r=a.message;switch(i){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=i,this.cause=a}}e.ExtractError=P;function C(l){const i=l.externalFileAttributes>>16||33188;return[448,56,7].map(a=>i&a).reduce((a,r)=>a+r,i&61440)}function f(l){if(l instanceof P)return l;let i;return/end of central directory record signature not found/.test(l.message)&&(i="CorruptZip"),new P(i,l)}function S(l,i,a,r,t,o){const s=L.dirname(i),c=L.join(r,s);if(!c.startsWith(r))return Promise.reject(new Error(I.localize(0,null,i)));const h=L.join(r,i);let g;return o.onCancellationRequested(()=>{g&&g.destroy()}),Promise.resolve(A.Promises.mkdir(c,{recursive:!0})).then(()=>new Promise((R,_)=>{if(!o.isCancellationRequested)try{g=(0,D.createWriteStream)(h,{mode:a}),g.once("close",()=>R()),g.once("error",_),l.once("error",_),l.pipe(g)}catch(U){_(U)}}))}function u(l,i,a,r){let t=(0,n.createCancelablePromise)(()=>Promise.resolve()),o=0;return r.onCancellationRequested(()=>{t.cancel(),l.close()}),new Promise((s,c)=>{const h=new n.Sequencer,g=R=>{R.isCancellationRequested||(o++,l.readEntry())};l.once("error",c),l.once("close",()=>t.then(()=>{r.isCancellationRequested||l.entryCount===o?s():c(new P("Incomplete",new Error(I.localize(1,null,o,l.entryCount))))},c)),l.readEntry(),l.on("entry",R=>{if(r.isCancellationRequested)return;if(!a.sourcePathRegex.test(R.fileName)){g(r);return}const _=R.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(_)){const k=L.join(i,_);t=(0,n.createCancelablePromise)(M=>A.Promises.mkdir(k,{recursive:!0}).then(()=>g(M)).then(void 0,c));return}const U=d(l,R),F=C(R);t=(0,n.createCancelablePromise)(k=>h.queue(()=>U.then(M=>S(M,_,F,i,a,k).then(()=>g(k)))).then(null,c))})})}function v(l,i=!1){return new Promise((a,r)=>{(0,b.open)(l,i?{lazyEntries:!0}:void 0,(t,o)=>{t?r(f(t)):a((0,T.assertIsDefined)(o))})})}function d(l,i){return new Promise((a,r)=>{l.openReadStream(i,(t,o)=>{t?r(f(t)):a((0,T.assertIsDefined)(o))})})}function m(l,i){return new Promise((a,r)=>{const t=new E.ZipFile;i.forEach(s=>{s.contents?t.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&t.addFile(s.localPath,s.path)}),t.end();const o=(0,D.createWriteStream)(l);t.outputStream.pipe(o),t.outputStream.once("error",r),o.once("error",r),o.once("finish",()=>a(l))})}e.zip=m;function w(l,i,a={},r){const t=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let o=v(l,!0);return a.overwrite&&(o=o.then(s=>A.Promises.rm(i).then(()=>s))),o.then(s=>u(s,i,{sourcePathRegex:t},r))}e.extract=w;function y(l,i){return v(l).then(a=>new Promise((r,t)=>{a.on("entry",o=>{o.fileName===i&&d(a,o).then(s=>r(s),s=>t(s))}),a.once("close",()=>t(new Error(I.localize(2,null,i))))}))}function p(l,i){return y(l,i).then(a=>new Promise((r,t)=>{const o=[];a.once("error",t),a.on("data",s=>o.push(s)),a.on("end",()=>r(Buffer.concat(o)))}))}e.buffer=p}),define(te[245],ne([0,1,66,133]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function L(T){return(0,D.buffer)(T,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=L}),define(te[246],ne([0,1,16,5,9,2,18,10,4,19,61,7,29,22,66,134,13,30,31,155,14,8,26]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S,u,v,d,m,w,y,p,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let a=class extends T.Disposable{constructor(t,o,s,c,h){super();this.beforeRemovingExtension=t,this.fileService=o,this.logService=s,this.environmentService=c,this.productService=h,this._devSystemExtensionsPath=null,this.systemExtensionsPath=c.builtinExtensionsPath,this.extensionsPath=c.extensionsPath,this.uninstalledPath=I.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new n.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const o=[];(t===null||t===0)&&o.push(this.scanSystemExtensions().then(null,s=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(s).message,m.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&o.push(this.scanUserExtensions(!0).then(null,s=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(s).message,m.ExtensionManagementErrorCode.Internal))));try{const s=await Promise.all(o);return(0,D.flatten)(s)}catch(s){throw this.joinErrors(s)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[o,s]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return s=s.filter(c=>!o[new w.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version).key()]),t&&(s=(0,w.groupByExtension)(s,h=>h.identifier).map(h=>h.sort((g,R)=>P.rcompare(g.manifest.version,R.manifest.version))[0])),this.logService.trace("Scanned user extensions:",s.length),s}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,o,s,c){const h=t.key(),g=I.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),R=I.join(this.extensionsPath,h);try{await S.Promises.rm(R)}catch{try{await S.Promises.rm(R)}catch{}throw new m.ExtensionManagementError((0,v.localize)(0,null,R,t.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,o,g,c);let _=await this.scanExtension(C.URI.file(g),1);if(!_)throw new Error((0,v.localize)(1,null,g));await this.storeMetadata(_,{...s,installedTimestamp:Date.now()});try{await this.rename(t,g,R,Date.now()+2*60*1e3),this.logService.info("Renamed to",R)}catch(U){try{await S.Promises.rm(g)}catch{}if(U.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(U)}. Deleted from extracted location`,g),U}try{_=await this.scanExtension(C.URI.file(R),1)}catch{}if(_)return _;throw new Error((0,v.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,o){return this.setMetadata(t,o),await this.storeMetadata(t,{...o,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,o){o.isMachineScoped=o.isMachineScoped||void 0,o.isBuiltin=o.isBuiltin||void 0,o.installedTimestamp=o.installedTimestamp||void 0;const s=I.join(t.location.fsPath,"package.json"),c=await S.Promises.readFile(s,"utf8"),{manifest:h}=await this.parseManifest(c);return h.__metadata=o,await S.Promises.writeFile(s,JSON.stringify(h,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const o=t.map(s=>new w.ExtensionIdentifierWithVersion(s.identifier,s.manifest.version));await this.withUninstalledExtensions(s=>{o.forEach(c=>s[c.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(c=>delete c[t.key()]);const s=(await this.scanExtensions(1)).find(c=>new w.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version).equals(t))||null;return s?(await this.storeMetadata(s,{installedTimestamp:Date.now()}),this.scanExtension(s.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let o;try{o=await S.Promises.readFile(this.uninstalledPath,"utf8")}catch(c){if(c.code!=="ENOENT")throw c}let s={};if(o)try{s=JSON.parse(o)}catch{}return t&&(t(s),Object.keys(s).length?await S.Promises.writeFile(this.uninstalledPath,JSON.stringify(s)):await S.Promises.rm(this.uninstalledPath)),s})}async removeExtension(t,o){this.logService.trace(`Deleting ${o} extension from disk`,t.identifier.id,t.location.fsPath),await S.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(o=>delete o[new w.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,o,s,c){this.logService.trace(`Started extracting the extension from ${o} to ${s}`);try{await S.Promises.rm(s)}catch(h){throw new m.ExtensionManagementError(this.joinErrors(h).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,u.extract)(o,s,{sourcePath:"extension",overwrite:!0},c),this.logService.info(`Extracted extension to ${s}:`,t.id)}catch(h){try{await S.Promises.rm(s)}catch{}let g=m.ExtensionManagementErrorCode.Extract;throw h instanceof u.ExtractError&&(h.type==="CorruptZip"?g=m.ExtensionManagementErrorCode.CorruptZip:h.type==="Incomplete"&&(g=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(h.message,g)}}async rename(t,o,s,c){try{await S.Promises.rename(o,s)}catch(h){if(b.isWindows&&h&&h.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${o} to ${s} with 'EPERM' error. Trying again...`,t.id),this.rename(t,o,s,c);throw new m.ExtensionManagementError(h.message||(0,v.localize)(3,null,o,s),h.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const o=this.scanDevSystemExtensions(),[s,c]=await Promise.all([t,o]);return[...s,...c]}async scanExtensionsInDir(t,o){const s=new n.Limiter(10),c=await this.fileService.resolve(C.URI.file(t));return c.children?(await Promise.all(c.children.filter(g=>g.isDirectory).map(g=>s.queue(async()=>o===1&&(0,E.basename)(g.resource).indexOf(".")===0?null:this.scanExtension(g.resource,o))))).filter(g=>g&&g.identifier):[]}async scanExtension(t,o){try{const s=await this.fileService.resolve(t);if(s.children){const{manifest:c,metadata:h}=await this.readManifest(t.fsPath),g=s.children.find(({name:F})=>/^readme(\.txt|\.md|)$/i.test(F))?.resource,R=s.children.find(({name:F})=>/^changelog(\.txt|\.md|)$/i.test(F))?.resource,_={id:(0,w.getGalleryExtensionId)(c.publisher,c.name)},U={type:o,identifier:_,manifest:c,location:t,readmeUrl:g,changelogUrl:R,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:o===0};return this.setMetadata(U,h),U}}catch(s){o!==0&&this.logService.trace(s)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const o=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",o.length),o.filter(s=>t.some(c=>(0,w.areSameExtensions)(s.identifier,{id:c})))}else return[]}setMetadata(t,o){t.publisherDisplayName=o?.publisherDisplayName||null,t.publisherId=o?.publisherId||null,t.identifier.uuid=o?.id,t.isMachineScoped=!!o?.isMachineScoped,t.isPreReleaseVersion=!!o?.isPreReleaseVersion,t.preRelease=!!o?.preRelease,t.isBuiltin=t.type===0||!!o?.isBuiltin,t.installedTimestamp=o?.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),o=await this.scanAllUserExtensions(),s=new Set;for(const g of o)t[new w.ExtensionIdentifierWithVersion(g.identifier,g.manifest.version).key()]||s.add(g.identifier.id.toLowerCase());const c=(0,w.groupByExtension)(o,g=>g.identifier);await n.Promises.settled(c.map(async g=>{const R=g.sort((_,U)=>P.rcompare(_.manifest.version,U.manifest.version))[0];s.has(R.identifier.id.toLowerCase())||await this.beforeRemovingExtension(R)}));const h=o.filter(g=>t[new w.ExtensionIdentifierWithVersion(g.identifier,g.manifest.version).key()]);await n.Promises.settled(h.map(g=>this.removeUninstalledExtension(g)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),o=[],s=(0,w.groupByExtension)(t,c=>c.identifier);o.push(...(0,D.flatten)(s.map(c=>c.sort((h,g)=>P.rcompare(h.manifest.version,g.manifest.version)).slice(1)))),await n.Promises.settled(o.map(c=>this.removeExtension(c,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const o=Array.isArray(t)?t:[t];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((s,c)=>new Error(`${s.message}${s.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=I.normalize(I.join(A.FileAccess.asFileUri("",Y).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const o=[S.Promises.readFile(I.join(t,"package.json"),"utf8").then(g=>this.parseManifest(g)),S.Promises.readFile(I.join(t,"package.nls.json"),"utf8").then(void 0,g=>g.code!=="ENOENT"?Promise.reject(g):"{}").then(g=>JSON.parse(g))],[{manifest:s,metadata:c},h]=await Promise.all(o);return{manifest:(0,y.localizeManifest)(s,h),metadata:c}}parseManifest(t){return new Promise((o,s)=>{try{const c=JSON.parse(t),h=c.__metadata||null;o({manifest:c,metadata:h})}catch{s(new Error((0,v.localize)(4,null)))}})}};a=he([J(1,p.IFileService),J(2,l.ILogService),J(3,d.INativeEnvironmentService),J(4,i.IProductService)],a),e.ExtensionsScanner=a}),define(te[247],ne([0,1,37,9,18,10,4,32,19,61,7,29,22,66,132,81,13,207,30,31,189,174,245,190,246,222,78,14,6,8,26,21,34]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S,u,v,d,m,w,y,p,l,i,a,r,t,o,s,c,h,g,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let U=class extends m.AbstractExtensionManagementService{constructor(z,G,ee,q,j,K,V,Q,Z){super(z,G,ee,Q);this.environmentService=q,this.downloadService=j,this.fileService=V;const B=this._register(K.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(K.createInstance(r.ExtensionsScanner,N=>B.postUninstall(N))),this.manifestCache=this._register(new a.ExtensionsManifestCache(q,this)),this.extensionsDownloader=this._register(K.createInstance(p.ExtensionsDownloader));const O=this._register(new t.ExtensionsWatcher(this,V,q,ee,Z));this._register(O.onDidChangeExtensionsByAnotherSource(({added:N,removed:W})=>{N.length&&this._onDidInstallExtensions.fire(N.map(H=>({identifier:H.identifier,operation:1,local:H}))),W.forEach(H=>this._onDidUninstallExtension.fire({identifier:H}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const z=await this.isAlpineLinux(),G=(0,w.getTargetPlatform)(z?"alpine":A.platform,I.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",G),G})()),this._targetPlatformPromise}async isAlpineLinux(){if(!A.isLinux)return!1;let z;try{z=(await this.fileService.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{z=(await this.fileService.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(ee){this.logService.debug("Error while getting the os-release file.",(0,n.getErrorMessage)(ee))}}return!!z&&(z.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(z){this.logService.trace("ExtensionManagementService#zip",z.identifier.id);const G=await this.collectFiles(z),ee=await(0,S.zip)((0,b.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,G);return P.URI.file(ee)}async unzip(z){return this.logService.trace("ExtensionManagementService#unzip",z.toString()),(await this.install(z)).identifier}async getManifest(z){const G=await this.downloadVsix(z),ee=T.resolve(G.fsPath);return(0,i.getManifest)(ee)}getInstalled(z=null){return this.extensionsScanner.scanExtensions(z)}async install(z,G={}){this.logService.trace("ExtensionManagementService#install",z.toString());const ee=await this.downloadVsix(z),q=await(0,i.getManifest)(T.resolve(ee.fsPath));if(q.engines&&q.engines.vscode&&!(0,o.isEngineValid)(q.engines.vscode,this.productService.version,this.productService.date))throw new Error(u.localize(0,null,(0,y.getGalleryExtensionId)(q.publisher,q.name),this.productService.version));return this.installExtension(q,ee,G)}async updateMetadata(z,G){this.logService.trace("ExtensionManagementService#updateMetadata",z.identifier.id);const ee={...z.manifest.__metadata||{},...G};return G.isPreReleaseVersion&&(ee.preRelease=!0),z=await this.extensionsScanner.saveMetadataForLocalExtension(z,ee),this.manifestCache.invalidate(),z}async updateExtensionScope(z,G){return this.logService.trace("ExtensionManagementService#updateExtensionScope",z.identifier.id),z=await this.extensionsScanner.saveMetadataForLocalExtension(z,{...z.manifest.__metadata||{},isMachineScoped:G}),this.manifestCache.invalidate(),z}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(z){if(z.scheme===L.Schemas.file)return z;const G=(0,b.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download(z,G),G}createInstallExtensionTask(z,G,ee){return P.URI.isUri(G)?new M(z,G,ee,this.galleryService,this.extensionsScanner,this.logService):new k(G,ee,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(z,G){return new $(z,G,this.extensionsScanner)}async collectFiles(z){const G=async q=>{let j=await f.Promises.readdir(q);j=j.map(Q=>T.join(q,Q));const K=await Promise.all(j.map(Q=>f.Promises.stat(Q)));let V=Promise.resolve([]);return K.forEach((Q,Z)=>{const B=j[Z];Q.isFile()&&(V=V.then(O=>[...O,B])),Q.isDirectory()&&(V=V.then(O=>G(B).then(N=>[...O,...N])))}),V};return(await G(z.location.fsPath)).map(q=>({path:`extension/${T.relative(z.location.fsPath,q)}`,localPath:q}))}};U=he([J(0,w.IExtensionGalleryService),J(1,R.ITelemetryService),J(2,h.ILogService),J(3,d.INativeEnvironmentService),J(4,v.IDownloadService),J(5,c.IInstantiationService),J(6,s.IFileService),J(7,g.IProductService),J(8,_.IUriIdentityService)],U),e.ExtensionManagementService=U;class F extends m.AbstractExtensionTask{constructor(z,G,ee,q){super();this.identifier=z,this.source=G,this.extensionsScanner=ee,this.logService=q,this._operation=2}get operation(){return this._operation}async installExtension(z,G){try{const ee=await this.unsetUninstalledAndGetLocal(z.identifierWithVersion);if(ee)return z.metadata?this.extensionsScanner.saveMetadataForLocalExtension(ee,{...ee.manifest.__metadata||{},...z.metadata}):ee}catch{throw A.isMacintosh?new w.ExtensionManagementError(u.localize(1,null),w.ExtensionManagementErrorCode.Internal):new w.ExtensionManagementError(u.localize(2,null),w.ExtensionManagementErrorCode.Internal)}return this.extract(z,G)}async unsetUninstalledAndGetLocal(z){if(!await this.isUninstalled(z))return null;this.logService.trace("Removing the extension from uninstalled list:",z.id);const ee=await this.extensionsScanner.setInstalled(z);return this.logService.info("Removed the extension from uninstalled list:",z.id),ee}async isUninstalled(z){return!!(await this.extensionsScanner.getUninstalledExtensions())[z.key()]}async extract({zipPath:z,identifierWithVersion:G,metadata:ee},q){let j=await this.extensionsScanner.extractUserExtension(G,z,ee,q);return this.logService.info("Extracting completed.",G.id),j}}class k extends F{constructor(z,G,ee,q,j){super(z.identifier,z,q,j);this.gallery=z,this.options=G,this.extensionsDownloader=ee}async doRun(z){const ee=(await this.extensionsScanner.scanExtensions(null)).find(j=>(0,y.areSameExtensions)(j.identifier,this.gallery.identifier));ee&&(this._operation=3);const q=await this.downloadInstallableExtension(this.gallery,this._operation);q.metadata.isMachineScoped=this.options.isMachineScoped||ee?.isMachineScoped,q.metadata.isBuiltin=this.options.isBuiltin||ee?.isBuiltin,q.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,q.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:ee?.preRelease||this.options.installPreReleaseVersion;try{const j=await this.installExtension(q,z);return ee&&E.neq(ee.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(ee),j}catch(j){throw await this.deleteDownloadedVSIX(q.zipPath),j}}async deleteDownloadedVSIX(z){try{await this.extensionsDownloader.delete(P.URI.file(z))}catch(G){this.logService.warn("Error while deleting the downloaded vsix",z.toString(),(0,n.getErrorMessage)(G))}}async downloadInstallableExtension(z,G){const ee={id:z.identifier.uuid,publisherId:z.publisherId,publisherDisplayName:z.publisherDisplayName};let q;try{this.logService.trace("Started downloading extension:",z.identifier.id),q=(await this.extensionsDownloader.downloadExtension(z,G)).fsPath,this.logService.info("Downloaded extension:",z.identifier.id,q)}catch(j){throw new w.ExtensionManagementError((0,m.joinErrors)(j).message,w.ExtensionManagementErrorCode.Download)}try{const j=await(0,i.getManifest)(q);return{zipPath:q,identifierWithVersion:new y.ExtensionIdentifierWithVersion(z.identifier,j.version),metadata:ee}}catch(j){throw await this.deleteDownloadedVSIX(q),new w.ExtensionManagementError((0,m.joinErrors)(j).message,w.ExtensionManagementErrorCode.Invalid)}}}class M extends F{constructor(z,G,ee,q,j,K){super({id:(0,y.getGalleryExtensionId)(z.publisher,z.name)},G,j,K);this.manifest=z,this.location=G,this.options=ee,this.galleryService=q}async doRun(z){const G=new y.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),q=(await this.extensionsScanner.scanExtensions(1)).find(K=>(0,y.areSameExtensions)(this.identifier,K.identifier)),j=await this.getMetadata(this.identifier.id,this.manifest.version,z);if(j.isMachineScoped=this.options.isMachineScoped||q?.isMachineScoped,j.isBuiltin=this.options.isBuiltin||q?.isBuiltin,q)if(this._operation=3,G.equals(new y.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version)))try{await this.extensionsScanner.removeExtension(q,"existing")}catch{throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else E.gt(q.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(q);else{const K=await this.unsetUninstalledAndGetLocal(G);if(K)try{await this.extensionsScanner.removeExtension(K,"existing")}catch{throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:T.resolve(this.location.fsPath),identifierWithVersion:G,metadata:j},z)}async getMetadata(z,G,ee){try{let[q]=await this.galleryService.getExtensions([{id:z,version:G}],ee);if(q||([q]=await this.galleryService.getExtensions([{id:z}],ee)),q)return{id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId,isPreReleaseVersion:q.properties.isPreReleaseVersion,preRelease:q.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class $ extends m.AbstractExtensionTask{constructor(z,G,ee){super();this.extension=z,this.options=G,this.extensionsScanner=ee}async doRun(z){const G=[],ee=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const q=new y.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);G.push(...ee.filter(j=>q.equals(new y.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version))))}else G.push(...ee.filter(q=>(0,y.areSameExtensions)(q.identifier,this.extension.identifier)));if(!G.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...G),this.options.remove)for(const q of G)try{z.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(q)}catch(j){throw new Error(u.localize(6,null,(0,D.toErrorMessage)(j)))}}}}),define(te[248],ne([0,1,83,56,33,17,9,3,2,10,4,29,36,73,258]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(R,_=""){this.debugLabel=_,this.socket=R,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=U=>{if(this.traceSocketEvent("error",{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,A.onUnexpectedError)(U)}},this.socket.on("error",this._errorListener)}traceSocketEvent(R,_){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,R,_)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(R){const _=U=>{this.traceSocketEvent("read",U),R(T.VSBuffer.wrap(U))};return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(R){const _=U=>{this.traceSocketEvent("close",{hadError:U}),R({type:0,hadError:U,error:void 0})};return this.socket.on("close",_),{dispose:()=>this.socket.off("close",_)}}onEnd(R){const _=()=>{this.traceSocketEvent("nodeEndReceived"),R()};return this.socket.on("end",_),{dispose:()=>this.socket.off("end",_)}}write(R){if(!this.socket.destroyed)try{this.traceSocketEvent("write",R),this.socket.write(R.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((R,_)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),R();return}const U=()=>{this.socket.off("close",U),this.socket.off("end",U),this.socket.off("error",U),this.socket.off("timeout",U),this.socket.off("drain",U),this.traceSocketEvent("nodeDrainEnd"),R()};this.socket.on("close",U),this.socket.on("end",U),this.socket.on("error",U),this.socket.on("timeout",U),this.socket.on("drain",U)})}}e.NodeSocket=v;var d;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize"})(d||(d={}));var m;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(m||(m={}));class w extends b.Disposable{constructor(R,_,U,F){super();this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=R,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:_,inflateBytesLength:U?.byteLength||0,recordInflateBytes:F}),this._flowManager=this._register(new y(this,_,U,F,this._onData,(k,M)=>this._write(k,M))),this._register(this._flowManager.onError(k=>{console.error(k),(0,A.onUnexpectedError)(k),this._onClose.fire({type:0,hadError:!0,error:k})})),this._incomingData=new S.ChunkStream,this._register(this.socket.onData(k=>this._acceptChunk(k))),this._register(this.socket.onClose(k=>this._onClose.fire(k)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(R,_){this.socket.traceSocketEvent(R,_)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(R){return this._onData.event(R)}onClose(R){return this._onClose.event(R)}onEnd(R){return this.socket.onEnd(R)}write(R){this._flowManager.writeMessage(R)}_write(R,_){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",R);let U=2;R.byteLength<126?U+=0:R.byteLength<2**16?U+=2:U+=8;const F=T.VSBuffer.alloc(U);if(_?F.writeUInt8(194,0):F.writeUInt8(130,0),R.byteLength<126)F.writeUInt8(R.byteLength,1);else if(R.byteLength<2**16){F.writeUInt8(126,1);let k=1;F.writeUInt8(R.byteLength>>>8&255,++k),F.writeUInt8(R.byteLength>>>0&255,++k)}else{F.writeUInt8(127,1);let k=1;F.writeUInt8(0,++k),F.writeUInt8(0,++k),F.writeUInt8(0,++k),F.writeUInt8(0,++k),F.writeUInt8(R.byteLength>>>24&255,++k),F.writeUInt8(R.byteLength>>>16&255,++k),F.writeUInt8(R.byteLength>>>8&255,++k),F.writeUInt8(R.byteLength>>>0&255,++k)}this.socket.write(T.VSBuffer.concat([F,R]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(R){if(R.byteLength!==0){for(this._incomingData.acceptChunk(R);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),U=_.readUInt8(0),F=(U&128)>>>7,k=(U&64)>>>6,M=_.readUInt8(1),$=(M&128)>>>7,x=M&127;this._state.state=2,this._state.readLen=2+($?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=F,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(k)),this._state.firstFrameOfMessage=Boolean(F),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),U=_.readUInt8(1),F=(U&128)>>>7;let k=U&127,M=1;k===126?k=_.readUInt8(++M)*2**8+_.readUInt8(++M):k===127&&(k=_.readUInt8(++M)*0+_.readUInt8(++M)*0+_.readUInt8(++M)*0+_.readUInt8(++M)*0+_.readUInt8(++M)*2**24+_.readUInt8(++M)*2**16+_.readUInt8(++M)*2**8+_.readUInt8(++M));let $=0;F&&($=_.readUInt8(++M)*2**24+_.readUInt8(++M)*2**16+_.readUInt8(++M)*2**8+_.readUInt8(++M)),this._state.state=3,this._state.readLen=k,this._state.mask=$,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",_),i(_,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",_),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(_,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class y extends b.Disposable{constructor(R,_,U,F,k,M){super();this._tracer=R,this._onData=k,this._writeFn=M,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,_?(this._zlibInflateStream=this._register(new p(this._tracer,F,U,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError($=>this._onError.fire($))),this._register(this._zlibDeflateStream.onError($=>this._onError.fire($)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:T.VSBuffer.alloc(0)}writeMessage(R){this._writeQueue.push(R),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const R=this._writeQueue.shift();if(this._zlibDeflateStream){const _=await this._deflateMessage(this._zlibDeflateStream,R);this._writeFn(_,!0)}else this._writeFn(R,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(R,_){return new Promise((U,F)=>{R.write(_),R.flush(k=>U(k))})}acceptFrame(R,_,U){this._readQueue.push({data:R,isCompressed:_,isLastFrameOfMessage:U}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const R=this._readQueue.shift();if(this._zlibInflateStream&&R.isCompressed){const _=await this._inflateFrame(this._zlibInflateStream,R.data,R.isLastFrameOfMessage);this._onData.fire(_)}else this._onData.fire(R.data)}this._isProcessingReadQueue=!1}}_inflateFrame(R,_,U){return new Promise((F,k)=>{R.write(_),U&&R.write(T.VSBuffer.fromByteArray([0,0,255,255])),R.flush(M=>F(M))})}}class p extends b.Disposable{constructor(R,_,U,F){super();this._tracer=R,this._recordInflateBytes=_,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=u.createInflateRaw(F),this._zlibInflate.on("error",k=>{this._tracer.traceSocketEvent("zlibInflateError",{message:k?.message,code:k?.code}),this._onError.fire(k)}),this._zlibInflate.on("data",k=>{this._tracer.traceSocketEvent("zlibInflateData",k),this._pendingInflateData.push(T.VSBuffer.wrap(k))}),U&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",U.buffer),this._zlibInflate.write(U.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.concat(this._recordedInflateBytes):T.VSBuffer.alloc(0)}write(R){this._recordInflateBytes&&this._recordedInflateBytes.push(R.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",R),this._zlibInflate.write(R.buffer)}flush(R){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const _=T.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,R(_)})}}class l extends b.Disposable{constructor(R,_){super();this._tracer=R,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=u.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",U=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibDeflate.on("data",U=>{this._tracer.traceSocketEvent("zlibDeflateData",U),this._pendingDeflateData.push(T.VSBuffer.wrap(U))})}write(R){this._tracer.traceSocketEvent("zlibDeflateWrite",R.buffer),this._zlibDeflate.write(R.buffer)}flush(R){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let _=T.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.byteLength-4),R(_)})}}function i(g,R){if(R===0)return;let _=g.byteLength>>>2;for(let x=0;x<_;x++){const z=g.readUInt32BE(x*4);g.writeUInt32BE(z^R,x*4)}let U=_*4,F=g.byteLength-U;const k=R>>>24&255,M=R>>>16&255,$=R>>>8&255;F>=1&&g.writeUInt8(g.readUInt8(U)^k,U),F>=2&&g.writeUInt8(g.readUInt8(U+1)^M,U+1),F>=3&&g.writeUInt8(g.readUInt8(U+2)^$,U+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function r(){const g=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;let R;return e.XDG_RUNTIME_DIR?R=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${g}.sock`):R=(0,E.join)((0,L.tmpdir)(),`vscode-ipc-${g}.sock`),o(R),R}e.createRandomIPCHandle=r;function t(g,R,_){const U=(0,D.createHash)("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${_}-${R}-sock`;let F;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-${U.substr(0,8)}-${_}-${R}.sock`):F=(0,E.join)(g,`${_}-${R}.sock`),o(F),F}e.createStaticIPCHandle=t;function o(g){const R=a[P.platform];typeof R=="number"&&g.length>=R&&console.warn(`WARNING: IPC handle "${g}" is longer than ${R} chars, try a shorter --user-data-dir`)}class s extends f.IPCServer{constructor(R){super(s.toClientConnectionEvent(R));this.server=R}static toClientConnectionEvent(R){const _=I.Event.fromNodeEventEmitter(R,"connection");return I.Event.map(_,U=>({protocol:new S.Protocol(new v(U,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(U,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function c(g){return new Promise((R,_)=>{const U=(0,n.createServer)();U.on("error",_),U.listen(g,()=>{U.removeListener("error",_),R(new s(U))})})}e.serve=c;function h(g,R){return new Promise((_,U)=>{const F=(0,n.createConnection)(g,()=>{F.removeListener("error",U),_(S.Client.fromSocket(new v(F,`ipc-client${R}`),R))});F.once("error",U)})}e.connect=h}),define(te[249],ne([0,1,56,248]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,T,A,I,b){const E=C=>b(C,void 0),P=D.createConnection({host:L,port:T},()=>{P.removeListener("error",E);const C=Buffer.alloc(16);for(let v=0;v<16;v++)C[v]=Math.round(Math.random()*256);const f=C.toString("base64"),S=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${T}/?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];P.write(S.join(`\r
`)+`\r
\r
`);const u=v=>{v.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",u),b(void 0,new n.NodeSocket(P,I)))};P.on("data",u)});P.setNoDelay(!0),P.once("error",E)}}}),define(te[250],ne([0,1,56,115,249,5,2,20,8,26,185,62,92]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function S(w,y,p,l,i){let a;for(let r=3;r&&(a&&a.dispose(),a=await new u(w,y,p,l,i).waitForReady(),!(i&&n.BROWSER_RESTRICTED_PORTS[i]||!n.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));r--);return a}class u extends A.Disposable{constructor(y,p,l,i,a){super();this.defaultTunnelHost=p,this.suggestedLocalPort=a,this.privacy=C.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=y,this._server=D.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(p=>{p()})}async waitForReady(){let y=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),p=null;return this._server.listen(y,this.defaultTunnelHost),await this._barrier.wait(),p=this._server.address(),p||(y=0,this._server.listen(y,this.defaultTunnelHost),await this._barrier.wait(),p=this._server.address()),this.tunnelLocalPort=p.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${p.port}`,this}async _onConnection(y){y.pause();const p=(0,C.isLocalhost)(this.tunnelRemoteHost)||(0,C.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,P.connectRemoteAgentTunnel)(this._options,p,this.tunnelRemotePort),i=l.getSocket().socket,a=l.readEntireBuffer();l.dispose(),a.byteLength>0&&y.write(a.buffer),y.on("end",()=>{this._socketsDispose.delete(y.localAddress),i.end()}),y.on("close",()=>i.end()),y.on("error",()=>{this._socketsDispose.delete(y.localAddress),i.destroy()}),i.on("end",()=>y.end()),i.on("close",()=>y.end()),i.on("error",()=>{y.destroy()}),y.pipe(i),i.pipe(y),this._socketsDispose.set(y.localAddress,()=>{y.end(),i.end()})}}let v=class extends C.AbstractTunnelService{constructor(y,p,l,i,a){super(p);this.socketFactory=y,this.signService=l,this.productService=i,this.configurationService=a}get defaultTunnelHost(){const y=this.configurationService.getValue("remote.localPortHost");return!y||y==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(y,p,l,i,a,r,t){const o=this.getTunnelFromMap(p,l);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,p,l,i,a,r,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${p}:${l} on local port ${i}.`);const s={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:y,signService:this.signService,logService:this.logService,ipcLogger:null},c=S(s,this.defaultTunnelHost,p,l,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(p,l,c),c}}};v=he([J(1,b.ILogService),J(2,f.ISignService),J(3,E.IProductService),J(4,I.IConfigurationService)],v),e.BaseTunnelService=v;let d=class extends v{constructor(y,p,l,i){super(L.nodeSocketFactory,y,p,l,i)}};d=he([J(0,b.ILogService),J(1,f.ISignService),J(2,E.IProductService),J(3,I.IConfigurationService)],d),e.TunnelService=d;let m=class extends A.Disposable{constructor(y,p,l,i){super();this.logService=y,this.productService=p,this.signService=l,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(y,p,l,i,a,r,t,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${i} on local port ${a}.`),!this._tunnelServices.has(y)){const s=new d(this.logService,this.signService,this.productService,this.configurationService);this._register(s),this._tunnelServices.set(y,s),s.onTunnelClosed(async()=>{(await s.tunnels).length===0&&(s.dispose(),this._tunnelServices.delete(y))})}return this._tunnelServices.get(y).openTunnel(p,l,i,a,r,t,o)}};m=he([J(0,b.ILogService),J(1,E.IProductService),J(2,f.ISignService),J(3,I.IConfigurationService)],m),e.SharedTunnelsService=m}),define(te[259],ne([0,1,74,33,37,9,2,18,19,7,36,118,179,202,180,171,172,173,158,160,20,183,80,206,81,195,13,199,201,211,30,187,208,247,82,156,14,176,178,51,6,168,85,169,170,59,191,8,86,60,87,26,194,43,24,204,205,21,93,94,95,44,212,213,96,215,221,63,98,25,64,235,237,238,65,236,240,241,242,243,244,92,200,62,250,192,193,91,198,209,34,223,4,224,163,182,181]),function(Y,e,D,n,L,T,A,I,b,E,P,C,f,S,u,v,d,m,w,y,p,l,i,a,r,t,o,s,c,h,g,R,_,U,F,k,M,$,x,z,G,ee,q,j,K,V,Q,Z,B,O,N,W,H,re,se,ue,de,we,pe,ge,be,Re,Le,Te,qe,Je,Ge,je,ie,ae,le,ye,Ee,Me,ke,Oe,_e,X,oe,ce,fe,me,De,Se,Pe,Ie,Ce,Ae,Ne,ze,We,It,Rt,Dt,pt,kt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Lt extends A.Disposable{constructor(ve){super();this.configuration=ve,this.server=this._register(new C.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ve=()=>this.dispose();process.once("exit",ve),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Ue="vscode:electron-main->shared-process=disposeWorker",$e=(Ke,Fe)=>this.onDisposeWorker(Fe);D.ipcRenderer.on(Ue,$e),this._register((0,A.toDisposable)(()=>D.ipcRenderer.removeListener(Ue,$e)))}onDisposeWorker(ve){this.sharedProcessWorkerService?.disposeWorker(ve)}async open(){const ve=await this.initServices();(0,ae.registerConfiguration)(),ve.invokeFunction(Ue=>{const $e=Ue.get(Z.ILogService);$e.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler($e)}),this._register((0,A.combinedDisposable)(ve.createInstance(f.CodeCacheCleaner,this.configuration.codeCachePath),ve.createInstance(u.LanguagePackCachedDataCleaner),ve.createInstance(m.StorageDataCleaner,this.configuration.backupWorkspacesPath),ve.createInstance(d.LogsDataCleaner),ve.createInstance(v.LocalizationsUpdater),ve.createInstance(S.ExtensionsCleaner)))}async initServices(){const ve=new q.ServiceCollection,Ue={_serviceBrand:void 0,...N.default};ve.set(W.IProductService,Ue);const $e=new P.StaticRouter(Ve=>Ve==="main"),Ke=new j.MessagePortMainProcessService(this.server,$e);ve.set(K.IMainProcessService,Ke);const Fe=new s.SharedProcessEnvironmentService(this.configuration.args,Ue);ve.set(o.INativeEnvironmentService,Fe);const it=new B.LogLevelChannelClient(this.server.getChannel("logLevel",$e)),Xe=new B.LoggerChannelClient(this.configuration.logLevel,it.onDidChangeLogLevel,Ke.getChannel("logger"));ve.set(Z.ILoggerService,Xe);const ot=this._register(new Z.MultiplexLogService([this._register(new Z.ConsoleLogger(this.configuration.logLevel)),this._register(Xe.createLogger((0,b.joinPath)(E.URI.file(Fe.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ye=this._register(new B.FollowerLogService(it,ot));ve.set(Z.ILogService,Ye),this.sharedProcessWorkerService=new Ne.SharedProcessWorkerService(Ye,Ue,Fe),ve.set(Ae.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Be=this._register(new $.FileService(Ye));ve.set(M.IFileService,Be);const at=this._register(new x.DiskFileSystemProvider(Ye));Be.registerProvider(I.Schemas.file,at);const ct=this._register(new Dt.FileUserDataProvider(I.Schemas.file,this._register(new pt.DiskFileSystemProviderClient(Ke.getChannel(pt.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Rt.isLinux})),I.Schemas.userData,Be,Ye));Be.registerProvider(I.Schemas.userData,ct);const xe=this._register(new l.ConfigurationService(Fe.settingsResource,Be));ve.set(p.IConfigurationService,xe);const et=new ue.NativeStorageService(void 0,Ke,Fe);ve.set(se.IStorageService,et),this._register((0,A.toDisposable)(()=>et.flush())),await Promise.all([xe.initialize(),et.initialize()]),ve.set(We.IUriIdentityService,new It.UriIdentityService(Be)),ve.set(re.IRequestService,new z.SyncDescriptor(H.RequestService)),ve.set(w.IChecksumService,new z.SyncDescriptor(y.ChecksumService)),ve.set(St.IV8InspectProfilingService,new z.SyncDescriptor(kt.InspectProfilingService));const rt=P.ProxyChannel.toService(Ke.getChannel("nativeHost"),{context:this.configuration.windowId});ve.set(O.INativeHostService,rt),ve.set(r.IDownloadService,new z.SyncDescriptor(t.DownloadService));const lt=this._register(new fe.ActiveWindowManager(rt)),ut=new P.StaticRouter(Ve=>lt.getActiveClientId().then(dt=>Ve===dt));ve.set(F.IExtensionRecommendationNotificationService,new k.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new ze.AssignmentService(this.configuration.machineId,xe,Ue);let tt;const Qe=[];if((0,Re.supportsTelemetry)(Ue,Fe)){const Ve=new ge.TelemetryLogAppender(Xe,Fe);Qe.push(Ve);const{appRoot:dt,extensionsPath:_t,installSourcePath:Ot}=Fe;if(Ue.aiConfig&&Ue.aiConfig.asimovKey){const st=await ht.getTreatment("telemetryMigration")??!1,ft=Ue.quality!=="stable";if(ft&&st){const bt=new Le.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,st,!0);this._register((0,A.toDisposable)(()=>bt.flush())),Qe.push(bt)}const Et=new Le.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,ft?!1:st,st&&ft);this._register((0,A.toDisposable)(()=>Et.flush())),Qe.push(Et)}tt=new be.TelemetryService({appenders:Qe,commonProperties:(0,de.resolveCommonProperties)(Be,(0,n.release)(),(0,n.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Ue.msftInternalDomains,Ot),sendErrorTelemetry:!0,piiPaths:[dt,_t]},xe)}else{tt=Re.NullTelemetryService;const Ve=Re.NullAppender;Qe.push(Ve)}this.server.registerChannel("telemetryAppender",new pe.TelemetryAppenderChannel(Qe)),ve.set(we.ITelemetryService,tt);const At=new Te.CustomEndpointTelemetryService(xe,tt,Xe,Fe);ve.set(we.ICustomEndpointTelemetryService,At),ve.set(g.IExtensionManagementService,new z.SyncDescriptor(U.ExtensionManagementService)),ve.set(g.IExtensionGalleryService,new z.SyncDescriptor(h.ExtensionGalleryService)),ve.set(g.IExtensionTipsService,new z.SyncDescriptor(_.ExtensionTipsService)),ve.set(V.ILocalizationsService,new z.SyncDescriptor(Q.LocalizationsService)),ve.set(i.IDiagnosticsService,new z.SyncDescriptor(a.DiagnosticsService)),ve.set(le.IUserDataSyncAccountService,new z.SyncDescriptor(le.UserDataSyncAccountService)),ve.set(ae.IUserDataSyncLogService,new z.SyncDescriptor(Me.UserDataSyncLogService)),ve.set(ae.IUserDataSyncUtilService,new Ee.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ve=>Ve.ctx!=="main"))),ve.set(g.IGlobalExtensionEnablementService,new z.SyncDescriptor(c.GlobalExtensionEnablementService)),ve.set(ie.IIgnoredExtensionsManagementService,new z.SyncDescriptor(ie.IgnoredExtensionsManagementService)),ve.set(je.IExtensionStorageService,new z.SyncDescriptor(je.ExtensionStorageService)),ve.set(ae.IUserDataSyncStoreManagementService,new z.SyncDescriptor(oe.UserDataSyncStoreManagementService)),ve.set(ae.IUserDataSyncStoreService,new z.SyncDescriptor(oe.UserDataSyncStoreService)),ve.set(ke.IUserDataSyncMachinesService,new z.SyncDescriptor(ke.UserDataSyncMachinesService)),ve.set(ae.IUserDataSyncBackupStoreService,new z.SyncDescriptor(ye.UserDataSyncBackupStoreService)),ve.set(ae.IUserDataSyncEnablementService,new z.SyncDescriptor(Oe.UserDataSyncEnablementService)),ve.set(ae.IUserDataSyncService,new z.SyncDescriptor(_e.UserDataSyncService));const wt=new Ge.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:xe.getValue("terminal.integrated.persistentSessionScrollback")??100},xe,Fe,Ye,tt);return await wt.initialize(),ve.set(Je.ILocalPtyService,this._register(wt)),ve.set(me.ISignService,new z.SyncDescriptor(De.SignService)),ve.set(Se.ISharedTunnelsService,new z.SyncDescriptor(Pe.SharedTunnelsService)),ve.set(Ie.ISharedProcessTunnelService,new z.SyncDescriptor(Ce.SharedProcessTunnelService)),new ee.InstantiationService(ve)}initChannels(ve){const Ue=new R.ExtensionManagementChannel(ve.get(g.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const $e=P.ProxyChannel.fromService(ve.get(V.ILocalizationsService));this.server.registerChannel("localizations",$e);const Ke=P.ProxyChannel.fromService(ve.get(i.IDiagnosticsService));this.server.registerChannel("diagnostics",Ke);const Fe=new R.ExtensionTipsChannel(ve.get(g.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Fe);const it=P.ProxyChannel.fromService(ve.get(w.IChecksumService));this.server.registerChannel("checksum",it);const Xe=P.ProxyChannel.fromService(ve.get(St.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",Xe);const ot=new Ee.UserDataSyncMachinesServiceChannel(ve.get(ke.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ot);const Ye=P.ProxyChannel.fromService(ve.get(we.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Ye);const Be=new Ee.UserDataSyncAccountServiceChannel(ve.get(le.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Be);const at=new Ee.UserDataSyncStoreManagementServiceChannel(ve.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",at);const ct=new X.UserDataSyncChannel(ve.get(ae.IUserDataSyncService),ve.get(Z.ILogService));this.server.registerChannel("userDataSync",ct);const xe=this._register(ve.get(G.IInstantiationService).createInstance(ce.UserDataAutoSyncService)),et=new Ee.UserDataAutoSyncChannel(xe);this.server.registerChannel("userDataAutoSync",et);const rt=ve.get(Je.ILocalPtyService),lt=P.ProxyChannel.fromService(rt);this.server.registerChannel(qe.TerminalIpcChannels.LocalPty,lt);const ut=P.ProxyChannel.fromService(ve.get(Ie.ISharedProcessTunnelService));this.server.registerChannel(Ie.ipcSharedProcessTunnelChannelName,ut);const ht=P.ProxyChannel.fromService(ve.get(Ae.ISharedProcessWorkerService));this.server.registerChannel(Ae.ipcSharedProcessWorkerChannelName,ht)}registerErrorHandler(ve){window.addEventListener("unhandledrejection",Ue=>{(0,T.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,T.setUnexpectedErrorHandler)(Ue=>{const $e=(0,L.toErrorMessage)(Ue,!0);!$e||ve.error(`[uncaught exception in sharedProcess]: ${$e}`)})}}async function Tt(yt){const ve=new Lt(yt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Tt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/23664355e61f3fb614932a5cb16613b4d987cfb7/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
